/* Dimensions.c generated by valac 0.34.4, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_widget_allocation (GtkWidget* widget, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
void dimensions_with_max (Dimensions *self, gint max_width, gint max_height, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
void scaling_to_fill_screen (GtkWindow* window, Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing);
void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self, ZoomState* other);


gchar* scale_constraint_to_string (ScaleConstraint self) {
	gchar* result = NULL;
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	switch (self) {
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 174 "Dimensions.c"
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
#line 30 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp0_ = _ ("Original size");
#line 30 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp1_ = g_strdup (_tmp0_);
#line 30 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp1_;
#line 30 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 186 "Dimensions.c"
		}
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 190 "Dimensions.c"
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 33 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = _ ("Width or height");
#line 33 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 33 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp3_;
#line 33 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 202 "Dimensions.c"
		}
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 206 "Dimensions.c"
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
#line 36 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp4_ = _ ("Width");
#line 36 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 36 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp5_;
#line 36 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 218 "Dimensions.c"
		}
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 222 "Dimensions.c"
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
#line 39 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp6_ = _ ("Height");
#line 39 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 39 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp7_;
#line 39 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 234 "Dimensions.c"
		}
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 238 "Dimensions.c"
		{
			gchar* _tmp8_ = NULL;
#line 43 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp8_ = g_strdup ("Fill Viewport");
#line 43 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp8_;
#line 43 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 247 "Dimensions.c"
		}
		default:
#line 28 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		break;
#line 252 "Dimensions.c"
	}
#line 46 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_warn_if_reached ();
#line 48 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = NULL;
#line 48 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 260 "Dimensions.c"
}


GType scale_constraint_get_type (void) {
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


void dimensions_init (Dimensions *self, gint width, gint height) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
#line 56 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = width;
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ < 0) {
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 293 "Dimensions.c"
	} else {
		gint _tmp2_ = 0;
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = height;
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_ < 0;
#line 300 "Dimensions.c"
	}
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 58 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		g_warning ("Dimensions.vala:58: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
#line 306 "Dimensions.c"
	}
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = width;
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = width;
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = CLAMP (_tmp3_, 0, _tmp4_);
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).width = _tmp5_;
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = height;
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = height;
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = CLAMP (_tmp6_, 0, _tmp7_);
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).height = _tmp8_;
#line 324 "Dimensions.c"
}


void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
#line 64 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (pixbuf != NULL);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = pixbuf;
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = pixbuf;
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = gdk_pixbuf_get_height (_tmp2_);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 350 "Dimensions.c"
}


void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
	GtkAllocation _tmp0_ = {0};
	gint _tmp1_ = 0;
	GtkAllocation _tmp2_ = {0};
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
#line 68 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *allocation;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 376 "Dimensions.c"
}


void dimensions_for_widget_allocation (GtkWidget* widget, Dimensions* result) {
	GtkAllocation allocation = {0};
	GtkWidget* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	GtkAllocation _tmp2_ = {0};
	gint _tmp3_ = 0;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_ = 0;
	Dimensions _tmp6_ = {0};
#line 72 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 74 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = widget;
#line 74 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
#line 74 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	allocation = _tmp1_;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = allocation;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = allocation;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.height;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp3_, _tmp5_);
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp6_;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 411 "Dimensions.c"
}


void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
	GdkRectangle _tmp0_ = {0};
	gint _tmp1_ = 0;
	GdkRectangle _tmp2_ = {0};
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
#line 79 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *rect;
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *rect;
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 80 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 437 "Dimensions.c"
}


gboolean dimensions_has_area (Dimensions *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ > 0) {
#line 449 "Dimensions.c"
		gint _tmp2_ = 0;
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = (*self).height;
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_ > 0;
#line 455 "Dimensions.c"
	} else {
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 459 "Dimensions.c"
	}
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 84 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 465 "Dimensions.c"
}


void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	Dimensions _tmp9_ = {0};
	gint _tmp10_ = 0;
	Dimensions _tmp14_ = {0};
#line 87 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *min;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ > _tmp3_) {
#line 489 "Dimensions.c"
		gint _tmp4_ = 0;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = (*self).width;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_;
#line 495 "Dimensions.c"
	} else {
		Dimensions _tmp5_ = {0};
		gint _tmp6_ = 0;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = *min;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp6_;
#line 505 "Dimensions.c"
	}
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = (*self).height;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = *min;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.height;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp8_ > _tmp10_) {
#line 515 "Dimensions.c"
		gint _tmp11_ = 0;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = (*self).height;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = _tmp11_;
#line 521 "Dimensions.c"
	} else {
		Dimensions _tmp12_ = {0};
		gint _tmp13_ = 0;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = *min;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = _tmp12_.height;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = _tmp13_;
#line 531 "Dimensions.c"
	}
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp14_, _tmp0_, _tmp7_);
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp14_;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 539 "Dimensions.c"
}


gchar* dimensions_to_string (Dimensions *self) {
	gchar* result = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
#line 93 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 93 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 93 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = g_strdup_printf ("%dx%d", _tmp0_, _tmp1_);
#line 93 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp2_;
#line 93 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 558 "Dimensions.c"
}


gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gint _tmp3_ = 0;
#line 96 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *dim;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ == _tmp3_) {
#line 578 "Dimensions.c"
		gint _tmp4_ = 0;
		Dimensions _tmp5_ = {0};
		gint _tmp6_ = 0;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = *dim;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.height;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_ == _tmp6_;
#line 590 "Dimensions.c"
	} else {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 594 "Dimensions.c"
	}
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 600 "Dimensions.c"
}


gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *dim;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = abs (_tmp1_ - _tmp3_);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = fudge;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp4_ <= _tmp5_) {
#line 626 "Dimensions.c"
		gint _tmp6_ = 0;
		Dimensions _tmp7_ = {0};
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = (*self).height;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = *dim;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = _tmp7_.height;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = abs (_tmp6_ - _tmp8_);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = fudge;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp9_ <= _tmp10_;
#line 644 "Dimensions.c"
	} else {
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 648 "Dimensions.c"
	}
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 654 "Dimensions.c"
}


gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = scale;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = fudge;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ <= (_tmp2_ + _tmp3_)) {
#line 672 "Dimensions.c"
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = scale;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = fudge;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_ <= (_tmp5_ + _tmp6_);
#line 684 "Dimensions.c"
	} else {
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 688 "Dimensions.c"
	}
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 694 "Dimensions.c"
}


gint dimensions_major_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = MAX (_tmp0_, _tmp1_);
#line 110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp2_;
#line 110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 713 "Dimensions.c"
}


gint dimensions_minor_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = MIN (_tmp0_, _tmp1_);
#line 114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp2_;
#line 114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 732 "Dimensions.c"
}


void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	Dimensions _tmp6_ = {0};
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = min_width;
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = MAX (_tmp0_, _tmp1_);
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = (*self).height;
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = min_height;
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = MAX (_tmp3_, _tmp4_);
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp2_, _tmp5_);
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp6_;
#line 118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 762 "Dimensions.c"
}


void dimensions_with_max (Dimensions *self, gint max_width, gint max_height, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	Dimensions _tmp6_ = {0};
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = max_width;
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = MIN (_tmp0_, _tmp1_);
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = (*self).height;
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = max_height;
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = MIN (_tmp3_, _tmp4_);
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp2_, _tmp5_);
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp6_;
#line 122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 792 "Dimensions.c"
}


void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
#line 126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp0_ > 0, "scale > 0");
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = (*self).width;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = scale;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp3_ == _tmp4_) {
#line 818 "Dimensions.c"
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = (*self).height;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = scale;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = _tmp5_ < _tmp6_;
#line 827 "Dimensions.c"
	} else {
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = FALSE;
#line 831 "Dimensions.c"
	}
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp2_) {
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = TRUE;
#line 837 "Dimensions.c"
	} else {
		gboolean _tmp7_ = FALSE;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = (*self).height;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = scale;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp8_ == _tmp9_) {
#line 848 "Dimensions.c"
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp10_ = (*self).width;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp11_ = scale;
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = _tmp10_ < _tmp11_;
#line 857 "Dimensions.c"
		} else {
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = FALSE;
#line 861 "Dimensions.c"
		}
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = _tmp7_;
#line 865 "Dimensions.c"
	}
#line 129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_) {
#line 869 "Dimensions.c"
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		Dimensions _tmp14_ = {0};
#line 130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = (*self).width;
#line 130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = (*self).height;
#line 130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		dimensions_init (&_tmp14_, _tmp12_, _tmp13_);
#line 130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp14_;
#line 130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 883 "Dimensions.c"
	}
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = scale_up;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (!_tmp16_) {
#line 889 "Dimensions.c"
		gboolean _tmp17_ = FALSE;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp18_ = (*self).width;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp19_ = scale;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp18_ < _tmp19_) {
#line 899 "Dimensions.c"
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp20_ = (*self).height;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp21_ = scale;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp17_ = _tmp20_ < _tmp21_;
#line 908 "Dimensions.c"
		} else {
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp17_ = FALSE;
#line 912 "Dimensions.c"
		}
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = _tmp17_;
#line 916 "Dimensions.c"
	} else {
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = FALSE;
#line 920 "Dimensions.c"
	}
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp15_) {
#line 924 "Dimensions.c"
		gint _tmp22_ = 0;
		gint _tmp23_ = 0;
		Dimensions _tmp24_ = {0};
#line 134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp22_ = (*self).width;
#line 134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp23_ = (*self).height;
#line 134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		dimensions_init (&_tmp24_, _tmp22_, _tmp23_);
#line 134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp24_;
#line 134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 938 "Dimensions.c"
	}
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = (*self).width;
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = scale;
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = (*self).height;
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp28_ = scale;
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if ((_tmp25_ - _tmp26_) > (_tmp27_ - _tmp28_)) {
#line 950 "Dimensions.c"
		gint _tmp29_ = 0;
		Dimensions _tmp30_ = {0};
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp29_ = scale;
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), _tmp29_, &_tmp30_);
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp30_;
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 961 "Dimensions.c"
	} else {
		gint _tmp31_ = 0;
		Dimensions _tmp32_ = {0};
#line 139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp31_ = scale;
#line 139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), _tmp31_, &_tmp32_);
#line 139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp32_;
#line 139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 973 "Dimensions.c"
	}
}


void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio) {
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Dimensions _tmp3_ = {0};
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = *scaled;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.height;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = (*self).height;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp4_) / ((gdouble) _tmp5_);
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (width_ratio) {
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 1009 "Dimensions.c"
	}
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (height_ratio) {
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 1015 "Dimensions.c"
	}
}


gdouble dimensions_get_aspect_ratio (Dimensions *self) {
	gdouble result = 0.0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = ((gdouble) _tmp0_) / _tmp1_;
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 1032 "Dimensions.c"
}


void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Dimensions scaled = {0};
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	Dimensions _tmp17_ = {0};
	Dimensions _tmp18_ = {0};
	Dimensions _tmp19_ = {0};
	Dimensions _tmp20_ = {0};
	gint _tmp21_ = 0;
	Dimensions _tmp22_ = {0};
	gint _tmp23_ = 0;
	Dimensions _tmp24_ = {0};
	gint _tmp25_ = 0;
	Dimensions _tmp26_ = {0};
	gint _tmp27_ = 0;
#line 151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = width_ratio;
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = height_ratio;
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp3_ < _tmp4_) {
#line 1078 "Dimensions.c"
		Dimensions _tmp5_ = {0};
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gdouble _tmp8_ = 0.0;
#line 157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_;
#line 158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = width_ratio;
#line 158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp7_) * _tmp8_;
#line 1095 "Dimensions.c"
	} else {
		gint _tmp9_ = 0;
		gdouble _tmp10_ = 0.0;
		Dimensions _tmp11_ = {0};
		gint _tmp12_ = 0;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = (*self).width;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = height_ratio;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_width = ((gdouble) _tmp9_) * _tmp10_;
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = *viewport;
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = _tmp11_.height;
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_height = (gdouble) _tmp12_;
#line 1113 "Dimensions.c"
	}
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = scaled_width;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = round (_tmp13_);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = scaled_height;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = round (_tmp15_);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp17_, (gint) _tmp14_, (gint) _tmp16_);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp18_, 1, 1);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_floor (&_tmp17_, &_tmp18_, &_tmp19_);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp19_;
#line 166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp20_ = scaled;
#line 166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp21_ = _tmp20_.height;
#line 166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp22_ = *viewport;
#line 166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp23_ = _tmp22_.height;
#line 166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp21_ <= _tmp23_, "scaled.height <= viewport.height");
#line 167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = scaled;
#line 167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = _tmp24_.width;
#line 167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = *viewport;
#line 167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = _tmp26_.width;
#line 167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp25_ <= _tmp27_, "scaled.width <= viewport.width");
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = scaled;
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1155 "Dimensions.c"
}


void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_ = 0;
	Dimensions _tmp5_ = {0};
	gint _tmp6_ = 0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_ = 0.0;
	Dimensions _tmp36_ = {0};
	Dimensions _tmp37_ = {0};
	Dimensions _tmp38_ = {0};
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = (*self).width;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = *viewport;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = _tmp5_.width;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp4_ < _tmp6_) {
#line 1196 "Dimensions.c"
		gint _tmp7_ = 0;
		Dimensions _tmp8_ = {0};
		gint _tmp9_ = 0;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.height;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = _tmp7_ >= _tmp9_;
#line 1208 "Dimensions.c"
	} else {
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 1212 "Dimensions.c"
	}
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp3_) {
#line 1216 "Dimensions.c"
		Dimensions _tmp10_ = {0};
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gdouble _tmp13_ = 0.0;
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = *viewport;
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = _tmp10_.width;
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_width = (gdouble) _tmp11_;
#line 180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = (*self).height;
#line 180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = width_ratio;
#line 180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp12_) * _tmp13_;
#line 1233 "Dimensions.c"
	} else {
		gboolean _tmp14_ = FALSE;
		gint _tmp15_ = 0;
		Dimensions _tmp16_ = {0};
		gint _tmp17_ = 0;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = (*self).width;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp16_ = *viewport;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp17_ = _tmp16_.width;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp15_ >= _tmp17_) {
#line 1247 "Dimensions.c"
			gint _tmp18_ = 0;
			Dimensions _tmp19_ = {0};
			gint _tmp20_ = 0;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp18_ = (*self).height;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp19_ = *viewport;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp20_ = _tmp19_.height;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp14_ = _tmp18_ < _tmp20_;
#line 1259 "Dimensions.c"
		} else {
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp14_ = FALSE;
#line 1263 "Dimensions.c"
		}
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp14_) {
#line 1267 "Dimensions.c"
			gint _tmp21_ = 0;
			gdouble _tmp22_ = 0.0;
			Dimensions _tmp23_ = {0};
			gint _tmp24_ = 0;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp21_ = (*self).width;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp22_ = height_ratio;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp21_) * _tmp22_;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp23_ = *viewport;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp24_ = _tmp23_.height;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			scaled_height = (gdouble) _tmp24_;
#line 1284 "Dimensions.c"
		} else {
			gdouble ratio = 0.0;
			gdouble _tmp25_ = 0.0;
			gdouble _tmp26_ = 0.0;
			gdouble _tmp27_ = 0.0;
			gint _tmp28_ = 0;
			gdouble _tmp29_ = 0.0;
			gint _tmp30_ = 0;
			gdouble _tmp31_ = 0.0;
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp25_ = width_ratio;
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp26_ = height_ratio;
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp27_ = MAX (_tmp25_, _tmp26_);
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			ratio = _tmp27_;
#line 189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp28_ = (*self).width;
#line 189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp29_ = ratio;
#line 189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp28_) * _tmp29_;
#line 190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp30_ = (*self).height;
#line 190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp31_ = ratio;
#line 190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			scaled_height = ((gdouble) _tmp30_) * _tmp31_;
#line 1314 "Dimensions.c"
		}
	}
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp32_ = scaled_width;
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp33_ = round (_tmp32_);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp34_ = scaled_height;
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp35_ = round (_tmp34_);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp36_, (gint) _tmp33_, (gint) _tmp35_);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp37_, 1, 1);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_floor (&_tmp36_, &_tmp37_, &_tmp38_);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp38_;
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1335 "Dimensions.c"
}


void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	GdkRectangle _tmp7_ = {0};
	gint _tmp8_ = 0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GdkRectangle _tmp11_ = {0};
	gint _tmp12_ = 0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	GdkRectangle _tmp15_ = {0};
	gint _tmp16_ = 0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	GdkRectangle _tmp19_ = {0};
	gint _tmp20_ = 0;
	GdkRectangle _tmp21_ = {0};
	gint _tmp22_ = 0;
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	x_scale = _tmp1_;
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	y_scale = _tmp2_;
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = *rect;
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.x;
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = x_scale;
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = round (((gdouble) _tmp4_) * _tmp5_);
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled_rect.x = (gint) _tmp6_;
#line 202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = *rect;
#line 202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.y;
#line 202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = y_scale;
#line 202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = round (((gdouble) _tmp8_) * _tmp9_);
#line 202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled_rect.y = (gint) _tmp10_;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = *rect;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.width;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = x_scale;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = round (((gdouble) _tmp12_) * _tmp13_);
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled_rect.width = (gint) _tmp14_;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = *rect;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.height;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp17_ = y_scale;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp18_ = round (((gdouble) _tmp16_) * _tmp17_);
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled_rect.height = (gint) _tmp18_;
#line 206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp19_ = scaled_rect;
#line 206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp20_ = _tmp19_.width;
#line 206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp20_ <= 0) {
#line 207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_rect.width = 1;
#line 1428 "Dimensions.c"
	}
#line 209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp21_ = scaled_rect;
#line 209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp22_ = _tmp21_.height;
#line 209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp22_ <= 0) {
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaled_rect.height = 1;
#line 1438 "Dimensions.c"
	}
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = scaled_rect;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1444 "Dimensions.c"
}


void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	gdouble _tmp5_ = 0.0;
	gint _tmp6_ = 0;
	gdouble _tmp7_ = 0.0;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	x_scale = _tmp1_;
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	y_scale = _tmp2_;
#line 220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = MIN (x_scale, y_scale);
#line 220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scale = _tmp3_;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = (*self).width;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = round (((gdouble) _tmp4_) * scale);
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = (*self).height;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = round (((gdouble) _tmp6_) * scale);
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp8_, (gint) _tmp5_, (gint) _tmp7_);
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp9_, 1, 1);
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_floor (&_tmp8_, &_tmp9_, &_tmp10_);
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp10_;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1497 "Dimensions.c"
}


void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
	gint _tmp0_ = 0;
	gdouble ratio = 0.0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gdouble _tmp5_ = 0.0;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
#line 227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp0_ > 0, "scale > 0");
#line 229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = scale;
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = (*self).height;
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = round (((gdouble) _tmp4_) * ratio);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp3_, (gint) _tmp5_);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp7_, 1, 1);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_floor (&_tmp6_, &_tmp7_, &_tmp8_);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp8_;
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1538 "Dimensions.c"
}


void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
	gint _tmp0_ = 0;
	gdouble ratio = 0.0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gdouble _tmp4_ = 0.0;
	gint _tmp5_ = 0;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
#line 235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp0_ > 0, "scale > 0");
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).height;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = (*self).width;
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = round (((gdouble) _tmp3_) * ratio);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = scale;
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, (gint) _tmp4_, _tmp5_);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp7_, 1, 1);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_floor (&_tmp6_, &_tmp7_, &_tmp8_);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp8_;
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1579 "Dimensions.c"
}


void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
	ScaleConstraint _tmp0_ = 0;
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	switch (_tmp0_) {
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1591 "Dimensions.c"
		{
			gint _tmp1_ = 0;
			gint _tmp2_ = 0;
			Dimensions _tmp3_ = {0};
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp1_ = (*self).width;
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = (*self).height;
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			dimensions_init (&_tmp3_, _tmp1_, _tmp2_);
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*result = _tmp3_;
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return;
#line 1606 "Dimensions.c"
		}
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1610 "Dimensions.c"
		{
			Dimensions _tmp4_ = {0};
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp5_ = (*self).width;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp6_ = (*self).height;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (_tmp5_ >= _tmp6_) {
#line 1621 "Dimensions.c"
				gint _tmp7_ = 0;
				Dimensions _tmp8_ = {0};
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp7_ = scale;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), _tmp7_, &_tmp8_);
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp4_ = _tmp8_;
#line 1630 "Dimensions.c"
			} else {
				gint _tmp9_ = 0;
				Dimensions _tmp10_ = {0};
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp9_ = scale;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), _tmp9_, &_tmp10_);
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp4_ = _tmp10_;
#line 1640 "Dimensions.c"
			}
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*result = _tmp4_;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return;
#line 1646 "Dimensions.c"
		}
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1650 "Dimensions.c"
		{
			gint _tmp11_ = 0;
			Dimensions _tmp12_ = {0};
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp11_ = scale;
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), _tmp11_, &_tmp12_);
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*result = _tmp12_;
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return;
#line 1662 "Dimensions.c"
		}
#line 243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1666 "Dimensions.c"
		{
			gint _tmp13_ = 0;
			Dimensions _tmp14_ = {0};
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp13_ = scale;
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), _tmp13_, &_tmp14_);
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*result = _tmp14_;
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return;
#line 1678 "Dimensions.c"
		}
		default:
		{
			ScaleConstraint _tmp15_ = 0;
#line 257 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp15_ = constraint;
#line 257 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			g_error ("Dimensions.vala:257: Bad constraint: %d", (gint) _tmp15_);
#line 1687 "Dimensions.c"
		}
	}
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return dup;
#line 1701 "Dimensions.c"
}


void dimensions_free (Dimensions* self) {
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_free (self);
#line 1708 "Dimensions.c"
}


GType dimensions_get_type (void) {
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
	ScaleConstraint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
#line 270 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 270 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).constraint = _tmp0_;
#line 272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).scale = _tmp1_;
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *viewport;
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport = _tmp2_;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).scale_up = _tmp3_;
#line 1748 "Dimensions.c"
}


void scaling_for_original (Scaling* result) {
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp1_;
#line 278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1763 "Dimensions.c"
}


void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
	GtkWindow* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Scaling _tmp3_ = {0};
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_get_screen_dimensions (_tmp0_, &_tmp1_);
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = scale_up;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_for_viewport (&_tmp1_, _tmp2_, &_tmp3_);
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp3_;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1786 "Dimensions.c"
}


void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	Scaling _tmp4_ = {0};
#line 286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = pixels;
#line 286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp0_ > 0, "pixels > 0");
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = pixels;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp2_, 0, 0);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp4_, SCALE_CONSTRAINT_DIMENSIONS, _tmp1_, &_tmp2_, _tmp3_);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1812 "Dimensions.c"
}


void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Scaling _tmp3_ = {0};
#line 291 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = dimensions_has_area (viewport);
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp0_, "viewport.has_area ()");
#line 294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = scale_up;
#line 294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp3_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp1_, _tmp2_);
#line 294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp3_;
#line 294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1837 "Dimensions.c"
}


void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
	Dimensions viewport = {0};
	GtkWidget* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_ = {0};
	gint _tmp4_ = 0;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_ = FALSE;
	Scaling _tmp10_ = {0};
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = widget;
#line 298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_for_widget_allocation (_tmp0_, &_tmp1_);
#line 298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	viewport = _tmp1_;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = viewport;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.width;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp4_ <= 1) {
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = TRUE;
#line 1867 "Dimensions.c"
	} else {
		Dimensions _tmp5_ = {0};
		gint _tmp6_ = 0;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = viewport;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.height;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = _tmp6_ <= 1;
#line 1877 "Dimensions.c"
	}
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp2_) {
#line 1881 "Dimensions.c"
		Scaling _tmp7_ = {0};
#line 309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaling_for_original (&_tmp7_);
#line 309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp7_;
#line 309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 1889 "Dimensions.c"
	}
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = viewport;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = scale_up;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp10_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp8_, _tmp9_);
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp10_;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1901 "Dimensions.c"
}


void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_ = {0};
	gint _tmp2_ = 0;
	Dimensions _tmp6_ = {0};
	Scaling _tmp7_ = {0};
#line 314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = _tmp1_.width;
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp2_ <= 1) {
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 1921 "Dimensions.c"
	} else {
		Dimensions _tmp3_ = {0};
		gint _tmp4_ = 0;
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = *viewport;
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = _tmp3_.height;
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_ <= 1;
#line 1931 "Dimensions.c"
	}
#line 317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 1935 "Dimensions.c"
		Scaling _tmp5_ = {0};
#line 318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		scaling_for_original (&_tmp5_);
#line 318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp5_;
#line 318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 1943 "Dimensions.c"
	}
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = *viewport;
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp7_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp6_, TRUE);
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp7_;
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1953 "Dimensions.c"
}


void scaling_to_fill_screen (GtkWindow* window, Scaling* result) {
	GtkWindow* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
#line 323 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_get_screen_dimensions (_tmp0_, &_tmp1_);
#line 324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp1_, &_tmp2_);
#line 324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp2_;
#line 324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1973 "Dimensions.c"
}


void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result) {
	ScaleConstraint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	Scaling _tmp4_ = {0};
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp2_, 0, 0);
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaling_init (&_tmp4_, _tmp0_, _tmp1_, &_tmp2_, _tmp3_);
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 1997 "Dimensions.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 2004 "Dimensions.c"
}


static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
	GdkScreen* screen = NULL;
	GtkWindow* _tmp0_ = NULL;
	GdkScreen* _tmp1_ = NULL;
	GdkScreen* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	Dimensions _tmp5_ = {0};
#line 331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = gtk_window_get_screen (_tmp0_);
#line 332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	screen = _tmp2_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = gdk_screen_get_width (screen);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = gdk_screen_get_height (screen);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_tmp5_, _tmp3_, _tmp4_);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp5_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_g_object_unref0 (screen);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 2038 "Dimensions.c"
}


static gint scaling_scale_to_pixels (Scaling *self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).scale;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_ >= 0) {
#line 2050 "Dimensions.c"
		gint _tmp2_ = 0;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = (*self).scale;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 2056 "Dimensions.c"
	} else {
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = 0;
#line 2060 "Dimensions.c"
	}
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 2066 "Dimensions.c"
}


gboolean scaling_is_unscaled (Scaling *self) {
	gboolean result = FALSE;
	ScaleConstraint _tmp0_ = 0;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_ == SCALE_CONSTRAINT_ORIGINAL;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 2079 "Dimensions.c"
}


gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
	gint _vala_pixels = 0;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	ScaleConstraint _tmp1_ = 0;
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_pixels = 0;
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (pixels) {
#line 349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 2102 "Dimensions.c"
		}
#line 349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2106 "Dimensions.c"
	}
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2116 "Dimensions.c"
		{
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = FALSE;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (pixels) {
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2124 "Dimensions.c"
			}
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2128 "Dimensions.c"
		}
		default:
		{
			gint _tmp2_ = 0;
			gint _tmp3_ = 0;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = scaling_scale_to_pixels (&(*self));
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_vala_pixels = _tmp2_;
#line 358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp3_ = _vala_pixels;
#line 358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_vala_assert (_tmp3_ > 0, "pixels > 0");
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = TRUE;
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (pixels) {
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2148 "Dimensions.c"
			}
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2152 "Dimensions.c"
		}
	}
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (pixels) {
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*pixels = _vala_pixels;
#line 2159 "Dimensions.c"
	}
}


gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	ScaleConstraint _tmp1_ = 0;
#line 364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 365 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (scaled) {
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2183 "Dimensions.c"
		}
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2187 "Dimensions.c"
	}
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2197 "Dimensions.c"
		{
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = FALSE;
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (scaled) {
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2205 "Dimensions.c"
			}
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2209 "Dimensions.c"
		}
		default:
		{
			gint pixels = 0;
			gint _tmp2_ = 0;
			gint _tmp3_ = 0;
			gint _tmp4_ = 0;
			ScaleConstraint _tmp5_ = 0;
			Dimensions _tmp6_ = {0};
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = scaling_scale_to_pixels (&(*self));
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			pixels = _tmp2_;
#line 377 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp3_ = pixels;
#line 377 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_vala_assert (_tmp3_ > 0, "pixels > 0");
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp4_ = pixels;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp5_ = (*self).constraint;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, _tmp4_, _tmp5_, &_tmp6_);
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_vala_scaled = _tmp6_;
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = TRUE;
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (scaled) {
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2241 "Dimensions.c"
			}
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2245 "Dimensions.c"
		}
	}
#line 364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (scaled) {
#line 364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2252 "Dimensions.c"
	}
}


gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	ScaleConstraint _tmp1_ = 0;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_ != SCALING_NO_SCALE) {
#line 389 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 389 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (scaled) {
#line 389 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2276 "Dimensions.c"
		}
#line 389 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2280 "Dimensions.c"
	}
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2290 "Dimensions.c"
		{
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = FALSE;
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (scaled) {
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2298 "Dimensions.c"
			}
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2302 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = dimensions_has_area (&(*self).viewport);
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_vala_assert (_tmp2_, "viewport.has_area ()");
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp5_ = (*self).scale_up;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (!_tmp5_) {
#line 2318 "Dimensions.c"
				Dimensions _tmp6_ = {0};
				gint _tmp7_ = 0;
				Dimensions _tmp8_ = {0};
				gint _tmp9_ = 0;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp6_ = *original;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp7_ = _tmp6_.width;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp8_ = (*self).viewport;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp9_ = _tmp8_.width;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp4_ = _tmp7_ < _tmp9_;
#line 2333 "Dimensions.c"
			} else {
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp4_ = FALSE;
#line 2337 "Dimensions.c"
			}
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (_tmp4_) {
#line 2341 "Dimensions.c"
				Dimensions _tmp10_ = {0};
				gint _tmp11_ = 0;
				Dimensions _tmp12_ = {0};
				gint _tmp13_ = 0;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp10_ = *original;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp11_ = _tmp10_.height;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp12_ = (*self).viewport;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp13_ = _tmp12_.height;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp3_ = _tmp11_ < _tmp13_;
#line 2356 "Dimensions.c"
			} else {
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp3_ = FALSE;
#line 2360 "Dimensions.c"
			}
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (_tmp3_) {
#line 2364 "Dimensions.c"
				Dimensions _tmp14_ = {0};
#line 400 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp14_ = *original;
#line 400 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_vala_scaled = _tmp14_;
#line 2370 "Dimensions.c"
			} else {
				Dimensions _tmp15_ = {0};
				Dimensions _tmp16_ = {0};
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp15_ = (*self).viewport;
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp15_, &_tmp16_);
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_vala_scaled = _tmp16_;
#line 2380 "Dimensions.c"
			}
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = TRUE;
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (scaled) {
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2388 "Dimensions.c"
			}
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2392 "Dimensions.c"
		}
	}
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (scaled) {
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2399 "Dimensions.c"
	}
}


gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
#line 408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_ != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (scaled) {
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2425 "Dimensions.c"
		}
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2429 "Dimensions.c"
	}
#line 414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = dimensions_has_area (&(*self).viewport);
#line 414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp1_, "viewport.has_area ()");
#line 415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport;
#line 415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp2_, &_tmp3_);
#line 415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_scaled = _tmp3_;
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = TRUE;
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (scaled) {
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2447 "Dimensions.c"
	}
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 2451 "Dimensions.c"
}


void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions scaled = {0};
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	gboolean is_viewport = FALSE;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = scaling_is_unscaled (&(*self));
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 2475 "Dimensions.c"
		Dimensions _tmp1_ = {0};
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = *original;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = _tmp1_;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 2483 "Dimensions.c"
	}
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *original;
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = scaling_is_fill_viewport (&(*self), &_tmp2_, &_tmp3_);
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp3_;
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp4_) {
#line 426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = scaled;
#line 426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 2497 "Dimensions.c"
	}
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = *original;
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = scaling_is_best_fit_dimensions (&(*self), &_tmp5_, &_tmp6_);
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp6_;
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		*result = scaled;
#line 429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return;
#line 2511 "Dimensions.c"
	}
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = *original;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = scaling_is_for_viewport (&(*self), &_tmp8_, &_tmp9_);
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp9_;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	is_viewport = _tmp10_;
#line 432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = is_viewport;
#line 432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp11_, "is_viewport");
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = scaled;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 2529 "Dimensions.c"
}


GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	Dimensions pixbuf_dim = {0};
	GdkPixbuf* _tmp3_ = NULL;
	Dimensions _tmp4_ = {0};
	gint pixels = 0;
	Dimensions _tmp5_ = {0};
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	Dimensions scaled = {0};
	Dimensions _tmp13_ = {0};
	Dimensions _tmp14_ = {0};
	gboolean _tmp15_ = FALSE;
	gboolean is_viewport = FALSE;
	Dimensions _tmp20_ = {0};
	Dimensions _tmp21_ = {0};
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GdkPixbuf* _tmp24_ = NULL;
	Dimensions _tmp25_ = {0};
	GdkInterpType _tmp26_ = 0;
	GdkPixbuf* _tmp27_ = NULL;
#line 437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = scaling_is_unscaled (&(*self));
#line 438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 2562 "Dimensions.c"
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_ = NULL;
#line 439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = pixbuf;
#line 439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = _tmp2_;
#line 439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2573 "Dimensions.c"
	}
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = pixbuf;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_for_pixbuf (_tmp3_, &_tmp4_);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	pixbuf_dim = _tmp4_;
#line 444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = pixbuf_dim;
#line 444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = scaling_is_best_fit (&(*self), &_tmp5_, &_tmp6_);
#line 444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	pixels = _tmp6_;
#line 444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 2589 "Dimensions.c"
		GdkPixbuf* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		GdkInterpType _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
		GdkPixbuf* _tmp12_ = NULL;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = pixbuf;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = pixels;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = interp;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = scale_up;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = scale_pixbuf (_tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = _tmp12_;
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2609 "Dimensions.c"
	}
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = pixbuf_dim;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = scaling_is_fill_viewport (&(*self), &_tmp13_, &_tmp14_);
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp14_;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp15_) {
#line 2619 "Dimensions.c"
		GdkPixbuf* _tmp16_ = NULL;
		Dimensions _tmp17_ = {0};
		GdkInterpType _tmp18_ = 0;
		GdkPixbuf* _tmp19_ = NULL;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp16_ = pixbuf;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp17_ = scaled;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp18_ = interp;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp19_ = resize_pixbuf (_tmp16_, &_tmp17_, _tmp18_);
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = _tmp19_;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2636 "Dimensions.c"
	}
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp20_ = pixbuf_dim;
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp22_ = scaling_is_for_viewport (&(*self), &_tmp20_, &_tmp21_);
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scaled = _tmp21_;
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	is_viewport = _tmp22_;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp23_ = is_viewport;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_vala_assert (_tmp23_, "is_viewport");
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = pixbuf;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = scaled;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = interp;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = resize_pixbuf (_tmp24_, &_tmp25_, _tmp26_);
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp27_;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 2662 "Dimensions.c"
}


gchar* scaling_to_string (Scaling *self) {
	gchar* result = NULL;
	ScaleConstraint _tmp0_ = 0;
#line 458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp0_ == SCALE_CONSTRAINT_ORIGINAL) {
#line 2673 "Dimensions.c"
		gchar* _tmp1_ = NULL;
#line 459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = g_strdup ("scaling: UNSCALED");
#line 459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = _tmp1_;
#line 459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 2681 "Dimensions.c"
	} else {
		ScaleConstraint _tmp2_ = 0;
#line 460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp2_ = (*self).constraint;
#line 460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp2_ == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2688 "Dimensions.c"
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp3_ = dimensions_to_string (&(*self).viewport);
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp5_ = g_strdup_printf ("scaling: fill viewport %s", _tmp4_);
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp6_ = _tmp5_;
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_g_free0 (_tmp4_);
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			result = _tmp6_;
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			return result;
#line 2707 "Dimensions.c"
		} else {
			gint _tmp7_ = 0;
#line 462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = (*self).scale;
#line 462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			if (_tmp7_ != SCALING_NO_SCALE) {
#line 2714 "Dimensions.c"
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
				ScaleConstraint _tmp10_ = 0;
				gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp9_ = (*self).scale_up;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				if (_tmp9_) {
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
					_tmp8_ = "scaled up";
#line 2729 "Dimensions.c"
				} else {
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
					_tmp8_ = "not scaled up";
#line 2733 "Dimensions.c"
				}
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp10_ = (*self).constraint;
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp11_ = scale_constraint_to_string (_tmp10_);
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp13_ = scaling_scale_to_pixels (&(*self));
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp14_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp12_, _tmp13_, _tmp8_);
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp15_ = _tmp14_;
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_g_free0 (_tmp12_);
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				result = _tmp15_;
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				return result;
#line 2753 "Dimensions.c"
			} else {
				const gchar* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp17_ = (*self).scale_up;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				if (_tmp17_) {
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
					_tmp16_ = "scaled up";
#line 2767 "Dimensions.c"
				} else {
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
					_tmp16_ = "not scaled up";
#line 2771 "Dimensions.c"
				}
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp18_ = dimensions_to_string (&(*self).viewport);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp19_ = _tmp18_;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp20_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp19_, _tmp16_);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_tmp21_ = _tmp20_;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				_g_free0 (_tmp19_);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				result = _tmp21_;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
				return result;
#line 2787 "Dimensions.c"
			}
		}
	}
}


gboolean scaling_equals (Scaling *self, Scaling* scaling) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ScaleConstraint _tmp2_ = 0;
	Scaling _tmp3_ = {0};
	ScaleConstraint _tmp4_ = 0;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).constraint;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = *scaling;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.constraint;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp2_ == _tmp4_) {
#line 2811 "Dimensions.c"
		gint _tmp5_ = 0;
		Scaling _tmp6_ = {0};
		gint _tmp7_ = 0;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = (*self).scale;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = *scaling;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = _tmp6_.scale;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = _tmp5_ == _tmp7_;
#line 2823 "Dimensions.c"
	} else {
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2827 "Dimensions.c"
	}
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_) {
#line 2831 "Dimensions.c"
		Scaling _tmp8_ = {0};
		Dimensions _tmp9_ = {0};
		gboolean _tmp10_ = FALSE;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = *scaling;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.viewport;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = dimensions_equals (&(*self).viewport, &_tmp9_);
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = _tmp10_;
#line 2843 "Dimensions.c"
	} else {
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2847 "Dimensions.c"
	}
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 2853 "Dimensions.c"
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
#line 262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return dup;
#line 2865 "Dimensions.c"
}


void scaling_free (Scaling* self) {
#line 262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_free (self);
#line 2872 "Dimensions.c"
}


GType scaling_get_type (void) {
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GdkPoint* _tmp5_ = NULL;
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = slider_val;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp2_;
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = viewport_center;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp5_ == NULL) {
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = TRUE;
#line 2920 "Dimensions.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GdkPoint* _tmp7_ = NULL;
		gint _tmp8_ = 0;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = viewport_center;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = (*_tmp7_).x;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (_tmp8_ == 0) {
#line 2931 "Dimensions.c"
			GdkPoint* _tmp9_ = NULL;
			gint _tmp10_ = 0;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp9_ = viewport_center;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp10_ = (*_tmp9_).y;
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp6_ = _tmp10_ == 0;
#line 2940 "Dimensions.c"
		} else {
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp6_ = FALSE;
#line 2944 "Dimensions.c"
		}
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = _tmp6_;
#line 2948 "Dimensions.c"
	}
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp4_) {
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2954 "Dimensions.c"
	} else {
		gdouble _tmp11_ = 0.0;
#line 494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = slider_val;
#line 494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = _tmp11_ == 0.0;
#line 2961 "Dimensions.c"
	}
#line 493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp3_) {
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2967 "Dimensions.c"
	} else {
		GdkPoint* _tmp12_ = NULL;
#line 497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = viewport_center;
#line 497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).viewport_center = *_tmp12_;
#line 498 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2976 "Dimensions.c"
	}
}


void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val) {
	ZoomState _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	ZoomState _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 503 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 503 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 503 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = new_slider_val;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp4_;
#line 507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = new_slider_val;
#line 509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp5_ == 0.0) {
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 3016 "Dimensions.c"
	} else {
		gdouble _tmp6_ = 0.0;
		ZoomState _tmp7_ = {0};
		GdkPoint _tmp8_ = {0};
		gint _tmp9_ = 0;
		ZoomState _tmp10_ = {0};
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		ZoomState _tmp13_ = {0};
		GdkPoint _tmp14_ = {0};
		gint _tmp15_ = 0;
		ZoomState _tmp16_ = {0};
		gdouble _tmp17_ = 0.0;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = (*self).zoom_factor;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = *existing;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.x;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = *existing;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = _tmp10_.zoom_factor;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp6_ * (_tmp9_ / _tmp11_));
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp12_ = (*self).zoom_factor;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = *existing;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp14_ = _tmp13_.viewport_center;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = _tmp14_.y;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp16_ = *existing;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp17_ = _tmp16_.zoom_factor;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp12_ * (_tmp15_ / _tmp17_));
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3060 "Dimensions.c"
	}
}


void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing) {
	ZoomState _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	ZoomState _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	ZoomState _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	ZoomState _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	ZoomState _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = *existing;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.min_factor;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = log (1.0 / _tmp5_);
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = *existing;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.max_factor;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = *existing;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.min_factor;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = log (_tmp8_ / _tmp10_);
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp6_ / _tmp11_;
#line 526 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = (*self).interpolation_factor;
#line 528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp12_ == 0.0) {
#line 529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 3121 "Dimensions.c"
	} else {
		gdouble _tmp13_ = 0.0;
		ZoomState _tmp14_ = {0};
		GdkPoint _tmp15_ = {0};
		gint _tmp16_ = 0;
		ZoomState _tmp17_ = {0};
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		ZoomState _tmp20_ = {0};
		GdkPoint _tmp21_ = {0};
		gint _tmp22_ = 0;
		ZoomState _tmp23_ = {0};
		gdouble _tmp24_ = 0.0;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = (*self).zoom_factor;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp14_ = *existing;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = _tmp14_.viewport_center;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp16_ = _tmp15_.x;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp17_ = *existing;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp18_ = _tmp17_.zoom_factor;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp13_ * (_tmp16_ / _tmp18_));
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp19_ = (*self).zoom_factor;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp20_ = *existing;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp21_ = _tmp20_.viewport_center;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp22_ = _tmp21_.y;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp23_ = *existing;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp24_ = _tmp23_.zoom_factor;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp19_ * (_tmp22_ / _tmp24_));
#line 535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3165 "Dimensions.c"
	}
}


void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center) {
	ZoomState _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	ZoomState _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	ZoomState _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	GdkPoint _tmp6_ = {0};
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = *existing;
#line 542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.interpolation_factor;
#line 542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp5_;
#line 544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = *new_viewport_center;
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_center = _tmp6_;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 3210 "Dimensions.c"
}


static void zoom_state_clamp_viewport_center (ZoomState *self) {
	gint zoomed_width = 0;
	gint _tmp0_ = 0;
	gint zoomed_height = 0;
	gint _tmp1_ = 0;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
	gint _tmp5_ = 0;
	Dimensions _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	GdkPoint _tmp9_ = {0};
	gint _tmp10_ = 0;
	Dimensions _tmp11_ = {0};
	gint _tmp12_ = 0;
	Dimensions _tmp13_ = {0};
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
#line 552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_width = _tmp0_;
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_height = _tmp1_;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport_center;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.x;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.width;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = (*self).viewport_dimensions;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = _tmp6_.width;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = CLAMP (_tmp3_, _tmp5_ / 2, (zoomed_width - (_tmp7_ / 2)) - 1);
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_center.x = _tmp8_;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = (*self).viewport_center;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.y;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = (*self).viewport_dimensions;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.height;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = (*self).viewport_dimensions;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.height;
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = CLAMP (_tmp10_, _tmp12_ / 2, (zoomed_height - (_tmp14_ / 2)) - 1);
#line 557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_center.y = _tmp15_;
#line 3273 "Dimensions.c"
}


static void zoom_state_center_viewport (ZoomState *self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_center.x = _tmp0_ / 2;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).viewport_center.y = _tmp1_ / 2;
#line 3288 "Dimensions.c"
}


static void zoom_state_compute_zoom_factors (ZoomState *self) {
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
#line 567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).max_factor = 2.0;
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = viewport_to_content_x;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = viewport_to_content_y;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = MIN (_tmp3_, _tmp4_);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).min_factor = _tmp5_;
#line 574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = (*self).min_factor;
#line 574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp6_ > 1.0) {
#line 575 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 3331 "Dimensions.c"
	}
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = (*self).min_factor;
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = (*self).max_factor;
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = (*self).min_factor;
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = (*self).interpolation_factor;
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = pow (_tmp8_ / _tmp9_, _tmp10_);
#line 577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	(*self).zoom_factor = _tmp7_ * _tmp11_;
#line 3345 "Dimensions.c"
}


gdouble zoom_state_get_interpolation_factor (ZoomState *self) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).interpolation_factor;
#line 581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 3358 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result) {
	gint zoomed_width = 0;
	gint _tmp0_ = 0;
	gint zoomed_height = 0;
	gint _tmp1_ = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GdkRectangle _tmp12_ = {0};
	gint _tmp13_ = 0;
	Dimensions _tmp14_ = {0};
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	GdkRectangle _tmp24_ = {0};
	gint _tmp25_ = 0;
	gint right = 0;
	GdkRectangle _tmp26_ = {0};
	gint _tmp27_ = 0;
	Dimensions _tmp28_ = {0};
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint _tmp33_ = 0;
	GdkRectangle _tmp34_ = {0};
	gint _tmp35_ = 0;
	gint bottom = 0;
	GdkRectangle _tmp36_ = {0};
	gint _tmp37_ = 0;
	Dimensions _tmp38_ = {0};
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gint _tmp43_ = 0;
	GdkRectangle _tmp44_ = {0};
	gint _tmp45_ = 0;
	GdkRectangle _tmp46_ = {0};
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	GdkRectangle _tmp49_ = {0};
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_width = _tmp0_;
#line 587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_height = _tmp1_;
#line 589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 591 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 591 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 591 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = zoomed_width;
#line 591 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp3_ < _tmp4_) {
#line 3422 "Dimensions.c"
		GdkPoint _tmp5_ = {0};
		gint _tmp6_ = 0;
		Dimensions _tmp7_ = {0};
		gint _tmp8_ = 0;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = (*self).viewport_center;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.x;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp7_ = (*self).viewport_dimensions;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = _tmp7_.width;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.x = _tmp6_ - (_tmp8_ / 2);
#line 3437 "Dimensions.c"
	} else {
		gint _tmp9_ = 0;
		Dimensions _tmp10_ = {0};
		gint _tmp11_ = 0;
#line 594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = zoomed_width;
#line 594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = (*self).viewport_dimensions;
#line 594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp11_ = _tmp10_.width;
#line 594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.x = (_tmp9_ - _tmp11_) / 2;
#line 3450 "Dimensions.c"
	}
#line 596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = _result_;
#line 596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = _tmp12_.x;
#line 596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp13_ < 0) {
#line 597 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.x = 0;
#line 3460 "Dimensions.c"
	}
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = (*self).viewport_dimensions;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = _tmp14_.height;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = zoomed_height;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp15_ < _tmp16_) {
#line 3470 "Dimensions.c"
		GdkPoint _tmp17_ = {0};
		gint _tmp18_ = 0;
		Dimensions _tmp19_ = {0};
		gint _tmp20_ = 0;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp17_ = (*self).viewport_center;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp18_ = _tmp17_.y;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp19_ = (*self).viewport_dimensions;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp20_ = _tmp19_.height;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.y = _tmp18_ - (_tmp20_ / 2);
#line 3485 "Dimensions.c"
	} else {
		gint _tmp21_ = 0;
		Dimensions _tmp22_ = {0};
		gint _tmp23_ = 0;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp21_ = zoomed_height;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp22_ = (*self).viewport_dimensions;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp23_ = _tmp22_.height;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.y = (_tmp21_ - _tmp23_) / 2;
#line 3498 "Dimensions.c"
	}
#line 604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = _result_;
#line 604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = _tmp24_.y;
#line 604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp25_ < 0) {
#line 605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.y = 0;
#line 3508 "Dimensions.c"
	}
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = _result_;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = _tmp26_.x;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp28_ = (*self).viewport_dimensions;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp29_ = _tmp28_.width;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	right = _tmp27_ + _tmp29_;
#line 608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp30_ = right;
#line 608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp31_ = zoomed_width;
#line 608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp30_ > _tmp31_) {
#line 3526 "Dimensions.c"
		gint _tmp32_ = 0;
#line 609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp32_ = zoomed_width;
#line 609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		right = _tmp32_;
#line 3532 "Dimensions.c"
	}
#line 610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp33_ = right;
#line 610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp34_ = _result_;
#line 610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp35_ = _tmp34_.x;
#line 610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.width = _tmp33_ - _tmp35_;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp36_ = _result_;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp37_ = _tmp36_.y;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp38_ = (*self).viewport_dimensions;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp39_ = _tmp38_.height;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	bottom = _tmp37_ + _tmp39_;
#line 613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp40_ = bottom;
#line 613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp41_ = zoomed_height;
#line 613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp40_ > _tmp41_) {
#line 3558 "Dimensions.c"
		gint _tmp42_ = 0;
#line 614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp42_ = zoomed_height;
#line 614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		bottom = _tmp42_;
#line 3564 "Dimensions.c"
	}
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp43_ = bottom;
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp44_ = _result_;
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp45_ = _tmp44_.y;
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.height = _tmp43_ - _tmp45_;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp46_ = _result_;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp47_ = _tmp46_.width;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp48_ = CLAMP (_tmp47_, 1, G_MAXINT);
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.width = _tmp48_;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp49_ = _result_;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp50_ = _tmp49_.height;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp51_ = CLAMP (_tmp50_, 1, G_MAXINT);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.height = _tmp51_;
#line 620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _result_;
#line 620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 3594 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result) {
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_ = {0};
	gint _tmp2_ = 0;
	GdkRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	GdkRectangle _tmp5_ = {0};
	gint _tmp6_ = 0;
	Dimensions _tmp7_ = {0};
	gint _tmp8_ = 0;
	GdkRectangle _tmp9_ = {0};
	gint _tmp10_ = 0;
	GdkRectangle _tmp11_ = {0};
	gint _tmp12_ = 0;
	GdkRectangle _tmp13_ = {0};
	gint _tmp14_ = 0;
	GdkRectangle _tmp15_ = {0};
	gint _tmp16_ = 0;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = _tmp1_.width;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = wrt_content;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.width;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.x = (_tmp2_ / 2) - (_tmp4_ / 2);
#line 630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = _result_;
#line 630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = _tmp5_.x;
#line 630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp6_ < 0) {
#line 631 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.x = 0;
#line 3642 "Dimensions.c"
	}
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = (*self).viewport_dimensions;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.height;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = wrt_content;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.height;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.y = (_tmp8_ / 2) - (_tmp10_ / 2);
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = _result_;
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.y;
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp12_ < 0) {
#line 634 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_result_.y = 0;
#line 3662 "Dimensions.c"
	}
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = wrt_content;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.width;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.width = _tmp14_;
#line 636 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = wrt_content;
#line 636 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.height;
#line 636 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.height = _tmp16_;
#line 638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _result_;
#line 638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 3680 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result) {
	gdouble zoomed_width = 0.0;
	gint _tmp0_ = 0;
	gdouble zoomed_height = 0.0;
	gint _tmp1_ = 0;
	gdouble horiz_scale = 0.0;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gdouble vert_scale = 0.0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp8_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp9_ = {0};
	gint _tmp10_ = 0;
	GdkRectangle _tmp11_ = {0};
	gint _tmp12_ = 0;
	GdkPixbuf* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	GdkRectangle _tmp17_ = {0};
	gint _tmp18_ = 0;
	GdkRectangle _tmp19_ = {0};
	gint _tmp20_ = 0;
	GdkPixbuf* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gint right = 0;
	GdkRectangle _tmp25_ = {0};
	gint _tmp26_ = 0;
	GdkRectangle _tmp27_ = {0};
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	GdkPixbuf* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gint bottom = 0;
	GdkRectangle _tmp34_ = {0};
	gint _tmp35_ = 0;
	GdkRectangle _tmp36_ = {0};
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	GdkPixbuf* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	GdkRectangle _tmp44_ = {0};
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	GdkRectangle _tmp47_ = {0};
	gint _tmp48_ = 0;
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_if_fail (for_pixbuf != NULL);
#line 643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_width = (gdouble) _tmp0_;
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoomed_height = (gdouble) _tmp1_;
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = for_pixbuf;
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_;
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	horiz_scale = _tmp4_ / zoomed_width;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = for_pixbuf;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = _tmp6_;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	vert_scale = _tmp7_ / zoomed_height;
#line 648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp8_);
#line 650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	viewing_rectangle = _tmp8_;
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = viewing_rectangle;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.x;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.x = (gint) (_tmp10_ * scale);
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = _result_;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.x;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = for_pixbuf;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = _tmp14_;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = CLAMP (_tmp12_, 0, _tmp15_);
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.x = _tmp16_;
#line 655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp17_ = viewing_rectangle;
#line 655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp18_ = _tmp17_.y;
#line 655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.y = (gint) (_tmp18_ * scale);
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp19_ = _result_;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp20_ = _tmp19_.y;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp21_ = for_pixbuf;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp22_ = gdk_pixbuf_get_height (_tmp21_);
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp23_ = _tmp22_;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = CLAMP (_tmp20_, 0, _tmp23_);
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.y = _tmp24_;
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = viewing_rectangle;
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = _tmp25_.x;
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = viewing_rectangle;
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp28_ = _tmp27_.width;
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	right = (gint) ((_tmp26_ + _tmp28_) * scale);
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp29_ = right;
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp30_ = for_pixbuf;
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp31_ = gdk_pixbuf_get_width (_tmp30_);
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp32_ = _tmp31_;
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp33_ = CLAMP (_tmp29_, 0, _tmp32_);
#line 658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	right = _tmp33_;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp34_ = viewing_rectangle;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp35_ = _tmp34_.y;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp36_ = viewing_rectangle;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp37_ = _tmp36_.height;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	bottom = (gint) ((_tmp35_ + _tmp37_) * scale);
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp38_ = bottom;
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp39_ = for_pixbuf;
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp40_ = gdk_pixbuf_get_height (_tmp39_);
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp41_ = _tmp40_;
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp42_ = CLAMP (_tmp38_, 0, _tmp41_);
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	bottom = _tmp42_;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp43_ = right;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp44_ = _result_;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp45_ = _tmp44_.x;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.width = _tmp43_ - _tmp45_;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp46_ = bottom;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp47_ = _result_;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp48_ = _tmp47_.y;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_result_.height = _tmp46_ - _tmp48_;
#line 664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _result_;
#line 664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 3881 "Dimensions.c"
}


gdouble zoom_state_get_zoom_factor (ZoomState *self) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 3894 "Dimensions.c"
}


gint zoom_state_get_zoomed_width (ZoomState *self) {
	gint result = 0;
	Dimensions _tmp0_ = {0};
	gint _tmp1_ = 0;
	gdouble _tmp2_ = 0.0;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 3913 "Dimensions.c"
}


gint zoom_state_get_zoomed_height (ZoomState *self) {
	gint result = 0;
	Dimensions _tmp0_ = {0};
	gint _tmp1_ = 0;
	gdouble _tmp2_ = 0.0;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.height;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 3932 "Dimensions.c"
}


void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result) {
	GdkPoint _tmp0_ = {0};
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	*result = _tmp0_;
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return;
#line 3944 "Dimensions.c"
}


gchar* zoom_state_to_string (ZoomState *self) {
	gchar* result = NULL;
	gchar* named_modes = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp21_ = NULL;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp23_ = {0};
	Dimensions _tmp24_ = {0};
	gint _tmp25_ = 0;
	Dimensions _tmp26_ = {0};
	gint _tmp27_ = 0;
	Dimensions _tmp28_ = {0};
	gint _tmp29_ = 0;
	Dimensions _tmp30_ = {0};
	gint _tmp31_ = 0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gint _tmp35_ = 0;
	gint _tmp36_ = 0;
	const gchar* _tmp37_ = NULL;
	GdkRectangle _tmp38_ = {0};
	gint _tmp39_ = 0;
	GdkRectangle _tmp40_ = {0};
	gint _tmp41_ = 0;
	GdkRectangle _tmp42_ = {0};
	gint _tmp43_ = 0;
	GdkRectangle _tmp44_ = {0};
	gint _tmp45_ = 0;
	GdkPoint _tmp46_ = {0};
	gint _tmp47_ = 0;
	GdkPoint _tmp48_ = {0};
	gint _tmp49_ = 0;
	gchar* _tmp50_ = NULL;
#line 685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	named_modes = _tmp0_;
#line 686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_is_min (&(*self));
#line 686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp1_) {
#line 3994 "Dimensions.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp3_, "") == 0) {
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = "MIN";
#line 4005 "Dimensions.c"
		} else {
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp2_ = ", MIN";
#line 4009 "Dimensions.c"
		}
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp4_ = named_modes;
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp5_ = g_strconcat (_tmp4_, _tmp2_, NULL);
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 687 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		named_modes = _tmp5_;
#line 4019 "Dimensions.c"
	}
#line 688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = zoom_state_is_default (&(*self));
#line 688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp6_) {
#line 4025 "Dimensions.c"
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp8_ = named_modes;
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp8_, "") == 0) {
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = "DEFAULT";
#line 4036 "Dimensions.c"
		} else {
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp7_ = ", DEFAULT";
#line 4040 "Dimensions.c"
		}
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp9_ = named_modes;
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp10_ = g_strconcat (_tmp9_, _tmp7_, NULL);
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		named_modes = _tmp10_;
#line 4050 "Dimensions.c"
	}
#line 690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = zoom_state_is_isomorphic (&(*self));
#line 690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp11_) {
#line 4056 "Dimensions.c"
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp13_ = named_modes;
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp13_, "") == 0) {
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp12_ = "ISOMORPHIC";
#line 4067 "Dimensions.c"
		} else {
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp12_ = ", ISOMORPHIC";
#line 4071 "Dimensions.c"
		}
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp14_ = named_modes;
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp15_ = g_strconcat (_tmp14_, _tmp12_, NULL);
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		named_modes = _tmp15_;
#line 4081 "Dimensions.c"
	}
#line 692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = zoom_state_is_max (&(*self));
#line 692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp16_) {
#line 4087 "Dimensions.c"
		const gchar* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp18_ = named_modes;
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp18_, "") == 0) {
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp17_ = "MAX";
#line 4098 "Dimensions.c"
		} else {
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
			_tmp17_ = ", MAX";
#line 4102 "Dimensions.c"
		}
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp19_ = named_modes;
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp20_ = g_strconcat (_tmp19_, _tmp17_, NULL);
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		named_modes = _tmp20_;
#line 4112 "Dimensions.c"
	}
#line 694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp21_ = named_modes;
#line 694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (g_strcmp0 (_tmp21_, "") == 0) {
#line 4118 "Dimensions.c"
		gchar* _tmp22_ = NULL;
#line 695 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_tmp22_ = g_strdup ("(none)");
#line 695 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 695 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		named_modes = _tmp22_;
#line 4126 "Dimensions.c"
	}
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp23_);
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	viewing_rect = _tmp23_;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = (*self).content_dimensions;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp25_ = _tmp24_.width;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp26_ = (*self).content_dimensions;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp27_ = _tmp26_.height;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp28_ = (*self).viewport_dimensions;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp29_ = _tmp28_.width;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp30_ = (*self).viewport_dimensions;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp31_ = _tmp30_.height;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp32_ = (*self).min_factor;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp33_ = (*self).max_factor;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp34_ = (*self).zoom_factor;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp35_ = zoom_state_get_zoomed_width (&(*self));
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp36_ = zoom_state_get_zoomed_height (&(*self));
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp37_ = named_modes;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp38_ = viewing_rect;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp39_ = _tmp38_.x;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp40_ = viewing_rect;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp41_ = _tmp40_.y;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp42_ = viewing_rect;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp43_ = _tmp42_.width;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp44_ = viewing_rect;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp45_ = _tmp44_.height;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp46_ = (*self).viewport_center;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp47_ = _tmp46_.x;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp48_ = (*self).viewport_center;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp49_ = _tmp48_.y;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp50_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp25_, _tmp27_, _tmp29_, _tmp31_, _tmp32_, _tmp33_, _tmp34_, _tmp35_, _tmp36_, _tmp37_, _tmp39_, _tmp41_, _tmp43_, _tmp45_, _tmp47_, _tmp49_);
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp50_;
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_g_free0 (named_modes);
#line 699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4192 "Dimensions.c"
}


gboolean zoom_state_is_min (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).min_factor;
#line 711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4208 "Dimensions.c"
}


gboolean zoom_state_is_default (ZoomState *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_is_min (&(*self));
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4221 "Dimensions.c"
}


gboolean zoom_state_is_max (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = (*self).max_factor;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4237 "Dimensions.c"
}


gboolean zoom_state_is_isomorphic (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
#line 723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = _tmp0_ == 1.0;
#line 723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4250 "Dimensions.c"
}


gboolean zoom_state_equals (ZoomState *self, ZoomState* other) {
	gboolean result = FALSE;
	ZoomState _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	ZoomState _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	gdouble _tmp6_ = 0.0;
	ZoomState _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	ZoomState _tmp10_ = {0};
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	ZoomState _tmp13_ = {0};
	gdouble _tmp14_ = 0.0;
	GdkPoint _tmp15_ = {0};
	gint _tmp16_ = 0;
	ZoomState _tmp17_ = {0};
	GdkPoint _tmp18_ = {0};
	gint _tmp19_ = 0;
	GdkPoint _tmp20_ = {0};
	gint _tmp21_ = 0;
	ZoomState _tmp22_ = {0};
	GdkPoint _tmp23_ = {0};
	gint _tmp24_ = 0;
#line 726 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp0_ = *other;
#line 727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp2_ = dimensions_equals (&(*self).content_dimensions, &_tmp1_);
#line 727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (!_tmp2_) {
#line 728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4295 "Dimensions.c"
	}
#line 729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp3_ = *other;
#line 729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.viewport_dimensions;
#line 729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp5_ = dimensions_equals (&(*self).viewport_dimensions, &_tmp4_);
#line 729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (!_tmp5_) {
#line 730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4309 "Dimensions.c"
	}
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp6_ = (*self).zoom_factor;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp7_ = *other;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.zoom_factor;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp6_ != _tmp8_) {
#line 732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4323 "Dimensions.c"
	}
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp9_ = (*self).min_factor;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp10_ = *other;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp11_ = _tmp10_.min_factor;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp9_ != _tmp11_) {
#line 734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4337 "Dimensions.c"
	}
#line 735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp12_ = (*self).max_factor;
#line 735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp13_ = *other;
#line 735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.max_factor;
#line 735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp12_ != _tmp14_) {
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4351 "Dimensions.c"
	}
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp15_ = (*self).viewport_center;
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.x;
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp17_ = *other;
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp18_ = _tmp17_.viewport_center;
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp19_ = _tmp18_.x;
#line 737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp16_ != _tmp19_) {
#line 738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4369 "Dimensions.c"
	}
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp20_ = (*self).viewport_center;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp21_ = _tmp20_.y;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp22_ = *other;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp23_ = _tmp22_.viewport_center;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	_tmp24_ = _tmp23_.y;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	if (_tmp21_ != _tmp24_) {
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		result = FALSE;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
		return result;
#line 4387 "Dimensions.c"
	}
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	result = TRUE;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return result;
#line 4393 "Dimensions.c"
}


ZoomState* zoom_state_dup (const ZoomState* self) {
	ZoomState* dup;
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	return dup;
#line 4405 "Dimensions.c"
}


void zoom_state_free (ZoomState* self) {
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Dimensions.vala"
	g_free (self);
#line 4412 "Dimensions.c"
}


GType zoom_state_get_type (void) {
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}



