/* Photo.c generated by valac 0.34.4, the Vala compiler
 * generated from Photo.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	gboolean enhanced;
	GeeHashMap* original_transforms;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	GeeHashMap* original_transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gboolean enhanced;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface* photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_row (GValue* value, gpointer v_object);
void value_take_photo_row (GValue* value, gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_photo_row (GValue* value, gpointer v_object);
void value_take_backing_photo_row (GValue* value, gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoRow* state, GError** error);
void photo_table_update_raw_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, BackingPhotoID* backing_photo_id, GError** error);
static void photo_develop_photo (Photo* self, RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self, const gchar* raw_filepath, const gchar* camera_development_filename, GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
void photo_set_default_raw_developer (Photo* self, RawDeveloper d);
void photo_set_raw_developer (Photo* self, RawDeveloper d);
void photo_populate_prefetched (Photo* self, GError** error);
void photo_revert_to_master (Photo* self, gboolean notify);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
gboolean photo_discard_prefetched (Photo* self, gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, GError** error);
void photo_redevelop_raw (Photo* self, RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type, BackingPhotoRow* photo_row, const gchar* md5);
static void _vala_array_add97 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add98 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add99 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add100 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add101 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add102 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add103 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add104 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self, BackingPhotoRow* from);
static void _vala_array_add105 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add106 (gchar*** array, int* length, int* size, gchar* value);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoRow* row, GError** error);
void media_source_set_title (MediaSource* self, const gchar* title);
gboolean media_source_set_comment (MediaSource* self, const gchar* comment);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add107 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add108 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add109 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add110 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add111 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add112 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add113 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
gboolean photo_is_enhanced (Photo* self);
void photo_set_enhanced (Photo* self, gboolean enhanced);
gboolean photo_table_set_enhanced (PhotoTable* self, PhotoID* photo_id, gboolean enhanced);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self, PhotoID* photo_id, const gchar* new_comment);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error);
void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void dateable_set_exposure_time (Dateable* self, time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self, gdouble* theta);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop, PhotoException exceptions);
void box_get_dimensions (Box *self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
static KeyValueMap* photo_get_color_adjustments_map (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations, GeeHashMap* original_transforms, gboolean enhanced);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
static gboolean photo_set_original_transforms (Photo* self, KeyValueMap* trans);
gboolean photo_table_set_original_transforms (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
static gboolean photo_clear_original_transforms (Photo* self);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self, Box* crop);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
static void photo_set_raw_crop (Photo* self, Box* crop);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def);
static void photo_set_raw_straighten (Photo* self, gdouble theta);
void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE _ ("Photos")
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, const gchar* commandline, GError** error);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self, const gchar* external_editor, GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
void configuration_facade_set_external_raw_app (ConfigurationFacade* self, const gchar* external_raw_app);
void photo_open_with_external_editor (Photo* self, const gchar* external_editor, GError** error);
GFile* photo_get_modified_file (Photo* self, GError** error);
void configuration_facade_set_external_photo_app (ConfigurationFacade* self, const gchar* external_photo_app);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
static void _vala_array_add114 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add115 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add116 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add117 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add118 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add119 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_set_straighten (Photo* self, gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
gboolean photo_unenhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_BACKING_READERS_DUMMY_PROPERTY
};
static void photo_backing_readers_finalize (PhotoBackingReaders* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup7 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_DUMMY_PROPERTY
};
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DUMMY_PROPERTY
};
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_DUMMY_PROPERTY
};
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj);
static void photo_finalize (GObject* obj);
static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v, gpointer self);
gboolean file_equal (GFile* a, GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
gint int64_compare (gint64* a, gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a, gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self, const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self, const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result);
gint utf8_ci_compare (void* a, void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, BackingPhotoID* develop_shotwell, BackingPhotoID* develop_camera_id, BackingPhotoID* develop_embedded_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self, const gchar* name, gboolean treat_htags_as_root);
static void library_photo_finalize (GObject* obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 2819 "Photo.c"
}


static gpointer _thumbnails_ref0 (gpointer self) {
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 2826 "Photo.c"
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	ImportID _tmp4_ = {0};
	PhotoFileSnifferOptions _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	Thumbnails* _tmp12_ = NULL;
	Thumbnails* _tmp13_ = NULL;
#line 51 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 51 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->file = _tmp1_;
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = final_associated_file;
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->final_associated_file = _tmp3_;
#line 56 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = *import_id;
#line 56 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->import_id = _tmp4_;
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = sniffer_options;
#line 57 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->sniffer_options = _tmp5_;
#line 58 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = exif_md5;
#line 58 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 58 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 58 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->exif_md5 = _tmp7_;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = thumbnail_md5;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->thumbnail_md5 = _tmp9_;
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = full_md5;
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->full_md5 = _tmp11_;
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = thumbnails;
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _thumbnails_ref0 (_tmp12_);
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 61 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->thumbnails = _tmp13_;
#line 51 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 2910 "Photo.c"
}


PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
#line 51 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 2917 "Photo.c"
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	ImportID _tmp2_ = {0};
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->file = _tmp1_;
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = *import_id;
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->import_id = _tmp2_;
#line 68 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->exif_md5 = NULL;
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->full_md5 = NULL;
#line 72 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 72 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->thumbnails = NULL;
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 2964 "Photo.c"
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
#line 65 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 2971 "Photo.c"
}


static void value_photo_import_params_init (GValue* value) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 2978 "Photo.c"
}


static void value_photo_import_params_free_value (GValue* value) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 2987 "Photo.c"
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 2997 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3001 "Photo.c"
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3009 "Photo.c"
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 3016 "Photo.c"
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3023 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3027 "Photo.c"
		}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 3031 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3035 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 3039 "Photo.c"
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3050 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 3056 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 3060 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 3064 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 3068 "Photo.c"
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 3082 "Photo.c"
}


gpointer value_get_photo_import_params (const GValue* value) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3091 "Photo.c"
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 3111 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3115 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 3121 "Photo.c"
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 3140 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3144 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 3150 "Photo.c"
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 3160 "Photo.c"
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow* _tmp0_ = NULL;
#line 37 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->final_associated_file = NULL;
#line 48 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 48 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->row = _tmp0_;
#line 49 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->keywords = NULL;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 3176 "Photo.c"
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 36 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 37 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 40 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 45 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 49 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 3202 "Photo.c"
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 3227 "Photo.c"
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 34 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3240 "Photo.c"
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
#line 85 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 85 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 3251 "Photo.c"
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 88 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 89 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 3266 "Photo.c"
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
#line 82 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 3273 "Photo.c"
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3288 "Photo.c"
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 77 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 3297 "Photo.c"
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 76 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 3307 "Photo.c"
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_ = 0;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = exception;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (self & _tmp0_) != 0;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 3332 "Photo.c"
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_ = 0;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = exception;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (self & _tmp0_) == 0;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 3345 "Photo.c"
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer _photo_row_ref0 (gpointer self) {
#line 335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 3364 "Photo.c"
}


static gpointer _backing_photo_row_ref0 (gpointer self) {
#line 356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 3371 "Photo.c"
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoRow* _tmp2_ = NULL;
	PhotoRow* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	PhotoRow* _tmp6_ = NULL;
	PhotoRow* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	PhotoBackingReaders* _tmp10_ = NULL;
	PhotoRow* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_ = NULL;
	PhotoFileFormat _tmp13_ = 0;
	PhotoRow* _tmp14_ = NULL;
	BackingPhotoRow* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	PhotoFileReader* _tmp17_ = NULL;
	gchar* basename = NULL;
	PhotoRow* _tmp18_ = NULL;
	BackingPhotoRow* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	PhotoRow* _tmp31_ = NULL;
	BackingPhotoID _tmp32_ = {0};
	gint64 _tmp33_ = 0LL;
	PhotoRow* _tmp49_ = NULL;
	BackingPhotoRow* _tmp50_ = NULL;
	PhotoFileFormat _tmp51_ = 0;
	gboolean _tmp67_ = FALSE;
	PhotoRow* _tmp68_ = NULL;
	BackingPhotoRow* _tmp69_ = NULL;
	PhotoFileFormat _tmp70_ = 0;
	PhotoBackingReaders* _tmp85_ = NULL;
	PhotoFileReader* _tmp86_ = NULL;
	PhotoRow* _tmp106_ = NULL;
	time_t _tmp107_ = 0;
	GError * _inner_error_ = NULL;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = row;
#line 335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->row = _tmp1_;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = self->row;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = self->row;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_->title;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = media_source_prep_title (_tmp4_);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp2_->title);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_->title = _tmp5_;
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = self->row;
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = self->row;
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_->comment;
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = media_source_prep_comment (_tmp8_);
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp6_->comment);
#line 339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_->comment = _tmp9_;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = self->priv->readers;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = row;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = _tmp11_->master;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_->file_format;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = row;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = photo_file_format_create_reader (_tmp13_, _tmp16_);
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_->master);
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_->master = _tmp17_;
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = row;
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_->master;
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = _tmp19_->filepath;
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = string_sliced_at_last_char (_tmp20_, (gunichar) G_DIR_SEPARATOR, 0);
#line 346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	basename = _tmp21_;
#line 347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = basename;
#line 347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 3488 "Photo.c"
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = basename;
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = string_sliced_at (_tmp23_, 1);
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 3499 "Photo.c"
	}
#line 350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = self->priv->file_title;
#line 350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = is_string_empty (_tmp25_);
#line 350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp26_) {
#line 3507 "Photo.c"
		PhotoRow* _tmp27_ = NULL;
		BackingPhotoRow* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp27_ = row;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp28_ = _tmp27_->master;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_ = _tmp28_->filepath;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = g_strdup (_tmp29_);
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		self->priv->file_title = _tmp30_;
#line 3524 "Photo.c"
	}
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = row;
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp31_->editable_id;
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = _tmp32_.id;
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp33_ != BACKING_PHOTO_ID_INVALID) {
#line 3534 "Photo.c"
		BackingPhotoRow* e = NULL;
		PhotoRow* _tmp34_ = NULL;
		BackingPhotoID _tmp35_ = {0};
		BackingPhotoRow* _tmp36_ = NULL;
		BackingPhotoRow* _tmp37_ = NULL;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp34_ = row;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp35_ = _tmp34_->editable_id;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = photo_get_backing_row (self, &_tmp35_);
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		e = _tmp36_;
#line 355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = e;
#line 355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp37_ != NULL) {
#line 3552 "Photo.c"
			BackingPhotoRow* _tmp38_ = NULL;
			BackingPhotoRow* _tmp39_ = NULL;
			PhotoBackingReaders* _tmp40_ = NULL;
			BackingPhotoRow* _tmp41_ = NULL;
			PhotoFileFormat _tmp42_ = 0;
			BackingPhotoRow* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
			PhotoFileReader* _tmp45_ = NULL;
#line 356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = e;
#line 356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = _backing_photo_row_ref0 (_tmp38_);
#line 356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->priv->editable = _tmp39_;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = self->priv->readers;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp41_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = _tmp41_->file_format;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp43_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp44_ = _tmp43_->filepath;
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp45_ = photo_file_format_create_reader (_tmp42_, _tmp44_);
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp40_->editable);
#line 357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_->editable = _tmp45_;
#line 3585 "Photo.c"
		} else {
			{
				PhotoTable* _tmp46_ = NULL;
				PhotoTable* _tmp47_ = NULL;
				PhotoRow* _tmp48_ = NULL;
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = photo_table_get_instance ();
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = self->row;
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_detach_editable (_tmp47_, _tmp48_, &_inner_error_);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp47_);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3605 "Photo.c"
						goto __catch114_database_error;
					}
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (basename);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return NULL;
#line 3618 "Photo.c"
				}
			}
			goto __finally114;
			__catch114_database_error:
			{
				GError* err = NULL;
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				err = _inner_error_;
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3631 "Photo.c"
			}
			__finally114:
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (basename);
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return NULL;
#line 3646 "Photo.c"
			}
#line 367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 3650 "Photo.c"
		}
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 3654 "Photo.c"
	}
#line 371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp49_ = row;
#line 371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = _tmp49_->master;
#line 371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = _tmp50_->file_format;
#line 371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp51_ == PHOTO_FILE_FORMAT_RAW) {
#line 3664 "Photo.c"
		GeeHashMap* _tmp52_ = NULL;
		gint _tmp53_ = 0;
		RawDeveloper* _tmp54_ = NULL;
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 373 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		self->priv->developments = _tmp52_;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp54_ = raw_developer_as_array (&_tmp53_);
#line 3676 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection = _tmp54_;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection_length1 = _tmp53_;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			for (d_it = 0; d_it < _tmp53_; d_it = d_it + 1) {
#line 3688 "Photo.c"
				RawDeveloper d = 0;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				d = d_collection[d_it];
#line 3692 "Photo.c"
				{
					BackingPhotoID id = {0};
					PhotoRow* _tmp55_ = NULL;
					BackingPhotoID* _tmp56_ = NULL;
					gint _tmp56__length1 = 0;
					RawDeveloper _tmp57_ = 0;
					BackingPhotoID _tmp58_ = {0};
					BackingPhotoID _tmp59_ = {0};
					gint64 _tmp60_ = 0LL;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp55_ = row;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp56_ = _tmp55_->development_ids;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp56__length1 = _tmp55_->development_ids_length1;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp57_ = d;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp58_ = _tmp56_[_tmp57_];
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					id = _tmp58_;
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp59_ = id;
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp60_ = _tmp59_.id;
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp60_ != BACKING_PHOTO_ID_INVALID) {
#line 3720 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp61_ = {0};
						BackingPhotoRow* _tmp62_ = NULL;
						BackingPhotoRow* _tmp63_ = NULL;
#line 377 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp61_ = id;
#line 377 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp62_ = photo_get_backing_row (self, &_tmp61_);
#line 377 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						bpr = _tmp62_;
#line 378 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp63_ = bpr;
#line 378 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp63_ != NULL) {
#line 3735 "Photo.c"
							GeeHashMap* _tmp64_ = NULL;
							RawDeveloper _tmp65_ = 0;
							BackingPhotoRow* _tmp66_ = NULL;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp64_ = self->priv->developments;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp65_ = d;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp66_ = bpr;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) _tmp65_), _tmp66_);
#line 3747 "Photo.c"
						}
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 3751 "Photo.c"
					}
				}
			}
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 3757 "Photo.c"
		}
	}
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp68_ = row;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp69_ = _tmp68_->master;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp70_ = _tmp69_->file_format;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp70_ == PHOTO_FILE_FORMAT_RAW) {
#line 3768 "Photo.c"
		GeeHashMap* _tmp71_ = NULL;
		PhotoRow* _tmp72_ = NULL;
		RawDeveloper _tmp73_ = 0;
		gboolean _tmp74_ = FALSE;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp71_ = self->priv->developments;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp72_ = row;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp73_ = _tmp72_->developer;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp74_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp71_, (gpointer) ((gintptr) _tmp73_));
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp67_ = _tmp74_;
#line 3783 "Photo.c"
	} else {
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp67_ = FALSE;
#line 3787 "Photo.c"
	}
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp67_) {
#line 3791 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp75_ = NULL;
		PhotoRow* _tmp76_ = NULL;
		RawDeveloper _tmp77_ = 0;
		gpointer _tmp78_ = NULL;
		PhotoBackingReaders* _tmp79_ = NULL;
		BackingPhotoRow* _tmp80_ = NULL;
		PhotoFileFormat _tmp81_ = 0;
		BackingPhotoRow* _tmp82_ = NULL;
		const gchar* _tmp83_ = NULL;
		PhotoFileReader* _tmp84_ = NULL;
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp75_ = self->priv->developments;
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp76_ = row;
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp77_ = _tmp76_->developer;
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp78_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp75_, (gpointer) ((gintptr) _tmp77_));
#line 386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp78_;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp79_ = self->priv->readers;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp80_ = r;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp81_ = _tmp80_->file_format;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp82_ = r;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = _tmp82_->filepath;
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp84_ = photo_file_format_create_reader (_tmp81_, _tmp83_);
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp79_->developer);
#line 387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp79_->developer = _tmp84_;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 3831 "Photo.c"
	}
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp85_ = self->priv->readers;
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp86_ = _tmp85_->editable;
#line 391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp86_ != NULL) {
#line 3839 "Photo.c"
		BackingPhotoRow* _tmp87_ = NULL;
		BackingPhotoRow* _tmp88_ = NULL;
#line 392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp87_ = self->priv->editable;
#line 392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp88_ = _backing_photo_row_ref0 (_tmp87_);
#line 392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		self->backing_photo_row = _tmp88_;
#line 3850 "Photo.c"
	} else {
		PhotoRow* _tmp89_ = NULL;
		BackingPhotoRow* _tmp90_ = NULL;
		PhotoFileFormat _tmp91_ = 0;
#line 393 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp89_ = row;
#line 393 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp90_ = _tmp89_->master;
#line 393 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp91_ = _tmp90_->file_format;
#line 393 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp91_ != PHOTO_FILE_FORMAT_RAW) {
#line 3863 "Photo.c"
			PhotoRow* _tmp92_ = NULL;
			BackingPhotoRow* _tmp93_ = NULL;
			BackingPhotoRow* _tmp94_ = NULL;
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp92_ = self->row;
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp93_ = _tmp92_->master;
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp94_ = _backing_photo_row_ref0 (_tmp93_);
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->backing_photo_row = _tmp94_;
#line 3877 "Photo.c"
		} else {
			GeeHashMap* _tmp95_ = NULL;
			PhotoRow* _tmp96_ = NULL;
			RawDeveloper _tmp97_ = 0;
			gboolean _tmp98_ = FALSE;
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp95_ = self->priv->developments;
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp96_ = row;
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp97_ = _tmp96_->developer;
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp98_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp95_, (gpointer) ((gintptr) _tmp97_));
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp98_) {
#line 3893 "Photo.c"
				GeeHashMap* _tmp99_ = NULL;
				PhotoRow* _tmp100_ = NULL;
				RawDeveloper _tmp101_ = 0;
				gpointer _tmp102_ = NULL;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp99_ = self->priv->developments;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp100_ = row;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp101_ = _tmp100_->developer;
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp102_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) _tmp101_));
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp102_;
#line 3910 "Photo.c"
			} else {
				PhotoRow* _tmp103_ = NULL;
				BackingPhotoRow* _tmp104_ = NULL;
				BackingPhotoRow* _tmp105_ = NULL;
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp103_ = self->row;
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp104_ = _tmp103_->master;
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp105_ = _backing_photo_row_ref0 (_tmp104_);
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->backing_photo_row = _tmp105_;
#line 3925 "Photo.c"
			}
		}
	}
#line 406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp106_ = self->row;
#line 406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp107_ = _tmp106_->exposure_time;
#line 406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->cached_exposure_time = _tmp107_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (basename);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 3939 "Photo.c"
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
#line 410 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 410 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = new_file;
#line 410 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-replaced", _tmp0_, _tmp1_);
#line 3952 "Photo.c"
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 3961 "Photo.c"
}


static void photo_real_notify_raw_development_modified (Photo* self) {
#line 414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "raw-development-modified");
#line 3968 "Photo.c"
}


void photo_notify_raw_development_modified (Photo* self) {
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 3977 "Photo.c"
}


static void photo_real_notify_baseline_replaced (Photo* self) {
#line 418 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-replaced");
#line 3984 "Photo.c"
}


void photo_notify_baseline_replaced (Photo* self) {
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 3993 "Photo.c"
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_);
#line 4003 "Photo.c"
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 4012 "Photo.c"
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_);
#line 4022 "Photo.c"
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 4031 "Photo.c"
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_);
#line 4041 "Photo.c"
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 4050 "Photo.c"
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_);
#line 4060 "Photo.c"
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 4069 "Photo.c"
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	PhotoFileFormat _tmp7_ = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GError * _inner_error_ = NULL;
#line 437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ret = TRUE;
#line 439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = NULL;
#line 4089 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 4096 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 4106 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				file = _tmp5_;
#line 4120 "Photo.c"
			}
		}
		__finally115:
		{
			PhotoBackingReaders* _tmp6_ = NULL;
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4130 "Photo.c"
		}
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 4140 "Photo.c"
		}
	}
#line 445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = photo_get_master_file_format (self);
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_ == PHOTO_FILE_FORMAT_RAW) {
#line 4149 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_ = NULL;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 4154 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection = _tmp9_;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 4166 "Photo.c"
				RawDeveloper d = 0;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				d = d_collection[d_it];
#line 4170 "Photo.c"
				{
					RawDeveloper _tmp10_ = 0;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = d;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 4177 "Photo.c"
				}
			}
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4182 "Photo.c"
		}
	}
#line 453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_delete_original_file ((MediaSource*) self);
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_inner_error_);
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = _tmp13_;
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 4199 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_) {
#line 4203 "Photo.c"
		gboolean _tmp14_ = FALSE;
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = ret;
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp14_;
#line 4209 "Photo.c"
	} else {
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = FALSE;
#line 4213 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp11_;
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 4221 "Photo.c"
}


static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id) {
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = *id;
#line 462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 4246 "Photo.c"
	}
#line 465 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing_row = NULL;
#line 4250 "Photo.c"
	{
		BackingPhotoRow* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_ = NULL;
		BackingPhotoTable* _tmp4_ = NULL;
		BackingPhotoID _tmp5_ = {0};
		BackingPhotoRow* _tmp6_ = NULL;
		BackingPhotoRow* _tmp7_ = NULL;
		BackingPhotoRow* _tmp8_ = NULL;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = *id;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = backing_photo_table_fetch (_tmp4_, &_tmp5_, &_inner_error_);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp7_;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 4277 "Photo.c"
				goto __catch116_database_error;
			}
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 4288 "Photo.c"
		}
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = _tmp2_;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = NULL;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		backing_row = _tmp8_;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp2_);
#line 4300 "Photo.c"
	}
	goto __finally116;
	__catch116_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = data_object_to_string ((DataObject*) self);
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = err;
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:469: Unable to fetch backing state for %s: %s", _tmp10_, _tmp12_);
#line 469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 4328 "Photo.c"
	}
	__finally116:
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 4341 "Photo.c"
	}
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = backing_row;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 4347 "Photo.c"
		{
			BackingPhotoTable* _tmp14_ = NULL;
			BackingPhotoTable* _tmp15_ = NULL;
			BackingPhotoID _tmp16_ = {0};
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = *id;
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_photo_table_remove (_tmp15_, &_tmp16_, &_inner_error_);
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 4366 "Photo.c"
					goto __catch117_database_error;
				}
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return NULL;
#line 4377 "Photo.c"
			}
		}
		goto __finally117;
		__catch117_database_error:
		{
			GError* err = NULL;
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 4390 "Photo.c"
		}
		__finally117:
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 4403 "Photo.c"
		}
#line 478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 4411 "Photo.c"
	}
#line 481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = backing_row;
#line 481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 4417 "Photo.c"
}


gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4426 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4433 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_ = NULL;
			RawDeveloper _tmp3_ = 0;
			gboolean _tmp4_ = FALSE;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = d;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) _tmp3_));
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp4_) {
#line 4447 "Photo.c"
				GeeHashMap* _tmp5_ = NULL;
				RawDeveloper _tmp6_ = 0;
				gpointer _tmp7_ = NULL;
				BackingPhotoRow* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = self->priv->developments;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = d;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) _tmp6_));
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = (BackingPhotoRow*) _tmp7_;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_->filepath;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp10_;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp8_);
#line 4470 "Photo.c"
			} else {
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 4474 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 4478 "Photo.c"
			{
				GeeHashMap* _tmp11_ = NULL;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4485 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 4489 "Photo.c"
		}
		__finally118:
		{
			GeeHashMap* _tmp12_ = NULL;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4498 "Photo.c"
		}
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 4506 "Photo.c"
	}
}


gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	RawDeveloper _tmp6_ = 0;
	GError * _inner_error_ = NULL;
#line 494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4517 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4524 "Photo.c"
		{
			GeeHashMap* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
			gboolean _tmp3_ = FALSE;
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = d;
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) _tmp2_));
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_) {
#line 497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = TRUE;
#line 4539 "Photo.c"
				{
					GeeHashMap* _tmp4_ = NULL;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4546 "Photo.c"
				}
#line 497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 4550 "Photo.c"
			}
		}
		__finally119:
		{
			GeeHashMap* _tmp5_ = NULL;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4560 "Photo.c"
		}
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 4570 "Photo.c"
		}
	}
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = d;
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp6_) {
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 4579 "Photo.c"
		{
#line 502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = TRUE;
#line 502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 4585 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 4589 "Photo.c"
		{
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = FALSE;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 4595 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 4599 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp7_ = NULL;
				guint num_previews = 0U;
				PhotoMetadata* _tmp8_ = NULL;
				guint _tmp9_ = 0U;
				guint _tmp10_ = 0U;
#line 509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = photo_get_master_metadata (self, &_inner_error_);
#line 509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				meta = _tmp7_;
#line 509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4614 "Photo.c"
					goto __catch120_g_error;
				}
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = meta;
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo_metadata_get_preview_count (_tmp8_);
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				num_previews = _tmp9_;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = num_previews;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp10_ > ((guint) 0)) {
#line 4627 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp11_ = NULL;
					guint _tmp12_ = 0U;
					PhotoPreview* _tmp13_ = NULL;
					PhotoPreview* _tmp14_ = NULL;
					Dimensions dims = {0};
					PhotoPreview* _tmp15_ = NULL;
					Dimensions _tmp16_ = {0};
					gint _tmp17_ = 0;
					Dimensions _tmp18_ = {0};
					gint _tmp19_ = 0;
					Dimensions _tmp20_ = {0};
					gint _tmp21_ = 0;
					gint preview_major_axis = 0;
					gint _tmp26_ = 0;
#line 513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = meta;
#line 513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = num_previews;
#line 513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_ = photo_metadata_get_preview (_tmp11_, _tmp12_ - 1);
#line 513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					prev = _tmp13_;
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = prev;
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp14_ == NULL) {
#line 517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						result = FALSE;
#line 517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return result;
#line 4663 "Photo.c"
					}
#line 519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = prev;
#line 519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp15_, &_tmp16_);
#line 519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					dims = _tmp16_;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = dims;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = _tmp18_.width;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp20_ = dims;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp21_ = _tmp20_.height;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp19_ > _tmp21_) {
#line 4681 "Photo.c"
						Dimensions _tmp22_ = {0};
						gint _tmp23_ = 0;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp22_ = dims;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp23_ = _tmp22_.width;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp17_ = _tmp23_;
#line 4690 "Photo.c"
					} else {
						Dimensions _tmp24_ = {0};
						gint _tmp25_ = 0;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp24_ = dims;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp25_ = _tmp24_.height;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp17_ = _tmp25_;
#line 4700 "Photo.c"
					}
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					preview_major_axis = _tmp17_;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp26_ = preview_major_axis;
#line 523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp26_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						result = FALSE;
#line 524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return result;
#line 4716 "Photo.c"
					}
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					result = TRUE;
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return result;
#line 4726 "Photo.c"
				}
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = FALSE;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 4734 "Photo.c"
			}
			goto __finally120;
			__catch120_g_error:
			{
				GError* e = NULL;
				GError* _tmp27_ = NULL;
				const gchar* _tmp28_ = NULL;
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				e = _inner_error_;
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = e;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = _tmp27_->message;
#line 533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_debug ("Photo.vala:533: Error accessing embedded preview. Message: %s", _tmp28_);
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (e);
#line 4754 "Photo.c"
			}
			__finally120:
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return FALSE;
#line 4765 "Photo.c"
			}
#line 535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = FALSE;
#line 535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 4771 "Photo.c"
		}
		default:
		{
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_assert_not_reached ();
#line 4777 "Photo.c"
		}
	}
}


void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	PhotoRow* _tmp0_ = NULL;
	RawDeveloper _tmp1_ = 0;
	BackingPhotoRow* _tmp2_ = NULL;
	Alteration* _tmp8_ = NULL;
	Alteration* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
#line 545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = d;
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = bpr;
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 4808 "Photo.c"
	}
	{
		GeeHashMap* _tmp3_ = NULL;
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4816 "Photo.c"
		{
			GeeHashMap* _tmp4_ = NULL;
			RawDeveloper _tmp5_ = 0;
			BackingPhotoRow* _tmp6_ = NULL;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = d;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = bpr;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp5_), _tmp6_);
#line 4829 "Photo.c"
		}
		__finally121:
		{
			GeeHashMap* _tmp7_ = NULL;
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4838 "Photo.c"
		}
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 4846 "Photo.c"
		}
	}
#line 550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = alteration_new ("image", "developer");
#line 550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp9_);
#line 550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp9_);
#line 4857 "Photo.c"
}


void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	GFile* file = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileInfo* info = NULL;
	GFile* _tmp3_ = NULL;
	GFileInfo* _tmp4_ = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp5_ = NULL;
	GTimeVal _tmp6_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp7_ = NULL;
	PhotoFileInterrogator* _tmp8_ = NULL;
	PhotoFileInterrogator* _tmp9_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp10_ = NULL;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_ = NULL;
	DetectedPhotoInformation* _tmp13_ = NULL;
	Dimensions _tmp14_ = {0};
	BackingPhotoRow* _tmp15_ = NULL;
	GFileInfo* _tmp16_ = NULL;
	gint64 _tmp17_ = 0LL;
	BackingPhotoRow* _tmp18_ = NULL;
	GTimeVal _tmp19_ = {0};
	glong _tmp20_ = 0L;
	Orientation _tmp21_ = 0;
	DetectedPhotoInformation* _tmp22_ = NULL;
	PhotoMetadata* _tmp23_ = NULL;
	BackingPhotoRow* _tmp27_ = NULL;
	BackingPhotoTable* _tmp28_ = NULL;
	BackingPhotoTable* _tmp29_ = NULL;
	BackingPhotoRow* _tmp30_ = NULL;
	PhotoTable* _tmp31_ = NULL;
	PhotoTable* _tmp32_ = NULL;
	PhotoRow* _tmp33_ = NULL;
	RawDeveloper _tmp34_ = 0;
	BackingPhotoRow* _tmp35_ = NULL;
	BackingPhotoID _tmp36_ = {0};
	GError * _inner_error_ = NULL;
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (row != NULL);
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = bpr;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->filepath;
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp2_;
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = file;
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	info = _tmp4_;
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 4928 "Photo.c"
	}
#line 558 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = info;
#line 558 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 558 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	timestamp = _tmp6_;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = file;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (_tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	interrogator = _tmp8_;
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = interrogator;
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error_);
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 4958 "Photo.c"
	}
#line 564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = interrogator;
#line 564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp11_;
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = bpr;
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = detected;
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = _tmp13_->image_dim;
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_->dim = _tmp14_;
#line 566 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = bpr;
#line 566 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = info;
#line 566 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = g_file_info_get_size (_tmp16_);
#line 566 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_->filesize = _tmp17_;
#line 567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = bpr;
#line 567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = timestamp;
#line 567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = _tmp19_.tv_sec;
#line 567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_->timestamp = (time_t) _tmp20_;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = detected;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = _tmp22_->metadata;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 4996 "Photo.c"
		DetectedPhotoInformation* _tmp24_ = NULL;
		PhotoMetadata* _tmp25_ = NULL;
		Orientation _tmp26_ = 0;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = detected;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = photo_metadata_get_orientation (_tmp25_);
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = _tmp26_;
#line 5008 "Photo.c"
	} else {
#line 569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = ORIENTATION_TOP_LEFT;
#line 5012 "Photo.c"
	}
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = bpr;
#line 568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_->original_orientation = _tmp21_;
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = backing_photo_table_get_instance ();
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = _tmp28_;
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = bpr;
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing_photo_table_add (_tmp29_, _tmp30_, &_inner_error_);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp29_);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 5042 "Photo.c"
	}
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = photo_table_get_instance ();
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = row;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = d;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = bpr;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_->id;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_table_update_raw_development (_tmp32_, _tmp33_, _tmp34_, &_tmp36_, &_inner_error_);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp32_);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 5074 "Photo.c"
	}
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 5084 "Photo.c"
}


static void photo_develop_photo (Photo* self, RawDeveloper d) {
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	RawDeveloper _tmp0_ = 0;
	GError * _inner_error_ = NULL;
#line 578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	bps = NULL;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = d;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp0_) {
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5105 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp1_ = NULL;
				RawDeveloper _tmp2_ = 0;
				PhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				BackingPhotoRow* _tmp6_ = NULL;
				BackingPhotoRow* _tmp7_ = NULL;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp14_ = NULL;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				PhotoFileWriter* _tmp22_ = NULL;
				PhotoFileWriter* _tmp23_ = NULL;
				GdkPixbuf* _tmp24_ = NULL;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp25_ = NULL;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				PhotoFileMetadataWriter* _tmp28_ = NULL;
				PhotoFileMetadataWriter* _tmp29_ = NULL;
				PhotoMetadata* _tmp30_ = NULL;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp2_ = d;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->filepath;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = raw_developer_create_backing_row_for_development (_tmp2_, _tmp5_, NULL, &_inner_error_);
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5145 "Photo.c"
					goto __catch122_g_error;
				}
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp1_;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				bps = _tmp7_;
#line 587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				pix = NULL;
#line 5158 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_ = NULL;
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5165 "Photo.c"
					{
						GdkPixbuf* _tmp9_ = NULL;
						Scaling _tmp10_ = {0};
						GdkPixbuf* _tmp11_ = NULL;
						GdkPixbuf* _tmp12_ = NULL;
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						scaling_for_original (&_tmp10_);
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp11_ = photo_get_master_pixbuf (self, &_tmp10_, FALSE, &_inner_error_);
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp9_ = _tmp11_;
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5179 "Photo.c"
							goto __finally123;
						}
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp12_ = _tmp9_;
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp9_ = NULL;
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						pix = _tmp12_;
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_tmp9_);
#line 5192 "Photo.c"
					}
					__finally123:
					{
						PhotoBackingReaders* _tmp13_ = NULL;
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp13_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5201 "Photo.c"
					}
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp1_);
#line 5209 "Photo.c"
						goto __catch122_g_error;
					}
				}
#line 596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = pix;
#line 596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp14_ == NULL) {
#line 597 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_debug ("Photo.vala:597: Could not get preview pixbuf");
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5223 "Photo.c"
					{
						gboolean _tmp15_ = FALSE;
#line 622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp15_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp15_) {
#line 5230 "Photo.c"
							{
								RawDeveloper _tmp16_ = 0;
								BackingPhotoRow* _tmp17_ = NULL;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp16_ = d;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp17_ = bps;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp16_, _tmp17_, &_inner_error_);
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5242 "Photo.c"
									goto __catch124_g_error;
								}
#line 627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5247 "Photo.c"
							}
							goto __finally124;
							__catch124_g_error:
							{
								GError* e = NULL;
								GError* _tmp18_ = NULL;
								const gchar* _tmp19_ = NULL;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								e = _inner_error_;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp18_ = e;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp19_ = _tmp18_->message;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp19_);
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5267 "Photo.c"
							}
							__finally124:
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5272 "Photo.c"
								goto __catch122_g_error;
							}
						}
					}
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 5281 "Photo.c"
				}
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = bps;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = _tmp20_->filepath;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp21_, &_inner_error_);
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				writer = _tmp22_;
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5297 "Photo.c"
					goto __catch122_g_error;
				}
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = writer;
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = pix;
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_file_writer_write (_tmp23_, _tmp24_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5314 "Photo.c"
					goto __catch122_g_error;
				}
#line 611 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = photo_get_master_metadata (self, &_inner_error_);
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				meta = _tmp25_;
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5331 "Photo.c"
					goto __catch122_g_error;
				}
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = bps;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = _tmp26_->filepath;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp27_, &_inner_error_);
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				mwriter = _tmp28_;
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 617 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5352 "Photo.c"
					goto __catch122_g_error;
				}
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = mwriter;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = meta;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp29_, _tmp30_, &_inner_error_);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5373 "Photo.c"
					goto __catch122_g_error;
				}
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (pix);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 5386 "Photo.c"
			}
			goto __finally122;
			__catch122_g_error:
			{
				GError* err = NULL;
				GError* _tmp31_ = NULL;
				const gchar* _tmp32_ = NULL;
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				err = _inner_error_;
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = err;
#line 620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = _tmp31_->message;
#line 620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_debug ("Photo.vala:620: Error developing photo: %s", _tmp32_);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (err);
#line 5406 "Photo.c"
			}
			__finally122:
			{
				gboolean _tmp33_ = FALSE;
#line 622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp33_) {
#line 5415 "Photo.c"
					{
						RawDeveloper _tmp34_ = 0;
						BackingPhotoRow* _tmp35_ = NULL;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp34_ = d;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp35_ = bps;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp34_, _tmp35_, &_inner_error_);
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5427 "Photo.c"
							goto __catch125_g_error;
						}
#line 627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 5432 "Photo.c"
					}
					goto __finally125;
					__catch125_g_error:
					{
						GError* e = NULL;
						GError* _tmp36_ = NULL;
						const gchar* _tmp37_ = NULL;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						e = _inner_error_;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp36_ = e;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp37_ = _tmp36_->message;
#line 629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp37_);
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_error_free0 (e);
#line 5452 "Photo.c"
					}
					__finally125:
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return;
#line 5465 "Photo.c"
					}
				}
			}
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 5479 "Photo.c"
			}
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 5483 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5487 "Photo.c"
		{
#line 639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 5491 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5495 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp38_ = NULL;
				guint c = 0U;
				PhotoMetadata* _tmp39_ = NULL;
				guint _tmp40_ = 0U;
				guint _tmp41_ = 0U;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp47_ = NULL;
				guint _tmp48_ = 0U;
				PhotoPreview* _tmp49_ = NULL;
				PhotoPreview* _tmp50_ = NULL;
				GdkPixbuf* pix = NULL;
				PhotoPreview* _tmp56_ = NULL;
				GdkPixbuf* _tmp57_ = NULL;
				GdkPixbuf* _tmp58_ = NULL;
				BackingPhotoRow* _tmp64_ = NULL;
				RawDeveloper _tmp65_ = 0;
				PhotoRow* _tmp66_ = NULL;
				BackingPhotoRow* _tmp67_ = NULL;
				const gchar* _tmp68_ = NULL;
				BackingPhotoRow* _tmp69_ = NULL;
				BackingPhotoRow* _tmp70_ = NULL;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp71_ = NULL;
				const gchar* _tmp72_ = NULL;
				PhotoFileWriter* _tmp73_ = NULL;
				PhotoFileWriter* _tmp74_ = NULL;
				GdkPixbuf* _tmp75_ = NULL;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp76_ = NULL;
				const gchar* _tmp77_ = NULL;
				PhotoFileMetadataWriter* _tmp78_ = NULL;
				PhotoFileMetadataWriter* _tmp79_ = NULL;
				PhotoMetadata* _tmp80_ = NULL;
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = photo_get_master_metadata (self, &_inner_error_);
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				meta = _tmp38_;
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5538 "Photo.c"
					goto __catch126_g_error;
				}
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = meta;
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp40_ = photo_metadata_get_preview_count (_tmp39_);
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				c = _tmp40_;
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp41_ = c;
#line 646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp41_ <= ((guint) 0)) {
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5553 "Photo.c"
					{
						gboolean _tmp42_ = FALSE;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp42_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp42_) {
#line 5560 "Photo.c"
							{
								RawDeveloper _tmp43_ = 0;
								BackingPhotoRow* _tmp44_ = NULL;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp43_ = d;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp44_ = bps;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp43_, _tmp44_, &_inner_error_);
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5572 "Photo.c"
									goto __catch127_g_error;
								}
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5577 "Photo.c"
							}
							goto __finally127;
							__catch127_g_error:
							{
								GError* e = NULL;
								GError* _tmp45_ = NULL;
								const gchar* _tmp46_ = NULL;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp45_ = e;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp46_ = _tmp45_->message;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp46_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5597 "Photo.c"
							}
							__finally127:
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5602 "Photo.c"
								goto __catch126_g_error;
							}
						}
					}
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 5611 "Photo.c"
				}
#line 648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = meta;
#line 648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = c;
#line 648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp49_ = photo_metadata_get_preview (_tmp47_, _tmp48_ - 1);
#line 648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				prev = _tmp49_;
#line 649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp50_ = prev;
#line 649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp50_ == NULL) {
#line 650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_debug ("Photo.vala:650: Could not get preview from metadata");
#line 651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5631 "Photo.c"
					{
						gboolean _tmp51_ = FALSE;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp51_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp51_) {
#line 5638 "Photo.c"
							{
								RawDeveloper _tmp52_ = 0;
								BackingPhotoRow* _tmp53_ = NULL;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp52_ = d;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp53_ = bps;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp52_, _tmp53_, &_inner_error_);
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5650 "Photo.c"
									goto __catch128_g_error;
								}
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5655 "Photo.c"
							}
							goto __finally128;
							__catch128_g_error:
							{
								GError* e = NULL;
								GError* _tmp54_ = NULL;
								const gchar* _tmp55_ = NULL;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp54_ = e;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp55_ = _tmp54_->message;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp55_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5675 "Photo.c"
							}
							__finally128:
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5680 "Photo.c"
								goto __catch126_g_error;
							}
						}
					}
#line 651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 5689 "Photo.c"
				}
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp56_ = prev;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp57_ = photo_preview_get_pixbuf (_tmp56_, &_inner_error_);
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				pix = _tmp57_;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5703 "Photo.c"
					goto __catch126_g_error;
				}
#line 655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58_ = pix;
#line 655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp58_ == NULL) {
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_debug ("Photo.vala:656: Could not get preview pixbuf");
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5718 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp59_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp59_) {
#line 5725 "Photo.c"
							{
								RawDeveloper _tmp60_ = 0;
								BackingPhotoRow* _tmp61_ = NULL;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp60_ = d;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp61_ = bps;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp60_, _tmp61_, &_inner_error_);
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5737 "Photo.c"
									goto __catch129_g_error;
								}
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5742 "Photo.c"
							}
							goto __finally129;
							__catch129_g_error:
							{
								GError* e = NULL;
								GError* _tmp62_ = NULL;
								const gchar* _tmp63_ = NULL;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp62_ = e;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp63_ = _tmp62_->message;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp63_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5762 "Photo.c"
							}
							__finally129:
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5767 "Photo.c"
								goto __catch126_g_error;
							}
						}
					}
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 5776 "Photo.c"
				}
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp65_ = d;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp66_ = self->row;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp67_ = _tmp66_->master;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp68_ = _tmp67_->filepath;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp69_ = raw_developer_create_backing_row_for_development (_tmp65_, _tmp68_, NULL, &_inner_error_);
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp64_ = _tmp69_;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5798 "Photo.c"
					goto __catch126_g_error;
				}
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp70_ = _tmp64_;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp64_ = NULL;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				bps = _tmp70_;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp71_ = bps;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp72_ = _tmp71_->filepath;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp73_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp72_, &_inner_error_);
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				writer = _tmp73_;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5827 "Photo.c"
					goto __catch126_g_error;
				}
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp74_ = writer;
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp75_ = pix;
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_file_writer_write (_tmp74_, _tmp75_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5848 "Photo.c"
					goto __catch126_g_error;
				}
#line 667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp76_ = bps;
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp77_ = _tmp76_->filepath;
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp78_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp77_, &_inner_error_);
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				mwriter = _tmp78_;
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 670 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5873 "Photo.c"
					goto __catch126_g_error;
				}
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp79_ = mwriter;
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp80_ = meta;
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp79_, _tmp80_, &_inner_error_);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5896 "Photo.c"
					goto __catch126_g_error;
				}
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp64_);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (pix);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 5911 "Photo.c"
			}
			goto __finally126;
			__catch126_g_error:
			{
				GError* e = NULL;
				GError* _tmp81_ = NULL;
				const gchar* _tmp82_ = NULL;
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				e = _inner_error_;
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp81_ = e;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp82_ = _tmp81_->message;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_debug ("Photo.vala:673: Error accessing embedded preview. Message: %s", _tmp82_);
#line 674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (e);
#line 5931 "Photo.c"
				{
					gboolean _tmp83_ = FALSE;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp83_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp83_) {
#line 5938 "Photo.c"
						{
							RawDeveloper _tmp84_ = 0;
							BackingPhotoRow* _tmp85_ = NULL;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp84_ = d;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp85_ = bps;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							photo_add_backing_photo_for_development (self, _tmp84_, _tmp85_, &_inner_error_);
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5950 "Photo.c"
								goto __catch130_g_error;
							}
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 5955 "Photo.c"
						}
						goto __finally130;
						__catch130_g_error:
						{
							GError* e = NULL;
							GError* _tmp86_ = NULL;
							const gchar* _tmp87_ = NULL;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							e = _inner_error_;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp86_ = e;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp87_ = _tmp86_->message;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp87_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_error_free0 (e);
#line 5975 "Photo.c"
						}
						__finally130:
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 5982 "Photo.c"
						}
					}
				}
#line 674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 5990 "Photo.c"
			}
			__finally126:
			{
				gboolean _tmp88_ = FALSE;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp88_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp88_) {
#line 5999 "Photo.c"
					{
						RawDeveloper _tmp89_ = 0;
						BackingPhotoRow* _tmp90_ = NULL;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp89_ = d;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp90_ = bps;
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp89_, _tmp90_, &_inner_error_);
#line 679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6011 "Photo.c"
							goto __catch131_g_error;
						}
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6016 "Photo.c"
					}
					goto __finally131;
					__catch131_g_error:
					{
						GError* e = NULL;
						GError* _tmp91_ = NULL;
						const gchar* _tmp92_ = NULL;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						e = _inner_error_;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp91_ = e;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp92_ = _tmp91_->message;
#line 683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp92_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_error_free0 (e);
#line 6036 "Photo.c"
					}
					__finally131:
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return;
#line 6049 "Photo.c"
					}
				}
			}
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 6063 "Photo.c"
			}
#line 688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 6067 "Photo.c"
		}
		default:
		{
#line 691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_assert_not_reached ();
#line 6073 "Photo.c"
		}
	}
#line 578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 6078 "Photo.c"
}


void photo_set_default_raw_developer (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 6086 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6093 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
#line 698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = d;
#line 698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_->developer = _tmp2_;
#line 6103 "Photo.c"
		}
		__finally132:
		{
			PhotoRow* _tmp3_ = NULL;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6112 "Photo.c"
		}
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 6122 "Photo.c"
		}
	}
}


void photo_set_raw_developer (Photo* self, RawDeveloper d) {
	PhotoFileFormat _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Alteration* _tmp46_ = NULL;
	Alteration* _tmp47_ = NULL;
	GError * _inner_error_ = NULL;
#line 703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 6144 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA);
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 6150 "Photo.c"
		RawDeveloper _tmp3_ = 0;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = d;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp3_ == RAW_DEVELOPER_EMBEDDED;
#line 6156 "Photo.c"
	} else {
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 6160 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 6166 "Photo.c"
	}
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED);
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp4_) {
#line 716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 6174 "Photo.c"
	}
	{
		GeeHashMap* _tmp5_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6182 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp6_ = NULL;
			RawDeveloper _tmp7_ = 0;
			RawDeveloper _tmp8_ = 0;
			gboolean _tmp9_ = FALSE;
			GeeHashMap* _tmp13_ = NULL;
			RawDeveloper _tmp14_ = 0;
			gboolean _tmp15_ = FALSE;
			PhotoRow* _tmp17_ = NULL;
			RawDeveloper _tmp18_ = 0;
			GeeHashMap* _tmp19_ = NULL;
			RawDeveloper _tmp20_ = 0;
			gpointer _tmp21_ = NULL;
			PhotoBackingReaders* _tmp22_ = NULL;
			BackingPhotoRow* _tmp23_ = NULL;
			PhotoFileFormat _tmp24_ = 0;
			BackingPhotoRow* _tmp25_ = NULL;
			const gchar* _tmp26_ = NULL;
			PhotoFileReader* _tmp27_ = NULL;
			BackingPhotoRow* _tmp28_ = NULL;
			Orientation _tmp29_ = 0;
			gboolean _tmp39_ = FALSE;
			RawDeveloper _tmp40_ = 0;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp6_->developer;
#line 719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			stale_raw_developer = _tmp7_;
#line 722 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = d;
#line 722 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = photo_is_raw_developer_complete (self, _tmp8_);
#line 722 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp9_) {
#line 6219 "Photo.c"
				RawDeveloper _tmp10_ = 0;
#line 723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = d;
#line 723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_develop_photo (self, _tmp10_);
#line 6225 "Photo.c"
				{
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6231 "Photo.c"
						goto __catch134_g_error;
					}
				}
				goto __finally134;
				__catch134_g_error:
				{
					GError* e = NULL;
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					e = _inner_error_;
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_error_free0 (e);
#line 6245 "Photo.c"
					{
						GeeHashMap* _tmp11_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp11_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6252 "Photo.c"
					}
#line 728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 6256 "Photo.c"
				}
				__finally134:
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6261 "Photo.c"
					{
						GeeHashMap* _tmp12_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp12_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6268 "Photo.c"
					}
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 6276 "Photo.c"
				}
			}
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->priv->developments;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = d;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) _tmp14_));
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp15_) {
#line 6287 "Photo.c"
				{
					GeeHashMap* _tmp16_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6294 "Photo.c"
				}
#line 732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 6298 "Photo.c"
			}
#line 735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = d;
#line 738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_->developer = _tmp18_;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->priv->developments;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = d;
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp21_;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = _tmp23_->file_format;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = _tmp25_->filepath;
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = photo_file_format_create_reader (_tmp24_, _tmp26_);
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp22_->developer);
#line 740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_->developer = _tmp27_;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = self->backing_photo_row;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = _tmp28_->original_orientation;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_orientation (self, _tmp29_);
#line 6340 "Photo.c"
			{
				PhotoTable* _tmp30_ = NULL;
				PhotoTable* _tmp31_ = NULL;
				PhotoRow* _tmp32_ = NULL;
				RawDeveloper _tmp33_ = 0;
				BackingPhotoRow* _tmp34_ = NULL;
				BackingPhotoID _tmp35_ = {0};
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = photo_table_get_instance ();
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = self->row;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = d;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = self->backing_photo_row;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = _tmp34_->id;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_update_raw_development (_tmp31_, _tmp32_, _tmp33_, &_tmp35_, &_inner_error_);
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp31_);
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6366 "Photo.c"
					goto __catch135_g_error;
				}
			}
			goto __finally135;
			__catch135_g_error:
			{
				GError* e = NULL;
				GError* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				e = _inner_error_;
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = e;
#line 747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _tmp36_->message;
#line 747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_warning ("Photo.vala:747: Error updating database: %s", _tmp37_);
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (e);
#line 6388 "Photo.c"
			}
			__finally135:
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6393 "Photo.c"
				{
					GeeHashMap* _tmp38_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp38_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6400 "Photo.c"
				}
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 6408 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = stale_raw_developer;
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp40_ != RAW_DEVELOPER_CAMERA) {
#line 6414 "Photo.c"
				RawDeveloper _tmp41_ = 0;
				PhotoRow* _tmp42_ = NULL;
				RawDeveloper _tmp43_ = 0;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp41_ = stale_raw_developer;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp42_ = self->row;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = _tmp42_->developer;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = _tmp41_ != _tmp43_;
#line 6426 "Photo.c"
			} else {
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = FALSE;
#line 6430 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp39_) {
#line 6434 "Photo.c"
				RawDeveloper _tmp44_ = 0;
#line 758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = stale_raw_developer;
#line 758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_delete_raw_development (self, _tmp44_);
#line 6440 "Photo.c"
			}
		}
		__finally133:
		{
			GeeHashMap* _tmp45_ = NULL;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp45_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6450 "Photo.c"
		}
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 6460 "Photo.c"
		}
	}
#line 765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = alteration_new ("image", "developer");
#line 765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = _tmp46_;
#line 765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp47_);
#line 765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp47_);
#line 766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 6473 "Photo.c"
}


RawDeveloper photo_get_raw_developer (Photo* self) {
	RawDeveloper result = 0;
	PhotoRow* _tmp0_ = NULL;
	RawDeveloper _tmp1_ = 0;
#line 769 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 6491 "Photo.c"
}


static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError * _inner_error_ = NULL;
#line 775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ret = FALSE;
#line 6503 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6510 "Photo.c"
		{
			GeeHashMap* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
			gboolean _tmp3_ = FALSE;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			RawDeveloper _tmp7_ = 0;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp10_ = NULL;
			RawDeveloper _tmp11_ = 0;
			gpointer _tmp12_ = NULL;
			BackingPhotoRow* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			GeeHashMap* _tmp37_ = NULL;
			RawDeveloper _tmp38_ = 0;
			gboolean _tmp39_ = FALSE;
#line 779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = d;
#line 779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) _tmp2_));
#line 779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp3_) {
#line 780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = FALSE;
#line 6539 "Photo.c"
				{
					GeeHashMap* _tmp4_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6546 "Photo.c"
				}
#line 780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 6550 "Photo.c"
			}
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = data_object_to_string ((DataObject*) self);
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = d;
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = raw_developer_to_string (_tmp7_);
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_debug ("Photo.vala:784: Delete raw development: %s %s", _tmp6_, _tmp9_);
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->priv->developments;
#line 785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = d;
#line 785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) _tmp11_));
#line 785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp12_;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = bpr;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp14_ != NULL) {
#line 6582 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
				const gchar* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
#line 787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = bpr;
#line 787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = _tmp15_->filepath;
#line 787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = g_file_new_for_path (_tmp16_);
#line 787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				f = _tmp17_;
#line 6595 "Photo.c"
				{
					RawDeveloper _tmp18_ = 0;
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = d;
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp18_ == RAW_DEVELOPER_CAMERA) {
#line 6602 "Photo.c"
						GFile* _tmp19_ = NULL;
#line 790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp19_ = f;
#line 790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_file_trash (_tmp19_, NULL, &_inner_error_);
#line 790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6610 "Photo.c"
							goto __catch137_g_error;
						}
					} else {
						GFile* _tmp20_ = NULL;
#line 792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp20_ = f;
#line 792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_file_delete (_tmp20_, NULL, &_inner_error_);
#line 792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6621 "Photo.c"
							goto __catch137_g_error;
						}
					}
				}
				goto __finally137;
				__catch137_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					GError* _tmp23_ = NULL;
					const gchar* _tmp24_ = NULL;
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					e = _inner_error_;
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp21_ = bpr;
#line 794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp22_ = _tmp21_->filepath;
#line 794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp23_ = e;
#line 794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp24_ = _tmp23_->message;
#line 794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_warning ("Photo.vala:794: Unable to delete RAW development: %s error: %s", _tmp22_, _tmp24_);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_error_free0 (e);
#line 6650 "Photo.c"
				}
				__finally137:
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 6663 "Photo.c"
					{
						GeeHashMap* _tmp25_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp25_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6670 "Photo.c"
					}
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return FALSE;
#line 6678 "Photo.c"
				}
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 6682 "Photo.c"
			}
			{
				PhotoTable* _tmp26_ = NULL;
				PhotoTable* _tmp27_ = NULL;
				PhotoRow* _tmp28_ = NULL;
				RawDeveloper _tmp29_ = 0;
				BackingPhotoTable* _tmp30_ = NULL;
				BackingPhotoTable* _tmp31_ = NULL;
				BackingPhotoRow* _tmp32_ = NULL;
				BackingPhotoID _tmp33_ = {0};
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = photo_table_get_instance ();
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = self->row;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = d;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_remove_development (_tmp27_, _tmp28_, _tmp29_, &_inner_error_);
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp27_);
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6707 "Photo.c"
					goto __catch138_g_error;
				}
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = backing_photo_table_get_instance ();
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = bpr;
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = _tmp32_->id;
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				backing_photo_table_remove (_tmp31_, &_tmp33_, &_inner_error_);
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp31_);
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6724 "Photo.c"
					goto __catch138_g_error;
				}
			}
			goto __finally138;
			__catch138_g_error:
			{
				GError* e = NULL;
				GError* _tmp34_ = NULL;
				const gchar* _tmp35_ = NULL;
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				e = _inner_error_;
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 803 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = e;
#line 803 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = _tmp34_->message;
#line 803 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_warning ("Photo.vala:803: Database error while deleting RAW development: %s", _tmp35_);
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (e);
#line 6746 "Photo.c"
			}
			__finally138:
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 6755 "Photo.c"
				{
					GeeHashMap* _tmp36_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp36_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6762 "Photo.c"
				}
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return FALSE;
#line 6770 "Photo.c"
			}
#line 806 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp37_ = self->priv->developments;
#line 806 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = d;
#line 806 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) _tmp38_), NULL);
#line 806 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			ret = _tmp39_;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 6782 "Photo.c"
		}
		__finally136:
		{
			GeeHashMap* _tmp40_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6791 "Photo.c"
		}
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 6801 "Photo.c"
		}
	}
#line 809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 810 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = ret;
#line 810 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 6810 "Photo.c"
}


void photo_redevelop_raw (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 814 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 6818 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6825 "Photo.c"
		{
			RawDeveloper _tmp1_ = 0;
			RawDeveloper dev = 0;
			RawDeveloper _tmp2_ = 0;
			RawDeveloper _tmp3_ = 0;
			RawDeveloper _tmp4_ = 0;
#line 816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = d;
#line 816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_delete_raw_development (self, _tmp1_);
#line 817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = d;
#line 817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			dev = _tmp2_;
#line 818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = dev;
#line 818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ == RAW_DEVELOPER_CAMERA) {
#line 819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 6846 "Photo.c"
			}
#line 821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = dev;
#line 821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_raw_developer (self, _tmp4_);
#line 6852 "Photo.c"
		}
		__finally139:
		{
			GeeHashMap* _tmp5_ = NULL;
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6861 "Photo.c"
		}
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 6871 "Photo.c"
		}
	}
}


static void _vala_array_add97 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6884 "Photo.c"
	}
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6890 "Photo.c"
}


static void _vala_array_add98 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6901 "Photo.c"
	}
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6907 "Photo.c"
}


static void _vala_array_add99 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6918 "Photo.c"
	}
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6924 "Photo.c"
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_ = NULL;
	gint backing_length1 = 0;
	gint _backing_size_ = 0;
	BackingFileState** _tmp27_ = NULL;
	gint _tmp27__length1 = 0;
	GError * _inner_error_ = NULL;
#line 825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing = _tmp0_;
#line 826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing_length1 = 0;
#line 826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 6948 "Photo.c"
	{
		PhotoRow* _tmp1_ = NULL;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6955 "Photo.c"
		{
			BackingFileState** _tmp2_ = NULL;
			gint _tmp2__length1 = 0;
			PhotoRow* _tmp3_ = NULL;
			BackingPhotoRow* _tmp4_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			BackingFileState* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp12_ = FALSE;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = backing;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add97 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = photo_has_editable (self);
#line 829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp8_) {
#line 6986 "Photo.c"
				BackingFileState** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
				BackingPhotoRow* _tmp10_ = NULL;
				BackingFileState* _tmp11_ = NULL;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = backing;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9__length1 = backing_length1;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = self->priv->editable;
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = backing_file_state_new_from_photo_row (_tmp10_, NULL);
#line 830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_array_add98 (&backing, &backing_length1, &_backing_size_, _tmp11_);
#line 7001 "Photo.c"
			}
#line 832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo_is_developed (self);
#line 832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp12_) {
#line 7007 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp13_ = NULL;
				GeeCollection* _tmp14_ = NULL;
#line 833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = photo_get_raw_development_photo_rows (self);
#line 833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				dev_rows = _tmp13_;
#line 834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = dev_rows;
#line 834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 7019 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp15_ = NULL;
						GeeIterator* _tmp16_ = NULL;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp15_ = dev_rows;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_r_it = _tmp16_;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 7032 "Photo.c"
							GeeIterator* _tmp17_ = NULL;
							gboolean _tmp18_ = FALSE;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp19_ = NULL;
							gpointer _tmp20_ = NULL;
							BackingPhotoRow* _tmp21_ = NULL;
							const gchar* _tmp22_ = NULL;
							BackingFileState** _tmp23_ = NULL;
							gint _tmp23__length1 = 0;
							BackingPhotoRow* _tmp24_ = NULL;
							BackingFileState* _tmp25_ = NULL;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp17_ = _r_it;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp18_ = gee_iterator_next (_tmp17_);
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp18_) {
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 7052 "Photo.c"
							}
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp19_ = _r_it;
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp20_;
#line 836 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp21_ = r;
#line 836 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp22_ = _tmp21_->filepath;
#line 836 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							g_debug ("Photo.vala:836: adding: %s", _tmp22_);
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp23_ = backing;
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp23__length1 = backing_length1;
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp24_ = r;
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp25_ = backing_file_state_new_from_photo_row (_tmp24_, NULL);
#line 837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_vala_array_add99 (&backing, &backing_length1, &_backing_size_, _tmp25_);
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 7078 "Photo.c"
						}
#line 835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 7082 "Photo.c"
					}
				}
#line 832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 7087 "Photo.c"
			}
		}
		__finally140:
		{
			PhotoRow* _tmp26_ = NULL;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = self->row;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7097 "Photo.c"
		}
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 7109 "Photo.c"
		}
	}
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = backing;
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27__length1 = backing_length1;
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (result_length1) {
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*result_length1 = _tmp27__length1;
#line 7120 "Photo.c"
	}
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp27_;
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 7126 "Photo.c"
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	BackingFetchMode _tmp0_ = 0;
#line 846 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = mode;
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp0_) {
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 7141 "Photo.c"
		{
			PhotoFileReader* _tmp1_ = NULL;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_get_master_reader (self);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7150 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 7154 "Photo.c"
		{
			PhotoFileReader* _tmp2_ = NULL;
#line 852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = photo_get_baseline_reader (self);
#line 852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7163 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 7167 "Photo.c"
		{
			PhotoFileReader* _tmp3_ = NULL;
#line 855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = photo_get_source_reader (self);
#line 855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7176 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 7180 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 858 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = photo_get_master_file_format (self);
#line 858 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp4_ == PHOTO_FILE_FORMAT_RAW) {
#line 7187 "Photo.c"
				PhotoFileReader* _tmp5_ = NULL;
#line 859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = photo_get_raw_developer_reader (self);
#line 859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp5_;
#line 859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7195 "Photo.c"
			} else {
				PhotoFileReader* _tmp6_ = NULL;
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = photo_get_master_reader (self);
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp6_;
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7204 "Photo.c"
			}
		}
		default:
		{
			BackingFetchMode _tmp7_ = 0;
			GEnumValue* _tmp8_;
#line 864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = mode;
#line 864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), _tmp7_);
#line 864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_error ("Photo.vala:864: Unknown backing fetch mode %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
#line 7217 "Photo.c"
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 7226 "Photo.c"
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7235 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7242 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 7255 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7262 "Photo.c"
			}
#line 870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7266 "Photo.c"
		}
		__finally141:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7275 "Photo.c"
		}
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 7283 "Photo.c"
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7293 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7300 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 7313 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7320 "Photo.c"
			}
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7324 "Photo.c"
		}
		__finally142:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7333 "Photo.c"
		}
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 7341 "Photo.c"
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 881 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7351 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7358 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoBackingReaders* _tmp7_ = NULL;
			PhotoFileReader* _tmp8_ = NULL;
			PhotoBackingReaders* _tmp13_ = NULL;
			PhotoFileReader* _tmp14_ = NULL;
			PhotoFileReader* _tmp15_ = NULL;
#line 883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7373 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
#line 884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp5_;
#line 7385 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_ = NULL;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7392 "Photo.c"
				}
#line 884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7396 "Photo.c"
			}
#line 886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7404 "Photo.c"
				PhotoBackingReaders* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
				PhotoFileReader* _tmp11_ = NULL;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp11_;
#line 7416 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_ = NULL;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7423 "Photo.c"
				}
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7427 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp15_;
#line 7437 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_ = NULL;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7444 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7448 "Photo.c"
		}
		__finally143:
		{
			PhotoBackingReaders* _tmp17_ = NULL;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7457 "Photo.c"
		}
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 7465 "Photo.c"
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7475 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7482 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoBackingReaders* _tmp7_ = NULL;
			PhotoFileReader* _tmp8_ = NULL;
			PhotoBackingReaders* _tmp13_ = NULL;
			PhotoFileReader* _tmp14_ = NULL;
			PhotoFileReader* _tmp15_ = NULL;
#line 896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7497 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp5_;
#line 7509 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7516 "Photo.c"
				}
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7520 "Photo.c"
			}
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7528 "Photo.c"
				PhotoBackingReaders* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
				PhotoFileReader* _tmp11_ = NULL;
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp11_;
#line 7540 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7547 "Photo.c"
				}
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 7551 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp15_;
#line 7561 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7568 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7572 "Photo.c"
		}
		__finally144:
		{
			PhotoBackingReaders* _tmp17_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7581 "Photo.c"
		}
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 7589 "Photo.c"
	}
}


static PhotoFileReader* photo_get_raw_developer_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7599 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7606 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 7619 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7626 "Photo.c"
			}
#line 909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7630 "Photo.c"
		}
		__finally145:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7639 "Photo.c"
		}
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 7647 "Photo.c"
	}
}


gboolean photo_is_developed (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7657 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7664 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7674 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7681 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7685 "Photo.c"
		}
		__finally146:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7694 "Photo.c"
		}
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 7702 "Photo.c"
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7712 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7719 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7729 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7736 "Photo.c"
			}
#line 921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7740 "Photo.c"
		}
		__finally147:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7749 "Photo.c"
		}
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 7757 "Photo.c"
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7767 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7774 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp2_);
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 7787 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7794 "Photo.c"
			}
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7798 "Photo.c"
		}
		__finally148:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7807 "Photo.c"
		}
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 7815 "Photo.c"
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 932 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7825 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7832 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 7843 "Photo.c"
				PhotoBackingReaders* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp5_);
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 7855 "Photo.c"
			} else {
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 7859 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 7863 "Photo.c"
			{
				PhotoBackingReaders* _tmp7_ = NULL;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7870 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7874 "Photo.c"
		}
		__finally149:
		{
			PhotoBackingReaders* _tmp8_ = NULL;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7883 "Photo.c"
		}
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 7891 "Photo.c"
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7901 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7908 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 7918 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7925 "Photo.c"
			}
#line 940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7929 "Photo.c"
		}
		__finally150:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7938 "Photo.c"
		}
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 7946 "Photo.c"
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 944 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = !_tmp0_;
#line 945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 7962 "Photo.c"
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 948 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7971 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7978 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7988 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7995 "Photo.c"
			}
#line 950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 7999 "Photo.c"
		}
		__finally151:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8008 "Photo.c"
		}
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 8016 "Photo.c"
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 8032 "Photo.c"
}


BackingPhotoRow* photo_get_master_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8041 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8048 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoRow* _tmp2_ = NULL;
			BackingPhotoRow* _tmp3_ = NULL;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 8061 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8068 "Photo.c"
			}
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 8072 "Photo.c"
		}
		__finally152:
		{
			PhotoRow* _tmp5_ = NULL;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8081 "Photo.c"
		}
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 8089 "Photo.c"
	}
}


BackingPhotoRow* photo_get_editable_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 964 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8099 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8106 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = backing_photo_id_is_valid (&_tmp1_->editable_id);
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_) {
#line 8116 "Photo.c"
				BackingPhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
#line 968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->editable;
#line 968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _backing_photo_row_ref0 (_tmp3_);
#line 968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = _tmp4_;
#line 8125 "Photo.c"
				{
					PhotoRow* _tmp5_ = NULL;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp5_ = self->row;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8132 "Photo.c"
				}
#line 968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 8136 "Photo.c"
			} else {
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = NULL;
#line 8140 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8147 "Photo.c"
				}
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 8151 "Photo.c"
			}
		}
		__finally153:
		{
			PhotoRow* _tmp7_ = NULL;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8161 "Photo.c"
		}
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 8169 "Photo.c"
	}
}


GeeCollection* photo_get_raw_development_photo_rows (Photo* self) {
	GeeCollection* result = NULL;
	GError * _inner_error_ = NULL;
#line 974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8179 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8186 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8194 "Photo.c"
				GeeHashMap* _tmp3_ = NULL;
				GeeCollection* _tmp4_ = NULL;
				GeeCollection* _tmp5_ = NULL;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeMap*) _tmp3_);
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 8208 "Photo.c"
			} else {
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 8214 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 8218 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8225 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 8229 "Photo.c"
		}
		__finally154:
		{
			PhotoRow* _tmp7_ = NULL;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8238 "Photo.c"
		}
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 8246 "Photo.c"
	}
}


BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 980 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8256 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8263 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8271 "Photo.c"
				GeeHashMap* _tmp3_ = NULL;
				RawDeveloper _tmp4_ = 0;
				gpointer _tmp5_ = NULL;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = d;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp5_;
#line 8285 "Photo.c"
			} else {
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 8291 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 8295 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8302 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 8306 "Photo.c"
		}
		__finally155:
		{
			PhotoRow* _tmp7_ = NULL;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8315 "Photo.c"
		}
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 8323 "Photo.c"
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return dup;
#line 8336 "Photo.c"
}


static gpointer __photo_file_format_dup0 (gpointer self) {
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 8343 "Photo.c"
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	PhotoFileFormat* _tmp4_ = NULL;
#line 986 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reader = _tmp0_;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = reader;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8371 "Photo.c"
	}
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = reader;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 8385 "Photo.c"
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	PhotoFileFormat _tmp0_ = 0;
	ExportFormatParameters _tmp1_ = {0};
	ExportFormatMode _tmp2_ = 0;
#line 995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_file_format_get_system_default_format ();
#line 996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_result_ = _tmp0_;
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = *params;
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_.mode;
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp2_) {
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8411 "Photo.c"
		{
			PhotoFileFormat _tmp3_ = 0;
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = photo_get_master_file_format (self);
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_result_ = _tmp3_;
#line 1001 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 8420 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 8424 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 1004 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = photo_get_best_export_file_format (self);
#line 1004 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 1005 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 8433 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8437 "Photo.c"
		{
			ExportFormatParameters _tmp5_ = {0};
			PhotoFileFormat _tmp6_ = 0;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = *params;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_.specified_format;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_result_ = _tmp6_;
#line 1009 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 8449 "Photo.c"
		}
		default:
		{
#line 1012 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_error ("Photo.vala:1012: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 8455 "Photo.c"
		}
	}
#line 1015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _result_;
#line 1015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 8462 "Photo.c"
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_ = {0};
	ExportFormatMode _tmp1_ = 0;
	const gchar* _tmp8_ = NULL;
#line 1018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_result_ = NULL;
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = *params;
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp1_) {
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8486 "Photo.c"
		{
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1024 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 8505 "Photo.c"
		}
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8511 "Photo.c"
		{
			ExportFormatParameters _tmp5_ = {0};
			PhotoFileFormat _tmp6_ = 0;
			gchar* _tmp7_ = NULL;
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = *params;
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp7_;
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 8528 "Photo.c"
		}
		default:
		{
#line 1031 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_error ("Photo.vala:1031: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 8534 "Photo.c"
		}
	}
#line 1034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _result_;
#line 1034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _result_;
#line 1035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 8545 "Photo.c"
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	GFile* file = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp7_ = NULL;
	GFileType _tmp8_ = 0;
	GFile* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp19_ = NULL;
	GTimeVal _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	PhotoImportParams* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp32_ = NULL;
	PhotoImportParams* _tmp33_ = NULL;
	PhotoFileSnifferOptions _tmp34_ = 0;
	PhotoFileInterrogator* _tmp35_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp42_ = NULL;
	DetectedPhotoInformation* _tmp43_ = NULL;
	DetectedPhotoInformation* _tmp44_ = NULL;
	PhotoImportParams* _tmp45_ = NULL;
	PhotoFileSnifferOptions _tmp46_ = 0;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp59_ = NULL;
	gchar* comment = NULL;
	gchar* _tmp60_ = NULL;
	DetectedPhotoInformation* _tmp61_ = NULL;
	PhotoMetadata* _tmp62_ = NULL;
	gboolean _tmp82_ = FALSE;
	gboolean _tmp83_ = FALSE;
	DetectedPhotoInformation* _tmp84_ = NULL;
	GdkColorspace _tmp85_ = 0;
	PhotoImportParams* _tmp93_ = NULL;
	PhotoRow* _tmp94_ = NULL;
	PhotoImportParams* _tmp95_ = NULL;
	PhotoRow* _tmp96_ = NULL;
	BackingPhotoRow* _tmp97_ = NULL;
	GFile* _tmp98_ = NULL;
	gchar* _tmp99_ = NULL;
	PhotoImportParams* _tmp100_ = NULL;
	PhotoRow* _tmp101_ = NULL;
	BackingPhotoRow* _tmp102_ = NULL;
	DetectedPhotoInformation* _tmp103_ = NULL;
	Dimensions _tmp104_ = {0};
	PhotoImportParams* _tmp105_ = NULL;
	PhotoRow* _tmp106_ = NULL;
	BackingPhotoRow* _tmp107_ = NULL;
	GFileInfo* _tmp108_ = NULL;
	gint64 _tmp109_ = 0LL;
	PhotoImportParams* _tmp110_ = NULL;
	PhotoRow* _tmp111_ = NULL;
	BackingPhotoRow* _tmp112_ = NULL;
	GTimeVal _tmp113_ = {0};
	glong _tmp114_ = 0L;
	PhotoImportParams* _tmp115_ = NULL;
	PhotoRow* _tmp116_ = NULL;
	time_t _tmp117_ = 0;
	PhotoImportParams* _tmp118_ = NULL;
	PhotoRow* _tmp119_ = NULL;
	Orientation _tmp120_ = 0;
	PhotoImportParams* _tmp121_ = NULL;
	PhotoRow* _tmp122_ = NULL;
	BackingPhotoRow* _tmp123_ = NULL;
	Orientation _tmp124_ = 0;
	PhotoImportParams* _tmp125_ = NULL;
	PhotoRow* _tmp126_ = NULL;
	PhotoImportParams* _tmp127_ = NULL;
	ImportID _tmp128_ = {0};
	PhotoImportParams* _tmp129_ = NULL;
	PhotoRow* _tmp130_ = NULL;
	PhotoImportParams* _tmp131_ = NULL;
	PhotoRow* _tmp132_ = NULL;
	PhotoImportParams* _tmp133_ = NULL;
	PhotoRow* _tmp134_ = NULL;
	DetectedPhotoInformation* _tmp135_ = NULL;
	const gchar* _tmp136_ = NULL;
	gchar* _tmp137_ = NULL;
	PhotoImportParams* _tmp138_ = NULL;
	PhotoRow* _tmp139_ = NULL;
	DetectedPhotoInformation* _tmp140_ = NULL;
	const gchar* _tmp141_ = NULL;
	gchar* _tmp142_ = NULL;
	PhotoImportParams* _tmp143_ = NULL;
	PhotoRow* _tmp144_ = NULL;
	DetectedPhotoInformation* _tmp145_ = NULL;
	const gchar* _tmp146_ = NULL;
	gchar* _tmp147_ = NULL;
	PhotoImportParams* _tmp148_ = NULL;
	PhotoRow* _tmp149_ = NULL;
	PhotoImportParams* _tmp150_ = NULL;
	PhotoRow* _tmp151_ = NULL;
	PhotoImportParams* _tmp152_ = NULL;
	PhotoRow* _tmp153_ = NULL;
	BackingPhotoRow* _tmp154_ = NULL;
	DetectedPhotoInformation* _tmp155_ = NULL;
	PhotoFileFormat _tmp156_ = 0;
	PhotoImportParams* _tmp157_ = NULL;
	PhotoRow* _tmp158_ = NULL;
	const gchar* _tmp159_ = NULL;
	gchar* _tmp160_ = NULL;
	PhotoImportParams* _tmp161_ = NULL;
	PhotoRow* _tmp162_ = NULL;
	const gchar* _tmp163_ = NULL;
	gchar* _tmp164_ = NULL;
	PhotoImportParams* _tmp165_ = NULL;
	Thumbnails* _tmp166_ = NULL;
	GError * _inner_error_ = NULL;
#line 1050 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = params;
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp2_;
#line 1056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	info = NULL;
#line 8679 "Photo.c"
	{
		GFileInfo* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_ = NULL;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = file;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = g_file_query_info (_tmp4_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp5_;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 8693 "Photo.c"
			goto __catch156_g_error;
		}
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp3_;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = NULL;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		info = _tmp6_;
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 8706 "Photo.c"
	}
	goto __finally156;
	__catch156_g_error:
	{
		GError* err = NULL;
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8726 "Photo.c"
	}
	__finally156:
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 8741 "Photo.c"
	}
#line 1064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = info;
#line 1064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = g_file_info_get_file_type (_tmp7_);
#line 1064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_ != G_FILE_TYPE_REGULAR) {
#line 1065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8757 "Photo.c"
	}
#line 1067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = file;
#line 1067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = photo_is_file_image (_tmp9_);
#line 1067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp10_) {
#line 8765 "Photo.c"
		GFile* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
#line 1068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = file;
#line 1068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = g_file_get_path (_tmp11_);
#line 1068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 1068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_message ("Photo.vala:1068: Not importing %s: Not an image file", _tmp13_);
#line 1068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp13_);
#line 1070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8787 "Photo.c"
	}
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = file;
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = photo_file_format_is_file_supported (_tmp14_);
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp15_) {
#line 8795 "Photo.c"
		GFile* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 1074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = file;
#line 1074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = g_file_get_path (_tmp16_);
#line 1074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 1074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_message ("Photo.vala:1074: Not importing %s: Unsupported extension", _tmp18_);
#line 1074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp18_);
#line 1076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8817 "Photo.c"
	}
#line 1079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = info;
#line 1079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp19_, &_tmp20_);
#line 1079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	timestamp = _tmp20_;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = params;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = _tmp23_->exif_md5;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 8831 "Photo.c"
		PhotoImportParams* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = params;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = _tmp25_->thumbnail_md5;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = _tmp26_ != NULL;
#line 8840 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = FALSE;
#line 8844 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp22_) {
#line 8848 "Photo.c"
		PhotoImportParams* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp27_ = params;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp28_ = _tmp27_->full_md5;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = _tmp28_ != NULL;
#line 8857 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = FALSE;
#line 8861 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp21_) {
#line 8865 "Photo.c"
		PhotoImportParams* _tmp29_ = NULL;
		PhotoImportParams* _tmp30_ = NULL;
		PhotoFileSnifferOptions _tmp31_ = 0;
#line 1083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_ = params;
#line 1083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = params;
#line 1083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = _tmp30_->sniffer_options;
#line 1083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_->sniffer_options = _tmp31_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 8877 "Photo.c"
	}
#line 1086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = file;
#line 1086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = params;
#line 1086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _tmp33_->sniffer_options;
#line 1086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = photo_file_interrogator_new (_tmp32_, _tmp34_);
#line 1086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	interrogator = _tmp35_;
#line 8889 "Photo.c"
	{
		PhotoFileInterrogator* _tmp36_ = NULL;
#line 1088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = interrogator;
#line 1088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp36_, &_inner_error_);
#line 1088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 8898 "Photo.c"
			goto __catch157_g_error;
		}
	}
	goto __finally157;
	__catch157_g_error:
	{
		GError* err = NULL;
		GFile* _tmp37_ = NULL;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		GError* _tmp40_ = NULL;
		const gchar* _tmp41_ = NULL;
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = file;
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp38_ = g_file_get_path (_tmp37_);
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = err;
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = _tmp40_->message;
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:1090: Unable to interrogate photo file %s: %s", _tmp39_, _tmp41_);
#line 1090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp39_);
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8941 "Photo.c"
	}
	__finally157:
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 8958 "Photo.c"
	}
#line 1096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = interrogator;
#line 1096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = photo_file_interrogator_get_detected_photo_information (_tmp42_);
#line 1096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp43_;
#line 1097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = detected;
#line 1097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp44_ == NULL) {
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 8982 "Photo.c"
	}
#line 1101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = params;
#line 1101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = _tmp45_->sniffer_options;
#line 1101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((_tmp46_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 8990 "Photo.c"
		DetectedPhotoInformation* _tmp47_ = NULL;
		PhotoImportParams* _tmp48_ = NULL;
		const gchar* _tmp49_ = NULL;
		gchar* _tmp50_ = NULL;
		DetectedPhotoInformation* _tmp51_ = NULL;
		PhotoImportParams* _tmp52_ = NULL;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		DetectedPhotoInformation* _tmp55_ = NULL;
		PhotoImportParams* _tmp56_ = NULL;
		const gchar* _tmp57_ = NULL;
		gchar* _tmp58_ = NULL;
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = detected;
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = params;
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = _tmp48_->exif_md5;
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp47_->exif_md5);
#line 1102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_->exif_md5 = _tmp50_;
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_ = detected;
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = params;
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = _tmp52_->thumbnail_md5;
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp54_ = g_strdup (_tmp53_);
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp51_->thumbnail_md5);
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_->thumbnail_md5 = _tmp54_;
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp55_ = detected;
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp56_ = params;
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp57_ = _tmp56_->full_md5;
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = g_strdup (_tmp57_);
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp55_->md5);
#line 1104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp55_->md5 = _tmp58_;
#line 9039 "Photo.c"
	}
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp59_ = g_strdup ("");
#line 1109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	title = _tmp59_;
#line 1110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp60_ = g_strdup ("");
#line 1110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	comment = _tmp60_;
#line 1117 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp61_ = detected;
#line 1117 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp62_ = _tmp61_->metadata;
#line 1117 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 9059 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp63_ = NULL;
		PhotoMetadata* _tmp64_ = NULL;
		MetadataDateTime* _tmp65_ = NULL;
		MetadataDateTime* _tmp66_ = NULL;
		DetectedPhotoInformation* _tmp69_ = NULL;
		PhotoMetadata* _tmp70_ = NULL;
		Orientation _tmp71_ = 0;
		DetectedPhotoInformation* _tmp72_ = NULL;
		PhotoMetadata* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		DetectedPhotoInformation* _tmp75_ = NULL;
		PhotoMetadata* _tmp76_ = NULL;
		gchar* _tmp77_ = NULL;
		PhotoImportParams* _tmp78_ = NULL;
		DetectedPhotoInformation* _tmp79_ = NULL;
		PhotoMetadata* _tmp80_ = NULL;
		GeeSet* _tmp81_ = NULL;
#line 1118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp63_ = detected;
#line 1118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp65_ = photo_metadata_get_exposure_date_time (_tmp64_);
#line 1118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		date_time = _tmp65_;
#line 1119 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp66_ = date_time;
#line 1119 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp66_ != NULL) {
#line 9090 "Photo.c"
			MetadataDateTime* _tmp67_ = NULL;
			time_t _tmp68_ = 0;
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp67_ = date_time;
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp68_ = metadata_date_time_get_timestamp (_tmp67_);
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			exposure_time = _tmp68_;
#line 9099 "Photo.c"
		}
#line 1122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp69_ = detected;
#line 1122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp71_ = photo_metadata_get_orientation (_tmp70_);
#line 1122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		orientation = _tmp71_;
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp72_ = detected;
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp74_ = media_metadata_get_title ((MediaMetadata*) _tmp73_);
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (title);
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		title = _tmp74_;
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp75_ = detected;
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp76_ = _tmp75_->metadata;
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp77_ = media_metadata_get_comment ((MediaMetadata*) _tmp76_);
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (comment);
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		comment = _tmp77_;
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp78_ = params;
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp79_ = detected;
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp81_ = photo_metadata_get_keywords (_tmp80_, NULL, NULL, NULL);
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp78_->keywords);
#line 1125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp78_->keywords = (GeeCollection*) _tmp81_;
#line 1117 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 9143 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp84_ = detected;
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp85_ = _tmp84_->colorspace;
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp85_ != GDK_COLORSPACE_RGB) {
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = TRUE;
#line 9153 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp86_ = NULL;
		gint _tmp87_ = 0;
#line 1130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp86_ = detected;
#line 1130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp87_ = _tmp86_->channels;
#line 1130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = _tmp87_ < 3;
#line 9163 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp83_) {
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp82_ = TRUE;
#line 9169 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp88_ = NULL;
		gint _tmp89_ = 0;
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp88_ = detected;
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp89_ = _tmp88_->bits_per_channel;
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp82_ = _tmp89_ != 8;
#line 9179 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp82_) {
#line 9183 "Photo.c"
		GFile* _tmp90_ = NULL;
		gchar* _tmp91_ = NULL;
		gchar* _tmp92_ = NULL;
#line 1132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp90_ = file;
#line 1132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp91_ = g_file_get_path (_tmp90_);
#line 1132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp92_ = _tmp91_;
#line 1132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_message ("Photo.vala:1132: Not importing %s: Unsupported color format", _tmp92_);
#line 1132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp92_);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (comment);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (title);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 9213 "Photo.c"
	}
#line 1140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp93_ = params;
#line 1140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp94_ = _tmp93_->row;
#line 1140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id_init (&_tmp94_->photo_id, PHOTO_ID_INVALID);
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp95_ = params;
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp96_ = _tmp95_->row;
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp97_ = _tmp96_->master;
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp98_ = file;
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp99_ = g_file_get_path (_tmp98_);
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp97_->filepath);
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp97_->filepath = _tmp99_;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp100_ = params;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp101_ = _tmp100_->row;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp102_ = _tmp101_->master;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp103_ = detected;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp104_ = _tmp103_->image_dim;
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp102_->dim = _tmp104_;
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp105_ = params;
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp106_ = _tmp105_->row;
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp107_ = _tmp106_->master;
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp108_ = info;
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp109_ = g_file_info_get_size (_tmp108_);
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp107_->filesize = _tmp109_;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp110_ = params;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp111_ = _tmp110_->row;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp112_ = _tmp111_->master;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp113_ = timestamp;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp114_ = _tmp113_.tv_sec;
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp112_->timestamp = (time_t) _tmp114_;
#line 1145 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp115_ = params;
#line 1145 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp116_ = _tmp115_->row;
#line 1145 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp117_ = exposure_time;
#line 1145 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp116_->exposure_time = _tmp117_;
#line 1146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp118_ = params;
#line 1146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp119_ = _tmp118_->row;
#line 1146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp120_ = orientation;
#line 1146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp119_->orientation = _tmp120_;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp121_ = params;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp122_ = _tmp121_->row;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp123_ = _tmp122_->master;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp124_ = orientation;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp123_->original_orientation = _tmp124_;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp125_ = params;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp126_ = _tmp125_->row;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp127_ = params;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp128_ = _tmp127_->import_id;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp126_->import_id = _tmp128_;
#line 1149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp129_ = params;
#line 1149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp130_ = _tmp129_->row;
#line 1149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	event_id_init (&_tmp130_->event_id, EVENT_ID_INVALID);
#line 1150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp131_ = params;
#line 1150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp132_ = _tmp131_->row;
#line 1150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp132_->transformations);
#line 1150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp132_->transformations = NULL;
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp133_ = params;
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp134_ = _tmp133_->row;
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp135_ = detected;
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp136_ = _tmp135_->md5;
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp137_ = g_strdup (_tmp136_);
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp134_->md5);
#line 1151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp134_->md5 = _tmp137_;
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp138_ = params;
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp139_ = _tmp138_->row;
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp140_ = detected;
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp141_ = _tmp140_->thumbnail_md5;
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp142_ = g_strdup (_tmp141_);
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp139_->thumbnail_md5);
#line 1152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp139_->thumbnail_md5 = _tmp142_;
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp143_ = params;
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp144_ = _tmp143_->row;
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp145_ = detected;
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp146_ = _tmp145_->exif_md5;
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp147_ = g_strdup (_tmp146_);
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp144_->exif_md5);
#line 1153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp144_->exif_md5 = _tmp147_;
#line 1154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp148_ = params;
#line 1154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp149_ = _tmp148_->row;
#line 1154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp149_->time_created = (time_t) 0;
#line 1155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp150_ = params;
#line 1155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp151_ = _tmp150_->row;
#line 1155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp151_->flags = (guint64) 0;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp152_ = params;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp153_ = _tmp152_->row;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp154_ = _tmp153_->master;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp155_ = detected;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp156_ = _tmp155_->file_format;
#line 1156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp154_->file_format = _tmp156_;
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp157_ = params;
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp158_ = _tmp157_->row;
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp159_ = title;
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp160_ = g_strdup (_tmp159_);
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp158_->title);
#line 1157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp158_->title = _tmp160_;
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp161_ = params;
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp162_ = _tmp161_->row;
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp163_ = comment;
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp164_ = g_strdup (_tmp163_);
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp162_->comment);
#line 1158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp162_->comment = _tmp164_;
#line 1160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp165_ = params;
#line 1160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp166_ = _tmp165_->thumbnails;
#line 1160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp166_ != NULL) {
#line 9417 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoImportParams* _tmp167_ = NULL;
		PhotoRow* _tmp168_ = NULL;
		BackingPhotoRow* _tmp169_ = NULL;
		PhotoFileFormat _tmp170_ = 0;
		PhotoImportParams* _tmp171_ = NULL;
		PhotoRow* _tmp172_ = NULL;
		BackingPhotoRow* _tmp173_ = NULL;
		const gchar* _tmp174_ = NULL;
		PhotoFileReader* _tmp175_ = NULL;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp167_ = params;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp168_ = _tmp167_->row;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp169_ = _tmp168_->master;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp170_ = _tmp169_->file_format;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp171_ = params;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp172_ = _tmp171_->row;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp173_ = _tmp172_->master;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp174_ = _tmp173_->filepath;
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp175_ = photo_file_format_create_reader (_tmp170_, _tmp174_);
#line 1161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		reader = _tmp175_;
#line 9448 "Photo.c"
		{
			PhotoImportParams* _tmp176_ = NULL;
			Thumbnails* _tmp177_ = NULL;
			PhotoFileReader* _tmp178_ = NULL;
			PhotoImportParams* _tmp179_ = NULL;
			PhotoRow* _tmp180_ = NULL;
			Orientation _tmp181_ = 0;
			PhotoImportParams* _tmp182_ = NULL;
			PhotoRow* _tmp183_ = NULL;
			BackingPhotoRow* _tmp184_ = NULL;
			Dimensions _tmp185_ = {0};
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp176_ = params;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp177_ = _tmp176_->thumbnails;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp178_ = reader;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp179_ = params;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp180_ = _tmp179_->row;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp181_ = _tmp180_->orientation;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp182_ = params;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp183_ = _tmp182_->row;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp184_ = _tmp183_->master;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp185_ = _tmp184_->dim;
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp177_, _tmp178_, _tmp181_, &_tmp185_, &_inner_error_);
#line 1164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9484 "Photo.c"
				goto __catch158_g_error;
			}
		}
		goto __finally158;
		__catch158_g_error:
		{
			GError* err = NULL;
			GError* _tmp186_ = NULL;
			ImportResult _tmp187_ = 0;
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp186_ = err;
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp187_ = import_result_convert_error (_tmp186_, IMPORT_RESULT_FILE_ERROR);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp187_;
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (comment);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (title);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 9522 "Photo.c"
		}
		__finally158:
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (comment);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (title);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0;
#line 9547 "Photo.c"
		}
#line 1160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 9551 "Photo.c"
	}
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (comment);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (title);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 9569 "Photo.c"
}


void photo_create_pre_import (PhotoImportParams* params) {
	GFile* file = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	PhotoImportParams* _tmp3_ = NULL;
	PhotoRow* _tmp4_ = NULL;
	PhotoImportParams* _tmp5_ = NULL;
	PhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	PhotoImportParams* _tmp9_ = NULL;
	PhotoRow* _tmp10_ = NULL;
	BackingPhotoRow* _tmp11_ = NULL;
	PhotoImportParams* _tmp12_ = NULL;
	PhotoRow* _tmp13_ = NULL;
	BackingPhotoRow* _tmp14_ = NULL;
	PhotoImportParams* _tmp15_ = NULL;
	PhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_ = NULL;
	PhotoImportParams* _tmp18_ = NULL;
	PhotoRow* _tmp19_ = NULL;
	PhotoImportParams* _tmp20_ = NULL;
	PhotoRow* _tmp21_ = NULL;
	PhotoImportParams* _tmp22_ = NULL;
	PhotoRow* _tmp23_ = NULL;
	BackingPhotoRow* _tmp24_ = NULL;
	PhotoImportParams* _tmp25_ = NULL;
	PhotoRow* _tmp26_ = NULL;
	PhotoImportParams* _tmp27_ = NULL;
	ImportID _tmp28_ = {0};
	PhotoImportParams* _tmp29_ = NULL;
	PhotoRow* _tmp30_ = NULL;
	PhotoImportParams* _tmp31_ = NULL;
	PhotoRow* _tmp32_ = NULL;
	PhotoImportParams* _tmp33_ = NULL;
	PhotoRow* _tmp34_ = NULL;
	PhotoImportParams* _tmp35_ = NULL;
	PhotoRow* _tmp36_ = NULL;
	PhotoImportParams* _tmp37_ = NULL;
	PhotoRow* _tmp38_ = NULL;
	PhotoImportParams* _tmp39_ = NULL;
	PhotoRow* _tmp40_ = NULL;
	PhotoImportParams* _tmp41_ = NULL;
	PhotoRow* _tmp42_ = NULL;
	PhotoImportParams* _tmp43_ = NULL;
	PhotoRow* _tmp44_ = NULL;
	BackingPhotoRow* _tmp45_ = NULL;
	PhotoImportParams* _tmp46_ = NULL;
	PhotoRow* _tmp47_ = NULL;
	PhotoImportParams* _tmp48_ = NULL;
	PhotoRow* _tmp49_ = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoImportParams* _tmp50_ = NULL;
	GFile* _tmp51_ = NULL;
	PhotoImportParams* _tmp52_ = NULL;
	PhotoFileSnifferOptions _tmp53_ = 0;
	PhotoFileInterrogator* _tmp54_ = NULL;
	GError * _inner_error_ = NULL;
#line 1177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (params != NULL);
#line 1178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = params;
#line 1178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp2_;
#line 1179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = params;
#line 1179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_->row;
#line 1179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id_init (&_tmp4_->photo_id, PHOTO_ID_INVALID);
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = params;
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = _tmp5_->row;
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = g_file_get_path (file);
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp7_->filepath);
#line 1180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_->filepath = _tmp8_;
#line 1181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = params;
#line 1181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = _tmp9_->row;
#line 1181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_init (&_tmp11_->dim, 0, 0);
#line 1182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = params;
#line 1182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_->row;
#line 1182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = _tmp13_->master;
#line 1182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_->filesize = (gint64) 0;
#line 1183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = params;
#line 1183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = _tmp15_->row;
#line 1183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = _tmp16_->master;
#line 1183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_->timestamp = (time_t) 0;
#line 1184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = params;
#line 1184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_->row;
#line 1184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_->exposure_time = (time_t) 0;
#line 1185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = params;
#line 1185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = _tmp20_->row;
#line 1185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_->orientation = ORIENTATION_TOP_LEFT;
#line 1186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = params;
#line 1186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = _tmp22_->row;
#line 1186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = _tmp23_->master;
#line 1186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = params;
#line 1187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = _tmp25_->row;
#line 1187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = params;
#line 1187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = _tmp27_->import_id;
#line 1187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_->import_id = _tmp28_;
#line 1188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = params;
#line 1188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = _tmp29_->row;
#line 1188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	event_id_init (&_tmp30_->event_id, EVENT_ID_INVALID);
#line 1189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = params;
#line 1189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp31_->row;
#line 1189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp32_->transformations);
#line 1189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_->transformations = NULL;
#line 1190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = params;
#line 1190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _tmp33_->row;
#line 1190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp34_->md5);
#line 1190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_->md5 = NULL;
#line 1191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = params;
#line 1191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_->row;
#line 1191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp36_->thumbnail_md5);
#line 1191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_->thumbnail_md5 = NULL;
#line 1192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = params;
#line 1192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = _tmp37_->row;
#line 1192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp38_->exif_md5);
#line 1192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_->exif_md5 = NULL;
#line 1193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = params;
#line 1193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = _tmp39_->row;
#line 1193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_->time_created = (time_t) 0;
#line 1194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = params;
#line 1194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = _tmp41_->row;
#line 1194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_->flags = (guint64) 0;
#line 1195 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = params;
#line 1195 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = _tmp43_->row;
#line 1195 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = _tmp44_->master;
#line 1195 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = params;
#line 1196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = _tmp46_->row;
#line 1196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp47_->title);
#line 1196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_->title = NULL;
#line 1197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp48_ = params;
#line 1197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp49_ = _tmp48_->row;
#line 1197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp49_->comment);
#line 1197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp49_->comment = NULL;
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = params;
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = _tmp50_->file;
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp52_ = params;
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp53_ = _tmp52_->sniffer_options;
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp54_ = photo_file_interrogator_new (_tmp51_, _tmp53_);
#line 1199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	interrogator = _tmp54_;
#line 9800 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp55_ = NULL;
		DetectedPhotoInformation* _tmp56_ = NULL;
#line 1201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9809 "Photo.c"
			goto __catch159_g_error;
		}
#line 1202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp55_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		detected = _tmp55_;
#line 1203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp56_ = detected;
#line 1203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp56_ != NULL) {
#line 9820 "Photo.c"
			PhotoImportParams* _tmp57_ = NULL;
			PhotoRow* _tmp58_ = NULL;
			BackingPhotoRow* _tmp59_ = NULL;
			DetectedPhotoInformation* _tmp60_ = NULL;
			PhotoFileFormat _tmp61_ = 0;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp57_ = params;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp58_ = _tmp57_->row;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp59_ = _tmp58_->master;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp60_ = detected;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp61_ = _tmp60_->file_format;
#line 1204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp59_->file_format = _tmp61_;
#line 9838 "Photo.c"
		}
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 9842 "Photo.c"
	}
	goto __finally159;
	__catch159_g_error:
	{
		GError* err = NULL;
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_ = NULL;
		GError* _tmp64_ = NULL;
		const gchar* _tmp65_ = NULL;
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp62_ = g_file_get_path (file);
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp63_ = _tmp62_;
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp64_ = err;
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp65_ = _tmp64_->message;
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_debug ("Photo.vala:1206: Unable to interrogate photo file %s: %s", _tmp63_, _tmp65_);
#line 1206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp63_);
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 9870 "Photo.c"
	}
	__finally159:
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 9885 "Photo.c"
	}
#line 1177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 9891 "Photo.c"
}


BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error) {
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp10_ = NULL;
	PhotoFileSnifferOptions _tmp11_ = 0;
	PhotoFileInterrogator* _tmp12_ = NULL;
	PhotoFileInterrogator* _tmp13_ = NULL;
	PhotoFileInterrogator* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	DetectedPhotoInformation* _tmp16_ = NULL;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp19_ = NULL;
	GTimeVal _tmp20_ = {0};
	BackingPhotoRow* _tmp21_ = NULL;
	GFile* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	BackingPhotoRow* _tmp24_ = NULL;
	GTimeVal _tmp25_ = {0};
	glong _tmp26_ = 0L;
	BackingPhotoRow* _tmp27_ = NULL;
	GFileInfo* _tmp28_ = NULL;
	gint64 _tmp29_ = 0LL;
	BackingPhotoRow* _tmp30_ = NULL;
	DetectedPhotoInformation* _tmp31_ = NULL;
	PhotoFileFormat _tmp32_ = 0;
	BackingPhotoRow* _tmp33_ = NULL;
	DetectedPhotoInformation* _tmp34_ = NULL;
	Dimensions _tmp35_ = {0};
	Orientation _tmp36_ = 0;
	DetectedPhotoInformation* _tmp37_ = NULL;
	PhotoMetadata* _tmp38_ = NULL;
	BackingPhotoRow* _tmp42_ = NULL;
	GError * _inner_error_ = NULL;
#line 1210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_detected = NULL;
#line 1214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing = _tmp0_;
#line 1216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	info = NULL;
#line 9946 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_ = NULL;
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = file;
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9960 "Photo.c"
			goto __catch160_g_error;
		}
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		info = _tmp4_;
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 9973 "Photo.c"
	}
	goto __finally160;
	__catch160_g_error:
	{
		GError* err = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = file;
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = err;
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("Photo.vala:1221: Unable to read file information for %s: %s", _tmp7_, _tmp9_);
#line 1221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (detected) {
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*detected = _vala_detected;
#line 10014 "Photo.c"
		} else {
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10018 "Photo.c"
		}
#line 1223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 10022 "Photo.c"
	}
	__finally160:
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 10035 "Photo.c"
	}
#line 1227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = file;
#line 1227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = options;
#line 1227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo_file_interrogator_new (_tmp10_, _tmp11_);
#line 1227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	interrogator = _tmp12_;
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = interrogator;
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp13_, &_inner_error_);
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 10061 "Photo.c"
	}
#line 1229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = interrogator;
#line 1229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = photo_file_interrogator_get_detected_photo_information (_tmp14_);
#line 1229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_detected = _tmp15_;
#line 1230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = _vala_detected;
#line 1230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 10075 "Photo.c"
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 1231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = data_object_to_string ((DataObject*) self);
#line 1231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 1231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("Photo.vala:1231: Photo update: %s no longer a recognized image", _tmp18_);
#line 1231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp18_);
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (detected) {
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*detected = _vala_detected;
#line 10098 "Photo.c"
		} else {
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10102 "Photo.c"
		}
#line 1233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 10106 "Photo.c"
	}
#line 1236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = info;
#line 1236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp19_, &_tmp20_);
#line 1236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	modification_time = _tmp20_;
#line 1238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = backing;
#line 1238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = file;
#line 1238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = g_file_get_path (_tmp22_);
#line 1238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp21_->filepath);
#line 1238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_->filepath = _tmp23_;
#line 1239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = backing;
#line 1239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = modification_time;
#line 1239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = _tmp25_.tv_sec;
#line 1239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_->timestamp = (time_t) _tmp26_;
#line 1240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = backing;
#line 1240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = info;
#line 1240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = g_file_info_get_size (_tmp28_);
#line 1240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_->filesize = _tmp29_;
#line 1241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = backing;
#line 1241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = _vala_detected;
#line 1241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp31_->file_format;
#line 1241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_->file_format = _tmp32_;
#line 1242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = backing;
#line 1242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _vala_detected;
#line 1242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = _tmp34_->image_dim;
#line 1242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_->dim = _tmp35_;
#line 1243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = _vala_detected;
#line 1243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = _tmp37_->metadata;
#line 1243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp38_ != NULL) {
#line 10162 "Photo.c"
		DetectedPhotoInformation* _tmp39_ = NULL;
		PhotoMetadata* _tmp40_ = NULL;
		Orientation _tmp41_ = 0;
#line 1244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = _vala_detected;
#line 1244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = _tmp39_->metadata;
#line 1244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = photo_metadata_get_orientation (_tmp40_);
#line 1244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = _tmp41_;
#line 10174 "Photo.c"
	} else {
#line 1244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = ORIENTATION_TOP_LEFT;
#line 10178 "Photo.c"
	}
#line 1243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = backing;
#line 1243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_->original_orientation = _tmp36_;
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = backing;
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (detected) {
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*detected = _vala_detected;
#line 10194 "Photo.c"
	} else {
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 10198 "Photo.c"
	}
#line 1246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 10202 "Photo.c"
}


static void _vala_array_add100 (gchar*** array, int* length, int* size, gchar* value) {
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10213 "Photo.c"
	}
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10219 "Photo.c"
}


static void _vala_array_add101 (gchar*** array, int* length, int* size, gchar* value) {
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10230 "Photo.c"
	}
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10236 "Photo.c"
}


static void _vala_array_add102 (gchar*** array, int* length, int* size, gchar* value) {
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10247 "Photo.c"
	}
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10253 "Photo.c"
}


static void _vala_array_add103 (gchar*** array, int* length, int* size, gchar* value) {
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10264 "Photo.c"
	}
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10270 "Photo.c"
}


static void _vala_array_add104 (gchar*** array, int* length, int* size, gchar* value) {
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10281 "Photo.c"
	}
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10287 "Photo.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 10294 "Photo.c"
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* _tmp7_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_ = NULL;
	GdkColorspace _tmp14_ = 0;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp22_ = NULL;
	gchar** list = NULL;
	gchar** _tmp27_ = NULL;
	gint list_length1 = 0;
	gint _list_size_ = 0;
	PhotoRow* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	DetectedPhotoInformation* _tmp30_ = NULL;
	const gchar* _tmp31_ = NULL;
	PhotoRow* _tmp34_ = NULL;
	BackingPhotoRow* _tmp35_ = NULL;
	Orientation _tmp36_ = 0;
	BackingPhotoRow* _tmp37_ = NULL;
	Orientation _tmp38_ = 0;
	DetectedPhotoInformation* _tmp45_ = NULL;
	PhotoMetadata* _tmp46_ = NULL;
	PhotoRow* _tmp76_ = NULL;
	BackingPhotoRow* _tmp77_ = NULL;
	BackingPhotoRow* _tmp78_ = NULL;
	PhotoRow* _tmp79_ = NULL;
	DetectedPhotoInformation* _tmp80_ = NULL;
	const gchar* _tmp81_ = NULL;
	gchar* _tmp82_ = NULL;
	PhotoRow* _tmp83_ = NULL;
	DetectedPhotoInformation* _tmp84_ = NULL;
	const gchar* _tmp85_ = NULL;
	gchar* _tmp86_ = NULL;
	PhotoRow* _tmp87_ = NULL;
	DetectedPhotoInformation* _tmp88_ = NULL;
	const gchar* _tmp89_ = NULL;
	gchar* _tmp90_ = NULL;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp91_ = NULL;
	PhotoMetadata* _tmp92_ = NULL;
	PhotoRow* _tmp115_ = NULL;
	PhotoMetadata* _tmp116_ = NULL;
	gchar** _tmp117_ = NULL;
	gint _tmp117__length1 = 0;
	PhotoReimportMasterStateImpl* _tmp118_ = NULL;
	GError * _inner_error_ = NULL;
#line 1310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp3_;
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = file;
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error_);
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp5_;
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing = _tmp6_;
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 10395 "Photo.c"
	}
#line 1318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = backing;
#line 1318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 10401 "Photo.c"
		GFile* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 1319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = file;
#line 1319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:1319: Unable to retrieve photo state from %s for reimport", _tmp10_);
#line 1319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (reimport_state) {
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10427 "Photo.c"
		} else {
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10431 "Photo.c"
		}
#line 1320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 10435 "Photo.c"
	}
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = detected;
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = _tmp13_->colorspace;
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp14_ != GDK_COLORSPACE_RGB) {
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 10445 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_ = NULL;
		gint _tmp16_ = 0;
#line 1325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = detected;
#line 1325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp15_->channels;
#line 1325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _tmp16_ < 3;
#line 10455 "Photo.c"
	}
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_) {
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 10461 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp17_ = NULL;
		gint _tmp18_ = 0;
#line 1326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = detected;
#line 1326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = _tmp17_->bits_per_channel;
#line 1326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp18_ != 8;
#line 10471 "Photo.c"
	}
#line 1324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 10475 "Photo.c"
		GFile* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
#line 1327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = file;
#line 1327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = g_file_get_path (_tmp19_);
#line 1327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:1327: Not re-importing %s: Unsupported color format", _tmp21_);
#line 1327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp21_);
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (reimport_state) {
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10501 "Photo.c"
		} else {
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10505 "Photo.c"
		}
#line 1329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 10509 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = photo_row_new ();
#line 1333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	updated_row = _tmp22_;
#line 10515 "Photo.c"
	{
		PhotoRow* _tmp23_ = NULL;
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = self->row;
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 10522 "Photo.c"
		{
			PhotoRow* _tmp24_ = NULL;
			PhotoRow* _tmp25_ = NULL;
#line 1335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = self->row;
#line 1335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = _photo_row_ref0 (_tmp24_);
#line 1335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			updated_row = _tmp25_;
#line 10534 "Photo.c"
		}
		__finally161:
		{
			PhotoRow* _tmp26_ = NULL;
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = self->row;
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10543 "Photo.c"
		}
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 10559 "Photo.c"
		}
	}
#line 1339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = g_new0 (gchar*, 0 + 1);
#line 1339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	list = _tmp27_;
#line 1339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	list_length1 = 0;
#line 1339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_list_size_ = list_length1;
#line 1341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = updated_row;
#line 1341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = _tmp28_->md5;
#line 1341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = detected;
#line 1341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_strcmp0 (_tmp29_, _tmp31_) != 0) {
#line 10580 "Photo.c"
		gchar** _tmp32_ = NULL;
		gint _tmp32__length1 = 0;
		gchar* _tmp33_ = NULL;
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp32_ = list;
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp32__length1 = list_length1;
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp33_ = g_strdup ("metadata:md5");
#line 1342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add100 (&list, &list_length1, &_list_size_, _tmp33_);
#line 10592 "Photo.c"
	}
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = updated_row;
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = _tmp34_->master;
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_->original_orientation;
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = backing;
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp36_ != _tmp38_) {
#line 10606 "Photo.c"
		gchar** _tmp39_ = NULL;
		gint _tmp39__length1 = 0;
		gchar* _tmp40_ = NULL;
		PhotoRow* _tmp41_ = NULL;
		BackingPhotoRow* _tmp42_ = NULL;
		BackingPhotoRow* _tmp43_ = NULL;
		Orientation _tmp44_ = 0;
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = list;
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39__length1 = list_length1;
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = g_strdup ("image:orientation");
#line 1345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add101 (&list, &list_length1, &_list_size_, _tmp40_);
#line 1346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = updated_row;
#line 1346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = _tmp41_->master;
#line 1346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = backing;
#line 1346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp44_ = _tmp43_->original_orientation;
#line 1346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_->original_orientation = _tmp44_;
#line 10632 "Photo.c"
	}
#line 1349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = detected;
#line 1349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = _tmp45_->metadata;
#line 1349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp46_ != NULL) {
#line 10640 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp47_ = NULL;
		PhotoMetadata* _tmp48_ = NULL;
		MetadataDateTime* _tmp49_ = NULL;
		gboolean _tmp50_ = FALSE;
		MetadataDateTime* _tmp51_ = NULL;
		PhotoRow* _tmp58_ = NULL;
		const gchar* _tmp59_ = NULL;
		DetectedPhotoInformation* _tmp60_ = NULL;
		PhotoMetadata* _tmp61_ = NULL;
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_ = NULL;
		gboolean _tmp64_ = FALSE;
		PhotoRow* _tmp67_ = NULL;
		const gchar* _tmp68_ = NULL;
		DetectedPhotoInformation* _tmp69_ = NULL;
		PhotoMetadata* _tmp70_ = NULL;
		gchar* _tmp71_ = NULL;
		gchar* _tmp72_ = NULL;
		gboolean _tmp73_ = FALSE;
#line 1350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = detected;
#line 1350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = photo_metadata_get_exposure_date_time (_tmp48_);
#line 1350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		date_time = _tmp49_;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_ = date_time;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp51_ != NULL) {
#line 10673 "Photo.c"
			PhotoRow* _tmp52_ = NULL;
			time_t _tmp53_ = 0;
			MetadataDateTime* _tmp54_ = NULL;
			time_t _tmp55_ = 0;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp52_ = updated_row;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp53_ = _tmp52_->exposure_time;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp54_ = date_time;
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp55_ = metadata_date_time_get_timestamp (_tmp54_);
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp50_ = _tmp53_ != _tmp55_;
#line 10688 "Photo.c"
		} else {
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp50_ = FALSE;
#line 10692 "Photo.c"
		}
#line 1351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp50_) {
#line 10696 "Photo.c"
			gchar** _tmp56_ = NULL;
			gint _tmp56__length1 = 0;
			gchar* _tmp57_ = NULL;
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp56_ = list;
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp56__length1 = list_length1;
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp57_ = g_strdup ("metadata:exposure-time");
#line 1352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add102 (&list, &list_length1, &_list_size_, _tmp57_);
#line 10708 "Photo.c"
		}
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = updated_row;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp59_ = _tmp58_->title;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp60_ = detected;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp61_ = _tmp60_->metadata;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp62_ = media_metadata_get_title ((MediaMetadata*) _tmp61_);
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp63_ = _tmp62_;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp64_ = g_strcmp0 (_tmp59_, _tmp63_) != 0;
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp63_);
#line 1354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp64_) {
#line 10728 "Photo.c"
			gchar** _tmp65_ = NULL;
			gint _tmp65__length1 = 0;
			gchar* _tmp66_ = NULL;
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp65_ = list;
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp65__length1 = list_length1;
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp66_ = g_strdup ("metadata:name");
#line 1355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add103 (&list, &list_length1, &_list_size_, _tmp66_);
#line 10740 "Photo.c"
		}
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp67_ = updated_row;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp68_ = _tmp67_->comment;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp69_ = detected;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp71_ = media_metadata_get_comment ((MediaMetadata*) _tmp70_);
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp72_ = _tmp71_;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp73_ = g_strcmp0 (_tmp68_, _tmp72_) != 0;
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp72_);
#line 1357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp73_) {
#line 10760 "Photo.c"
			gchar** _tmp74_ = NULL;
			gint _tmp74__length1 = 0;
			gchar* _tmp75_ = NULL;
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp74_ = list;
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp74__length1 = list_length1;
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp75_ = g_strdup ("metadata:comment");
#line 1358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add104 (&list, &list_length1, &_list_size_, _tmp75_);
#line 10772 "Photo.c"
		}
#line 1349 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10776 "Photo.c"
	}
#line 1361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp76_ = updated_row;
#line 1361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp77_ = backing;
#line 1361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp78_ = _backing_photo_row_ref0 (_tmp77_);
#line 1361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp76_->master);
#line 1361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp76_->master = _tmp78_;
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp79_ = updated_row;
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp80_ = detected;
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp81_ = _tmp80_->md5;
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp82_ = g_strdup (_tmp81_);
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp79_->md5);
#line 1362 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp79_->md5 = _tmp82_;
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp83_ = updated_row;
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp84_ = detected;
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp85_ = _tmp84_->exif_md5;
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp86_ = g_strdup (_tmp85_);
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp83_->exif_md5);
#line 1363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp83_->exif_md5 = _tmp86_;
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp87_ = updated_row;
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp88_ = detected;
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp89_ = _tmp88_->thumbnail_md5;
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp90_ = g_strdup (_tmp89_);
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp87_->thumbnail_md5);
#line 1364 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp87_->thumbnail_md5 = _tmp90_;
#line 1366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = NULL;
#line 1367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp91_ = detected;
#line 1367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp92_ = _tmp91_->metadata;
#line 1367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp92_ != NULL) {
#line 10832 "Photo.c"
		DetectedPhotoInformation* _tmp93_ = NULL;
		PhotoMetadata* _tmp94_ = NULL;
		PhotoMetadata* _tmp95_ = NULL;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp96_ = NULL;
		PhotoMetadata* _tmp97_ = NULL;
		MetadataDateTime* _tmp98_ = NULL;
		MetadataDateTime* _tmp99_ = NULL;
		PhotoRow* _tmp103_ = NULL;
		DetectedPhotoInformation* _tmp104_ = NULL;
		PhotoMetadata* _tmp105_ = NULL;
		gchar* _tmp106_ = NULL;
		PhotoRow* _tmp107_ = NULL;
		DetectedPhotoInformation* _tmp108_ = NULL;
		PhotoMetadata* _tmp109_ = NULL;
		gchar* _tmp110_ = NULL;
		PhotoRow* _tmp111_ = NULL;
		DetectedPhotoInformation* _tmp112_ = NULL;
		PhotoMetadata* _tmp113_ = NULL;
		gchar* _tmp114_ = NULL;
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp93_ = detected;
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp94_ = _tmp93_->metadata;
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp95_ = _media_metadata_ref0 (_tmp94_);
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		metadata = _tmp95_;
#line 1370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp96_ = detected;
#line 1370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp97_ = _tmp96_->metadata;
#line 1370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp98_ = photo_metadata_get_exposure_date_time (_tmp97_);
#line 1370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		date_time = _tmp98_;
#line 1371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp99_ = date_time;
#line 1371 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp99_ != NULL) {
#line 10875 "Photo.c"
			PhotoRow* _tmp100_ = NULL;
			MetadataDateTime* _tmp101_ = NULL;
			time_t _tmp102_ = 0;
#line 1372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp100_ = updated_row;
#line 1372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp101_ = date_time;
#line 1372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp102_ = metadata_date_time_get_timestamp (_tmp101_);
#line 1372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp100_->exposure_time = _tmp102_;
#line 10887 "Photo.c"
		}
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp103_ = updated_row;
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp104_ = detected;
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp105_ = _tmp104_->metadata;
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp106_ = media_metadata_get_title ((MediaMetadata*) _tmp105_);
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp103_->title);
#line 1374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp103_->title = _tmp106_;
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp107_ = updated_row;
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp108_ = detected;
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp109_ = _tmp108_->metadata;
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp110_ = media_metadata_get_comment ((MediaMetadata*) _tmp109_);
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp107_->comment);
#line 1375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp107_->comment = _tmp110_;
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp111_ = updated_row;
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp112_ = detected;
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp113_ = _tmp112_->metadata;
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp114_ = media_metadata_get_comment ((MediaMetadata*) _tmp113_);
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp111_->comment);
#line 1376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp111_->comment = _tmp114_;
#line 1367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10927 "Photo.c"
	}
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp115_ = updated_row;
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp116_ = metadata;
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp117_ = list;
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp117__length1 = list_length1;
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp118_ = photo_reimport_master_state_impl_new (_tmp115_, _tmp116_, _tmp117_, _tmp117__length1);
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_reimport_state = (PhotoReimportMasterState*) _tmp118_;
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (reimport_state) {
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 10961 "Photo.c"
	} else {
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10965 "Photo.c"
	}
#line 1381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 10969 "Photo.c"
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 10978 "Photo.c"
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 10987 "Photo.c"
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
#line 1388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 10994 "Photo.c"
}


static void _vala_array_add105 (gchar*** array, int* length, int* size, gchar* value) {
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11005 "Photo.c"
	}
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11011 "Photo.c"
}


static void _vala_array_add106 (gchar*** array, int* length, int* size, gchar* value) {
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11022 "Photo.c"
	}
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11028 "Photo.c"
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterState* _tmp0_ = NULL;
	PhotoReimportMasterStateImpl* _tmp1_ = NULL;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_ = NULL;
	PhotoRow* _tmp4_ = NULL;
	PhotoMetadata* _tmp20_ = NULL;
	gboolean _tmp22_ = FALSE;
	gchar** _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	PhotoMetadata* _tmp32_ = NULL;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = state;
#line 1388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_table_get_instance ();
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = reimport_state->row;
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_table_reimport (_tmp3_, _tmp4_, &_inner_error_);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp3_);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 11077 "Photo.c"
		} else {
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1390 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 11087 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp5_ = NULL;
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = self->row;
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11096 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp6_ = NULL;
			BackingPhotoRow* _tmp7_ = NULL;
			BackingPhotoRow* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoRow* _tmp10_ = NULL;
			PhotoRow* _tmp11_ = NULL;
			BackingPhotoRow* _tmp12_ = NULL;
			BackingPhotoRow* _tmp13_ = NULL;
			PhotoRow* _tmp14_ = NULL;
			BackingPhotoRow* _tmp15_ = NULL;
			PhotoRow* _tmp16_ = NULL;
			BackingPhotoRow* _tmp17_ = NULL;
			gboolean _tmp18_ = FALSE;
#line 1394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 1394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp6_->master;
#line 1394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _backing_photo_row_ref0 (_tmp7_);
#line 1394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			original_master = _tmp8_;
#line 1395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = reimport_state->row;
#line 1395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _photo_row_ref0 (_tmp9_);
#line 1395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->row = _tmp10_;
#line 1396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 1396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = original_master;
#line 1396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp11_->master);
#line 1396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_->master = _tmp13_;
#line 1397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 1397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = _tmp14_->master;
#line 1397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = reimport_state->row;
#line 1397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = _tmp16_->master;
#line 1397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_photo_row_copy_from (_tmp15_, _tmp17_);
#line 1398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = reimport_state->metadata_only;
#line 1398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp18_) {
#line 1399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11154 "Photo.c"
			}
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 11158 "Photo.c"
		}
		__finally162:
		{
			PhotoRow* _tmp19_ = NULL;
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11167 "Photo.c"
		}
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 11179 "Photo.c"
			} else {
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 11189 "Photo.c"
			}
		}
	}
#line 1402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = reimport_state->metadata;
#line 1402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 11197 "Photo.c"
		PhotoMetadata* _tmp21_ = NULL;
#line 1403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = reimport_state->metadata;
#line 1403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp21_);
#line 11203 "Photo.c"
	}
#line 1405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = reimport_state->metadata_only;
#line 1405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp22_) {
#line 11209 "Photo.c"
		gchar** _tmp23_ = NULL;
		gint _tmp23__length1 = 0;
		gchar* _tmp24_ = NULL;
		gboolean _tmp25_ = FALSE;
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = g_strdup ("image:master");
#line 1406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add105 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp24_);
#line 1407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = photo_is_master_baseline (self);
#line 1407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp25_) {
#line 11226 "Photo.c"
			gchar** _tmp26_ = NULL;
			gint _tmp26__length1 = 0;
			gchar* _tmp27_ = NULL;
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = reimport_state->alterations;
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26__length1 = reimport_state->alterations_length1;
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = g_strdup ("image:baseline");
#line 1408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add106 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp27_);
#line 11238 "Photo.c"
		}
	}
#line 1411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = reimport_state->alterations;
#line 1411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28__length1 = reimport_state->alterations_length1;
#line 1411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp28__length1 > 0) {
#line 11247 "Photo.c"
		gchar** _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		Alteration* _tmp30_ = NULL;
		Alteration* _tmp31_ = NULL;
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_ = reimport_state->alterations;
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29__length1 = reimport_state->alterations_length1;
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = alteration_new_from_array (_tmp29_, _tmp29__length1);
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = _tmp30_;
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp31_);
#line 1412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp31_);
#line 11264 "Photo.c"
	}
#line 1414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = reimport_state->metadata;
#line 1414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp32_);
#line 1416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = photo_is_master_baseline (self);
#line 1416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp33_) {
#line 11274 "Photo.c"
		PhotoMetadata* _tmp34_ = NULL;
#line 1417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp34_ = reimport_state->metadata;
#line 1417 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp34_);
#line 11280 "Photo.c"
	}
#line 1419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = photo_is_master_source (self);
#line 1419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp35_) {
#line 11286 "Photo.c"
		PhotoMetadata* _tmp36_ = NULL;
#line 1420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = reimport_state->metadata;
#line 1420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp36_);
#line 11292 "Photo.c"
	}
#line 1387 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 11296 "Photo.c"
}


static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	DetectedPhotoInformation* _tmp2_ = NULL;
	BackingPhotoRow* _tmp3_ = NULL;
	BackingPhotoRow* _tmp4_ = NULL;
	BackingPhotoRow* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_ = NULL;
	GdkColorspace _tmp9_ = 0;
	GError * _inner_error_ = NULL;
#line 1424 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1424 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_query_backing_photo_row (self, _tmp1_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp2_, &_inner_error_);
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_detected = _tmp2_;
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 11335 "Photo.c"
	}
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (backing) {
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*backing = _vala_backing;
#line 11357 "Photo.c"
		} else {
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11361 "Photo.c"
		}
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (detected) {
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11367 "Photo.c"
		} else {
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11371 "Photo.c"
		}
#line 1429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 11375 "Photo.c"
	}
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_->colorspace;
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp9_ != GDK_COLORSPACE_RGB) {
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = TRUE;
#line 11385 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_ = NULL;
		gint _tmp11_ = 0;
#line 1434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp10_->channels;
#line 1434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp11_ < 3;
#line 11395 "Photo.c"
	}
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_) {
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 11401 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_ = NULL;
		gint _tmp13_ = 0;
#line 1435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp13_ != 8;
#line 11411 "Photo.c"
	}
#line 1433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 11415 "Photo.c"
		GFile* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
#line 1436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = file;
#line 1436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = g_file_get_path (_tmp14_);
#line 1436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:1436: Not re-importing %s: Unsupported color format", _tmp16_);
#line 1436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (backing) {
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*backing = _vala_backing;
#line 11437 "Photo.c"
		} else {
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11441 "Photo.c"
		}
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (detected) {
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11447 "Photo.c"
		} else {
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11451 "Photo.c"
		}
#line 1438 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 11455 "Photo.c"
	}
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (backing) {
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*backing = _vala_backing;
#line 11465 "Photo.c"
	} else {
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 11469 "Photo.c"
	}
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (detected) {
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*detected = _vala_detected;
#line 11475 "Photo.c"
	} else {
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11479 "Photo.c"
	}
#line 1441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 11483 "Photo.c"
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_ = NULL;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	BackingPhotoRow* _tmp7_ = NULL;
	DetectedPhotoInformation* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoReimportEditableStateImpl* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 1445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = NULL;
#line 1448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp0_;
#line 1449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 1449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 11527 "Photo.c"
		} else {
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11531 "Photo.c"
		}
#line 1450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 11535 "Photo.c"
	}
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = file;
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing = _tmp4_;
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp5_;
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 11563 "Photo.c"
	}
#line 1454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp2_) {
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 11579 "Photo.c"
		} else {
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11583 "Photo.c"
		}
#line 1455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 11587 "Photo.c"
	}
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = backing;
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = detected;
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_->metadata;
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = photo_reimport_editable_state_impl_new (_tmp7_, _tmp9_);
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = (PhotoReimportEditableState*) _tmp10_;
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (state) {
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*state = _vala_state;
#line 11613 "Photo.c"
	} else {
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 11617 "Photo.c"
	}
#line 1459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 11621 "Photo.c"
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
#line 1468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 11628 "Photo.c"
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableState* _tmp2_ = NULL;
	PhotoReimportEditableStateImpl* _tmp3_ = NULL;
	PhotoReimportEditableStateImpl* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	PhotoReimportEditableStateImpl* _tmp21_ = NULL;
	PhotoMetadata* _tmp22_ = NULL;
	gchar* list = NULL;
	gchar* _tmp33_ = NULL;
	PhotoReimportEditableStateImpl* _tmp34_ = NULL;
	gboolean _tmp35_ = FALSE;
	const gchar* _tmp38_ = NULL;
	Alteration* _tmp39_ = NULL;
	Alteration* _tmp40_ = NULL;
	PhotoReimportEditableStateImpl* _tmp41_ = NULL;
	PhotoMetadata* _tmp42_ = NULL;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp46_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable_id = _tmp0_;
#line 1465 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = backing_photo_id_is_invalid (&editable_id);
#line 1465 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 1466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 11669 "Photo.c"
	}
#line 1468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = state;
#line 1468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reimport_state = _tmp3_;
#line 1470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = reimport_state;
#line 1470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_->metadata_only;
#line 1470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp5_) {
#line 11683 "Photo.c"
		BackingPhotoTable* _tmp6_ = NULL;
		BackingPhotoTable* _tmp7_ = NULL;
		PhotoReimportEditableStateImpl* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_ = NULL;
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = backing_photo_table_get_instance ();
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = reimport_state;
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = _tmp8_->backing_state;
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		backing_photo_table_update (_tmp7_, _tmp9_, &_inner_error_);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp7_);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 11710 "Photo.c"
			} else {
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 11720 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp10_ = NULL;
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 11729 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp11_ = NULL;
				BackingPhotoRow* _tmp12_ = NULL;
				BackingPhotoRow* _tmp13_ = NULL;
				PhotoReimportEditableStateImpl* _tmp14_ = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
				Orientation _tmp16_ = 0;
#line 1474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->editable = _tmp13_;
#line 1475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = reimport_state;
#line 1475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _tmp14_->backing_state;
#line 1475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 1475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_set_orientation (self, _tmp16_);
#line 1476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11757 "Photo.c"
			}
			__finally163:
			{
				PhotoRow* _tmp17_ = NULL;
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = self->row;
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11766 "Photo.c"
			}
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 11778 "Photo.c"
				} else {
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 11788 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp18_ = NULL;
		BackingPhotoRow* _tmp19_ = NULL;
		Orientation _tmp20_ = 0;
#line 1479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = _tmp18_->backing_state;
#line 1479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = _tmp19_->original_orientation;
#line 1479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_set_orientation (self, _tmp20_);
#line 11804 "Photo.c"
	}
#line 1482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = reimport_state;
#line 1482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = _tmp21_->metadata;
#line 1482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 11812 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp23_ = NULL;
		PhotoMetadata* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		PhotoReimportEditableStateImpl* _tmp27_ = NULL;
		PhotoMetadata* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		PhotoReimportEditableStateImpl* _tmp31_ = NULL;
		PhotoMetadata* _tmp32_ = NULL;
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = reimport_state;
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = _tmp23_->metadata;
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = media_metadata_get_title ((MediaMetadata*) _tmp24_);
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp26_);
#line 1483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp26_);
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp27_ = reimport_state;
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp28_ = _tmp27_->metadata;
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_ = media_metadata_get_comment ((MediaMetadata*) _tmp28_);
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp30_);
#line 1484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp30_);
#line 1485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 11853 "Photo.c"
	}
#line 1488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	list = _tmp33_;
#line 1489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = _tmp34_->metadata_only;
#line 1489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp35_) {
#line 11865 "Photo.c"
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
#line 1490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = list;
#line 1490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = g_strconcat (_tmp36_, "image:editable,image:baseline", NULL);
#line 1490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (list);
#line 1490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		list = _tmp37_;
#line 11876 "Photo.c"
	}
#line 1492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = list;
#line 1492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = alteration_new_from_list (_tmp38_);
#line 1492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 1492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp40_);
#line 1492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp40_);
#line 1494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = reimport_state;
#line 1494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = _tmp41_->metadata;
#line 1494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp42_);
#line 1496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = photo_is_editable_baseline (self);
#line 1496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp43_) {
#line 11898 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp44_ = NULL;
		PhotoMetadata* _tmp45_ = NULL;
#line 1497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp44_ = reimport_state;
#line 1497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = _tmp44_->metadata;
#line 1497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp45_);
#line 11907 "Photo.c"
	}
#line 1499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = photo_is_editable_source (self);
#line 1499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp46_) {
#line 11913 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp47_ = NULL;
		PhotoMetadata* _tmp48_ = NULL;
#line 1500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = reimport_state;
#line 1500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp48_);
#line 11922 "Photo.c"
	}
#line 1463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (list);
#line 1463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 11928 "Photo.c"
}


static gpointer _photo_reimport_raw_development_state_ref0 (gpointer self) {
#line 1522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 11935 "Photo.c"
}


gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error) {
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_ = NULL;
	PhotoReimportRawDevelopmentState* _tmp19_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	GError * _inner_error_ = NULL;
#line 1504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = NULL;
#line 1507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	files = _tmp0_;
#line 1508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = files;
#line 1508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (files);
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 11974 "Photo.c"
		} else {
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 11978 "Photo.c"
		}
#line 1509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 11982 "Photo.c"
	}
#line 1511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reimport_state = _tmp2_;
#line 11988 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = files;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_file_it = _tmp4_;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 12001 "Photo.c"
			GeeIterator* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
			GFile* file = NULL;
			GeeIterator* _tmp7_ = NULL;
			gpointer _tmp8_ = NULL;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp9_ = FALSE;
			GFile* _tmp10_ = NULL;
			BackingPhotoRow* _tmp11_ = NULL;
			DetectedPhotoInformation* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_ = NULL;
			BackingPhotoRow* _tmp15_ = NULL;
			DetectedPhotoInformation* _tmp16_ = NULL;
			PhotoMetadata* _tmp17_ = NULL;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp6_) {
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 12026 "Photo.c"
			}
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _file_it;
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			file = (GFile*) _tmp8_;
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = file;
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = photo_verify_file_for_reimport (self, _tmp10_, &_tmp11_, &_tmp12_, &_inner_error_);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing = _tmp11_;
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			detected = _tmp12_;
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp13_;
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (files);
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return FALSE;
#line 12066 "Photo.c"
			}
#line 1516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp9_) {
#line 1517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				continue;
#line 12078 "Photo.c"
			}
#line 1519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = backing;
#line 1519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = detected;
#line 1519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 12096 "Photo.c"
		}
#line 1513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 12100 "Photo.c"
	}
#line 1522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 ((PhotoReimportRawDevelopmentState*) _tmp18_);
#line 1522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = _tmp19_;
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = photo_reimport_raw_development_state_impl_get_size (_tmp20_);
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp21_ > 0;
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (files);
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (state) {
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*state = _vala_state;
#line 12124 "Photo.c"
	} else {
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12128 "Photo.c"
	}
#line 1523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 12132 "Photo.c"
}


void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentState* _tmp1_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_ = NULL;
	gchar* list = NULL;
	gchar* _tmp32_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp33_ = NULL;
	gboolean _tmp34_ = FALSE;
	const gchar* _tmp37_ = NULL;
	Alteration* _tmp38_ = NULL;
	Alteration* _tmp39_ = NULL;
	GError * _inner_error_ = NULL;
#line 1527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 12159 "Photo.c"
	}
#line 1531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = state;
#line 1531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12167 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp3_ = NULL;
		GeeCollection* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = reimport_state;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_->list;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_dev_it = _tmp5_;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 12183 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			PhotoReimportRawDevelopmentStateImpl* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _dev_it;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp7_) {
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 12199 "Photo.c"
			}
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _dev_it;
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp9_;
#line 1534 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = reimport_state;
#line 1534 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = _tmp10_->metadata_only;
#line 1534 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp11_) {
#line 12213 "Photo.c"
				BackingPhotoTable* _tmp12_ = NULL;
				BackingPhotoTable* _tmp13_ = NULL;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp14_ = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = backing_photo_table_get_instance ();
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = dev;
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _tmp14_->backing;
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				backing_photo_table_update (_tmp13_, _tmp15_, &_inner_error_);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return;
#line 12244 "Photo.c"
					} else {
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 1535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						return;
#line 12258 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp16_ = NULL;
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = self->row;
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 12267 "Photo.c"
					{
						gint _tmp17_ = 0;
						RawDeveloper* _tmp18_ = NULL;
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp18_ = raw_developer_as_array (&_tmp17_);
#line 12273 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							d_collection = _tmp18_;
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							d_collection_length1 = _tmp17_;
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							for (d_it = 0; d_it < _tmp17_; d_it = d_it + 1) {
#line 12285 "Photo.c"
								RawDeveloper d = 0;
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								d = d_collection[d_it];
#line 12289 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp19_ = NULL;
									BackingPhotoID* _tmp20_ = NULL;
									gint _tmp20__length1 = 0;
									RawDeveloper _tmp21_ = 0;
									BackingPhotoID _tmp22_ = {0};
									BackingPhotoID _tmp23_ = {0};
									gint64 _tmp24_ = 0LL;
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp19_ = self->row;
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp20_ = _tmp19_->development_ids;
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp20__length1 = _tmp19_->development_ids_length1;
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp21_ = d;
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp22_ = _tmp20_[_tmp21_];
#line 1540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									id = _tmp22_;
#line 1541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp23_ = id;
#line 1541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									_tmp24_ = _tmp23_.id;
#line 1541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
									if (_tmp24_ != BACKING_PHOTO_ID_INVALID) {
#line 12317 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp25_ = {0};
										BackingPhotoRow* _tmp26_ = NULL;
										BackingPhotoRow* _tmp27_ = NULL;
#line 1542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										_tmp25_ = id;
#line 1542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 1542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										bpr = _tmp26_;
#line 1543 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										_tmp27_ = bpr;
#line 1543 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										if (_tmp27_ != NULL) {
#line 12332 "Photo.c"
											GeeHashMap* _tmp28_ = NULL;
											RawDeveloper _tmp29_ = 0;
											BackingPhotoRow* _tmp30_ = NULL;
#line 1544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
											_tmp28_ = self->priv->developments;
#line 1544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
											_tmp29_ = d;
#line 1544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
											_tmp30_ = bpr;
#line 1544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
											gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) _tmp29_), _tmp30_);
#line 12344 "Photo.c"
										}
#line 1541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 12348 "Photo.c"
									}
								}
							}
#line 1539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 12354 "Photo.c"
						}
					}
					__finally164:
					{
						PhotoRow* _tmp31_ = NULL;
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp31_ = self->row;
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12364 "Photo.c"
					}
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							g_propagate_error (error, _inner_error_);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							return;
#line 12380 "Photo.c"
						} else {
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							g_clear_error (&_inner_error_);
#line 1537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							return;
#line 12394 "Photo.c"
						}
					}
				}
			}
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 12401 "Photo.c"
		}
#line 1533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 12405 "Photo.c"
	}
#line 1551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	list = _tmp32_;
#line 1552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = reimport_state;
#line 1552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata_only;
#line 1552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp34_) {
#line 12417 "Photo.c"
		const gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
#line 1553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp35_ = list;
#line 1553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (list);
#line 1553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		list = _tmp36_;
#line 12428 "Photo.c"
	}
#line 1555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = list;
#line 1555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp39_);
#line 1555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (list);
#line 1527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 12446 "Photo.c"
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1561 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1561 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 1561 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 12462 "Photo.c"
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
#line 1564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 1565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 12481 "Photo.c"
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 1568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = data_source_get_typename ((DataSource*) self);
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = data_source_get_instance_id ((DataSource*) self);
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 1572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 12511 "Photo.c"
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_ = NULL;
	GTimeVal _tmp1_ = {0};
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = info;
#line 1577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	modification = _tmp1_;
#line 12531 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 12539 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
				time_t _tmp5_ = 0;
				GTimeVal _tmp6_ = {0};
				glong _tmp7_ = 0L;
				PhotoTable* _tmp9_ = NULL;
				PhotoTable* _tmp10_ = NULL;
				PhotoRow* _tmp11_ = NULL;
				PhotoID _tmp12_ = {0};
				GTimeVal _tmp13_ = {0};
				glong _tmp14_ = 0L;
				PhotoRow* _tmp15_ = NULL;
				BackingPhotoRow* _tmp16_ = NULL;
				GTimeVal _tmp17_ = {0};
				glong _tmp18_ = 0L;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = modification;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp5_ == ((time_t) _tmp7_)) {
#line 12568 "Photo.c"
					{
						PhotoRow* _tmp8_ = NULL;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp8_ = self->row;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12575 "Photo.c"
					}
#line 1582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 12579 "Photo.c"
				}
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->row;
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tmp11_->photo_id;
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = modification;
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = _tmp13_.tv_sec;
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_update_timestamp (_tmp10_, &_tmp12_, (time_t) _tmp14_, &_inner_error_);
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12599 "Photo.c"
					goto __finally166;
				}
#line 1585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 1585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = _tmp15_->master;
#line 1585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = modification;
#line 1585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 12612 "Photo.c"
			}
			__finally166:
			{
				PhotoRow* _tmp19_ = NULL;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = self->row;
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12621 "Photo.c"
			}
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 12627 "Photo.c"
					goto __catch165_database_error;
				}
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 12636 "Photo.c"
			}
		}
	}
	goto __finally165;
	__catch165_database_error:
	{
		GError* err = NULL;
		GError* _tmp20_ = NULL;
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = err;
#line 1588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app_window_database_error (_tmp20_);
#line 1590 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1590 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 12657 "Photo.c"
	}
	__finally165:
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 12668 "Photo.c"
	}
#line 1593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = photo_is_master_baseline (self);
#line 1593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp21_) {
#line 12674 "Photo.c"
		Alteration* _tmp22_ = NULL;
		Alteration* _tmp23_ = NULL;
#line 1594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp23_);
#line 1594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 12685 "Photo.c"
	} else {
		Alteration* _tmp24_ = NULL;
		Alteration* _tmp25_ = NULL;
#line 1596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = alteration_new ("metadata", "master-timestamp");
#line 1596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp25_);
#line 1596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 12697 "Photo.c"
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_ = NULL;
	GTimeVal _tmp1_ = {0};
	gboolean altered = FALSE;
	gboolean _tmp20_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = info;
#line 1601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	modification = _tmp1_;
#line 1603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	altered = FALSE;
#line 12721 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12728 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
			PhotoRow* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = backing_photo_id_is_valid (&_tmp4_->editable_id);
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp5_) {
#line 12739 "Photo.c"
				BackingPhotoRow* _tmp6_ = NULL;
				time_t _tmp7_ = 0;
				GTimeVal _tmp8_ = {0};
				glong _tmp9_ = 0L;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->priv->editable;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp6_->timestamp;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = modification;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_.tv_sec;
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = _tmp7_ != ((time_t) _tmp9_);
#line 12754 "Photo.c"
			} else {
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = FALSE;
#line 12758 "Photo.c"
			}
#line 1605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_) {
#line 12762 "Photo.c"
				BackingPhotoTable* _tmp10_ = NULL;
				BackingPhotoTable* _tmp11_ = NULL;
				PhotoRow* _tmp12_ = NULL;
				BackingPhotoID _tmp13_ = {0};
				GTimeVal _tmp14_ = {0};
				glong _tmp15_ = 0L;
				BackingPhotoRow* _tmp16_ = NULL;
				GTimeVal _tmp17_ = {0};
				glong _tmp18_ = 0L;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = backing_photo_table_get_instance ();
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tmp12_->editable_id;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = modification;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _tmp14_.tv_sec;
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp11_, &_tmp13_, (time_t) _tmp15_, &_inner_error_);
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 1606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12790 "Photo.c"
					goto __finally167;
				}
#line 1608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = self->priv->editable;
#line 1608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = modification;
#line 1608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 1609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				altered = TRUE;
#line 12803 "Photo.c"
			}
		}
		__finally167:
		{
			PhotoRow* _tmp19_ = NULL;
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12813 "Photo.c"
		}
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 12823 "Photo.c"
			} else {
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 12831 "Photo.c"
			}
		}
	}
#line 1613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = altered;
#line 1613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp20_) {
#line 12839 "Photo.c"
		Alteration* _tmp21_ = NULL;
		Alteration* _tmp22_ = NULL;
#line 1614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp22_);
#line 1614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp22_);
#line 12850 "Photo.c"
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
#line 1618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 12861 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = map;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 12888 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			Photo* photo = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			Photo* _tmp10_ = NULL;
			GeeMap* _tmp11_ = NULL;
			Photo* _tmp12_ = NULL;
			gpointer _tmp13_ = NULL;
			GFileInfo* _tmp14_ = NULL;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp7_) {
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 12907 "Photo.c"
			}
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = (Photo*) _tmp9_;
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = photo;
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = map;
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo;
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = (GFileInfo*) _tmp13_;
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_update_editable_modification_time (_tmp10_, _tmp14_, &_inner_error_);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp14_);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 12941 "Photo.c"
				} else {
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 12953 "Photo.c"
				}
			}
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 12958 "Photo.c"
		}
#line 1621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 12962 "Photo.c"
	}
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 12974 "Photo.c"
		} else {
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 12982 "Photo.c"
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_file_format (self);
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 13002 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_get_file_format (self);
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 13008 "Photo.c"
	} else {
		PhotoFileFormat _tmp4_ = 0;
#line 1628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = photo_file_format_get_system_default_format ();
#line 1628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 13015 "Photo.c"
	}
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 1627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13021 "Photo.c"
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	Scaling _tmp2_ = {0};
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 1631 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = scale;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	scaling_for_best_fit (_tmp1_, TRUE, &_tmp2_);
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_source_get_pixbuf ((PhotoSource*) self, &_tmp2_, &_inner_error_);
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 13050 "Photo.c"
	}
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13062 "Photo.c"
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 1635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 1639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_format_is_file_supported (_tmp1_);
#line 1639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 13081 "Photo.c"
	} else {
		GFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = file;
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = photo_is_extension_found (_tmp5_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 1640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 13099 "Photo.c"
	}
#line 1639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 1639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13105 "Photo.c"
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
#line 1643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = basename;
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	disassemble_filename (_tmp0_, &_tmp1_, &_tmp2_);
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (name);
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	name = _tmp1_;
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (ext);
#line 1645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ext = _tmp2_;
#line 1646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = ext;
#line 1646 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 1647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 1647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (ext);
#line 1647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (name);
#line 1647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 13147 "Photo.c"
	}
#line 1650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = ext;
#line 1650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 1650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (ext);
#line 1650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ext = _tmp5_;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = extensions;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6__length1 = extensions_length1;
#line 13161 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		extension_collection = _tmp6_;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		extension_collection_length1 = _tmp6__length1;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		for (extension_it = 0; extension_it < _tmp6__length1; extension_it = extension_it + 1) {
#line 13173 "Photo.c"
			gchar* _tmp7_ = NULL;
			gchar* extension = NULL;
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = g_strdup (extension_collection[extension_it]);
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			extension = _tmp7_;
#line 13180 "Photo.c"
			{
				const gchar* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
#line 1654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = ext;
#line 1654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = extension;
#line 1654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 1655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					result = TRUE;
#line 1655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (extension);
#line 1655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (ext);
#line 1655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (name);
#line 1655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return result;
#line 13200 "Photo.c"
				}
#line 1653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (extension);
#line 13204 "Photo.c"
			}
		}
	}
#line 1658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = FALSE;
#line 1658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (ext);
#line 1658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (name);
#line 1658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13216 "Photo.c"
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_table_has_duplicate (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp7_;
#line 1667 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13252 "Photo.c"
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	gint _tmp6_ = 0;
	PhotoID* _tmp7_ = NULL;
	PhotoID* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	PhotoID* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = photo_table_get_duplicate_ids (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, &_tmp6_);
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8__length1 = _tmp6_;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9__length1 = _tmp8__length1;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (result_length1) {
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*result_length1 = _tmp9__length1;
#line 13298 "Photo.c"
	}
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp9_;
#line 1676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13304 "Photo.c"
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	DataSource* _tmp0_ = NULL;
	PhotoID _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
#line 1683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (source != NULL, 0LL);
#line 1684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source;
#line 1684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_photo_id ((Photo*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto), &_tmp1_);
#line 1684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp2_;
#line 1684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13325 "Photo.c"
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 1703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 13352 "Photo.c"
}


static void _vala_array_add107 (gchar*** array, int* length, int* size, gchar* value) {
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13363 "Photo.c"
	}
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13369 "Photo.c"
}


static void _vala_array_add108 (gchar*** array, int* length, int* size, gchar* value) {
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13380 "Photo.c"
	}
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13386 "Photo.c"
}


static void _vala_array_add109 (gchar*** array, int* length, int* size, gchar* value) {
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13397 "Photo.c"
	}
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13403 "Photo.c"
}


static void _vala_array_add110 (gchar*** array, int* length, int* size, gchar* value) {
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13414 "Photo.c"
	}
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13420 "Photo.c"
}


void photo_set_master_file (Photo* self, GFile* file) {
	gchar* filepath = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp41_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 1709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	altered = FALSE;
#line 1712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_source = FALSE;
#line 1714 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	name_changed = FALSE;
#line 1715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old_file = NULL;
#line 13455 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13463 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_ = NULL;
#line 1718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 13471 "Photo.c"
					{
						PhotoBackingReaders* _tmp4_ = NULL;
						PhotoFileReader* _tmp5_ = NULL;
						GFile* _tmp6_ = NULL;
						GFile* _tmp7_ = NULL;
						GFile* _tmp8_ = NULL;
						gboolean _tmp9_ = FALSE;
#line 1719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp5_ = _tmp4_->master;
#line 1719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp6_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp5_);
#line 1719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						old_file = _tmp6_;
#line 1720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp7_ = file;
#line 1720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp8_ = old_file;
#line 1720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp9_ = g_file_equal (_tmp7_, _tmp8_);
#line 1720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp9_) {
#line 13497 "Photo.c"
							PhotoTable* _tmp10_ = NULL;
							PhotoTable* _tmp11_ = NULL;
							PhotoID _tmp12_ = {0};
							const gchar* _tmp13_ = NULL;
							PhotoRow* _tmp14_ = NULL;
							BackingPhotoRow* _tmp15_ = NULL;
							const gchar* _tmp16_ = NULL;
							gchar* _tmp17_ = NULL;
							GFile* _tmp18_ = NULL;
							gchar* _tmp19_ = NULL;
							PhotoBackingReaders* _tmp20_ = NULL;
							PhotoRow* _tmp21_ = NULL;
							BackingPhotoRow* _tmp22_ = NULL;
							PhotoFileFormat _tmp23_ = 0;
							const gchar* _tmp24_ = NULL;
							PhotoFileReader* _tmp25_ = NULL;
							gboolean _tmp26_ = FALSE;
							gboolean _tmp27_ = FALSE;
							gboolean _tmp28_ = FALSE;
							PhotoRow* _tmp29_ = NULL;
							const gchar* _tmp30_ = NULL;
							gboolean _tmp31_ = FALSE;
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp10_ = photo_table_get_instance ();
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp11_ = _tmp10_;
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							photo_get_photo_id (self, &_tmp12_);
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp13_ = filepath;
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							photo_table_set_filepath (_tmp11_, &_tmp12_, _tmp13_, &_inner_error_);
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_database_table_unref0 (_tmp11_);
#line 1721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13534 "Photo.c"
								goto __finally170;
							}
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp14_ = self->row;
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp15_ = _tmp14_->master;
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp16_ = filepath;
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp17_ = g_strdup (_tmp16_);
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (_tmp15_->filepath);
#line 1723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp15_->filepath = _tmp17_;
#line 1724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp18_ = file;
#line 1724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp19_ = g_file_get_basename (_tmp18_);
#line 1724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							self->priv->file_title = _tmp19_;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp20_ = self->priv->readers;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp21_ = self->row;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp22_ = _tmp21_->master;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp24_ = filepath;
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp20_->master);
#line 1725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp20_->master = _tmp25_;
#line 1727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							altered = TRUE;
#line 1728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp26_ = photo_is_master_baseline (self);
#line 1728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							is_baseline = _tmp26_;
#line 1729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp27_ = photo_is_master_source (self);
#line 1729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							is_source = _tmp27_;
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp29_ = self->row;
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp30_ = _tmp29_->title;
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp31_ = is_string_empty (_tmp30_);
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (_tmp31_) {
#line 13591 "Photo.c"
								GFile* _tmp32_ = NULL;
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_ = NULL;
								GFile* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp32_ = old_file;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp33_ = g_file_get_basename (_tmp32_);
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp34_ = _tmp33_;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp35_ = file;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp36_ = g_file_get_basename (_tmp35_);
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp37_ = _tmp36_;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp28_ = g_strcmp0 (_tmp34_, _tmp37_) != 0;
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_free0 (_tmp37_);
#line 1731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_free0 (_tmp34_);
#line 13616 "Photo.c"
							} else {
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp28_ = FALSE;
#line 13620 "Photo.c"
							}
#line 1730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							name_changed = _tmp28_;
#line 13624 "Photo.c"
						}
					}
					__finally170:
					{
						PhotoBackingReaders* _tmp38_ = NULL;
#line 1718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp38_ = self->priv->readers;
#line 1718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 13634 "Photo.c"
					}
#line 1718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13638 "Photo.c"
						goto __finally169;
					}
				}
			}
			__finally169:
			{
				PhotoRow* _tmp39_ = NULL;
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = self->row;
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13650 "Photo.c"
			}
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13656 "Photo.c"
					goto __catch168_database_error;
				}
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 13669 "Photo.c"
			}
		}
	}
	goto __finally168;
	__catch168_database_error:
	{
		GError* err = NULL;
		GError* _tmp40_ = NULL;
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = err;
#line 1736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app_window_database_error (_tmp40_);
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 13688 "Photo.c"
	}
	__finally168:
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 13703 "Photo.c"
	}
#line 1739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = altered;
#line 1739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp41_) {
#line 13709 "Photo.c"
		GFile* _tmp42_ = NULL;
		GFile* _tmp43_ = NULL;
		gboolean _tmp44_ = FALSE;
		gchar** alteration_list = NULL;
		gchar** _tmp45_ = NULL;
		gint alteration_list_length1 = 0;
		gint _alteration_list_size_ = 0;
		gchar** _tmp46_ = NULL;
		gint _tmp46__length1 = 0;
		gchar* _tmp47_ = NULL;
		gboolean _tmp48_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp54_ = FALSE;
		gchar** _tmp57_ = NULL;
		gint _tmp57__length1 = 0;
		Alteration* _tmp58_ = NULL;
		Alteration* _tmp59_ = NULL;
#line 1740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = old_file;
#line 1740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = file;
#line 1740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_notify_master_replaced ((MediaSource*) self, _tmp42_, _tmp43_);
#line 1742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp44_ = is_baseline;
#line 1742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp44_) {
#line 1743 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 13739 "Photo.c"
		}
#line 1745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = g_new0 (gchar*, 0 + 1);
#line 1745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list = _tmp45_;
#line 1745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = alteration_list;
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46__length1 = alteration_list_length1;
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = g_strdup ("backing:master");
#line 1746 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
#line 1750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = name_changed;
#line 1750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp48_) {
#line 13761 "Photo.c"
			gchar** _tmp49_ = NULL;
			gint _tmp49__length1 = 0;
			gchar* _tmp50_ = NULL;
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp49_ = alteration_list;
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp49__length1 = alteration_list_length1;
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp50_ = g_strdup ("metadata:name");
#line 1751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp50_);
#line 13773 "Photo.c"
		}
#line 1753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_ = is_source;
#line 1753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp51_) {
#line 13779 "Photo.c"
			gchar** _tmp52_ = NULL;
			gint _tmp52__length1 = 0;
			gchar* _tmp53_ = NULL;
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp52_ = alteration_list;
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp52__length1 = alteration_list_length1;
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp53_ = g_strdup ("backing:source");
#line 1754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add109 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp53_);
#line 13791 "Photo.c"
		}
#line 1756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp54_ = is_baseline;
#line 1756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp54_) {
#line 13797 "Photo.c"
			gchar** _tmp55_ = NULL;
			gint _tmp55__length1 = 0;
			gchar* _tmp56_ = NULL;
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp55_ = alteration_list;
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp55__length1 = alteration_list_length1;
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp56_ = g_strdup ("backing:baseline");
#line 1757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add110 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp56_);
#line 13809 "Photo.c"
		}
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp57_ = alteration_list;
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp57__length1 = alteration_list_length1;
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = alteration_new_from_array (_tmp57_, _tmp57__length1);
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp59_ = _tmp58_;
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp59_);
#line 1759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp59_);
#line 1739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 13825 "Photo.c"
	}
#line 1708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (filepath);
#line 13831 "Photo.c"
}


static void _vala_array_add111 (gchar*** array, int* length, int* size, gchar* value) {
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13842 "Photo.c"
	}
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13848 "Photo.c"
}


static void _vala_array_add112 (gchar*** array, int* length, int* size, gchar* value) {
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13859 "Photo.c"
	}
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13865 "Photo.c"
}


static void _vala_array_add113 (gchar*** array, int* length, int* size, gchar* value) {
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13876 "Photo.c"
	}
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13882 "Photo.c"
}


void photo_set_editable_file (Photo* self, GFile* file) {
	gchar* filepath = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp34_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 1766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	altered = FALSE;
#line 1769 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_source = FALSE;
#line 1771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old_file = NULL;
#line 13914 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13922 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_ = NULL;
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 13930 "Photo.c"
					{
						GFile* _tmp4_ = NULL;
						PhotoBackingReaders* _tmp5_ = NULL;
						PhotoFileReader* _tmp6_ = NULL;
						GFile* _tmp10_ = NULL;
						gboolean _tmp11_ = FALSE;
						GFile* _tmp12_ = NULL;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp5_ = self->priv->readers;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp6_ = _tmp5_->editable;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp6_ != NULL) {
#line 13944 "Photo.c"
							PhotoBackingReaders* _tmp7_ = NULL;
							PhotoFileReader* _tmp8_ = NULL;
							GFile* _tmp9_ = NULL;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp7_ = self->priv->readers;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp8_ = _tmp7_->editable;
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp9_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp8_);
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp4_ = _tmp9_;
#line 13958 "Photo.c"
						} else {
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp4_ = NULL;
#line 13964 "Photo.c"
						}
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp10_ = _g_object_ref0 (_tmp4_);
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						old_file = _tmp10_;
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp12_ = old_file;
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp12_ != NULL) {
#line 13976 "Photo.c"
							GFile* _tmp13_ = NULL;
							GFile* _tmp14_ = NULL;
							gboolean _tmp15_ = FALSE;
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp13_ = old_file;
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp14_ = file;
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp15_ = g_file_equal (_tmp13_, _tmp14_);
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp11_ = !_tmp15_;
#line 13988 "Photo.c"
						} else {
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp11_ = FALSE;
#line 13992 "Photo.c"
						}
#line 1776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp11_) {
#line 13996 "Photo.c"
							BackingPhotoTable* _tmp16_ = NULL;
							BackingPhotoTable* _tmp17_ = NULL;
							PhotoRow* _tmp18_ = NULL;
							BackingPhotoID _tmp19_ = {0};
							const gchar* _tmp20_ = NULL;
							BackingPhotoRow* _tmp21_ = NULL;
							const gchar* _tmp22_ = NULL;
							gchar* _tmp23_ = NULL;
							PhotoBackingReaders* _tmp24_ = NULL;
							BackingPhotoRow* _tmp25_ = NULL;
							PhotoFileFormat _tmp26_ = 0;
							const gchar* _tmp27_ = NULL;
							PhotoFileReader* _tmp28_ = NULL;
							gboolean _tmp29_ = FALSE;
							gboolean _tmp30_ = FALSE;
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp16_ = backing_photo_table_get_instance ();
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp17_ = _tmp16_;
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp18_ = self->row;
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp19_ = _tmp18_->editable_id;
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp20_ = filepath;
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp17_, &_tmp19_, _tmp20_, &_inner_error_);
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_database_table_unref0 (_tmp17_);
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_g_object_unref0 (_tmp4_);
#line 14030 "Photo.c"
								goto __finally173;
							}
#line 1779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp21_ = self->priv->editable;
#line 1779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp22_ = filepath;
#line 1779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp23_ = g_strdup (_tmp22_);
#line 1779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (_tmp21_->filepath);
#line 1779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp21_->filepath = _tmp23_;
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp24_ = self->priv->readers;
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp25_ = self->priv->editable;
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp26_ = _tmp25_->file_format;
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp27_ = filepath;
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp28_ = photo_file_format_create_reader (_tmp26_, _tmp27_);
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp24_->editable);
#line 1780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp24_->editable = _tmp28_;
#line 1782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							altered = TRUE;
#line 1783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp29_ = photo_is_editable_baseline (self);
#line 1783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							is_baseline = _tmp29_;
#line 1784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp30_ = photo_is_editable_source (self);
#line 1784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							is_source = _tmp30_;
#line 14067 "Photo.c"
						}
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_tmp4_);
#line 14071 "Photo.c"
					}
					__finally173:
					{
						PhotoBackingReaders* _tmp31_ = NULL;
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp31_ = self->priv->readers;
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14080 "Photo.c"
					}
#line 1774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 14084 "Photo.c"
						goto __finally172;
					}
				}
			}
			__finally172:
			{
				PhotoRow* _tmp32_ = NULL;
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = self->row;
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14096 "Photo.c"
			}
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 14102 "Photo.c"
					goto __catch171_database_error;
				}
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 14115 "Photo.c"
			}
		}
	}
	goto __finally171;
	__catch171_database_error:
	{
		GError* err = NULL;
		GError* _tmp33_ = NULL;
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp33_ = err;
#line 1789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app_window_database_error (_tmp33_);
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 14134 "Photo.c"
	}
	__finally171:
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1772 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 14149 "Photo.c"
	}
#line 1792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = altered;
#line 1792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp34_) {
#line 14155 "Photo.c"
		GFile* _tmp35_ = NULL;
		GFile* _tmp36_ = NULL;
		gboolean _tmp37_ = FALSE;
		gchar** alteration_list = NULL;
		gchar** _tmp38_ = NULL;
		gint alteration_list_length1 = 0;
		gint _alteration_list_size_ = 0;
		gchar** _tmp39_ = NULL;
		gint _tmp39__length1 = 0;
		gchar* _tmp40_ = NULL;
		gboolean _tmp41_ = FALSE;
		gboolean _tmp44_ = FALSE;
		gchar** _tmp47_ = NULL;
		gint _tmp47__length1 = 0;
		Alteration* _tmp48_ = NULL;
		Alteration* _tmp49_ = NULL;
#line 1793 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp35_ = old_file;
#line 1793 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = file;
#line 1793 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp35_, _tmp36_);
#line 1795 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = is_baseline;
#line 1795 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp37_) {
#line 1796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14184 "Photo.c"
		}
#line 1798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp38_ = g_new0 (gchar*, 0 + 1);
#line 1798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list = _tmp38_;
#line 1798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = alteration_list;
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39__length1 = alteration_list_length1;
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = g_strdup ("backing:editable");
#line 1799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add111 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 1801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = is_baseline;
#line 1801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp41_) {
#line 14206 "Photo.c"
			gchar** _tmp42_ = NULL;
			gint _tmp42__length1 = 0;
			gchar* _tmp43_ = NULL;
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = alteration_list;
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42__length1 = alteration_list_length1;
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp43_ = g_strdup ("backing:baseline");
#line 1802 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add112 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp43_);
#line 14218 "Photo.c"
		}
#line 1804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp44_ = is_source;
#line 1804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp44_) {
#line 14224 "Photo.c"
			gchar** _tmp45_ = NULL;
			gint _tmp45__length1 = 0;
			gchar* _tmp46_ = NULL;
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp45_ = alteration_list;
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp45__length1 = alteration_list_length1;
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp46_ = g_strdup ("backing:source");
#line 1805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add113 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp46_);
#line 14236 "Photo.c"
		}
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = alteration_list;
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47__length1 = alteration_list_length1;
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = alteration_new_from_array (_tmp47_, _tmp47__length1);
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = _tmp48_;
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp49_);
#line 1807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp49_);
#line 1792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14252 "Photo.c"
	}
#line 1765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (filepath);
#line 14258 "Photo.c"
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	GeeMapIterator* map_iter = NULL;
	GeeMap* _tmp0_ = NULL;
	GeeMapIterator* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 1812 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 1815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = map;
#line 1815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 1815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map_iter = _tmp1_;
#line 1816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	while (TRUE) {
#line 14279 "Photo.c"
		GeeMapIterator* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		GeeMapIterator* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		Photo* _tmp6_ = NULL;
		GeeMapIterator* _tmp7_ = NULL;
		gpointer _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
#line 1816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = map_iter;
#line 1816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = gee_map_iterator_next (_tmp2_);
#line 1816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (!_tmp3_) {
#line 1816 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 14296 "Photo.c"
		}
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = map_iter;
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = gee_map_iterator_get_key (_tmp4_);
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = (Photo*) _tmp5_;
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = map_iter;
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = gee_map_iterator_get_value (_tmp7_);
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = (GFile*) _tmp8_;
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_set_editable_file (_tmp6_, _tmp9_);
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 1817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 14316 "Photo.c"
	}
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 14330 "Photo.c"
		} else {
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 14340 "Photo.c"
		}
	}
#line 1812 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 14345 "Photo.c"
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 1825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14371 "Photo.c"
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 1829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14398 "Photo.c"
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
#line 1832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reader = _tmp0_;
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 14418 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = reader;
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp3_);
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 14429 "Photo.c"
	} else {
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 14435 "Photo.c"
	}
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1835 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14443 "Photo.c"
}


GeeCollection* photo_get_raw_developer_files (Photo* self) {
	GeeCollection* result = NULL;
	PhotoFileFormat _tmp0_ = 0;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 1838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1839 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1839 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 1840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 14463 "Photo.c"
	}
#line 1842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 1842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ret = _tmp1_;
#line 14469 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14476 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp3_ = NULL;
				GeeCollection* _tmp4_ = NULL;
				GeeCollection* _tmp5_ = NULL;
				GeeCollection* _tmp6_ = NULL;
				GeeIterator* _tmp7_ = NULL;
				GeeIterator* _tmp8_ = NULL;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeMap*) _tmp3_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = _tmp5_;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp6_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_row_it = _tmp8_;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				while (TRUE) {
#line 14504 "Photo.c"
					GeeIterator* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp11_ = NULL;
					gpointer _tmp12_ = NULL;
					GeeArrayList* _tmp13_ = NULL;
					BackingPhotoRow* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					GFile* _tmp16_ = NULL;
					GFile* _tmp17_ = NULL;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = gee_iterator_next (_tmp9_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (!_tmp10_) {
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						break;
#line 14523 "Photo.c"
					}
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = _row_it;
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp12_;
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_ = ret;
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = row;
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = _tmp14_->filepath;
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = g_file_new_for_path (_tmp15_);
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = _tmp16_;
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp17_);
#line 1845 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp17_);
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 14547 "Photo.c"
				}
#line 1844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 14551 "Photo.c"
			}
		}
		__finally174:
		{
			PhotoRow* _tmp18_ = NULL;
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14561 "Photo.c"
		}
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 14573 "Photo.c"
		}
	}
#line 1848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (GeeCollection*) ret;
#line 1848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14580 "Photo.c"
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 1852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14606 "Photo.c"
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14615 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14622 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			PhotoFileFormat _tmp2_ = 0;
#line 1857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 14632 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14639 "Photo.c"
			}
#line 1857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 14643 "Photo.c"
		}
		__finally175:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14652 "Photo.c"
		}
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 14660 "Photo.c"
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1862 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_file_format (self);
#line 1862 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file_format = _tmp0_;
#line 1863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file_format;
#line 1863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write (_tmp1_);
#line 1863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp2_) {
#line 14683 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_file_format_get_system_default_format ();
#line 1864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		file_format = _tmp3_;
#line 14689 "Photo.c"
	}
#line 1866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = file_format;
#line 1866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14695 "Photo.c"
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14704 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14711 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileFormat _tmp3_ = 0;
#line 1871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 1871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 14724 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14731 "Photo.c"
			}
#line 1871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 14735 "Photo.c"
		}
		__finally176:
		{
			PhotoRow* _tmp5_ = NULL;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14744 "Photo.c"
		}
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 14752 "Photo.c"
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 14763 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14770 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			time_t _tmp2_ = 0;
#line 1877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 14780 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14787 "Photo.c"
			}
#line 1877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 14791 "Photo.c"
		}
		__finally177:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14800 "Photo.c"
		}
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 14808 "Photo.c"
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1881 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 14817 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14824 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			PhotoID _tmp2_ = {0};
#line 1883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*result = _tmp2_;
#line 14834 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14841 "Photo.c"
			}
#line 1883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 14845 "Photo.c"
		}
		__finally178:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14854 "Photo.c"
		}
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 14862 "Photo.c"
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	PhotoRow* _tmp0_ = NULL;
	EventID _tmp1_ = {0};
#line 1888 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 1889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 1889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = _tmp1_;
#line 1889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 14881 "Photo.c"
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	PhotoRow* _tmp0_ = NULL;
	EventID _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
#line 1893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 1894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp2_;
#line 1894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 14902 "Photo.c"
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 14911 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14918 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			ImportID _tmp2_ = {0};
#line 1899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*result = _tmp2_;
#line 14928 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14935 "Photo.c"
			}
#line 1899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 14939 "Photo.c"
		}
		__finally179:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14948 "Photo.c"
		}
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 14956 "Photo.c"
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 14965 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14972 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoID _tmp2_ = {0};
#line 1905 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1905 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1905 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*result = _tmp2_;
#line 14982 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14989 "Photo.c"
			}
#line 1905 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 14993 "Photo.c"
		}
		__finally180:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15002 "Photo.c"
		}
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 15010 "Photo.c"
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 15021 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15028 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 1911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 15041 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15048 "Photo.c"
			}
#line 1911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 15052 "Photo.c"
		}
		__finally181:
		{
			PhotoRow* _tmp5_ = NULL;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15061 "Photo.c"
		}
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 15069 "Photo.c"
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15079 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15086 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
#line 1919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 15096 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15103 "Photo.c"
			}
#line 1919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 15107 "Photo.c"
		}
		__finally182:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15116 "Photo.c"
		}
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0ULL;
#line 15124 "Photo.c"
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* alteration = NULL;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
	Alteration* _tmp5_ = NULL;
#line 1923 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	alteration = _tmp0_;
#line 1925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = additional_alteration;
#line 1925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 15144 "Photo.c"
		Alteration* _tmp2_ = NULL;
		Alteration* _tmp3_ = NULL;
		Alteration* _tmp4_ = NULL;
#line 1926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 1926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = additional_alteration;
#line 1926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = alteration_compress (_tmp2_, _tmp3_);
#line 1926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		alteration = _tmp4_;
#line 15158 "Photo.c"
	}
#line 1928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = alteration;
#line 1928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp5_);
#line 1923 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 15166 "Photo.c"
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp10_ = FALSE;
	guint64 _tmp12_ = 0ULL;
	GError * _inner_error_ = NULL;
#line 1931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15178 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15185 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoID _tmp3_ = {0};
			guint64 _tmp4_ = 0ULL;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = flags;
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp3_, _tmp4_);
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp5_;
#line 1934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = committed;
#line 1935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_) {
#line 15211 "Photo.c"
				PhotoRow* _tmp7_ = NULL;
				guint64 _tmp8_ = 0ULL;
#line 1936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 1936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = flags;
#line 1936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_->flags = _tmp8_;
#line 15220 "Photo.c"
			}
		}
		__finally183:
		{
			PhotoRow* _tmp9_ = NULL;
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15230 "Photo.c"
		}
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0ULL;
#line 15240 "Photo.c"
		}
	}
#line 1939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = committed;
#line 1939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_) {
#line 15247 "Photo.c"
		Alteration* _tmp11_ = NULL;
#line 1940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = additional_alteration;
#line 1940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp11_);
#line 15253 "Photo.c"
	}
#line 1942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = flags;
#line 1942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp12_;
#line 1942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 15261 "Photo.c"
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 15270 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15277 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			gboolean _tmp4_ = FALSE;
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = media_source_internal_is_flag_set (_tmp2_, _tmp3_);
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp4_;
#line 15293 "Photo.c"
			{
				PhotoRow* _tmp5_ = NULL;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15300 "Photo.c"
			}
#line 1947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 15304 "Photo.c"
		}
		__finally184:
		{
			PhotoRow* _tmp6_ = NULL;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15313 "Photo.c"
		}
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 15321 "Photo.c"
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1951 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1952 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 15338 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15345 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 1956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = media_source_internal_add_flags (_tmp2_, _tmp3_);
#line 1956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			flags = _tmp4_;
#line 1957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15372 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp12_;
#line 1958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp13_) {
#line 15397 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 1960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 1960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = flags;
#line 1960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15406 "Photo.c"
				}
			}
		}
		__finally185:
		{
			PhotoRow* _tmp16_ = NULL;
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15417 "Photo.c"
		}
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0ULL;
#line 15427 "Photo.c"
		}
	}
#line 1964 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = committed;
#line 1964 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_) {
#line 15434 "Photo.c"
		Alteration* _tmp18_ = NULL;
#line 1965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 1965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15440 "Photo.c"
	}
#line 1967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = flags;
#line 1967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 15446 "Photo.c"
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1973 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 15462 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15469 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 1975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = media_source_internal_remove_flags (_tmp2_, _tmp3_);
#line 1975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			flags = _tmp4_;
#line 1976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15496 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp12_;
#line 1977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp13_) {
#line 15521 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 1979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 1979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = flags;
#line 1979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15530 "Photo.c"
				}
			}
		}
		__finally186:
		{
			PhotoRow* _tmp16_ = NULL;
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15541 "Photo.c"
		}
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0ULL;
#line 15551 "Photo.c"
		}
	}
#line 1983 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = committed;
#line 1983 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_) {
#line 15558 "Photo.c"
		Alteration* _tmp18_ = NULL;
#line 1984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 1984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15564 "Photo.c"
	}
#line 1986 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = flags;
#line 1986 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 15570 "Photo.c"
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1990 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 15586 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15593 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 1994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = add;
#line 1994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = remove;
#line 1994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			flags = (_tmp2_ | _tmp3_) & (~_tmp4_);
#line 1995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15620 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp12_;
#line 1996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1997 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1997 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp13_) {
#line 15645 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 1998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 1998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = flags;
#line 1998 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15654 "Photo.c"
				}
			}
		}
		__finally187:
		{
			PhotoRow* _tmp16_ = NULL;
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15665 "Photo.c"
		}
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0ULL;
#line 15675 "Photo.c"
		}
	}
#line 2002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_) {
#line 15682 "Photo.c"
		Alteration* _tmp18_ = NULL;
#line 2003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 2003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15688 "Photo.c"
	}
#line 2005 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = flags;
#line 2005 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 15694 "Photo.c"
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 2011 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 2013 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = add;
#line 2013 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 15708 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeCollection* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = add;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_it = _tmp2_;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 15721 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				Photo* photo = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				Photo* _tmp7_ = NULL;
				guint64 _tmp8_ = 0ULL;
				Alteration* _tmp9_ = NULL;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = _photo_it;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp4_) {
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 15738 "Photo.c"
				}
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _photo_it;
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = (Photo*) _tmp6_;
#line 2015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = photo;
#line 2015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = add_mask;
#line 2015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = additional_add_alteration;
#line 2015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_add_flags (_tmp7_, _tmp8_, _tmp9_);
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 15756 "Photo.c"
			}
#line 2014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 15760 "Photo.c"
		}
	}
#line 2018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = remove;
#line 2018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 15767 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeCollection* _tmp11_ = NULL;
			GeeIterator* _tmp12_ = NULL;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = remove;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_it = _tmp12_;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 15780 "Photo.c"
				GeeIterator* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				Photo* photo = NULL;
				GeeIterator* _tmp15_ = NULL;
				gpointer _tmp16_ = NULL;
				Photo* _tmp17_ = NULL;
				guint64 _tmp18_ = 0ULL;
				Alteration* _tmp19_ = NULL;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _photo_it;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = gee_iterator_next (_tmp13_);
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp14_) {
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 15797 "Photo.c"
				}
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _photo_it;
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = gee_iterator_get (_tmp15_);
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = (Photo*) _tmp16_;
#line 2020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = photo;
#line 2020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = remove_mask;
#line 2020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = additional_remove_alteration;
#line 2020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_remove_flags (_tmp17_, _tmp18_, _tmp19_);
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 15815 "Photo.c"
			}
#line 2019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 15819 "Photo.c"
		}
	}
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 15832 "Photo.c"
		} else {
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 15840 "Photo.c"
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp16_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2027 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 15858 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15865 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			PhotoRow* _tmp4_ = NULL;
			guint64 _tmp5_ = 0ULL;
			guint64 _tmp6_ = 0ULL;
#line 2031 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2031 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2031 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = mask;
#line 2031 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			flags = _tmp2_ ^ _tmp3_;
#line 2032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _tmp4_->flags;
#line 2032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = flags;
#line 2032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp5_ != _tmp6_) {
#line 15889 "Photo.c"
				PhotoTable* _tmp7_ = NULL;
				PhotoTable* _tmp8_ = NULL;
				PhotoID _tmp9_ = {0};
				guint64 _tmp10_ = 0ULL;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp9_);
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = flags;
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = photo_table_replace_flags (_tmp8_, &_tmp9_, _tmp10_);
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp11_;
#line 2033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 2034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = committed;
#line 2034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp12_) {
#line 15914 "Photo.c"
					PhotoRow* _tmp13_ = NULL;
					guint64 _tmp14_ = 0ULL;
#line 2035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_ = self->row;
#line 2035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = flags;
#line 2035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_->flags = _tmp14_;
#line 15923 "Photo.c"
				}
			}
		}
		__finally188:
		{
			PhotoRow* _tmp15_ = NULL;
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15934 "Photo.c"
		}
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return 0ULL;
#line 15944 "Photo.c"
		}
	}
#line 2039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = committed;
#line 2039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp16_) {
#line 15951 "Photo.c"
		Alteration* _tmp17_ = NULL;
#line 2040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 2040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 15957 "Photo.c"
	}
#line 2042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = flags;
#line 2042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 15963 "Photo.c"
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 15972 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15979 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 2047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 15989 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15996 "Photo.c"
			}
#line 2047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 16000 "Photo.c"
		}
		__finally189:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16009 "Photo.c"
		}
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 16017 "Photo.c"
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed = FALSE;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2052 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 16030 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16037 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
#line 2054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = dirty;
#line 2054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16050 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_ = FALSE;
				PhotoRow* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = dirty;
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp5_, &_tmp6_, _tmp7_, &_inner_error_);
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16071 "Photo.c"
					goto __finally190;
				}
#line 2056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = dirty;
#line 2056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_->metadata_dirty = _tmp9_;
#line 2057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = TRUE;
#line 16082 "Photo.c"
			}
		}
		__finally190:
		{
			PhotoRow* _tmp10_ = NULL;
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16092 "Photo.c"
		}
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 16102 "Photo.c"
			} else {
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 16110 "Photo.c"
			}
		}
	}
#line 2061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = committed;
#line 2061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 16118 "Photo.c"
		Alteration* _tmp12_ = NULL;
		Alteration* _tmp13_ = NULL;
#line 2062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "master-dirty");
#line 2062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp13_);
#line 2062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 16129 "Photo.c"
	}
}


gboolean photo_is_enhanced (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16139 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16146 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 2067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 16156 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16163 "Photo.c"
			}
#line 2067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 16167 "Photo.c"
		}
		__finally191:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16176 "Photo.c"
		}
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 16184 "Photo.c"
	}
}


void photo_set_enhanced (Photo* self, gboolean enhanced) {
	gboolean committed = FALSE;
	gboolean _tmp13_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2071 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2072 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 16197 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16204 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
#line 2074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = enhanced;
#line 2074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16217 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = enhanced;
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = photo_table_set_enhanced (_tmp5_, &_tmp6_, _tmp7_);
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp8_;
#line 2075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = committed;
#line 2076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp9_) {
#line 16242 "Photo.c"
					PhotoRow* _tmp10_ = NULL;
					gboolean _tmp11_ = FALSE;
#line 2077 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = self->row;
#line 2077 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = enhanced;
#line 2077 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_->enhanced = _tmp11_;
#line 16251 "Photo.c"
				}
			}
		}
		__finally192:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16262 "Photo.c"
		}
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 16272 "Photo.c"
		}
	}
#line 2081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = committed;
#line 2081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp13_) {
#line 16279 "Photo.c"
		Alteration* _tmp14_ = NULL;
		Alteration* _tmp15_ = NULL;
#line 2082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "enhanced");
#line 2082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 16290 "Photo.c"
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 16300 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_ = NULL;
		PhotoID _tmp2_ = {0};
		const gchar* _tmp3_ = NULL;
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = backlinks;
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, _tmp3_, &_inner_error_);
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 16322 "Photo.c"
				goto __catch193_database_error;
			}
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 16331 "Photo.c"
		}
		{
			PhotoRow* _tmp4_ = NULL;
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 16339 "Photo.c"
			{
				PhotoRow* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
#line 2092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = backlinks;
#line 2092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 2092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp5_->backlinks);
#line 2092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_->backlinks = _tmp7_;
#line 16354 "Photo.c"
			}
			__finally194:
			{
				PhotoRow* _tmp8_ = NULL;
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16363 "Photo.c"
			}
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 16369 "Photo.c"
					goto __catch193_database_error;
				}
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 16378 "Photo.c"
			}
		}
	}
	goto __finally193;
	__catch193_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = data_object_to_string ((DataObject*) self);
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = err;
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2095: Unable to update link state for %s: %s", _tmp10_, _tmp12_);
#line 2095 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 16408 "Photo.c"
	}
	__finally193:
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 16419 "Photo.c"
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 16432 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16439 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			EventID _tmp5_ = {0};
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp7_;
#line 2107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = committed;
#line 2107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp8_) {
#line 16472 "Photo.c"
				PhotoRow* _tmp9_ = NULL;
				EventID _tmp10_ = {0};
#line 2108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = *event_id;
#line 2108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_->event_id = _tmp10_;
#line 16481 "Photo.c"
			}
#line 2110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = committed;
#line 16485 "Photo.c"
			{
				PhotoRow* _tmp11_ = NULL;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->row;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16492 "Photo.c"
			}
#line 2110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 16496 "Photo.c"
		}
		__finally195:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16505 "Photo.c"
		}
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2104 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 16513 "Photo.c"
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	PhotoID _tmp10_ = {0};
	gint64 _tmp11_ = 0LL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
#line 2114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_is_master_baseline (self);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp1_) {
#line 16539 "Photo.c"
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = photo_get_actual_file (self);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 16571 "Photo.c"
	} else {
		gchar* _tmp9_ = NULL;
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = g_strdup ("");
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp9_;
#line 16580 "Photo.c"
	}
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp10_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_.id;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = photo_get_master_reader (self);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp15_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp0_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp17_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp15_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp13_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp19_;
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2115 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 16614 "Photo.c"
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	DataSource* _tmp0_ = NULL;
	Photo* _tmp1_ = NULL;
	Photo* _tmp2_ = NULL;
	DataSource* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
#line 2119 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2121 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source;
#line 2121 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_PHOTO) ? ((Photo*) _tmp0_) : NULL);
#line 2121 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp1_;
#line 2122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo;
#line 2122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16639 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp3_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp4_ = NULL;
		PhotoID _tmp5_ = {0};
		gboolean _tmp6_ = FALSE;
		Photo* _tmp7_ = NULL;
#line 2123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp3_);
#line 2123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_id = _tmp3_;
#line 2124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = photo;
#line 2124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_get_photo_id (_tmp4_, &_tmp5_);
#line 2124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		other_photo_id = _tmp5_;
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = photo;
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (self != _tmp7_) {
#line 16661 "Photo.c"
			PhotoID _tmp8_ = {0};
			gint64 _tmp9_ = 0LL;
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = photo_id;
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_.id;
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp9_ != PHOTO_ID_INVALID;
#line 16670 "Photo.c"
		} else {
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = FALSE;
#line 16674 "Photo.c"
		}
#line 2126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp6_) {
#line 16678 "Photo.c"
			PhotoID _tmp10_ = {0};
			gint64 _tmp11_ = 0LL;
			PhotoID _tmp12_ = {0};
			gint64 _tmp13_ = 0LL;
#line 2127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = photo_id;
#line 2127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = _tmp10_.id;
#line 2127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = other_photo_id;
#line 2127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = _tmp12_.id;
#line 2127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_assert (_tmp11_ != _tmp13_, "photo_id.id != other_photo_id.id");
#line 16693 "Photo.c"
		}
	}
#line 2131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = source;
#line 2131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = DATA_SOURCE_CLASS (photo_parent_class)->equals ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), _tmp14_);
#line 2131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp15_;
#line 2131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 16706 "Photo.c"
}


static void photo_file_exif_updated (Photo* self) {
	GFile* file = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_ = NULL;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	gboolean success = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_get_file ((MediaSource*) self);
#line 2136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp0_;
#line 2138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	info = NULL;
#line 16733 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_ = NULL;
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16744 "Photo.c"
			goto __catch196_g_error;
		}
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		info = _tmp3_;
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 16757 "Photo.c"
	}
	goto __finally196;
	__catch196_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = data_object_to_string ((DataObject*) self);
#line 2143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = err->message;
#line 2143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_error ("Photo.vala:2143: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 16782 "Photo.c"
	}
	__finally196:
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 16797 "Photo.c"
	}
#line 2146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = info;
#line 2146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	timestamp = _tmp8_;
#line 2149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	interrogator = _tmp9_;
#line 16809 "Photo.c"
	{
#line 2151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 2151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16815 "Photo.c"
			goto __catch197_g_error;
		}
	}
	goto __finally197;
	__catch197_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = err;
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2153: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2153 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 16845 "Photo.c"
	}
	__finally197:
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 16862 "Photo.c"
	}
#line 2156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp14_;
#line 2157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = detected;
#line 2157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 16872 "Photo.c"
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 2158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("Photo.vala:2158: file_exif_updated: %s no longer an image", _tmp17_);
#line 2158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 2160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 16893 "Photo.c"
	}
	{
		PhotoRow* _tmp18_ = NULL;
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = self->row;
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16901 "Photo.c"
		{
			PhotoTable* _tmp19_ = NULL;
			PhotoTable* _tmp20_ = NULL;
			PhotoID _tmp21_ = {0};
			GFileInfo* _tmp22_ = NULL;
			gint64 _tmp23_ = 0LL;
			GTimeVal _tmp24_ = {0};
			glong _tmp25_ = 0L;
			DetectedPhotoInformation* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			DetectedPhotoInformation* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			DetectedPhotoInformation* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			PhotoRow* _tmp32_ = NULL;
			gboolean _tmp33_ = FALSE;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = photo_table_get_instance ();
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp21_);
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = info;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = g_file_info_get_size (_tmp22_);
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = timestamp;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = _tmp24_.tv_sec;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = detected;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = _tmp26_->md5;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = detected;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = _tmp28_->exif_md5;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp30_ = detected;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp31_ = _tmp30_->thumbnail_md5;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp32_ = self->row;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp33_ = photo_table_master_exif_updated (_tmp20_, &_tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp29_, _tmp31_, _tmp32_);
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			success = _tmp33_;
#line 2165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 16952 "Photo.c"
		}
		__finally198:
		{
			PhotoRow* _tmp34_ = NULL;
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp34_ = self->row;
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16961 "Photo.c"
		}
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 16979 "Photo.c"
		}
	}
#line 2169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = success;
#line 2169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp35_) {
#line 16986 "Photo.c"
		Alteration* _tmp36_ = NULL;
		Alteration* _tmp37_ = NULL;
#line 2170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = _tmp36_;
#line 2170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp37_);
#line 2170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp37_);
#line 16997 "Photo.c"
	}
#line 2135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 2135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 17007 "Photo.c"
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2175 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 17017 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17024 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			gint64 _tmp2_ = 0LL;
#line 2177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17034 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17041 "Photo.c"
			}
#line 2177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17045 "Photo.c"
		}
		__finally199:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17054 "Photo.c"
		}
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0ULL;
#line 17062 "Photo.c"
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 17073 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17080 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoRow* _tmp2_ = NULL;
			gint64 _tmp3_ = 0LL;
#line 2183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 17093 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17100 "Photo.c"
			}
#line 2183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17104 "Photo.c"
		}
		__finally200:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17113 "Photo.c"
		}
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0ULL;
#line 17121 "Photo.c"
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 17131 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17138 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			gint64 _tmp2_ = 0LL;
#line 2189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17148 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17155 "Photo.c"
			}
#line 2189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17159 "Photo.c"
		}
		__finally201:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17168 "Photo.c"
		}
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0ULL;
#line 17176 "Photo.c"
	}
}


static time_t photo_real_get_exposure_time (Dateable* base) {
	Photo * self;
	time_t result = 0;
	time_t _tmp0_ = 0;
#line 2193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 2194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 17193 "Photo.c"
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 17203 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17210 "Photo.c"
		{
			const gchar* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
#line 2199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 17220 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17227 "Photo.c"
			}
#line 2199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17231 "Photo.c"
		}
		__finally202:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17240 "Photo.c"
		}
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 17248 "Photo.c"
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 17259 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17266 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 2205 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2205 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2205 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2205 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 17279 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17286 "Photo.c"
			}
#line 2205 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17290 "Photo.c"
		}
		__finally203:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17299 "Photo.c"
		}
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 17307 "Photo.c"
	}
}


static gchar* photo_real_get_comment (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 17318 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17325 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 2211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 17338 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17345 "Photo.c"
			}
#line 2211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 17349 "Photo.c"
		}
		__finally204:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17358 "Photo.c"
		}
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 17366 "Photo.c"
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	gchar* new_title = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = title;
#line 2216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = media_source_prep_title (_tmp0_);
#line 2216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	new_title = _tmp1_;
#line 2218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 17389 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17396 "Photo.c"
		{
			const gchar* _tmp3_ = NULL;
			PhotoRow* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoID _tmp10_ = {0};
			const gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 2220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = new_title;
#line 2220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _tmp4_->title;
#line 2220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 17416 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17423 "Photo.c"
				}
#line 2221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (new_title);
#line 2221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 17429 "Photo.c"
			}
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = new_title;
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo_table_set_title (_tmp8_, &_tmp10_, _tmp11_);
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp12_;
#line 2223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = committed;
#line 2224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp13_) {
#line 17451 "Photo.c"
				PhotoRow* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
#line 2225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = new_title;
#line 2225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp14_->title);
#line 2225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_->title = _tmp16_;
#line 17465 "Photo.c"
			}
		}
		__finally205:
		{
			PhotoRow* _tmp17_ = NULL;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17475 "Photo.c"
		}
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (new_title);
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 17487 "Photo.c"
		}
	}
#line 2228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = committed;
#line 2228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp18_) {
#line 17494 "Photo.c"
		Alteration* _tmp19_ = NULL;
		Alteration* _tmp20_ = NULL;
#line 2229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "name");
#line 2229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp20_);
#line 2229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 17505 "Photo.c"
	}
#line 2215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (new_title);
#line 17509 "Photo.c"
}


static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment) {
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = comment;
#line 2233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = media_source_prep_comment (_tmp0_);
#line 2233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	new_comment = _tmp1_;
#line 2235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 17532 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17539 "Photo.c"
		{
			const gchar* _tmp3_ = NULL;
			PhotoRow* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoID _tmp10_ = {0};
			const gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 2237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = new_comment;
#line 2237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _tmp4_->comment;
#line 2237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 2238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = TRUE;
#line 17561 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17568 "Photo.c"
				}
#line 2238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (new_comment);
#line 2238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 17574 "Photo.c"
			}
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = new_comment;
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo_table_set_comment (_tmp8_, &_tmp10_, _tmp11_);
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp12_;
#line 2240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = committed;
#line 2241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp13_) {
#line 17596 "Photo.c"
				PhotoRow* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
#line 2242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = new_comment;
#line 2242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp14_->comment);
#line 2242 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_->comment = _tmp16_;
#line 17610 "Photo.c"
			}
		}
		__finally206:
		{
			PhotoRow* _tmp17_ = NULL;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17620 "Photo.c"
		}
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (new_comment);
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 17632 "Photo.c"
		}
	}
#line 2245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = committed;
#line 2245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp18_) {
#line 17639 "Photo.c"
		Alteration* _tmp19_ = NULL;
		Alteration* _tmp20_ = NULL;
#line 2246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "comment");
#line 2246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp20_);
#line 2246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 17650 "Photo.c"
	}
#line 2248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = committed;
#line 2248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (new_comment);
#line 2248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 17658 "Photo.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 2258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 17665 "Photo.c"
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr = NULL;
	GError* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 2251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dberr = NULL;
#line 17679 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17686 "Photo.c"
		{
			{
				PhotoTable* _tmp1_ = NULL;
				PhotoTable* _tmp2_ = NULL;
				PhotoRow* _tmp3_ = NULL;
				PhotoID _tmp4_ = {0};
				ImportID _tmp5_ = {0};
				PhotoRow* _tmp7_ = NULL;
				ImportID _tmp8_ = {0};
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 17714 "Photo.c"
						goto __catch208_database_error;
					}
					{
						PhotoRow* _tmp6_ = NULL;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp6_ = self->row;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17723 "Photo.c"
					}
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 2255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 17733 "Photo.c"
				}
#line 2256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 17741 "Photo.c"
			}
			goto __finally208;
			__catch208_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_ = NULL;
				GError* _tmp10_ = NULL;
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				err = _inner_error_;
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 2258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = err;
#line 2258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				dberr = _tmp10_;
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (err);
#line 17763 "Photo.c"
			}
			__finally208:
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17768 "Photo.c"
				{
					PhotoRow* _tmp11_ = NULL;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17775 "Photo.c"
				}
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 17785 "Photo.c"
			}
		}
		__finally207:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17795 "Photo.c"
		}
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 17807 "Photo.c"
		}
	}
#line 2262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = dberr;
#line 2262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 17814 "Photo.c"
		Alteration* _tmp14_ = NULL;
		Alteration* _tmp15_ = NULL;
#line 2263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 17825 "Photo.c"
	} else {
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = dberr;
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2265: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 17843 "Photo.c"
	}
#line 2251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_error_free0 (dberr);
#line 17847 "Photo.c"
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_ = NULL;
	const gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
#line 2268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2269 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2269 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	source = _tmp0_;
#line 2272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = source;
#line 2272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp3_) {
#line 17884 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = source;
#line 2273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2273: No photo file writer available for %s", _tmp6_);
#line 2273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = title;
#line 2275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp7_);
#line 2277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 17907 "Photo.c"
	}
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = source;
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 17923 "Photo.c"
	}
#line 2281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = title;
#line 2281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_metadata_set_title (_tmp10_, _tmp11_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = source;
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	writer = _tmp13_;
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 17947 "Photo.c"
	}
#line 2284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = source;
#line 2284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp14_);
#line 2284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_title");
#line 2284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 17959 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_ = NULL;
		PhotoMetadata* _tmp18_ = NULL;
#line 2286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = writer;
#line 2286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = metadata;
#line 2286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2286 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17971 "Photo.c"
			goto __finally209;
		}
	}
	__finally209:
	{
		PhotoFileReader* _tmp19_ = NULL;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_ = NULL;
#line 2288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = source;
#line 2288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp19_);
#line 2288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 17990 "Photo.c"
	}
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18004 "Photo.c"
	}
#line 2291 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = title;
#line 2291 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_set_title ((MediaSource*) self, _tmp22_);
#line 2293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18018 "Photo.c"
}


void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_ = NULL;
	const gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
#line 2296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	source = _tmp0_;
#line 2300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = source;
#line 2300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp3_) {
#line 18055 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = source;
#line 2301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2301: No photo file writer available for %s", _tmp6_);
#line 2301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = comment;
#line 2303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp7_);
#line 2305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18078 "Photo.c"
	}
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = source;
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18094 "Photo.c"
	}
#line 2309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = comment;
#line 2309 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_metadata_set_comment (_tmp10_, _tmp11_);
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = source;
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	writer = _tmp13_;
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18118 "Photo.c"
	}
#line 2312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = source;
#line 2312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp14_);
#line 2312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_comment");
#line 2312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 18130 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_ = NULL;
		PhotoMetadata* _tmp18_ = NULL;
#line 2314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = writer;
#line 2314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = metadata;
#line 2314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18142 "Photo.c"
			goto __finally210;
		}
	}
	__finally210:
	{
		PhotoFileReader* _tmp19_ = NULL;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_ = NULL;
#line 2316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = source;
#line 2316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp19_);
#line 2316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 18161 "Photo.c"
	}
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18175 "Photo.c"
	}
#line 2319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = comment;
#line 2319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_set_comment ((MediaSource*) self, _tmp22_);
#line 2321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18189 "Photo.c"
}


static void photo_real_set_exposure_time (Dateable* base, time_t time) {
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 18200 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18207 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			time_t _tmp5_ = 0;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = time;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = photo_table_set_exposure_time (_tmp2_, &_tmp4_, _tmp5_);
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp6_;
#line 2327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = committed;
#line 2328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp7_) {
#line 18236 "Photo.c"
				PhotoRow* _tmp8_ = NULL;
				time_t _tmp9_ = 0;
				time_t _tmp10_ = 0;
#line 2329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = time;
#line 2329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_->exposure_time = _tmp9_;
#line 2330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = time;
#line 2330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->cached_exposure_time = _tmp10_;
#line 18250 "Photo.c"
			}
		}
		__finally211:
		{
			PhotoRow* _tmp11_ = NULL;
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18260 "Photo.c"
		}
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 18270 "Photo.c"
		}
	}
#line 2334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = committed;
#line 2334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_) {
#line 18277 "Photo.c"
		Alteration* _tmp13_ = NULL;
		Alteration* _tmp14_ = NULL;
#line 2335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "exposure-time");
#line 2335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp14_);
#line 2335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 18288 "Photo.c"
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	time_t _tmp11_ = 0;
	MetadataDateTime* _tmp12_ = NULL;
	MetadataDateTime* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileMetadataWriter* _tmp15_ = NULL;
	PhotoFileReader* _tmp16_ = NULL;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_ = NULL;
	time_t _tmp24_ = 0;
	GError * _inner_error_ = NULL;
#line 2338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	source = _tmp0_;
#line 2342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = source;
#line 2342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp3_) {
#line 18328 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		time_t _tmp7_ = 0;
#line 2343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = source;
#line 2343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2343: No photo file writer available for %s", _tmp6_);
#line 2343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = time;
#line 2345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dateable_set_exposure_time ((Dateable*) self, _tmp7_);
#line 2347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18351 "Photo.c"
	}
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = source;
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18367 "Photo.c"
	}
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = time;
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = metadata_date_time_new (_tmp11_);
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp10_, _tmp13_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp13_);
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = source;
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = photo_file_reader_create_metadata_writer (_tmp14_, &_inner_error_);
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	writer = _tmp15_;
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18397 "Photo.c"
	}
#line 2354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = source;
#line 2354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp16_);
#line 2354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp18_, "Photo.set_exposure_time_persistent");
#line 2354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 18409 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp19_ = NULL;
		PhotoMetadata* _tmp20_ = NULL;
#line 2356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = writer;
#line 2356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = metadata;
#line 2356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp19_, _tmp20_, &_inner_error_);
#line 2356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18421 "Photo.c"
			goto __finally212;
		}
	}
	__finally212:
	{
		PhotoFileReader* _tmp21_ = NULL;
		GFile* _tmp22_ = NULL;
		GFile* _tmp23_ = NULL;
#line 2358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = source;
#line 2358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp21_);
#line 2358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 2358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp23_);
#line 18440 "Photo.c"
	}
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 18454 "Photo.c"
	}
#line 2361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = time;
#line 2361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dateable_set_exposure_time ((Dateable*) self, _tmp24_);
#line 2363 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18468 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options ()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result) {
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
	PhotoException _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	PhotoException _tmp10_ = 0;
	gboolean _tmp11_ = FALSE;
	PhotoException _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
#line 2379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 2381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = disallowed_steps;
#line 2384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_exception_allows (_tmp1_, PHOTO_EXCEPTION_ORIENTATION);
#line 2384 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 18507 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp3_ = 0;
		Orientation _tmp4_ = 0;
#line 2385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_get_orientation (self);
#line 2385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		ori_tmp = _tmp3_;
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = ori_tmp;
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		switch (_tmp4_) {
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 18527 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp5_ = {0};
				gint _tmp6_ = 0;
				Dimensions _tmp7_ = {0};
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
#line 2394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = returned_dims;
#line 2394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = _tmp5_.width;
#line 2394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				width_tmp = _tmp6_;
#line 2396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = returned_dims;
#line 2396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_.height;
#line 2396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				returned_dims.width = _tmp8_;
#line 2397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = width_tmp;
#line 2397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				returned_dims.height = _tmp9_;
#line 2398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 18553 "Photo.c"
			}
			default:
			{
#line 2402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 18559 "Photo.c"
			}
		}
	}
#line 2407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = disallowed_steps;
#line 2407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 2407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 18569 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp12_ = 0.0;
		Dimensions _tmp13_ = {0};
		gint _tmp14_ = 0;
		Dimensions _tmp15_ = {0};
		gint _tmp16_ = 0;
		gdouble _tmp17_ = 0.0;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
#line 2409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		angle = 0.0;
#line 2411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_get_straighten (self, &_tmp12_);
#line 2411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		angle = _tmp12_;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = returned_dims;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = _tmp13_.width;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = returned_dims;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp15_.height;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = angle;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp14_, (gdouble) _tmp16_, _tmp17_, &_tmp18_, &_tmp19_);
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		x_size = _tmp18_;
#line 2413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		y_size = _tmp19_;
#line 2415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = x_size;
#line 2415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		returned_dims.width = (gint) _tmp20_;
#line 2416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = y_size;
#line 2416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		returned_dims.height = (gint) _tmp21_;
#line 18613 "Photo.c"
	}
#line 2420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = disallowed_steps;
#line 2420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = photo_exception_allows (_tmp22_, PHOTO_EXCEPTION_CROP);
#line 2420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp23_) {
#line 18621 "Photo.c"
		Box crop = {0};
		PhotoException _tmp24_ = 0;
		Box _tmp25_ = {0};
		gboolean _tmp26_ = FALSE;
#line 2422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = disallowed_steps;
#line 2422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = photo_get_crop (self, &_tmp25_, _tmp24_);
#line 2422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		crop = _tmp25_;
#line 2422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp26_) {
#line 18634 "Photo.c"
			Dimensions _tmp27_ = {0};
#line 2423 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp27_);
#line 2423 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			returned_dims = _tmp27_;
#line 18640 "Photo.c"
		}
	}
#line 2426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = returned_dims;
#line 2426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 18647 "Photo.c"
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_ = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* _tmp2_ = NULL;
	PixelTransformationBundle* _tmp6_ = NULL;
	PixelTransformer* _tmp7_ = NULL;
#line 2430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp1_;
#line 2434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = map;
#line 2434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 18674 "Photo.c"
		PixelTransformationBundle* _tmp3_ = NULL;
#line 2435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 18680 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_ = NULL;
		KeyValueMap* _tmp5_ = NULL;
#line 2437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = map;
#line 2437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 18690 "Photo.c"
	}
#line 2439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 18702 "Photo.c"
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 2443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18711 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18718 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_ = NULL;
			PixelTransformationBundle* _tmp2_ = NULL;
			PixelTransformationBundle* _tmp3_ = NULL;
#line 2445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18729 "Photo.c"
			}
#line 2448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 18737 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18744 "Photo.c"
			}
#line 2448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 18748 "Photo.c"
		}
		__finally213:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18757 "Photo.c"
		}
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 18765 "Photo.c"
	}
}


static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* original_adjustments = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	KeyValueMap* map = NULL;
	PhotoRow* _tmp1_ = NULL;
	GeeHashMap* _tmp2_ = NULL;
	KeyValueMap* _tmp10_ = NULL;
#line 2453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	original_adjustments = _tmp0_;
#line 2457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = self->row;
#line 2457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_->original_transforms;
#line 2457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 18790 "Photo.c"
		PhotoRow* _tmp3_ = NULL;
		GeeHashMap* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		KeyValueMap* _tmp6_ = NULL;
#line 2458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = self->row;
#line 2458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_->original_transforms;
#line 2458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "adjustments");
#line 2458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		map = (KeyValueMap*) _tmp5_;
#line 2459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = map;
#line 2459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 18809 "Photo.c"
			KeyValueMap* _tmp7_ = NULL;
			KeyValueMap* _tmp8_ = NULL;
#line 2460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = map;
#line 2460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = key_value_map_copy (_tmp7_);
#line 2460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2460 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			map = _tmp8_;
#line 18820 "Photo.c"
		}
	} else {
		KeyValueMap* _tmp9_ = NULL;
#line 2462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = key_value_map_new ("adjustments");
#line 2462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		map = _tmp9_;
#line 18830 "Photo.c"
	}
#line 2464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = map;
#line 2464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 18836 "Photo.c"
		PixelTransformationBundle* _tmp11_ = NULL;
#line 2465 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = original_adjustments;
#line 2465 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp11_);
#line 18842 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp12_ = NULL;
		KeyValueMap* _tmp13_ = NULL;
#line 2467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = original_adjustments;
#line 2467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = map;
#line 2467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp12_, _tmp13_);
#line 18852 "Photo.c"
	}
#line 2469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = original_adjustments;
#line 2469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 18860 "Photo.c"
}


static KeyValueMap* photo_get_color_adjustments_map (Photo* self) {
	KeyValueMap* result = NULL;
	GError * _inner_error_ = NULL;
#line 2474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18869 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18876 "Photo.c"
		{
			KeyValueMap* map = NULL;
			KeyValueMap* _tmp1_ = NULL;
			KeyValueMap* _tmp2_ = NULL;
#line 2476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			map = _tmp1_;
#line 2477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = map;
#line 2477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 18889 "Photo.c"
				KeyValueMap* _tmp3_ = NULL;
#line 2478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = key_value_map_new ("adjustments");
#line 2478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				map = _tmp3_;
#line 18897 "Photo.c"
			}
#line 2479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = map;
#line 18901 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18908 "Photo.c"
			}
#line 2479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 18912 "Photo.c"
		}
		__finally214:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18921 "Photo.c"
		}
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 18929 "Photo.c"
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 2483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18939 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18946 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_ = NULL;
			PixelTransformer* _tmp3_ = NULL;
#line 2485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18957 "Photo.c"
			}
#line 2488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp3_;
#line 18965 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18972 "Photo.c"
			}
#line 2488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 18976 "Photo.c"
		}
		__finally215:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18985 "Photo.c"
		}
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 18993 "Photo.c"
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "adjustments");
#line 2493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 2493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19009 "Photo.c"
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
	PixelTransformationType _tmp2_ = 0;
	PixelTransformation* _tmp3_ = NULL;
	PixelTransformation* _tmp4_ = NULL;
#line 2496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = type;
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = pixel_transformation_bundle_get_transformation (_tmp1_, _tmp2_);
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 2497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19038 "Photo.c"
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	PixelTransformationBundle* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	KeyValueMap* map = NULL;
	PixelTransformationBundle* _tmp8_ = NULL;
	KeyValueMap* _tmp9_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp39_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (new_adjustments != NULL);
#line 2503 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_set_enhanced (self, FALSE);
#line 2504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = new_adjustments;
#line 2504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = pixel_transformation_bundle_is_identity (_tmp0_);
#line 2504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 19063 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp5_ = FALSE;
		{
			PhotoRow* _tmp2_ = NULL;
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 19072 "Photo.c"
			{
				gboolean _tmp3_ = FALSE;
#line 2507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = photo_remove_transformation (self, "adjustments");
#line 2507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_result_ = _tmp3_;
#line 2508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->transformer = NULL;
#line 19087 "Photo.c"
			}
			__finally216:
			{
				PhotoRow* _tmp4_ = NULL;
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19096 "Photo.c"
			}
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 19106 "Photo.c"
			}
		}
#line 2512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _result_;
#line 2512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp5_) {
#line 19113 "Photo.c"
			Alteration* _tmp6_ = NULL;
			Alteration* _tmp7_ = NULL;
#line 2513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = alteration_new ("image", "color-adjustments");
#line 2513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			data_object_notify_altered ((DataObject*) self, _tmp7_);
#line 2513 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_alteration_unref0 (_tmp7_);
#line 19124 "Photo.c"
		}
#line 2515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 19128 "Photo.c"
	}
#line 2519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = new_adjustments;
#line 2519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = pixel_transformation_bundle_save (_tmp8_, "adjustments");
#line 2519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp9_;
#line 19136 "Photo.c"
	{
		PhotoRow* _tmp10_ = NULL;
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = self->row;
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19143 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			PixelTransformer* _tmp12_ = NULL;
			KeyValueMap* _tmp36_ = NULL;
			gboolean _tmp37_ = FALSE;
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->priv->transformer;
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = TRUE;
#line 19155 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp13_ = NULL;
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = self->priv->adjustments;
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _tmp13_ == NULL;
#line 19162 "Photo.c"
			}
#line 2523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp11_) {
#line 19166 "Photo.c"
				PixelTransformationBundle* _tmp14_ = NULL;
				PixelTransformationBundle* _tmp15_ = NULL;
				PixelTransformationBundle* _tmp16_ = NULL;
				PixelTransformer* _tmp17_ = NULL;
#line 2525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = new_adjustments;
#line 2525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = pixel_transformation_bundle_copy (_tmp14_);
#line 2525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->adjustments = _tmp15_;
#line 2526 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = new_adjustments;
#line 2526 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = pixel_transformation_bundle_generate_transformer (_tmp16_);
#line 2526 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2526 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->transformer = _tmp17_;
#line 19187 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp34_ = NULL;
				PixelTransformationBundle* _tmp35_ = NULL;
				{
					GeeIterator* _transformation_it = NULL;
					PixelTransformationBundle* _tmp18_ = NULL;
					GeeIterable* _tmp19_ = NULL;
					GeeIterable* _tmp20_ = NULL;
					GeeIterator* _tmp21_ = NULL;
					GeeIterator* _tmp22_ = NULL;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = new_adjustments;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = pixel_transformation_bundle_get_transformations (_tmp18_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp20_ = _tmp19_;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp21_ = gee_iterable_iterator (_tmp20_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp20_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_transformation_it = _tmp22_;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					while (TRUE) {
#line 19214 "Photo.c"
						GeeIterator* _tmp23_ = NULL;
						gboolean _tmp24_ = FALSE;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp25_ = NULL;
						gpointer _tmp26_ = NULL;
						PixelTransformer* _tmp27_ = NULL;
						PixelTransformationBundle* _tmp28_ = NULL;
						PixelTransformation* _tmp29_ = NULL;
						PixelTransformationType _tmp30_ = 0;
						PixelTransformation* _tmp31_ = NULL;
						PixelTransformation* _tmp32_ = NULL;
						PixelTransformation* _tmp33_ = NULL;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp23_ = _transformation_it;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp24_ = gee_iterator_next (_tmp23_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp24_) {
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							break;
#line 19235 "Photo.c"
						}
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp25_ = _transformation_it;
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp26_ = gee_iterator_get (_tmp25_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp26_;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp27_ = self->priv->transformer;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp28_ = self->priv->adjustments;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp29_ = transformation;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp30_ = pixel_transformation_get_transformation_type (_tmp29_);
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp31_ = pixel_transformation_bundle_get_transformation (_tmp28_, _tmp30_);
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp32_ = _tmp31_;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp33_ = transformation;
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp27_, _tmp32_, _tmp33_);
#line 2530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp32_);
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 19263 "Photo.c"
					}
#line 2529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 19267 "Photo.c"
				}
#line 2535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = new_adjustments;
#line 2535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = pixel_transformation_bundle_copy (_tmp34_);
#line 2535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->adjustments = _tmp35_;
#line 19277 "Photo.c"
			}
#line 2538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp36_ = map;
#line 2538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp37_ = photo_set_transformation (self, _tmp36_);
#line 2538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp37_;
#line 19285 "Photo.c"
		}
		__finally217:
		{
			PhotoRow* _tmp38_ = NULL;
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = self->row;
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19294 "Photo.c"
		}
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19306 "Photo.c"
		}
	}
#line 2541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = committed;
#line 2541 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp39_) {
#line 19313 "Photo.c"
		Alteration* _tmp40_ = NULL;
		Alteration* _tmp41_ = NULL;
#line 2542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = alteration_new ("image", "color-adjustments");
#line 2542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 2542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp41_);
#line 2542 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp41_);
#line 19324 "Photo.c"
	}
#line 2500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19328 "Photo.c"
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 2546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 19338 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_ = NULL;
		PhotoMetadata* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
		PhotoMetadata* _tmp5_ = NULL;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19360 "Photo.c"
			goto __catch218_g_error;
		}
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp5_;
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19373 "Photo.c"
	}
	goto __finally218;
	__catch218_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 2547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = err;
#line 2550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:2550: Unable to load metadata: %s", _tmp7_);
#line 2552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 2552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 2552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19397 "Photo.c"
	}
	__finally218:
#line 2547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 2547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 19406 "Photo.c"
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	PhotoMetadata* _tmp4_ = NULL;
	PhotoMetadata* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 2556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 19439 "Photo.c"
	}
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp5_;
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19451 "Photo.c"
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 2560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2561 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2561 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reader = _tmp0_;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = reader;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19472 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = reader;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 19493 "Photo.c"
		}
	} else {
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 19500 "Photo.c"
	}
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19508 "Photo.c"
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileMetadataWriter* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_ = NULL;
	PhotoFileMetadataWriter* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	PhotoReimportMasterState* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	PhotoReimportMasterState* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 2569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = NULL;
#line 2573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	master_reader = _tmp0_;
#line 2575 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2575 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2575 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2575 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp3_) {
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 19559 "Photo.c"
		} else {
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19563 "Photo.c"
		}
#line 2576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19567 "Photo.c"
	}
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = master_reader;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_create_metadata_writer (_tmp5_, &_inner_error_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp6_;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19583 "Photo.c"
	}
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp4_;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = NULL;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = metadata;
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp8_, _tmp9_, &_inner_error_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp8_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2578 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19607 "Photo.c"
	}
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo_prepare_for_reimport_master (self, &_tmp11_, &_inner_error_);
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = _tmp11_;
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = _tmp12_;
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19627 "Photo.c"
	}
#line 2580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp10_) {
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 19641 "Photo.c"
		} else {
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19645 "Photo.c"
		}
#line 2581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19649 "Photo.c"
	}
#line 2583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _vala_state;
#line 2583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp4_);
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (state) {
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*state = _vala_state;
#line 19665 "Photo.c"
	} else {
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 19669 "Photo.c"
	}
#line 2585 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19673 "Photo.c"
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 2588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = state;
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_finish_reimport_master (self, _tmp0_, &_inner_error_);
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19696 "Photo.c"
		} else {
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19704 "Photo.c"
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoFileMetadataWriter* _tmp5_ = NULL;
	PhotoFileReader* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_ = NULL;
	PhotoFileMetadataWriter* _tmp8_ = NULL;
	PhotoFileMetadataWriter* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	PhotoReimportEditableState* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	PhotoReimportEditableState* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
#line 2592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = NULL;
#line 2596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2597 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2597 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 19754 "Photo.c"
		} else {
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19758 "Photo.c"
		}
#line 2598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19762 "Photo.c"
	}
#line 2600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 2600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 2600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp4_) {
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 19780 "Photo.c"
		} else {
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19784 "Photo.c"
		}
#line 2601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19788 "Photo.c"
	}
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = editable_reader;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = photo_file_reader_create_metadata_writer (_tmp6_, &_inner_error_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp7_;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19804 "Photo.c"
	}
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp5_;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = NULL;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp9_, _tmp10_, &_inner_error_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19828 "Photo.c"
	}
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = photo_prepare_for_reimport_editable (self, &_tmp12_, &_inner_error_);
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = _tmp12_;
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp13_;
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 19848 "Photo.c"
	}
#line 2605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp11_) {
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 19862 "Photo.c"
		} else {
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19866 "Photo.c"
		}
#line 2606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 19870 "Photo.c"
	}
#line 2608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = _vala_state;
#line 2608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (state) {
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*state = _vala_state;
#line 19886 "Photo.c"
	} else {
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 19890 "Photo.c"
	}
#line 2610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 19894 "Photo.c"
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	PhotoReimportEditableState* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 2613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = state;
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_finish_reimport_editable (self, _tmp0_, &_inner_error_);
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19917 "Photo.c"
		} else {
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19925 "Photo.c"
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
#line 2619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 19935 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19942 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			Dimensions _tmp2_ = {0};
#line 2621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*result = _tmp2_;
#line 19952 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19959 "Photo.c"
			}
#line 2621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 19963 "Photo.c"
		}
		__finally219:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19972 "Photo.c"
		}
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 19980 "Photo.c"
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19990 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19997 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_ = NULL;
			Orientation _tmp3_ = 0;
			BackingPhotoRow* _tmp4_ = NULL;
			Orientation _tmp5_ = 0;
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = TRUE;
#line 20016 "Photo.c"
			} else {
				PhotoRow* _tmp6_ = NULL;
				GeeHashMap* _tmp7_ = NULL;
#line 2629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 20026 "Photo.c"
			}
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 20030 "Photo.c"
			{
				PhotoRow* _tmp8_ = NULL;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20037 "Photo.c"
			}
#line 2627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 20041 "Photo.c"
		}
		__finally220:
		{
			PhotoRow* _tmp9_ = NULL;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20050 "Photo.c"
		}
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 20058 "Photo.c"
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 2633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2634 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	date_time = NULL;
#line 2636 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2636 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2637 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2637 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20082 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		MetadataDateTime* _tmp3_ = NULL;
#line 2638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		date_time = _tmp3_;
#line 20093 "Photo.c"
	}
	{
		PhotoRow* _tmp4_ = NULL;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = self->row;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20101 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_ = NULL;
			GeeHashMap* _tmp7_ = NULL;
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 20112 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_ = NULL;
				Orientation _tmp10_ = 0;
				BackingPhotoRow* _tmp11_ = NULL;
				Orientation _tmp12_ = 0;
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp8_ = TRUE;
#line 20130 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_ = NULL;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = date_time;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 20138 "Photo.c"
						PhotoRow* _tmp15_ = NULL;
						time_t _tmp16_ = 0;
						MetadataDateTime* _tmp17_ = NULL;
						time_t _tmp18_ = 0;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp15_ = self->row;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp17_ = date_time;
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp18_ = metadata_date_time_get_timestamp (_tmp17_);
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp13_ = _tmp16_ != _tmp18_;
#line 20153 "Photo.c"
					} else {
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp13_ = FALSE;
#line 20157 "Photo.c"
					}
#line 2643 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 20161 "Photo.c"
				}
#line 2642 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20165 "Photo.c"
			} else {
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = FALSE;
#line 20169 "Photo.c"
			}
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp5_;
#line 20173 "Photo.c"
			{
				PhotoRow* _tmp19_ = NULL;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = self->row;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20180 "Photo.c"
			}
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 20188 "Photo.c"
		}
		__finally221:
		{
			PhotoRow* _tmp20_ = NULL;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = self->row;
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20197 "Photo.c"
		}
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 20209 "Photo.c"
	}
#line 2633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20215 "Photo.c"
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	MetadataDateTime* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
#line 2647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	date_time = NULL;
#line 2649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	title = NULL;
#line 2650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	comment = NULL;
#line 2652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20245 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		MetadataDateTime* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		PhotoMetadata* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 2654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		date_time = _tmp3_;
#line 2655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = metadata;
#line 2655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = media_metadata_get_title ((MediaMetadata*) _tmp4_);
#line 2655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (title);
#line 2655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		title = _tmp5_;
#line 2656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = metadata;
#line 2656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = media_metadata_get_comment ((MediaMetadata*) _tmp6_);
#line 2656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (comment);
#line 2656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		comment = _tmp7_;
#line 20276 "Photo.c"
	}
#line 2660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = date_time;
#line 2660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 20282 "Photo.c"
		{
			PhotoRow* _tmp9_ = NULL;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20289 "Photo.c"
			{
				BackingPhotoRow* _tmp10_ = NULL;
				time_t _tmp11_ = 0;
				PhotoRow* _tmp12_ = NULL;
				time_t _tmp13_ = 0;
#line 2664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					result = TRUE;
#line 20307 "Photo.c"
					{
						PhotoRow* _tmp14_ = NULL;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp14_ = self->row;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20314 "Photo.c"
					}
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (comment);
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (title);
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2666 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return result;
#line 20326 "Photo.c"
				}
			}
			__finally222:
			{
				PhotoRow* _tmp15_ = NULL;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20336 "Photo.c"
			}
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (comment);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (title);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return FALSE;
#line 20354 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp16_ = NULL;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = self->row;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20364 "Photo.c"
		{
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			PhotoRow* _tmp21_ = NULL;
			GeeHashMap* _tmp22_ = NULL;
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = self->row;
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = _tmp21_->transformations;
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp22_ != NULL) {
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = TRUE;
#line 20380 "Photo.c"
			} else {
				PhotoRow* _tmp23_ = NULL;
				Orientation _tmp24_ = 0;
				BackingPhotoRow* _tmp25_ = NULL;
				Orientation _tmp26_ = 0;
#line 2673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = self->row;
#line 2673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = _tmp23_->orientation;
#line 2673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = self->backing_photo_row;
#line 2673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = _tmp25_->original_orientation;
#line 2673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = _tmp24_ != _tmp26_;
#line 20396 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp20_) {
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = TRUE;
#line 20402 "Photo.c"
			} else {
				gboolean _tmp27_ = FALSE;
				MetadataDateTime* _tmp28_ = NULL;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = date_time;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp28_ != NULL) {
#line 20410 "Photo.c"
					PhotoRow* _tmp29_ = NULL;
					time_t _tmp30_ = 0;
					MetadataDateTime* _tmp31_ = NULL;
					time_t _tmp32_ = 0;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp29_ = self->row;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp30_ = _tmp29_->exposure_time;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31_ = date_time;
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp32_ = metadata_date_time_get_timestamp (_tmp31_);
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp27_ = _tmp30_ != _tmp32_;
#line 20425 "Photo.c"
				} else {
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp27_ = FALSE;
#line 20429 "Photo.c"
				}
#line 2674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = _tmp27_;
#line 20433 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp19_) {
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = TRUE;
#line 20439 "Photo.c"
			} else {
				gchar* _tmp33_ = NULL;
				gchar* _tmp34_ = NULL;
				const gchar* _tmp35_ = NULL;
#line 2675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = media_source_get_comment ((MediaSource*) self);
#line 2675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = comment;
#line 2675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp34_);
#line 20454 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp18_) {
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = TRUE;
#line 20460 "Photo.c"
			} else {
				gchar* _tmp36_ = NULL;
				gchar* _tmp37_ = NULL;
				const gchar* _tmp38_ = NULL;
#line 2676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = media_source_get_title ((MediaSource*) self);
#line 2676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = title;
#line 2676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp37_);
#line 20475 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp17_;
#line 20479 "Photo.c"
			{
				PhotoRow* _tmp39_ = NULL;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = self->row;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20486 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (comment);
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (title);
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 20498 "Photo.c"
		}
		__finally223:
		{
			PhotoRow* _tmp40_ = NULL;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = self->row;
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20507 "Photo.c"
		}
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (comment);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (title);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2671 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 20523 "Photo.c"
	}
#line 2647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (comment);
#line 2647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (title);
#line 2647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20533 "Photo.c"
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20542 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20549 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_ = NULL;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			Orientation _tmp10_ = 0;
			PhotoRow* _tmp11_ = NULL;
			GeeHashMap* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			GeeHashMap* _tmp14_ = NULL;
			PhotoRow* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			PhotoPhotoTransformationStateImpl* _tmp17_ = NULL;
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20568 "Photo.c"
				PixelTransformer* _tmp3_ = NULL;
				PixelTransformer* _tmp4_ = NULL;
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 20579 "Photo.c"
			} else {
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 20585 "Photo.c"
			}
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 20591 "Photo.c"
				PixelTransformationBundle* _tmp7_ = NULL;
				PixelTransformationBundle* _tmp8_ = NULL;
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20602 "Photo.c"
			} else {
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = NULL;
#line 20608 "Photo.c"
			}
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->original_transforms;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = _tmp15_->enhanced;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_, _tmp14_, _tmp16_);
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = (PhotoTransformationState*) _tmp17_;
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 20634 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20641 "Photo.c"
			}
#line 2683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 20645 "Photo.c"
		}
		__finally224:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20654 "Photo.c"
		}
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 20662 "Photo.c"
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
#line 2712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 20670 "Photo.c"
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
#line 2713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 20677 "Photo.c"
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoTransformationState* _tmp0_ = NULL;
	PhotoPhotoTransformationStateImpl* _tmp1_ = NULL;
	PhotoPhotoTransformationStateImpl* _tmp2_ = NULL;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp3_ = NULL;
	Orientation _tmp4_ = 0;
	gboolean saved_enhanced = FALSE;
	PhotoPhotoTransformationStateImpl* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_ = NULL;
	GeeHashMap* _tmp8_ = NULL;
	GeeHashMap* saved_original_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp9_ = NULL;
	GeeHashMap* _tmp10_ = NULL;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp11_ = NULL;
	PixelTransformer* _tmp12_ = NULL;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp13_ = NULL;
	PixelTransformationBundle* _tmp14_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp41_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2691 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 2692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = state;
#line 2692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
#line 2692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	state_impl = _tmp1_;
#line 2693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 2694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 20728 "Photo.c"
	}
#line 2696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_orientation (_tmp3_);
#line 2696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_orientation = _tmp4_;
#line 2697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_enhanced (_tmp5_);
#line 2697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_enhanced = _tmp6_;
#line 2698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_transformations (_tmp7_);
#line 2698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_transformations = _tmp8_;
#line 2699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = state_impl;
#line 2699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = photo_photo_transformation_state_impl_get_original_transformations (_tmp9_);
#line 2699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_original_transformations = _tmp10_;
#line 2700 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = state_impl;
#line 2700 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo_photo_transformation_state_impl_get_transformer (_tmp11_);
#line 2700 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_transformer = _tmp12_;
#line 2701 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = state_impl;
#line 2701 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp13_);
#line 2701 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	saved_adjustments = _tmp14_;
#line 20766 "Photo.c"
	{
		PhotoRow* _tmp15_ = NULL;
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = self->row;
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20773 "Photo.c"
		{
			PhotoTable* _tmp16_ = NULL;
			PhotoTable* _tmp17_ = NULL;
			PhotoRow* _tmp18_ = NULL;
			PhotoID _tmp19_ = {0};
			Orientation _tmp20_ = 0;
			GeeHashMap* _tmp21_ = NULL;
			GeeHashMap* _tmp22_ = NULL;
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = photo_table_get_instance ();
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = _tmp18_->photo_id;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = saved_orientation;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = saved_transformations;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = saved_transformations;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = saved_enhanced;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = photo_table_set_transformation_state (_tmp17_, &_tmp19_, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			committed = _tmp24_;
#line 2705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp17_);
#line 2707 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = committed;
#line 2707 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp25_) {
#line 20811 "Photo.c"
				PhotoRow* _tmp26_ = NULL;
				Orientation _tmp27_ = 0;
				PhotoRow* _tmp28_ = NULL;
				GeeHashMap* _tmp29_ = NULL;
				GeeHashMap* _tmp30_ = NULL;
				PhotoRow* _tmp31_ = NULL;
				GeeHashMap* _tmp32_ = NULL;
				GeeHashMap* _tmp33_ = NULL;
				PhotoRow* _tmp34_ = NULL;
				gboolean _tmp35_ = FALSE;
				PixelTransformer* _tmp36_ = NULL;
				PixelTransformer* _tmp37_ = NULL;
				PixelTransformationBundle* _tmp38_ = NULL;
				PixelTransformationBundle* _tmp39_ = NULL;
#line 2708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = self->row;
#line 2708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = saved_orientation;
#line 2708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_->orientation = _tmp27_;
#line 2709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = self->row;
#line 2709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = saved_transformations;
#line 2709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = _g_object_ref0 (_tmp29_);
#line 2709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp28_->transformations);
#line 2709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_->transformations = _tmp30_;
#line 2710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = self->row;
#line 2710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = saved_original_transformations;
#line 2710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = _g_object_ref0 (_tmp32_);
#line 2710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp31_->original_transforms);
#line 2710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_->original_transforms = _tmp33_;
#line 2711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = self->row;
#line 2711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = saved_enhanced;
#line 2711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_->enhanced = _tmp35_;
#line 2712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = saved_transformer;
#line 2712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _pixel_transformer_ref0 (_tmp36_);
#line 2712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->transformer = _tmp37_;
#line 2713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = saved_adjustments;
#line 2713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = _pixel_transformation_bundle_ref0 (_tmp38_);
#line 2713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->adjustments = _tmp39_;
#line 20874 "Photo.c"
			}
		}
		__finally225:
		{
			PhotoRow* _tmp40_ = NULL;
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = self->row;
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20884 "Photo.c"
		}
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (saved_original_transformations);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 20904 "Photo.c"
		}
	}
#line 2717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = committed;
#line 2717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp41_) {
#line 20911 "Photo.c"
		Alteration* _tmp42_ = NULL;
		Alteration* _tmp43_ = NULL;
#line 2718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = alteration_new ("image", "transformation-state");
#line 2718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 2718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp43_);
#line 2718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp43_);
#line 20922 "Photo.c"
	}
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = committed;
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (saved_original_transformations);
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2720 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 20938 "Photo.c"
}


void photo_remove_all_transformations (Photo* self) {
#line 2723 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 20947 "Photo.c"
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2727 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_altered = FALSE;
#line 20960 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20967 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_ = NULL;
			PhotoRow* _tmp7_ = NULL;
			PhotoRow* _tmp8_ = NULL;
			Orientation _tmp9_ = 0;
			BackingPhotoRow* _tmp10_ = NULL;
			Orientation _tmp11_ = 0;
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			is_altered = _tmp5_;
#line 2730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp6_->transformations);
#line 2731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_->transformations = NULL;
#line 2732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_->enhanced = FALSE;
#line 2733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = self->row;
#line 2736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_->orientation;
#line 2736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->backing_photo_row;
#line 2736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = _tmp10_->original_orientation;
#line 2736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp9_ != _tmp11_) {
#line 21022 "Photo.c"
				PhotoTable* _tmp12_ = NULL;
				PhotoTable* _tmp13_ = NULL;
				PhotoRow* _tmp14_ = NULL;
				PhotoID _tmp15_ = {0};
				BackingPhotoRow* _tmp16_ = NULL;
				Orientation _tmp17_ = 0;
				PhotoRow* _tmp18_ = NULL;
				BackingPhotoRow* _tmp19_ = NULL;
				Orientation _tmp20_ = 0;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = photo_table_get_instance ();
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _tmp14_->photo_id;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = self->backing_photo_row;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = _tmp16_->original_orientation;
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_table_set_orientation (_tmp13_, &_tmp15_, _tmp17_);
#line 2737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 2739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 2739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = self->backing_photo_row;
#line 2739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = _tmp19_->original_orientation;
#line 2739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_->orientation = _tmp20_;
#line 2740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				is_altered = TRUE;
#line 21058 "Photo.c"
			}
		}
		__finally226:
		{
			PhotoRow* _tmp21_ = NULL;
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = self->row;
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21068 "Photo.c"
		}
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 21078 "Photo.c"
		}
	}
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = is_altered;
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp23_) {
#line 21085 "Photo.c"
		gboolean _tmp24_ = FALSE;
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = notify;
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = _tmp24_;
#line 21091 "Photo.c"
	} else {
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = FALSE;
#line 21095 "Photo.c"
	}
#line 2744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp22_) {
#line 21099 "Photo.c"
		Alteration* _tmp25_ = NULL;
		Alteration* _tmp26_ = NULL;
#line 2745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = alteration_new ("image", "revert");
#line 2745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp26_);
#line 2745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 21110 "Photo.c"
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21120 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21127 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
#line 2750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 21137 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21144 "Photo.c"
			}
#line 2750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21148 "Photo.c"
		}
		__finally227:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21157 "Photo.c"
		}
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 21165 "Photo.c"
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21175 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21182 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
#line 2756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp2_;
#line 21192 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21199 "Photo.c"
			}
#line 2756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21203 "Photo.c"
		}
		__finally228:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21212 "Photo.c"
		}
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return 0;
#line 21220 "Photo.c"
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed = FALSE;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2760 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	committed = FALSE;
#line 21234 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21241 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
			Orientation _tmp3_ = 0;
#line 2763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = orientation;
#line 2763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 21254 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoRow* _tmp6_ = NULL;
				PhotoID _tmp7_ = {0};
				Orientation _tmp8_ = 0;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp6_->photo_id;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = orientation;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo_table_set_orientation (_tmp5_, &_tmp7_, _tmp8_);
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				committed = _tmp9_;
#line 2764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp10_) {
#line 21282 "Photo.c"
					PhotoRow* _tmp11_ = NULL;
					Orientation _tmp12_ = 0;
#line 2766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = orientation;
#line 2766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_->orientation = _tmp12_;
#line 21291 "Photo.c"
				}
			}
		}
		__finally229:
		{
			PhotoRow* _tmp13_ = NULL;
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21302 "Photo.c"
		}
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 21312 "Photo.c"
		}
	}
#line 2770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = committed;
#line 2770 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp14_) {
#line 21319 "Photo.c"
		Alteration* _tmp15_ = NULL;
		Alteration* _tmp16_ = NULL;
#line 2771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "orientation");
#line 2771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp16_);
#line 2771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 21330 "Photo.c"
	}
#line 2773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = committed;
#line 2773 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 21336 "Photo.c"
}


gboolean photo_check_can_rotate (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 2777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 21351 "Photo.c"
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	{
		PhotoRow* _tmp0_ = NULL;
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21363 "Photo.c"
		{
			Orientation _tmp1_ = 0;
			Rotation _tmp2_ = 0;
			Orientation _tmp3_ = 0;
#line 2782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_get_orientation (self);
#line 2782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = rotation;
#line 2782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = orientation_perform (_tmp1_, _tmp2_);
#line 2782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_orientation (self, _tmp3_);
#line 21376 "Photo.c"
		}
		__finally230:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21385 "Photo.c"
		}
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 21395 "Photo.c"
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
#line 2780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 21406 "Photo.c"
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 21417 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21424 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_ = NULL;
			GeeHashMap* _tmp3_ = NULL;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 21435 "Photo.c"
				PhotoRow* _tmp4_ = NULL;
				GeeHashMap* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = name;
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 21450 "Photo.c"
			} else {
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 21454 "Photo.c"
			}
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp1_;
#line 21458 "Photo.c"
			{
				PhotoRow* _tmp8_ = NULL;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21465 "Photo.c"
			}
#line 2788 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21469 "Photo.c"
		}
		__finally231:
		{
			PhotoRow* _tmp9_ = NULL;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21478 "Photo.c"
		}
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 21486 "Photo.c"
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError * _inner_error_ = NULL;
#line 2795 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2795 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = NULL;
#line 21501 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21508 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 2798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21518 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				KeyValueMap* _tmp7_ = NULL;
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = name;
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				map = (KeyValueMap*) _tmp6_;
#line 2800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = map;
#line 2800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp7_ != NULL) {
#line 21540 "Photo.c"
					KeyValueMap* _tmp8_ = NULL;
					KeyValueMap* _tmp9_ = NULL;
#line 2801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp8_ = map;
#line 2801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp9_ = key_value_map_copy (_tmp8_);
#line 2801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					map = _tmp9_;
#line 21551 "Photo.c"
				}
			}
		}
		__finally232:
		{
			PhotoRow* _tmp10_ = NULL;
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21562 "Photo.c"
		}
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 21574 "Photo.c"
		}
	}
#line 2805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = map;
#line 2805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 21581 "Photo.c"
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21592 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21599 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			GeeHashMap* _tmp6_ = NULL;
			KeyValueMap* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			KeyValueMap* _tmp10_ = NULL;
			PhotoTable* _tmp11_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			PhotoID _tmp14_ = {0};
			KeyValueMap* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
#line 2810 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2810 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2810 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21622 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 21633 "Photo.c"
			}
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = trans;
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = key_value_map_get_group (_tmp7_);
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = trans;
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 2813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->photo_id;
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = trans;
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = photo_table_set_transformation (_tmp12_, &_tmp14_, _tmp15_);
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp17_;
#line 21669 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21676 "Photo.c"
			}
#line 2815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21680 "Photo.c"
		}
		__finally233:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21689 "Photo.c"
		}
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2809 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 21697 "Photo.c"
	}
}


static gboolean photo_set_original_transforms (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21709 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21716 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			GeeHashMap* _tmp6_ = NULL;
			KeyValueMap* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			KeyValueMap* _tmp10_ = NULL;
			PhotoTable* _tmp11_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			PhotoID _tmp14_ = {0};
			KeyValueMap* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
#line 2821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21739 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2822 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2822 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2822 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2822 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 21750 "Photo.c"
			}
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_->original_transforms;
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = trans;
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = key_value_map_get_group (_tmp7_);
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = trans;
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 2824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_->photo_id;
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = trans;
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = photo_table_set_original_transforms (_tmp12_, &_tmp14_, _tmp15_);
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp17_;
#line 21786 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21793 "Photo.c"
			}
#line 2826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21797 "Photo.c"
		}
		__finally234:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21806 "Photo.c"
		}
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 21814 "Photo.c"
	}
}


static gboolean photo_clear_original_transforms (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21824 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21831 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoTable* _tmp5_ = NULL;
			PhotoTable* _tmp6_ = NULL;
			PhotoRow* _tmp7_ = NULL;
			PhotoID _tmp8_ = {0};
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 2832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21847 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 21858 "Photo.c"
			}
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = photo_table_get_instance ();
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_->photo_id;
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = photo_table_set_original_transforms (_tmp6_, &_tmp8_, NULL);
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp6_);
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp10_;
#line 21876 "Photo.c"
			{
				PhotoRow* _tmp11_ = NULL;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->row;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21883 "Photo.c"
			}
#line 2834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 21887 "Photo.c"
		}
		__finally235:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21896 "Photo.c"
		}
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 21904 "Photo.c"
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 21920 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21927 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_ = NULL;
			PhotoRow* _tmp14_ = NULL;
			PhotoID _tmp15_ = {0};
			const gchar* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
#line 2841 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2841 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2841 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21943 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				PhotoRow* _tmp7_ = NULL;
				GeeHashMap* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
#line 2842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = name;
#line 2842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp5_, NULL);
#line 2842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				altered_cache = _tmp6_;
#line 2843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_->transformations;
#line 2843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = gee_abstract_map_get_size ((GeeMap*) _tmp8_);
#line 2843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp10_ == 0) {
#line 21972 "Photo.c"
					PhotoRow* _tmp11_ = NULL;
#line 2844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp11_->transformations);
#line 2844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_->transformations = NULL;
#line 21980 "Photo.c"
				}
			} else {
#line 2846 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				altered_cache = FALSE;
#line 21985 "Photo.c"
			}
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = name;
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = photo_table_remove_transformation (_tmp13_, &_tmp15_, _tmp16_);
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			altered_persistent = _tmp17_;
#line 2849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 22003 "Photo.c"
		}
		__finally236:
		{
			PhotoRow* _tmp18_ = NULL;
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22012 "Photo.c"
		}
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 22022 "Photo.c"
		}
	}
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = altered_cache;
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp20_) {
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = TRUE;
#line 22031 "Photo.c"
	} else {
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = altered_persistent;
#line 22035 "Photo.c"
	}
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp19_;
#line 2853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22041 "Photo.c"
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "crop");
#line 2857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 2857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22056 "Photo.c"
}


gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint left = 0;
	KeyValueMap* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint top = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint right = 0;
	KeyValueMap* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint bottom = 0;
	KeyValueMap* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
#line 2861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2862 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (crop) {
#line 2866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*crop = _vala_crop;
#line 22106 "Photo.c"
		}
#line 2866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 22110 "Photo.c"
	}
#line 2868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = map;
#line 2868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = key_value_map_get_int (_tmp2_, "left", -1);
#line 2868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	left = _tmp3_;
#line 2869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = map;
#line 2869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "top", -1);
#line 2869 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	top = _tmp5_;
#line 2870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = map;
#line 2870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = key_value_map_get_int (_tmp6_, "right", -1);
#line 2870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	right = _tmp7_;
#line 2871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = map;
#line 2871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = key_value_map_get_int (_tmp8_, "bottom", -1);
#line 2871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	bottom = _tmp9_;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = left;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp13_ == -1) {
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 22142 "Photo.c"
	} else {
		gint _tmp14_ = 0;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = top;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _tmp14_ == -1;
#line 22149 "Photo.c"
	}
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_) {
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 22155 "Photo.c"
	} else {
		gint _tmp15_ = 0;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = right;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp15_ == -1;
#line 22162 "Photo.c"
	}
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = TRUE;
#line 22168 "Photo.c"
	} else {
		gint _tmp16_ = 0;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = bottom;
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _tmp16_ == -1;
#line 22175 "Photo.c"
	}
#line 2873 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_) {
#line 2874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (crop) {
#line 2874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*crop = _vala_crop;
#line 22187 "Photo.c"
		}
#line 2874 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 22191 "Photo.c"
	}
#line 2876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = left;
#line 2876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = top;
#line 2876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = right;
#line 2876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = bottom;
#line 2876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	box_init (&_vala_crop, _tmp17_, _tmp18_, _tmp19_, _tmp20_);
#line 2878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 2878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (crop) {
#line 2878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*crop = _vala_crop;
#line 22211 "Photo.c"
	}
#line 2878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22215 "Photo.c"
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	Box _tmp2_ = {0};
	gint _tmp3_ = 0;
	KeyValueMap* _tmp4_ = NULL;
	Box _tmp5_ = {0};
	gint _tmp6_ = 0;
	KeyValueMap* _tmp7_ = NULL;
	Box _tmp8_ = {0};
	gint _tmp9_ = 0;
	KeyValueMap* _tmp10_ = NULL;
	Box _tmp11_ = {0};
	gint _tmp12_ = 0;
	KeyValueMap* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
#line 2882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = *crop;
#line 2884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2885 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = map;
#line 2885 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = *crop;
#line 2885 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2885 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = map;
#line 2886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = *crop;
#line 2886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = map;
#line 2887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = *crop;
#line 2887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = map;
#line 2889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = photo_set_transformation (self, _tmp13_);
#line 2889 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp14_) {
#line 22282 "Photo.c"
		Alteration* _tmp15_ = NULL;
		Alteration* _tmp16_ = NULL;
#line 2890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "crop");
#line 2890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp16_);
#line 2890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 22293 "Photo.c"
	}
#line 2882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22297 "Photo.c"
}


static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle) {
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
#line 2893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_angle = 0.0;
#line 2898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 2898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (angle) {
#line 2898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*angle = _vala_angle;
#line 22329 "Photo.c"
		}
#line 2898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 22333 "Photo.c"
	}
#line 2901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = map;
#line 2901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_angle = _tmp3_;
#line 2903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 2903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (angle) {
#line 2903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*angle = _vala_angle;
#line 22349 "Photo.c"
	}
#line 2903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22353 "Photo.c"
}


static void photo_set_raw_straighten (Photo* self, gdouble theta) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	KeyValueMap* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 2906 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = theta;
#line 2908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", _tmp2_);
#line 2910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = map;
#line 2910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_set_transformation (self, _tmp3_);
#line 2910 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp4_) {
#line 22382 "Photo.c"
		Alteration* _tmp5_ = NULL;
		Alteration* _tmp6_ = NULL;
#line 2911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = alteration_new ("image", "straighten");
#line 2911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp6_);
#line 2911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp6_);
#line 22393 "Photo.c"
	}
#line 2906 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22397 "Photo.c"
}


static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint num_points = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	EditingToolsRedeyeInstance* res = NULL;
	gint _tmp7_ = 0;
	EditingToolsRedeyeInstance* _tmp8_ = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	GdkPoint default_point = {0};
	GdkPoint _tmp9_ = {0};
	EditingToolsRedeyeInstance* _tmp47_ = NULL;
	gint _tmp47__length1 = 0;
#line 2916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22429 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_ = NULL;
		EditingToolsRedeyeInstance* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (result_length1) {
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 22443 "Photo.c"
		}
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp3_;
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 22451 "Photo.c"
	}
#line 2921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = map;
#line 2921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2921 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2922 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2922 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp6_ > 0, "num_points > 0");
#line 2924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = g_new0 (EditingToolsRedeyeInstance, _tmp7_);
#line 2924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	res = _tmp8_;
#line 2924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	res_length1 = _tmp7_;
#line 2924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_res_size_ = res_length1;
#line 2926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_.x = 0;
#line 2926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	default_point = _tmp9_;
#line 2927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	default_point.x = -1;
#line 2928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	default_point.y = -1;
#line 22481 "Photo.c"
	{
		gint i = 0;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		i = 0;
#line 22486 "Photo.c"
		{
			gboolean _tmp10_ = FALSE;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = TRUE;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 22493 "Photo.c"
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gchar* center_key = NULL;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gchar* radius_key = NULL;
				gint _tmp16_ = 0;
				gchar* _tmp17_ = NULL;
				EditingToolsRedeyeInstance* _tmp18_ = NULL;
				gint _tmp18__length1 = 0;
				gint _tmp19_ = 0;
				KeyValueMap* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				GdkPoint _tmp22_ = {0};
				GdkPoint _tmp23_ = {0};
				EditingToolsRedeyeInstance* _tmp24_ = NULL;
				gint _tmp24__length1 = 0;
				gint _tmp25_ = 0;
				EditingToolsRedeyeInstance _tmp26_ = {0};
				GdkPoint _tmp27_ = {0};
				gint _tmp28_ = 0;
				GdkPoint _tmp29_ = {0};
				gint _tmp30_ = 0;
				EditingToolsRedeyeInstance* _tmp31_ = NULL;
				gint _tmp31__length1 = 0;
				gint _tmp32_ = 0;
				EditingToolsRedeyeInstance _tmp33_ = {0};
				GdkPoint _tmp34_ = {0};
				gint _tmp35_ = 0;
				GdkPoint _tmp36_ = {0};
				gint _tmp37_ = 0;
				EditingToolsRedeyeInstance* _tmp38_ = NULL;
				gint _tmp38__length1 = 0;
				gint _tmp39_ = 0;
				KeyValueMap* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				gint _tmp42_ = 0;
				EditingToolsRedeyeInstance* _tmp43_ = NULL;
				gint _tmp43__length1 = 0;
				gint _tmp44_ = 0;
				EditingToolsRedeyeInstance _tmp45_ = {0};
				gint _tmp46_ = 0;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp10_) {
#line 22538 "Photo.c"
					gint _tmp11_ = 0;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = i;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					i = _tmp11_ + 1;
#line 22544 "Photo.c"
				}
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = FALSE;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = i;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = num_points;
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp12_ < _tmp13_)) {
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 22556 "Photo.c"
				}
#line 2931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = i;
#line 2931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = g_strdup_printf ("center%d", _tmp14_);
#line 2931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				center_key = _tmp15_;
#line 2932 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = i;
#line 2932 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = g_strdup_printf ("radius%d", _tmp16_);
#line 2932 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				radius_key = _tmp17_;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = res;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18__length1 = res_length1;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = i;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = map;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = center_key;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = default_point;
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				key_value_map_get_point (_tmp20_, _tmp21_, &_tmp22_, &_tmp23_);
#line 2934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_[_tmp19_].center = _tmp23_;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = res;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = i;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = _tmp24_[_tmp25_];
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = _tmp26_.center;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = _tmp27_.x;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = default_point;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = _tmp29_.x;
#line 2935 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_assert (_tmp28_ != _tmp30_, "res[i].center.x != default_point.x");
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = res;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31__length1 = res_length1;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = i;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = _tmp31_[_tmp32_];
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = _tmp33_.center;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = _tmp34_.y;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = default_point;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _tmp36_.y;
#line 2936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_assert (_tmp35_ != _tmp37_, "res[i].center.y != default_point.y");
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = res;
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38__length1 = res_length1;
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = i;
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp40_ = map;
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp41_ = radius_key;
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp42_ = key_value_map_get_int (_tmp40_, _tmp41_, -1);
#line 2938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_[_tmp39_].radius = _tmp42_;
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = res;
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43__length1 = res_length1;
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = i;
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = _tmp43_[_tmp44_];
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = _tmp45_.radius;
#line 2939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_assert (_tmp46_ != -1, "res[i].radius != -1");
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (radius_key);
#line 2930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (center_key);
#line 22652 "Photo.c"
			}
		}
	}
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = res;
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47__length1 = res_length1;
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (result_length1) {
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*result_length1 = _tmp47__length1;
#line 22664 "Photo.c"
	}
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp47_;
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22672 "Photo.c"
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "redeye");
#line 2946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 2946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 22687 "Photo.c"
}


void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint num_points = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gchar* radius_key = NULL;
	gint _tmp8_ = 0;
	gchar* _tmp9_ = NULL;
	gchar* center_key = NULL;
	gint _tmp10_ = 0;
	gchar* _tmp11_ = NULL;
	KeyValueMap* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	EditingToolsRedeyeInstance _tmp14_ = {0};
	gint _tmp15_ = 0;
	KeyValueMap* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	EditingToolsRedeyeInstance _tmp18_ = {0};
	GdkPoint _tmp19_ = {0};
	KeyValueMap* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	KeyValueMap* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
#line 2950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2951 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2951 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 2952 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = map;
#line 2952 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22730 "Photo.c"
		KeyValueMap* _tmp2_ = NULL;
		KeyValueMap* _tmp3_ = NULL;
#line 2953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		map = _tmp2_;
#line 2954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = map;
#line 2954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 22743 "Photo.c"
	}
#line 2957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = map;
#line 2957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp6_ >= 0, "num_points >= 0");
#line 2960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	num_points = _tmp7_ + 1;
#line 2962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = num_points;
#line 2962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = g_strdup_printf ("radius%d", _tmp8_ - 1);
#line 2962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	radius_key = _tmp9_;
#line 2963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = num_points;
#line 2963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("center%d", _tmp10_ - 1);
#line 2963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	center_key = _tmp11_;
#line 2965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = map;
#line 2965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = radius_key;
#line 2965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = *redeye;
#line 2965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_.radius;
#line 2965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp12_, _tmp13_, _tmp15_);
#line 2966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = map;
#line 2966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = center_key;
#line 2966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = *redeye;
#line 2966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_.center;
#line 2966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_point (_tmp16_, _tmp17_, &_tmp19_);
#line 2968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = map;
#line 2968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = num_points;
#line 2968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	key_value_map_set_int (_tmp20_, "num_points", _tmp21_);
#line 2970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = map;
#line 2970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = photo_set_transformation (self, _tmp22_);
#line 2970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp23_) {
#line 22803 "Photo.c"
		Alteration* _tmp24_ = NULL;
		Alteration* _tmp25_ = NULL;
#line 2971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = alteration_new ("image", "redeye");
#line 2971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 2971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp25_);
#line 2971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 22814 "Photo.c"
	}
#line 2950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (center_key);
#line 2950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (radius_key);
#line 2950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22822 "Photo.c"
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 22835 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22842 "Photo.c"
		{
			Scaling _tmp1_ = {0};
			PhotoException _tmp2_ = 0;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = exceptions;
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_scaled_image = _tmp3_;
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp4_;
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp5_;
#line 22861 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22868 "Photo.c"
			}
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (scaled_image) {
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 22874 "Photo.c"
			}
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (scaled_to_viewport) {
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22880 "Photo.c"
			}
#line 2989 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 22884 "Photo.c"
		}
		__finally237:
		{
			PhotoRow* _tmp7_ = NULL;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22893 "Photo.c"
		}
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 22901 "Photo.c"
	}
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (scaled_image) {
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 22907 "Photo.c"
	}
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 2985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22913 "Photo.c"
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Orientation orientation = 0;
	Orientation _tmp4_ = 0;
	PhotoException _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp53_ = FALSE;
	Dimensions _tmp54_ = {0};
	gint _tmp55_ = 0;
	Dimensions _tmp56_ = {0};
	gint _tmp57_ = 0;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
#line 2995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 2997 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2997 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw = _tmp0_;
#line 2999 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = scaling_is_unscaled (scaling);
#line 2999 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 22949 "Photo.c"
		Dimensions _tmp2_ = {0};
		Dimensions _tmp3_ = {0};
#line 3000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = raw;
#line 3000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_scaled_image = _tmp2_;
#line 3001 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = raw;
#line 3001 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp3_;
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (scaled_image) {
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 22966 "Photo.c"
		}
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22972 "Photo.c"
		}
#line 3003 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 22976 "Photo.c"
	}
#line 3006 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_get_orientation (self);
#line 3006 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation = _tmp4_;
#line 3011 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3012 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = exceptions;
#line 3014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_exception_allows (_tmp5_, PHOTO_EXCEPTION_CROP);
#line 3014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 22992 "Photo.c"
		Box crop = {0};
		Box _tmp7_ = {0};
		gboolean _tmp8_ = FALSE;
#line 3016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = photo_get_raw_crop (self, &_tmp7_);
#line 3016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		crop = _tmp7_;
#line 3016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp8_) {
#line 23002 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp9_ = {0};
			PhotoException _tmp10_ = 0;
			gboolean _tmp11_ = FALSE;
			Box scaled_crop = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Box _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
			gboolean _tmp23_ = FALSE;
			gint _tmp24_ = 0;
			gint _tmp25_ = 0;
			Dimensions _tmp30_ = {0};
			Dimensions _tmp31_ = {0};
			Dimensions _tmp32_ = {0};
			PhotoException _tmp33_ = 0;
			gboolean _tmp34_ = FALSE;
#line 3019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = raw;
#line 3019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			rotated_raw = _tmp9_;
#line 3020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = exceptions;
#line 3020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_ORIENTATION);
#line 3020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp11_) {
#line 23030 "Photo.c"
				Orientation _tmp12_ = 0;
				Dimensions _tmp13_ = {0};
				Box _tmp14_ = {0};
				Box _tmp15_ = {0};
				Orientation _tmp16_ = 0;
				Dimensions _tmp17_ = {0};
				Dimensions _tmp18_ = {0};
#line 3021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = orientation;
#line 3021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = raw;
#line 3021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = crop;
#line 3021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				orientation_rotate_box (_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 3021 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				crop = _tmp15_;
#line 3022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = orientation;
#line 3022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = raw;
#line 3022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				orientation_rotate_dimensions (_tmp16_, &_tmp17_, &_tmp18_);
#line 3022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				rotated_raw = _tmp18_;
#line 23056 "Photo.c"
			}
#line 3026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 3026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp19_, &_tmp20_);
#line 3026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_scaled (&crop, &_tmp20_, &_tmp21_);
#line 3026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaled_crop = _tmp21_;
#line 3029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp22_);
#line 3029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp22_;
#line 3032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = box_get_width (&crop);
#line 3032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = box_get_width (&scaled_crop);
#line 3032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp24_ <= _tmp25_) {
#line 23076 "Photo.c"
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
#line 3033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = box_get_height (&crop);
#line 3033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = box_get_height (&scaled_crop);
#line 3033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = _tmp26_ <= _tmp27_;
#line 23085 "Photo.c"
			} else {
#line 3032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = FALSE;
#line 23089 "Photo.c"
			}
#line 3032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp23_) {
#line 23093 "Photo.c"
				Dimensions _tmp28_ = {0};
				Dimensions _tmp29_ = {0};
#line 3034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = raw;
#line 3034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_scaled_image = _tmp28_;
#line 3035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp29_);
#line 3035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp29_;
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = FALSE;
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (scaled_image) {
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23110 "Photo.c"
				}
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (scaled_to_viewport) {
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23116 "Photo.c"
				}
#line 3037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 23120 "Photo.c"
			}
#line 3042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp30_);
#line 3042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp31_);
#line 3042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp30_, &_tmp31_, &_tmp32_);
#line 3042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_scaled_image = _tmp32_;
#line 3046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp33_ = exceptions;
#line 3046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp34_ = photo_exception_allows (_tmp33_, PHOTO_EXCEPTION_ORIENTATION);
#line 3046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp34_) {
#line 23136 "Photo.c"
				Orientation _tmp35_ = 0;
				Dimensions _tmp36_ = {0};
				Dimensions _tmp37_ = {0};
#line 3047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = orientation;
#line 3047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = _vala_scaled_image;
#line 3047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				orientation_derotate_dimensions (_tmp35_, &_tmp36_, &_tmp37_);
#line 3047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_vala_scaled_image = _tmp37_;
#line 23148 "Photo.c"
			}
		}
	}
#line 3052 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = dimensions_has_area (&_vala_scaled_image);
#line 3052 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp38_) {
#line 23156 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp39_ = {0};
		PhotoException _tmp40_ = 0;
		gboolean _tmp41_ = FALSE;
		Dimensions _tmp45_ = {0};
		Dimensions _tmp46_ = {0};
		Dimensions _tmp47_ = {0};
		PhotoException _tmp48_ = 0;
		gboolean _tmp49_ = FALSE;
#line 3054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = raw;
#line 3054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		rotated_raw = _tmp39_;
#line 3055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = exceptions;
#line 3055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = photo_exception_allows (_tmp40_, PHOTO_EXCEPTION_ORIENTATION);
#line 3055 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp41_) {
#line 23176 "Photo.c"
			Orientation _tmp42_ = 0;
			Dimensions _tmp43_ = {0};
			Dimensions _tmp44_ = {0};
#line 3056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = orientation;
#line 3056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp43_ = raw;
#line 3056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			orientation_rotate_dimensions (_tmp42_, &_tmp43_, &_tmp44_);
#line 3056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			rotated_raw = _tmp44_;
#line 23188 "Photo.c"
		}
#line 3058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = rotated_raw;
#line 3058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp45_, &_tmp46_);
#line 3058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_scaled_image = _tmp46_;
#line 3059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = _vala_scaled_image;
#line 3059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp47_;
#line 3062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = exceptions;
#line 3062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = photo_exception_allows (_tmp48_, PHOTO_EXCEPTION_ORIENTATION);
#line 3062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp49_) {
#line 23206 "Photo.c"
			Orientation _tmp50_ = 0;
			Dimensions _tmp51_ = {0};
			Dimensions _tmp52_ = {0};
#line 3063 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp50_ = orientation;
#line 3063 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp51_ = _vala_scaled_image;
#line 3063 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			orientation_derotate_dimensions (_tmp50_, &_tmp51_, &_tmp52_);
#line 3063 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_scaled_image = _tmp52_;
#line 23218 "Photo.c"
		}
	}
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp54_ = _vala_scaled_image;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp55_ = _tmp54_.width;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp56_ = raw;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp57_ = _tmp56_.width;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp55_ >= _tmp57_) {
#line 23231 "Photo.c"
		Dimensions _tmp58_ = {0};
		gint _tmp59_ = 0;
		Dimensions _tmp60_ = {0};
		gint _tmp61_ = 0;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = _vala_scaled_image;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp59_ = _tmp58_.height;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp60_ = raw;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp61_ = _tmp60_.height;
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = _tmp59_ >= _tmp61_;
#line 23246 "Photo.c"
	} else {
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = FALSE;
#line 23250 "Photo.c"
	}
#line 3067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp53_) {
#line 23254 "Photo.c"
		Dimensions _tmp62_ = {0};
#line 3068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp62_ = raw;
#line 3068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_scaled_image = _tmp62_;
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (scaled_image) {
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23266 "Photo.c"
		}
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23272 "Photo.c"
		}
#line 3070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 23276 "Photo.c"
	}
#line 3073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp63_ = dimensions_has_area (&_vala_scaled_image);
#line 3073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp63_, "scaled_image.has_area ()");
#line 3074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp64_ = dimensions_has_area (&_vala_scaled_to_viewport);
#line 3074 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp64_, "scaled_to_viewport.has_area ()");
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (scaled_image) {
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23292 "Photo.c"
	}
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23298 "Photo.c"
	}
#line 3076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23302 "Photo.c"
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	BackingFetchMode _tmp0_ = 0;
	PhotoFileReader* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp7_ = {0};
	PhotoException _tmp8_ = 0;
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp17_ = NULL;
	Dimensions _tmp18_ = {0};
	Dimensions _tmp19_ = {0};
	GdkPixbuf* _tmp20_ = NULL;
	GdkPixbuf* _tmp21_ = NULL;
	Dimensions _tmp22_ = {0};
	gboolean _tmp23_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = fetch_mode;
#line 3085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_backing_reader (self, _tmp0_);
#line 3085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	loader = _tmp1_;
#line 3088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = scaling_is_unscaled (scaling);
#line 3088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 23344 "Photo.c"
		GdkPixbuf* _tmp3_ = NULL;
		PhotoFileReader* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = loader;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_file_reader_unscaled_read (_tmp4_, &_inner_error_);
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp5_;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 23363 "Photo.c"
		}
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp3_;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = NULL;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp6_;
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 23377 "Photo.c"
	}
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = *scaling;
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = exceptions;
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = photo_calculate_pixbuf_dimensions (self, &_tmp7_, _tmp8_, &_tmp9_, &_tmp10_);
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	scaled_image = _tmp9_;
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	scaled_to_viewport = _tmp10_;
#line 3098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_scaled = _tmp11_;
#line 3100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = is_scaled;
#line 3100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp12_) {
#line 23395 "Photo.c"
		GdkPixbuf* _tmp13_ = NULL;
		PhotoFileReader* _tmp14_ = NULL;
		GdkPixbuf* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_ = NULL;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = loader;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = photo_file_reader_unscaled_read (_tmp14_, &_inner_error_);
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _tmp15_;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 23414 "Photo.c"
		}
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp13_;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = NULL;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp16_;
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp13_);
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 23428 "Photo.c"
	}
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = loader;
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp18_);
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = scaled_image;
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = photo_file_reader_scaled_read (_tmp17_, &_tmp18_, &_tmp19_, &_inner_error_);
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	pixbuf = _tmp20_;
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3108 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23448 "Photo.c"
	}
#line 3116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = pixbuf;
#line 3116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_for_pixbuf (_tmp21_, &_tmp22_);
#line 3116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = dimensions_approx_equals (&scaled_image, &_tmp22_, PHOTO_SCALING_FUDGE);
#line 3116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp23_, "scaled_image.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 3118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = pixbuf;
#line 3118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23464 "Photo.c"
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 3123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = rotate;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_get_untransformed_pixbuf (self, &_tmp1_, _tmp2_, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23494 "Photo.c"
	}
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23506 "Photo.c"
}


GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 3128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = rotate;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_get_untransformed_pixbuf (self, &_tmp1_, _tmp2_, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error_);
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23536 "Photo.c"
	}
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23548 "Photo.c"
}


static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp6_ = {0};
	BackingFetchMode _tmp7_ = 0;
	GdkPixbuf* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 23567 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23574 "Photo.c"
		{
			Scaling _tmp1_ = {0};
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			Orientation _tmp4_ = 0;
#line 3148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaled_image = _tmp2_;
#line 3148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = photo_get_original_orientation (self);
#line 3150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			original_orientation = _tmp4_;
#line 23592 "Photo.c"
		}
		__finally238:
		{
			PhotoRow* _tmp5_ = NULL;
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23601 "Photo.c"
		}
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 23609 "Photo.c"
		}
	}
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = *scaling;
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = fetch_mode;
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo_load_raw_pixbuf (self, &_tmp6_, PHOTO_EXCEPTION_NONE, _tmp7_, &_inner_error_);
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	pixbuf = _tmp8_;
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23626 "Photo.c"
	}
#line 3160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = rotate;
#line 3160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp9_) {
#line 23632 "Photo.c"
		GdkPixbuf* _tmp10_ = NULL;
		GdkPixbuf* _tmp11_ = NULL;
#line 3161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = pixbuf;
#line 3161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = orientation_rotate_pixbuf (original_orientation, _tmp10_);
#line 3161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp11_;
#line 23643 "Photo.c"
	}
#line 3170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = pixbuf;
#line 3170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23649 "Photo.c"
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 3173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (Photo*) base;
#line 3173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23677 "Photo.c"
	}
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 23689 "Photo.c"
}


/**
     * @brief Populates the cached version of the unmodified image.
     */
void photo_populate_prefetched (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 23700 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23707 "Photo.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
#line 3183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23714 "Photo.c"
				GdkPixbuf* _tmp2_ = NULL;
				Scaling _tmp3_ = {0};
				GdkPixbuf* _tmp4_ = NULL;
				GdkPixbuf* _tmp5_ = NULL;
				GTimer* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				scaling_for_original (&_tmp3_);
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = photo_load_raw_pixbuf (self, &_tmp3_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp2_ = _tmp4_;
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 23730 "Photo.c"
					goto __finally239;
				}
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp2_;
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp2_ = NULL;
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->unmodified_precached = _tmp5_;
#line 3185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = g_timer_new ();
#line 3185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->secs_since_access = _tmp6_;
#line 3186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), NULL);
#line 3187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_debug ("Photo.vala:3187: spawning new precache timeout for %s", _tmp8_);
#line 3187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp2_);
#line 23759 "Photo.c"
			}
		}
		__finally239:
		{
			GdkPixbuf* _tmp9_ = NULL;
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23769 "Photo.c"
		}
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 23777 "Photo.c"
		}
	}
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf* photo_get_prefetched_copy (Photo* self) {
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 3197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23793 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23800 "Photo.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
			GdkPixbuf* _tmp6_ = NULL;
			GdkPixbuf* _tmp7_ = NULL;
#line 3199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23809 "Photo.c"
				{
#line 3201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 3201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 23815 "Photo.c"
						goto __catch241_g_error;
					}
				}
				goto __finally241;
				__catch241_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_ = NULL;
					gchar* _tmp3_ = NULL;
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					e = _inner_error_;
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 3203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp2_ = data_object_to_string ((DataObject*) self);
#line 3203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_warning ("Photo.vala:3203: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					result = NULL;
#line 3204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_error_free0 (e);
#line 23841 "Photo.c"
					{
						GdkPixbuf* _tmp4_ = NULL;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23848 "Photo.c"
					}
#line 3204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return result;
#line 23852 "Photo.c"
				}
				__finally241:
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 23857 "Photo.c"
					{
						GdkPixbuf* _tmp5_ = NULL;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23864 "Photo.c"
					}
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return NULL;
#line 23872 "Photo.c"
				}
			}
#line 3208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp7_;
#line 23881 "Photo.c"
			{
				GdkPixbuf* _tmp8_ = NULL;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23888 "Photo.c"
			}
#line 3208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 23892 "Photo.c"
		}
		__finally240:
		{
			GdkPixbuf* _tmp9_ = NULL;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23901 "Photo.c"
		}
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 23909 "Photo.c"
	}
}


/**
     * @brief Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean photo_discard_prefetched (Photo* self, gboolean immed) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23924 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23931 "Photo.c"
		{
			GTimer* _tmp1_ = NULL;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_ = NULL;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_ = 0.0;
#line 3219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3219 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = FALSE;
#line 23945 "Photo.c"
				{
					GdkPixbuf* _tmp2_ = NULL;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23952 "Photo.c"
				}
#line 3220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 23956 "Photo.c"
			}
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = TRUE;
#line 23968 "Photo.c"
			} else {
				gboolean _tmp7_ = FALSE;
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = immed;
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = _tmp7_;
#line 23975 "Photo.c"
			}
#line 3223 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_) {
#line 23979 "Photo.c"
				gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
#line 3224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = data_object_to_string ((DataObject*) self);
#line 3224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 3224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp9_);
#line 3224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp9_);
#line 3227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = FALSE;
#line 24000 "Photo.c"
				{
					GdkPixbuf* _tmp10_ = NULL;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = self->priv->unmodified_precached;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24007 "Photo.c"
				}
#line 3229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 24011 "Photo.c"
			}
#line 3232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = TRUE;
#line 24015 "Photo.c"
			{
				GdkPixbuf* _tmp11_ = NULL;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->priv->unmodified_precached;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24022 "Photo.c"
			}
#line 3232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 24026 "Photo.c"
		}
		__finally242:
		{
			GdkPixbuf* _tmp12_ = NULL;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = self->priv->unmodified_precached;
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24035 "Photo.c"
		}
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 24043 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1 = 0;
	gint _redeye_instances_size_ = 0;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp33_ = NULL;
	GTimer* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	GdkPixbuf* _tmp37_ = NULL;
	PhotoException _tmp38_ = 0;
	gboolean _tmp39_ = FALSE;
	PhotoException _tmp44_ = 0;
	gboolean _tmp45_ = FALSE;
	PhotoException _tmp50_ = 0;
	gboolean _tmp51_ = FALSE;
	PhotoException _tmp89_ = 0;
	gboolean _tmp90_ = FALSE;
	gboolean _tmp93_ = FALSE;
	PhotoException _tmp100_ = 0;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp105_ = FALSE;
	gboolean _tmp106_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp4_) {
#line 24109 "Photo.c"
		PhotoFileFormat _tmp5_ = 0;
#line 3261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_get_master_file_format (self);
#line 3261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp5_ == PHOTO_FILE_FORMAT_RAW;
#line 24115 "Photo.c"
	} else {
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = FALSE;
#line 24119 "Photo.c"
	}
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 24123 "Photo.c"
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		BackingFetchMode _tmp8_ = 0;
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = fetch_mode;
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp8_ == BACKING_FETCH_MODE_BASELINE) {
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = TRUE;
#line 24133 "Photo.c"
		} else {
			BackingFetchMode _tmp9_ = 0;
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = fetch_mode;
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _tmp9_ == BACKING_FETCH_MODE_UNMODIFIED;
#line 24140 "Photo.c"
		}
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp7_) {
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 24146 "Photo.c"
		} else {
			BackingFetchMode _tmp10_ = 0;
#line 3263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = fetch_mode;
#line 3263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tmp10_ == BACKING_FETCH_MODE_SOURCE;
#line 24153 "Photo.c"
		}
#line 3262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 24157 "Photo.c"
	} else {
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 24161 "Photo.c"
	}
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 24165 "Photo.c"
		RawDeveloper _tmp11_ = 0;
		gboolean _tmp12_ = FALSE;
#line 3264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = photo_get_raw_developer (self);
#line 3264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = photo_is_raw_developer_complete (self, _tmp11_);
#line 3264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = !_tmp12_;
#line 24174 "Photo.c"
	} else {
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 24178 "Photo.c"
	}
#line 3260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_) {
#line 24182 "Photo.c"
		RawDeveloper _tmp13_ = 0;
#line 3265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = photo_get_raw_developer (self);
#line 3265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_set_raw_developer (self, _tmp13_);
#line 24188 "Photo.c"
	}
#line 3270 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	redeye_instances = NULL;
#line 3272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3272 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	transformer = NULL;
#line 24202 "Photo.c"
	{
		PhotoRow* _tmp14_ = NULL;
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = self->row;
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24209 "Photo.c"
		{
			Dimensions _tmp15_ = {0};
			PhotoException _tmp16_ = 0;
			Dimensions _tmp17_ = {0};
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			gboolean _tmp22_ = FALSE;
			gint _tmp23_ = 0;
			EditingToolsRedeyeInstance* _tmp24_ = NULL;
			Box _tmp25_ = {0};
			gboolean _tmp26_ = FALSE;
			gdouble _tmp27_ = 0.0;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_ = FALSE;
			Orientation _tmp31_ = 0;
#line 3279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ALL, &_tmp15_);
#line 3279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			original = _tmp15_;
#line 3280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = exceptions;
#line 3280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, _tmp16_, &_tmp17_);
#line 3280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp17_, &_tmp18_);
#line 3280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaled = _tmp18_;
#line 3281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = scaled;
#line 3281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaled_to_viewport = _tmp19_;
#line 3283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp20_);
#line 3283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = scaled;
#line 3283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = dimensions_equals (&_tmp20_, &_tmp21_);
#line 3283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			is_scaled = !_tmp22_;
#line 3285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = photo_get_raw_redeye_instances (self, &_tmp23_);
#line 3285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			redeye_instances = _tmp24_;
#line 3285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			redeye_instances_length1 = _tmp23_;
#line 3285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = photo_get_raw_crop (self, &_tmp25_);
#line 3287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			crop = _tmp25_;
#line 3287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			is_cropped = _tmp26_;
#line 3289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = photo_get_raw_straighten (self, &_tmp27_);
#line 3289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			straightening_angle = _tmp27_;
#line 3289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			is_straightened = _tmp28_;
#line 3291 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = photo_has_color_adjustments (self);
#line 3291 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp29_) {
#line 24277 "Photo.c"
				PixelTransformer* _tmp30_ = NULL;
#line 3292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = photo_get_pixel_transformer (self);
#line 3292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				transformer = _tmp30_;
#line 24285 "Photo.c"
			}
#line 3294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp31_ = photo_get_orientation (self);
#line 3294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			orientation = _tmp31_;
#line 24291 "Photo.c"
		}
		__finally243:
		{
			PhotoRow* _tmp32_ = NULL;
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp32_ = self->row;
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24300 "Photo.c"
		}
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 24312 "Photo.c"
		}
	}
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error_);
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 24327 "Photo.c"
	}
#line 3302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = photo_get_prefetched_copy (self);
#line 3302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	pixbuf = _tmp33_;
#line 3305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = self->priv->secs_since_access;
#line 3305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_timer_start (_tmp34_);
#line 3306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = data_object_to_string ((DataObject*) self);
#line 3306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 3306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3306: pipeline being run against %s, timer restarted.", _tmp36_);
#line 3306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp36_);
#line 3308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = pixbuf;
#line 3308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp37_ != NULL, "pixbuf != null");
#line 3315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = exceptions;
#line 3315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = photo_exception_allows (_tmp38_, PHOTO_EXCEPTION_REDEYE);
#line 3315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp39_) {
#line 24355 "Photo.c"
		EditingToolsRedeyeInstance* _tmp40_ = NULL;
		gint _tmp40__length1 = 0;
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = redeye_instances;
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40__length1 = redeye_instances_length1;
#line 24362 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			instance_collection = _tmp40_;
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			instance_collection_length1 = _tmp40__length1;
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp40__length1; instance_it = instance_it + 1) {
#line 24374 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 24378 "Photo.c"
				{
					GdkPixbuf* _tmp41_ = NULL;
					EditingToolsRedeyeInstance _tmp42_ = {0};
					GdkPixbuf* _tmp43_ = NULL;
#line 3321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp41_ = pixbuf;
#line 3321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp42_ = instance;
#line 3321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp43_ = photo_do_redeye (self, _tmp41_, &_tmp42_);
#line 3321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					pixbuf = _tmp43_;
#line 24393 "Photo.c"
				}
			}
		}
	}
#line 3329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = exceptions;
#line 3329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = photo_exception_allows (_tmp44_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 3329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp45_) {
#line 24404 "Photo.c"
		gboolean _tmp46_ = FALSE;
#line 3333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = is_straightened;
#line 3333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp46_) {
#line 24410 "Photo.c"
			GdkPixbuf* _tmp47_ = NULL;
			gdouble _tmp48_ = 0.0;
			GdkPixbuf* _tmp49_ = NULL;
#line 3334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp47_ = pixbuf;
#line 3334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp48_ = straightening_angle;
#line 3334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp49_ = rotate_arb (_tmp47_, _tmp48_);
#line 3334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			pixbuf = _tmp49_;
#line 24424 "Photo.c"
		}
	}
#line 3343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = exceptions;
#line 3343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = photo_exception_allows (_tmp50_, PHOTO_EXCEPTION_CROP);
#line 3343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp51_) {
#line 24433 "Photo.c"
		gboolean _tmp52_ = FALSE;
#line 3347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = is_cropped;
#line 3347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp52_) {
#line 24439 "Photo.c"
			Box _tmp53_ = {0};
			gint _tmp54_ = 0;
			GdkPixbuf* _tmp55_ = NULL;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			gint _tmp58_ = 0;
			Box _tmp59_ = {0};
			gint _tmp60_ = 0;
			GdkPixbuf* _tmp61_ = NULL;
			gint _tmp62_ = 0;
			gint _tmp63_ = 0;
			gint _tmp64_ = 0;
			Box _tmp65_ = {0};
			gint _tmp66_ = 0;
			Box _tmp67_ = {0};
			gint _tmp68_ = 0;
			GdkPixbuf* _tmp69_ = NULL;
			gint _tmp70_ = 0;
			gint _tmp71_ = 0;
			gint _tmp72_ = 0;
			Box _tmp73_ = {0};
			gint _tmp74_ = 0;
			Box _tmp75_ = {0};
			gint _tmp76_ = 0;
			GdkPixbuf* _tmp77_ = NULL;
			gint _tmp78_ = 0;
			gint _tmp79_ = 0;
			gint _tmp80_ = 0;
			GdkPixbuf* _tmp81_ = NULL;
			Box _tmp82_ = {0};
			gint _tmp83_ = 0;
			Box _tmp84_ = {0};
			gint _tmp85_ = 0;
			gint _tmp86_ = 0;
			gint _tmp87_ = 0;
			GdkPixbuf* _tmp88_ = NULL;
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp53_ = crop;
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp54_ = _tmp53_.left;
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp55_ = pixbuf;
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp56_ = gdk_pixbuf_get_width (_tmp55_);
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp57_ = _tmp56_;
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp58_ = CLAMP (_tmp54_, 0, _tmp57_ - 2);
#line 3352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			crop.left = _tmp58_;
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp59_ = crop;
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp60_ = _tmp59_.top;
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp61_ = pixbuf;
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp62_ = gdk_pixbuf_get_height (_tmp61_);
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp63_ = _tmp62_;
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp64_ = CLAMP (_tmp60_, 0, _tmp63_ - 2);
#line 3353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			crop.top = _tmp64_;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp65_ = crop;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp66_ = _tmp65_.right;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp67_ = crop;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp68_ = _tmp67_.left;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp69_ = pixbuf;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp70_ = gdk_pixbuf_get_width (_tmp69_);
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp71_ = _tmp70_;
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp72_ = CLAMP (_tmp66_, _tmp68_ + 1, _tmp71_ - 1);
#line 3355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			crop.right = _tmp72_;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp73_ = crop;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp74_ = _tmp73_.bottom;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp75_ = crop;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp76_ = _tmp75_.top;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp77_ = pixbuf;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp78_ = gdk_pixbuf_get_height (_tmp77_);
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp79_ = _tmp78_;
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp80_ = CLAMP (_tmp74_, _tmp76_ + 1, _tmp79_ - 1);
#line 3356 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			crop.bottom = _tmp80_;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp81_ = pixbuf;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp82_ = crop;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp83_ = _tmp82_.left;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp84_ = crop;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp85_ = _tmp84_.top;
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp86_ = box_get_width (&crop);
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp87_ = box_get_height (&crop);
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp88_ = gdk_pixbuf_new_subpixbuf (_tmp81_, _tmp83_, _tmp85_, _tmp86_, _tmp87_);
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			pixbuf = _tmp88_;
#line 24560 "Photo.c"
		}
	}
#line 3368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp89_ = exceptions;
#line 3368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp90_ = photo_exception_allows (_tmp89_, PHOTO_EXCEPTION_ORIENTATION);
#line 3368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp90_) {
#line 24569 "Photo.c"
		GdkPixbuf* _tmp91_ = NULL;
		GdkPixbuf* _tmp92_ = NULL;
#line 3372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp91_ = pixbuf;
#line 3372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp92_ = orientation_rotate_pixbuf (orientation, _tmp91_);
#line 3372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp92_;
#line 24580 "Photo.c"
	}
#line 3385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp93_ = is_scaled;
#line 3385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp93_) {
#line 24586 "Photo.c"
		GdkPixbuf* _tmp94_ = NULL;
		Dimensions _tmp95_ = {0};
		gint _tmp96_ = 0;
		Dimensions _tmp97_ = {0};
		gint _tmp98_ = 0;
		GdkPixbuf* _tmp99_ = NULL;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp94_ = pixbuf;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp95_ = scaled_to_viewport;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp96_ = _tmp95_.width;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp97_ = scaled_to_viewport;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp98_ = _tmp97_.height;
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp99_ = gdk_pixbuf_scale_simple (_tmp94_, _tmp96_, _tmp98_, GDK_INTERP_BILINEAR);
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3386 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp99_;
#line 24609 "Photo.c"
	}
#line 3391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp100_ = exceptions;
#line 3391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp101_ = photo_exception_allows (_tmp100_, PHOTO_EXCEPTION_ADJUST);
#line 3391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp101_) {
#line 24617 "Photo.c"
		PixelTransformer* _tmp102_ = NULL;
#line 3395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp102_ = transformer;
#line 3395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp102_ != NULL) {
#line 24623 "Photo.c"
			PixelTransformer* _tmp103_ = NULL;
			GdkPixbuf* _tmp104_ = NULL;
#line 3396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp103_ = transformer;
#line 3396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp104_ = pixbuf;
#line 3396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp103_, _tmp104_, NULL);
#line 24632 "Photo.c"
		}
	}
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp106_ = is_scaled;
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp106_) {
#line 24639 "Photo.c"
		gboolean _tmp107_ = FALSE;
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp107_ = is_straightened;
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp105_ = !_tmp107_;
#line 24645 "Photo.c"
	} else {
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp105_ = FALSE;
#line 24649 "Photo.c"
	}
#line 3405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp105_) {
#line 24653 "Photo.c"
		GdkPixbuf* _tmp108_ = NULL;
		Dimensions _tmp109_ = {0};
		gboolean _tmp110_ = FALSE;
#line 3406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp108_ = pixbuf;
#line 3406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp108_, &_tmp109_);
#line 3406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp110_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp109_, PHOTO_SCALING_FUDGE);
#line 3406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_assert (_tmp110_, "scaled_to_viewport.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 24665 "Photo.c"
	}
#line 3408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = pixbuf;
#line 3408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3408 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 24675 "Photo.c"
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
#line 3416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return FALSE;
#line 24684 "Photo.c"
}


gboolean photo_has_user_generated_metadata (Photo* self) {
#line 3416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3416 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 24693 "Photo.c"
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 24702 "Photo.c"
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 24711 "Photo.c"
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	PhotoFileFormat* _tmp0_ = NULL;
#line 3427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 3428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 24724 "Photo.c"
		PhotoFileFormat* _tmp1_ = NULL;
		PhotoFileFormatProperties* _tmp2_ = NULL;
		PhotoFileFormatProperties* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = file_format;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = photo_file_format_get_properties (*_tmp1_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = media_source_get_master_file ((MediaSource*) self);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = photo_file_format_properties_convert_file_extension (_tmp3_, _tmp5_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = g_file_get_basename (_tmp7_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp3_);
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp9_;
#line 3429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 24762 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
#line 3431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = photo_get_file_format (self);
#line 3431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = photo_file_format_can_write (_tmp10_);
#line 3431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp11_) {
#line 24772 "Photo.c"
			PhotoFileFormat _tmp12_ = 0;
			PhotoFileFormatProperties* _tmp13_ = NULL;
			PhotoFileFormatProperties* _tmp14_ = NULL;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_ = NULL;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = photo_get_file_format (self);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = photo_file_format_get_properties (_tmp12_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = media_source_get_master_file ((MediaSource*) self);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = photo_file_format_properties_convert_file_extension (_tmp14_, _tmp16_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = g_file_get_basename (_tmp18_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp18_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp16_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp14_);
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp20_;
#line 3432 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 24810 "Photo.c"
		} else {
			PhotoFileFormat _tmp21_ = 0;
			PhotoFileFormatProperties* _tmp22_ = NULL;
			PhotoFileFormatProperties* _tmp23_ = NULL;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_ = NULL;
			GFile* _tmp26_ = NULL;
			GFile* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_ = NULL;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = photo_file_format_get_system_default_format ();
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = photo_file_format_get_properties (_tmp21_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = media_source_get_master_file ((MediaSource*) self);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = _tmp24_;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = photo_file_format_properties_convert_file_extension (_tmp23_, _tmp25_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = g_file_get_basename (_tmp27_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp27_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp25_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp23_);
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			result = _tmp29_;
#line 3435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return result;
#line 24849 "Photo.c"
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp29_ = NULL;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp30_ = NULL;
	PhotoFileFormat _tmp31_ = 0;
	PhotoFileFormatProperties* _tmp32_ = NULL;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp33_ = NULL;
	GFile* _tmp34_ = NULL;
	GFile* _tmp35_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp36_ = NULL;
	PhotoFileFormat _tmp37_ = 0;
	GFile* _tmp38_ = NULL;
	gchar* _tmp39_ = NULL;
	gchar* _tmp40_ = NULL;
	PhotoFileMetadataWriter* _tmp41_ = NULL;
	PhotoFileMetadataWriter* _tmp42_ = NULL;
	gchar* _tmp43_ = NULL;
	gchar* _tmp44_ = NULL;
	PhotoFileMetadataWriter* _tmp45_ = NULL;
	gchar* _tmp46_ = NULL;
	gchar* _tmp47_ = NULL;
	PhotoFileReader* _tmp48_ = NULL;
	GFile* _tmp49_ = NULL;
	GFile* _tmp50_ = NULL;
	GFile* _tmp51_ = NULL;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp65_ = NULL;
	PhotoMetadata* _tmp66_ = NULL;
	PhotoMetadata* _tmp67_ = NULL;
	PhotoFileMetadataWriter* _tmp71_ = NULL;
	gchar* _tmp72_ = NULL;
	gchar* _tmp73_ = NULL;
	time_t _tmp74_ = 0;
	gboolean _tmp80_ = FALSE;
	PhotoFileMetadataWriter* _tmp98_ = NULL;
	PhotoMetadata* _tmp99_ = NULL;
	GError * _inner_error_ = NULL;
#line 3441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	export_reader = NULL;
#line 3445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_master = TRUE;
#line 24911 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 24918 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 24929 "Photo.c"
				PhotoBackingReaders* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
				PhotoFileFormat _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp5_);
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = photo_file_format_can_write_metadata (_tmp6_);
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 24944 "Photo.c"
			} else {
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 24948 "Photo.c"
			}
#line 3447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp1_) {
#line 24952 "Photo.c"
				PhotoBackingReaders* _tmp8_ = NULL;
				PhotoFileReader* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
#line 3448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = self->priv->readers;
#line 3448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tmp8_->editable;
#line 3448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _photo_file_adapter_ref0 (_tmp9_);
#line 3448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				export_reader = _tmp10_;
#line 3449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				is_master = FALSE;
#line 24968 "Photo.c"
			} else {
				gboolean _tmp11_ = FALSE;
				PhotoBackingReaders* _tmp12_ = NULL;
				PhotoFileReader* _tmp13_ = NULL;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = self->priv->readers;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tmp12_->developer;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp13_ != NULL) {
#line 24979 "Photo.c"
					PhotoBackingReaders* _tmp14_ = NULL;
					PhotoFileReader* _tmp15_ = NULL;
					PhotoFileFormat _tmp16_ = 0;
					gboolean _tmp17_ = FALSE;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp15_);
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = photo_file_format_can_write_metadata (_tmp16_);
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = _tmp17_;
#line 24994 "Photo.c"
				} else {
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = FALSE;
#line 24998 "Photo.c"
				}
#line 3450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp11_) {
#line 25002 "Photo.c"
					PhotoBackingReaders* _tmp18_ = NULL;
					PhotoFileReader* _tmp19_ = NULL;
					PhotoFileReader* _tmp20_ = NULL;
#line 3451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = self->priv->readers;
#line 3451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = _tmp18_->developer;
#line 3451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp20_ = _photo_file_adapter_ref0 (_tmp19_);
#line 3451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					export_reader = _tmp20_;
#line 3452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					is_master = FALSE;
#line 25018 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp21_ = NULL;
					PhotoFileReader* _tmp22_ = NULL;
					PhotoFileFormat _tmp23_ = 0;
					gboolean _tmp24_ = FALSE;
#line 3453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp21_ = self->priv->readers;
#line 3453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp22_ = _tmp21_->master;
#line 3453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp23_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp22_);
#line 3453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp24_ = photo_file_format_can_write_metadata (_tmp23_);
#line 3453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp24_) {
#line 25034 "Photo.c"
						PhotoBackingReaders* _tmp25_ = NULL;
						PhotoFileReader* _tmp26_ = NULL;
						PhotoFileReader* _tmp27_ = NULL;
#line 3454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp25_ = self->priv->readers;
#line 3454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp26_ = _tmp25_->master;
#line 3454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp27_ = _photo_file_adapter_ref0 (_tmp26_);
#line 3454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						export_reader = _tmp27_;
#line 25048 "Photo.c"
					}
				}
			}
		}
		__finally244:
		{
			PhotoBackingReaders* _tmp28_ = NULL;
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = self->priv->readers;
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25060 "Photo.c"
		}
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 25070 "Photo.c"
		}
	}
#line 3458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = export_reader;
#line 3458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp29_ == NULL) {
#line 3459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 3459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3459 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 25083 "Photo.c"
	}
#line 3461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = export_reader;
#line 3461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp30_);
#line 3461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = photo_file_format_get_properties (_tmp31_);
#line 3461 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	format_properties = _tmp32_;
#line 3464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = format_properties;
#line 3464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = file;
#line 3464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = photo_file_format_properties_convert_file_extension (_tmp33_, _tmp34_);
#line 3464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dest_file = _tmp35_;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = export_reader;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp36_);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = dest_file;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = g_file_get_path (_tmp38_);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = photo_file_format_create_metadata_writer (_tmp37_, _tmp40_, &_inner_error_);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = _tmp41_;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	writer = _tmp42_;
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 25131 "Photo.c"
	}
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = data_object_to_string ((DataObject*) self);
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = writer;
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp45_);
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = _tmp46_;
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3470: Exporting full-sized copy of %s to %s", _tmp44_, _tmp47_);
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp47_);
#line 3470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp44_);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp48_ = export_reader;
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp49_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp48_);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = _tmp49_;
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = dest_file;
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_copy (_tmp50_, _tmp51_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp50_);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 25175 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp57_ = photo_has_alterations (self);
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp57_) {
#line 25181 "Photo.c"
		gboolean _tmp58_ = FALSE;
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = is_master;
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp56_ = _tmp58_;
#line 25187 "Photo.c"
	} else {
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp56_ = FALSE;
#line 25191 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp56_) {
#line 25195 "Photo.c"
		gboolean _tmp59_ = FALSE;
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp59_ = photo_has_user_generated_metadata (self);
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp55_ = !_tmp59_;
#line 25201 "Photo.c"
	} else {
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp55_ = FALSE;
#line 25205 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp55_) {
#line 25209 "Photo.c"
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_ = NULL;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp60_ = media_source_get_title ((MediaSource*) self);
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp54_ = _tmp61_ == NULL;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp61_);
#line 25220 "Photo.c"
	} else {
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp54_ = FALSE;
#line 25224 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp54_) {
#line 25228 "Photo.c"
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_ = NULL;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp62_ = media_source_get_comment ((MediaSource*) self);
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp63_ = _tmp62_;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = _tmp63_ == NULL;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp63_);
#line 25239 "Photo.c"
	} else {
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = FALSE;
#line 25243 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp53_) {
#line 25247 "Photo.c"
		gboolean _tmp64_ = FALSE;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp64_ = export_metadata;
#line 3478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = _tmp64_;
#line 25253 "Photo.c"
	} else {
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = FALSE;
#line 25257 "Photo.c"
	}
#line 3477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp52_) {
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = TRUE;
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 25273 "Photo.c"
	}
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp65_ = export_reader;
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp66_ = photo_file_reader_read_metadata (_tmp65_, &_inner_error_);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp66_;
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 25295 "Photo.c"
	}
#line 3483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp67_ = metadata;
#line 3483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp67_ == NULL) {
#line 25301 "Photo.c"
		PhotoFileReader* _tmp68_ = NULL;
		PhotoFileFormat _tmp69_ = 0;
		PhotoMetadata* _tmp70_ = NULL;
#line 3484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp68_ = export_reader;
#line 3484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp69_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp68_);
#line 3484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp70_ = photo_file_format_create_metadata (_tmp69_);
#line 3484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		metadata = _tmp70_;
#line 25315 "Photo.c"
	}
#line 3486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp71_ = writer;
#line 3486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp72_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp71_);
#line 3486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp73_ = _tmp72_;
#line 3486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3486: Updating metadata of %s", _tmp73_);
#line 3486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp73_);
#line 3488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp74_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp74_ != ((time_t) 0)) {
#line 25331 "Photo.c"
		PhotoMetadata* _tmp75_ = NULL;
		time_t _tmp76_ = 0;
		MetadataDateTime* _tmp77_ = NULL;
		MetadataDateTime* _tmp78_ = NULL;
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp75_ = metadata;
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp76_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp77_ = metadata_date_time_new (_tmp76_);
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp78_ = _tmp77_;
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp75_, _tmp78_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp78_);
#line 25348 "Photo.c"
	} else {
		PhotoMetadata* _tmp79_ = NULL;
#line 3491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp79_ = metadata;
#line 3491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp79_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25355 "Photo.c"
	}
#line 3493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp80_ = export_metadata;
#line 3493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp80_) {
#line 25361 "Photo.c"
		PhotoMetadata* _tmp81_ = NULL;
		gchar* _tmp82_ = NULL;
		gchar* _tmp83_ = NULL;
		PhotoMetadata* _tmp84_ = NULL;
		gchar* _tmp85_ = NULL;
		gchar* _tmp86_ = NULL;
		PhotoMetadata* _tmp87_ = NULL;
		Dimensions _tmp88_ = {0};
		PhotoMetadata* _tmp89_ = NULL;
		Orientation _tmp90_ = 0;
		PhotoMetadata* _tmp91_ = NULL;
		const gchar* _tmp92_ = NULL;
		Orientation _tmp93_ = 0;
		Orientation _tmp94_ = 0;
		PhotoMetadata* _tmp96_ = NULL;
#line 3495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp81_ = metadata;
#line 3495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp82_ = media_source_get_title ((MediaSource*) self);
#line 3495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = _tmp82_;
#line 3495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_title (_tmp81_, _tmp83_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp83_);
#line 3496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp84_ = metadata;
#line 3496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp85_ = media_source_get_comment ((MediaSource*) self);
#line 3496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp86_ = _tmp85_;
#line 3496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp84_, _tmp86_);
#line 3496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp86_);
#line 3497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp87_ = metadata;
#line 3497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp88_);
#line 3497 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp87_, &_tmp88_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3498 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp89_ = metadata;
#line 3498 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp90_ = photo_get_orientation (self);
#line 3498 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp89_, _tmp90_);
#line 3499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp91_ = metadata;
#line 3499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp92_ = _ (RESOURCES_APP_TITLE);
#line 3499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_software (_tmp91_, _tmp92_, RESOURCES_APP_VERSION);
#line 3501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp93_ = photo_get_orientation (self);
#line 3501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp94_ = photo_get_original_orientation (self);
#line 3501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp93_ != _tmp94_) {
#line 25421 "Photo.c"
			PhotoMetadata* _tmp95_ = NULL;
#line 3502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp95_ = metadata;
#line 3502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp95_);
#line 25427 "Photo.c"
		}
#line 3504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp96_ = metadata;
#line 3504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp96_);
#line 25433 "Photo.c"
	} else {
		PhotoMetadata* _tmp97_ = NULL;
#line 3507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp97_ = metadata;
#line 3507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_clear (_tmp97_);
#line 25440 "Photo.c"
	}
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp98_ = writer;
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp99_ = metadata;
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp98_, _tmp99_, &_inner_error_);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3509 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 25464 "Photo.c"
	}
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 25480 "Photo.c"
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 3517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = scaling_is_unscaled (scaling);
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp3_) {
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = TRUE;
#line 25500 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = photo_has_alterations (self);
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 25507 "Photo.c"
	}
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = TRUE;
#line 25513 "Photo.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = photo_has_user_generated_metadata (self);
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 25520 "Photo.c"
	}
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 25526 "Photo.c"
	} else {
		PhotoFileFormat _tmp6_ = 0;
		PhotoFileFormat _tmp7_ = 0;
#line 3519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = export_format;
#line 3519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = photo_get_file_format (self);
#line 3519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp6_ != _tmp7_;
#line 25536 "Photo.c"
	}
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 3518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 25542 "Photo.c"
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp18_ = NULL;
	PhotoMetadata* _tmp19_ = NULL;
	PhotoFileFormat _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
	PhotoFileWriter* writer = NULL;
	PhotoFileFormat _tmp25_ = 0;
	GFile* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	PhotoFileWriter* _tmp29_ = NULL;
	PhotoFileWriter* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	PhotoFileWriter* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	PhotoFileFormat _tmp36_ = 0;
	GEnumValue* _tmp37_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp38_ = FALSE;
	PhotoFileFormat _tmp39_ = 0;
	PhotoFileWriter* _tmp49_ = NULL;
	GdkPixbuf* _tmp50_ = NULL;
	JpegQuality _tmp51_ = 0;
	PhotoFileWriter* _tmp52_ = NULL;
	gchar* _tmp53_ = NULL;
	gchar* _tmp54_ = NULL;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp76_ = FALSE;
	PhotoFileFormat _tmp77_ = 0;
	PhotoFileMetadataWriter* _tmp87_ = NULL;
	PhotoFileFormat _tmp88_ = 0;
	GFile* _tmp89_ = NULL;
	gchar* _tmp90_ = NULL;
	gchar* _tmp91_ = NULL;
	PhotoFileMetadataWriter* _tmp92_ = NULL;
	PhotoFileMetadataWriter* _tmp93_ = NULL;
	PhotoFileMetadataWriter* _tmp94_ = NULL;
	PhotoFileMetadataWriter* _tmp95_ = NULL;
	PhotoMetadata* _tmp96_ = NULL;
	GError * _inner_error_ = NULL;
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (dest_file != NULL);
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = direct_copy_unmodified;
#line 3527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_) {
#line 25604 "Photo.c"
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = media_source_get_master_file ((MediaSource*) self);
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = dest_file;
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_file_copy (_tmp2_, _tmp3_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 25624 "Photo.c"
		}
#line 3530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 25628 "Photo.c"
	}
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = scaling_is_unscaled (scaling);
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_) {
#line 25634 "Photo.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = photo_has_alterations (self);
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (!_tmp9_) {
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = TRUE;
#line 25643 "Photo.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = photo_only_metadata_changed (self);
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp10_;
#line 25650 "Photo.c"
		}
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp8_;
#line 25654 "Photo.c"
	} else {
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = FALSE;
#line 25658 "Photo.c"
	}
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 25662 "Photo.c"
		PhotoFileFormat _tmp11_ = 0;
		PhotoFileFormat _tmp12_ = 0;
#line 3538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = export_format;
#line 3538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = photo_get_file_format (self);
#line 3538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp11_ == _tmp12_;
#line 25671 "Photo.c"
	} else {
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = FALSE;
#line 25675 "Photo.c"
	}
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 25679 "Photo.c"
		PhotoFileFormat _tmp13_ = 0;
#line 3538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = photo_get_file_format (self);
#line 3538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp13_ == PHOTO_FILE_FORMAT_JFIF;
#line 25685 "Photo.c"
	} else {
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = FALSE;
#line 25689 "Photo.c"
	}
#line 3537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp4_) {
#line 25693 "Photo.c"
		gboolean _tmp14_ = FALSE;
		GFile* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = dest_file;
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = export_metadata;
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = photo_export_fullsized_backing (self, _tmp15_, _tmp16_, &_inner_error_);
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = _tmp17_;
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 25712 "Photo.c"
		}
#line 3539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp14_) {
#line 3540 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 25718 "Photo.c"
		}
	}
#line 3546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = photo_source_get_metadata ((PhotoSource*) self);
#line 3546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp18_;
#line 3547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = metadata;
#line 3547 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp19_ == NULL) {
#line 25729 "Photo.c"
		PhotoFileFormat _tmp20_ = 0;
		PhotoMetadata* _tmp21_ = NULL;
#line 3548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = export_format;
#line 3548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = photo_file_format_create_metadata (_tmp20_);
#line 3548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		metadata = _tmp21_;
#line 25740 "Photo.c"
	}
#line 3550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = export_format;
#line 3550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = photo_file_format_can_write (_tmp22_);
#line 3550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp23_) {
#line 25748 "Photo.c"
		PhotoFileFormat _tmp24_ = 0;
#line 3551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = photo_file_format_get_system_default_format ();
#line 3551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		export_format = _tmp24_;
#line 25754 "Photo.c"
	}
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = export_format;
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = dest_file;
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = g_file_get_path (_tmp26_);
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = photo_file_format_create_writer (_tmp25_, _tmp28_, &_inner_error_);
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = _tmp29_;
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp28_);
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	writer = _tmp30_;
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 25780 "Photo.c"
	}
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = data_object_to_string ((DataObject*) self);
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = writer;
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp33_);
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = export_format;
#line 3556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), _tmp36_);
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3555: Saving transformed version of %s to %s in file format" \
" %s", _tmp32_, _tmp35_, (_tmp37_ != NULL) ? _tmp37_->value_name : NULL);
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp35_);
#line 3555 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = photo_get_file_format (self);
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp39_ == PHOTO_FILE_FORMAT_JFIF) {
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp38_ = TRUE;
#line 25808 "Photo.c"
	} else {
		PhotoFileFormat _tmp40_ = 0;
#line 3563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = photo_get_file_format (self);
#line 3563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp38_ = _tmp40_ == PHOTO_FILE_FORMAT_RAW;
#line 25815 "Photo.c"
	}
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp38_) {
#line 25819 "Photo.c"
		GdkPixbuf* _tmp41_ = NULL;
		Scaling _tmp42_ = {0};
		GdkPixbuf* _tmp43_ = NULL;
		GdkPixbuf* _tmp44_ = NULL;
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = *scaling;
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = photo_get_pixbuf_with_options (self, &_tmp42_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = _tmp43_;
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 25842 "Photo.c"
		}
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp44_ = _tmp41_;
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = NULL;
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp44_;
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp41_);
#line 25854 "Photo.c"
	} else {
		GdkPixbuf* _tmp45_ = NULL;
		Scaling _tmp46_ = {0};
		GdkPixbuf* _tmp47_ = NULL;
		GdkPixbuf* _tmp48_ = NULL;
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = *scaling;
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = photo_get_pixbuf_with_options (self, &_tmp46_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = _tmp47_;
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 25878 "Photo.c"
		}
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp45_;
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = NULL;
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp48_;
#line 3562 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp45_);
#line 25890 "Photo.c"
	}
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp49_ = writer;
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = pixbuf;
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = quality;
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_writer_write (_tmp49_, _tmp50_, _tmp51_, &_inner_error_);
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 25912 "Photo.c"
	}
#line 3574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp52_ = writer;
#line 3574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp53_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp52_);
#line 3574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp54_ = _tmp53_;
#line 3574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3574: Setting EXIF for %s", _tmp54_);
#line 3574 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp54_);
#line 3577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp55_ = export_metadata;
#line 3577 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp55_) {
#line 25928 "Photo.c"
		PhotoMetadata* _tmp56_ = NULL;
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_ = NULL;
		PhotoMetadata* _tmp59_ = NULL;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_ = NULL;
		PhotoMetadata* _tmp62_ = NULL;
		const gchar* _tmp63_ = NULL;
		time_t _tmp64_ = 0;
		PhotoMetadata* _tmp70_ = NULL;
		PhotoMetadata* _tmp71_ = NULL;
		PhotoMetadata* _tmp72_ = NULL;
		gboolean _tmp73_ = FALSE;
#line 3579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp56_ = metadata;
#line 3579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp57_ = media_source_get_title ((MediaSource*) self);
#line 3579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp58_ = _tmp57_;
#line 3579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_title (_tmp56_, _tmp58_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp58_);
#line 3580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp59_ = metadata;
#line 3580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp60_ = media_source_get_comment ((MediaSource*) self);
#line 3580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 3580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp59_, _tmp61_);
#line 3580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp61_);
#line 3581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp62_ = metadata;
#line 3581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp63_ = _ (RESOURCES_APP_TITLE);
#line 3581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_software (_tmp62_, _tmp63_, RESOURCES_APP_VERSION);
#line 3583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp64_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp64_ != ((time_t) 0)) {
#line 25972 "Photo.c"
			PhotoMetadata* _tmp65_ = NULL;
			time_t _tmp66_ = 0;
			MetadataDateTime* _tmp67_ = NULL;
			MetadataDateTime* _tmp68_ = NULL;
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp65_ = metadata;
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp66_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp67_ = metadata_date_time_new (_tmp66_);
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp68_ = _tmp67_;
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp65_, _tmp68_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp68_);
#line 25989 "Photo.c"
		} else {
			PhotoMetadata* _tmp69_ = NULL;
#line 3586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp69_ = metadata;
#line 3586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp69_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25996 "Photo.c"
		}
#line 3588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp70_ = metadata;
#line 3588 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp70_, "Exif.Iop.RelatedImageWidth");
#line 3589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp71_ = metadata;
#line 3589 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp71_, "Exif.Iop.RelatedImageHeight");
#line 3590 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp72_ = metadata;
#line 3590 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp72_);
#line 3592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp73_ = photo_has_user_generated_metadata (self);
#line 3592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp73_) {
#line 26014 "Photo.c"
			PhotoMetadata* _tmp74_ = NULL;
#line 3593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp74_ = metadata;
#line 3593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp74_);
#line 26020 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp75_ = NULL;
#line 3596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp75_ = metadata;
#line 3596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_clear (_tmp75_);
#line 26028 "Photo.c"
	}
#line 3603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp77_ = photo_get_file_format (self);
#line 3603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp77_ == PHOTO_FILE_FORMAT_JFIF) {
#line 3603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp76_ = TRUE;
#line 26036 "Photo.c"
	} else {
		PhotoFileFormat _tmp78_ = 0;
#line 3604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp78_ = photo_get_file_format (self);
#line 3604 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp76_ = _tmp78_ == PHOTO_FILE_FORMAT_RAW;
#line 26043 "Photo.c"
	}
#line 3603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp76_) {
#line 26047 "Photo.c"
		PhotoMetadata* _tmp79_ = NULL;
		Dimensions _tmp80_ = {0};
		PhotoMetadata* _tmp81_ = NULL;
		Orientation _tmp82_ = 0;
#line 3605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp79_ = metadata;
#line 3605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ORIENTATION, &_tmp80_);
#line 3605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp79_, &_tmp80_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp81_ = metadata;
#line 3606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp82_ = photo_get_orientation (self);
#line 3606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp81_, _tmp82_);
#line 26064 "Photo.c"
	} else {
		PhotoMetadata* _tmp83_ = NULL;
		GdkPixbuf* _tmp84_ = NULL;
		Dimensions _tmp85_ = {0};
		PhotoMetadata* _tmp86_ = NULL;
#line 3609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = metadata;
#line 3609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp84_ = pixbuf;
#line 3609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp84_, &_tmp85_);
#line 3609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp83_, &_tmp85_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp86_ = metadata;
#line 3610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp86_, ORIENTATION_TOP_LEFT);
#line 26082 "Photo.c"
	}
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp88_ = export_format;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp89_ = dest_file;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp90_ = g_file_get_path (_tmp89_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp91_ = _tmp90_;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp92_ = photo_file_format_create_metadata_writer (_tmp88_, _tmp91_, &_inner_error_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp93_ = _tmp92_;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp91_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp87_ = _tmp93_;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 26112 "Photo.c"
	}
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp94_ = _tmp87_;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp87_ = NULL;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp95_ = _tmp94_;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp96_ = metadata;
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp95_, _tmp96_, &_inner_error_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp95_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp87_);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 26140 "Photo.c"
	}
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp87_);
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26150 "Photo.c"
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_ = NULL;
	gchar* editable_basename = NULL;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gboolean collision = FALSE;
	GFile* _tmp26_ = NULL;
	GFile* _tmp27_ = NULL;
	GFile* _tmp28_ = NULL;
	gboolean _tmp29_ = FALSE;
	GFile* _tmp30_ = NULL;
	GFile* _tmp31_ = NULL;
	GFile* _tmp32_ = NULL;
	GError * _inner_error_ = NULL;
#line 3616 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26184 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 26191 "Photo.c"
		{
			PhotoFileFormat _tmp1_ = 0;
			GFile* _tmp2_ = NULL;
#line 3619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = photo_get_file_format (self);
#line 3619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_file_format = _tmp1_;
#line 3620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = media_source_get_file ((MediaSource*) self);
#line 3620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing = _tmp2_;
#line 26205 "Photo.c"
		}
		__finally245:
		{
			PhotoRow* _tmp3_ = NULL;
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 26214 "Photo.c"
		}
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 26224 "Photo.c"
		}
	}
#line 3623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _vala_file_format;
#line 3623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_file_format_can_write (_tmp4_);
#line 3623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp5_) {
#line 26233 "Photo.c"
		PhotoFileFormat _tmp6_ = 0;
#line 3624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = photo_file_format_get_system_default_format ();
#line 3624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_file_format = _tmp6_;
#line 26239 "Photo.c"
	}
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = g_file_get_basename (backing);
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	disassemble_filename (_tmp8_, &_tmp9_, &_tmp10_);
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (name);
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	name = _tmp9_;
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (ext);
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ext = _tmp10_;
#line 3627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = ext;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 26263 "Photo.c"
	} else {
		PhotoFileFormat _tmp13_ = 0;
		PhotoFileFormatProperties* _tmp14_ = NULL;
		PhotoFileFormatProperties* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = _vala_file_format;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = photo_file_format_get_properties (_tmp13_);
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = ext;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_is_recognized_extension (_tmp15_, _tmp16_);
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = !_tmp17_;
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp15_);
#line 26284 "Photo.c"
	}
#line 3629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 26288 "Photo.c"
		PhotoFileFormat _tmp18_ = 0;
		PhotoFileFormatProperties* _tmp19_ = NULL;
		PhotoFileFormatProperties* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = _vala_file_format;
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = photo_file_format_get_properties (_tmp18_);
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = photo_file_format_properties_get_default_extension (_tmp20_);
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (ext);
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		ext = _tmp21_;
#line 3630 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp20_);
#line 26307 "Photo.c"
	}
#line 3632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = name;
#line 3632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = _ ("modified");
#line 3632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = ext;
#line 3632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = g_strdup_printf ("%s_%s.%s", _tmp22_, _tmp23_, _tmp24_);
#line 3632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable_basename = _tmp25_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = g_file_get_parent (backing);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = generate_unique_file (_tmp28_, editable_basename, &_tmp29_, &_inner_error_);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	collision = _tmp29_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp28_);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = _tmp31_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (ext);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (name);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 26347 "Photo.c"
	}
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = _tmp26_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = NULL;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp32_;
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp26_);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (ext);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (name);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (file_format) {
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*file_format = _vala_file_format;
#line 26369 "Photo.c"
	}
#line 3635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 26373 "Photo.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 26380 "Photo.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_list_free (self);
#line 26389 "Photo.c"
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, const gchar* commandline, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GAppInfo* _tmp8_ = NULL;
	gchar** argv = NULL;
	gchar** _tmp13_ = NULL;
	gint argv_length1 = 0;
	gint _argv_size_ = 0;
	gchar** _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	GFile* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	GPid child_pid = 0;
	gboolean _tmp22_ = FALSE;
	gchar** _tmp23_ = NULL;
	gint _tmp23__length1 = 0;
	GPid _tmp24_ = 0;
	gboolean _tmp25_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3638 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (commandline != NULL, FALSE);
#line 3640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = commandline;
#line 3640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 3640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 3641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 3641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 26437 "Photo.c"
	}
	{
		GAppInfo* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GAppInfo* _tmp4_ = NULL;
		GAppInfo* _tmp5_ = NULL;
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = commandline;
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = g_app_info_create_from_commandline (_tmp3_, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26452 "Photo.c"
			goto __catch246_g_error;
		}
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = NULL;
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app = _tmp5_;
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 26465 "Photo.c"
	}
	goto __finally246;
	__catch246_g_error:
	{
		GError* er = NULL;
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		er = _inner_error_;
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3648 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app = NULL;
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (er);
#line 26481 "Photo.c"
	}
	__finally246:
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 26492 "Photo.c"
	}
#line 3651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	files = NULL;
#line 3652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = file;
#line 3652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 3652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	files = g_list_insert (files, _tmp7_, -1);
#line 3654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = app;
#line 3654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 26506 "Photo.c"
		gboolean _tmp9_ = FALSE;
		GAppInfo* _tmp10_ = NULL;
		GList* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = app;
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = files;
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = g_app_info_launch (_tmp10_, _tmp11_, NULL, &_inner_error_);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = _tmp12_;
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (app);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 26529 "Photo.c"
		}
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp9_;
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 26539 "Photo.c"
	}
#line 3657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 3657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	argv = _tmp13_;
#line 3657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	argv_length1 = 2;
#line 3657 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = argv;
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14__length1 = argv_length1;
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = commandline;
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp14_[0]);
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_[0] = _tmp16_;
#line 3658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = _tmp14_[0];
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = argv;
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18__length1 = argv_length1;
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = file;
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = g_file_get_path (_tmp19_);
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp18_[1]);
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_[1] = _tmp20_;
#line 3659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = _tmp18_[1];
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = argv;
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23__length1 = argv_length1;
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = g_spawn_async ("/", _tmp23_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp24_, &_inner_error_);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	child_pid = _tmp24_;
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = _tmp25_;
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 26599 "Photo.c"
	}
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp22_;
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (app);
#line 3663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 26611 "Photo.c"
}


void photo_open_with_raw_external_editor (Photo* self, const gchar* external_editor, GError** error) {
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
#line 3673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = config_facade_get_instance ();
#line 3675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = external_editor;
#line 3675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	configuration_facade_set_external_raw_app ((ConfigurationFacade*) _tmp1_, _tmp2_);
#line 3675 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_get_master_file ((MediaSource*) self);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_get_master_file_format (self);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = external_editor;
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_launch_editor (_tmp4_, _tmp5_, _tmp6_, &_inner_error_);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp4_);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3676 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 26656 "Photo.c"
	}
}


void photo_open_with_external_editor (Photo* self, const gchar* external_editor, GError** error) {
	GFile* modified_file = NULL;
	GFile* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	ConfigFacade* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
#line 3680 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3680 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_modified_file (self, &_inner_error_);
#line 3681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	modified_file = _tmp0_;
#line 3681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 26685 "Photo.c"
	}
#line 3684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = config_facade_get_instance ();
#line 3684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = external_editor;
#line 3684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	configuration_facade_set_external_photo_app ((ConfigurationFacade*) _tmp2_, _tmp3_);
#line 3684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp2_);
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = modified_file;
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_get_file_format (self);
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = external_editor;
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_launch_editor (_tmp4_, _tmp5_, _tmp6_, &_inner_error_);
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (modified_file);
#line 3685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 26713 "Photo.c"
	}
#line 3680 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (modified_file);
#line 26717 "Photo.c"
}


GFile* photo_get_modified_file (Photo* self, GError** error) {
	GFile* result = NULL;
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GFile* _tmp17_ = NULL;
	gboolean _tmp25_ = FALSE;
	GFile* _tmp26_ = NULL;
	GFile* _tmp44_ = NULL;
	GFileMonitor* _tmp45_ = NULL;
	GError * _inner_error_ = NULL;
#line 3688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	current_editable_file = NULL;
#line 3690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	create_editable_file = NULL;
#line 26740 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 26747 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			GFile* _tmp6_ = NULL;
#line 3693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 26758 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
#line 3694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 26772 "Photo.c"
			}
#line 3696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 26778 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error_);
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26791 "Photo.c"
					goto __finally247;
				}
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = NULL;
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3696 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 26804 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_ = NULL;
				PhotoFileReader* _tmp12_ = NULL;
				PhotoFileFormat _tmp13_ = 0;
#line 3699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp12_);
#line 3699 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_file_format = _tmp13_;
#line 26817 "Photo.c"
			}
		}
		__finally247:
		{
			PhotoBackingReaders* _tmp14_ = NULL;
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = self->priv->readers;
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26827 "Photo.c"
		}
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3692 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 26839 "Photo.c"
		}
	}
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = create_editable_file;
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_ == NULL) {
#line 26846 "Photo.c"
		GFile* _tmp18_ = NULL;
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = current_editable_file;
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp18_ != NULL;
#line 26852 "Photo.c"
	} else {
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = FALSE;
#line 26856 "Photo.c"
	}
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp16_) {
#line 26860 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_ = NULL;
		gboolean _tmp21_ = FALSE;
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (!_tmp21_) {
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = TRUE;
#line 26872 "Photo.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = photo_has_transformations (self);
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = _tmp22_;
#line 26879 "Photo.c"
		}
#line 3705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = _tmp19_;
#line 26883 "Photo.c"
	} else {
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = FALSE;
#line 26887 "Photo.c"
	}
#line 3704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp15_) {
#line 26891 "Photo.c"
		GFile* _tmp23_ = NULL;
		GFile* _tmp24_ = NULL;
#line 3706 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = current_editable_file;
#line 3706 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 3706 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3706 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		create_editable_file = _tmp24_;
#line 26902 "Photo.c"
	}
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = create_editable_file;
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp26_ != NULL) {
#line 26908 "Photo.c"
		PhotoFileFormat _tmp27_ = 0;
		gboolean _tmp28_ = FALSE;
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp27_ = editable_file_format;
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp28_ = photo_file_format_can_write (_tmp27_);
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = _tmp28_;
#line 26917 "Photo.c"
	} else {
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = FALSE;
#line 26921 "Photo.c"
	}
#line 3709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp25_) {
#line 26925 "Photo.c"
		PhotoFileFormat _tmp40_ = 0;
		GFile* _tmp41_ = NULL;
		GFile* _tmp42_ = NULL;
		GFile* _tmp43_ = NULL;
#line 3710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 26932 "Photo.c"
		{
			GFile* _tmp29_ = NULL;
			Scaling _tmp30_ = {0};
			PhotoFileFormat _tmp31_ = 0;
#line 3713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = create_editable_file;
#line 3713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			scaling_for_original (&_tmp30_);
#line 3713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp31_ = editable_file_format;
#line 3713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_export (self, _tmp29_, &_tmp30_, JPEG_QUALITY_MAXIMUM, _tmp31_, FALSE, TRUE, &_inner_error_);
#line 3713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26947 "Photo.c"
				goto __catch248_g_error;
			}
		}
		goto __finally248;
		__catch248_g_error:
		{
			GError* err = NULL;
			GError* _tmp38_ = NULL;
			GError* _tmp39_ = NULL;
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 26961 "Photo.c"
			{
				GFile* _tmp32_ = NULL;
#line 3718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = create_editable_file;
#line 3718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_file_delete (_tmp32_, NULL, &_inner_error_);
#line 3718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26970 "Photo.c"
					goto __catch249_g_error;
				}
			}
			goto __finally249;
			__catch249_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp33_ = NULL;
				gchar* _tmp34_ = NULL;
				gchar* _tmp35_ = NULL;
				GError* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				delete_err = _inner_error_;
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = create_editable_file;
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = g_file_get_path (_tmp33_);
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = _tmp34_;
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = delete_err;
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _tmp36_->message;
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_warning ("Photo.vala:3721: Unable to delete editable file %s after export error:" \
" %s", _tmp35_, _tmp37_);
#line 3721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp35_);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27003 "Photo.c"
			}
			__finally249:
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 3717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return NULL;
#line 27022 "Photo.c"
			}
#line 3725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = err;
#line 3725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = _g_error_copy0 (_tmp38_);
#line 3725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = _tmp39_;
#line 3725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 27032 "Photo.c"
			goto __finally248;
		}
		__finally248:
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 27046 "Photo.c"
		}
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp40_ = editable_file_format;
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp41_ = create_editable_file;
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_attach_editable (self, _tmp40_, _tmp41_, &_inner_error_);
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 27064 "Photo.c"
		}
#line 3731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = create_editable_file;
#line 3731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = _g_object_ref0 (_tmp42_);
#line 3731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		current_editable_file = _tmp43_;
#line 27074 "Photo.c"
	}
#line 3734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = current_editable_file;
#line 3734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp44_ != NULL, "current_editable_file != null");
#line 3737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = self->priv->editable_monitor;
#line 3737 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp45_ == NULL) {
#line 27084 "Photo.c"
		GFile* _tmp46_ = NULL;
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = current_editable_file;
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp46_, &_inner_error_);
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return NULL;
#line 27100 "Photo.c"
		}
	}
#line 3740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = current_editable_file;
#line 3740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 27109 "Photo.c"
}


void photo_revert_to_master (Photo* self, gboolean notify) {
	gboolean _tmp0_ = FALSE;
#line 3743 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = notify;
#line 3744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, _tmp0_);
#line 27121 "Photo.c"
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 3754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 27128 "Photo.c"
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFile* _tmp0_ = NULL;
	GFileMonitor* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileMonitor* _tmp3_ = NULL;
	GFileMonitor* _tmp4_ = NULL;
	GFileMonitor* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 3747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 3751 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp0_, "Photo.start_monitoring_editable");
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = g_file_monitor (_tmp2_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp3_;
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27162 "Photo.c"
	}
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = NULL;
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->editable_monitor = _tmp4_;
#line 3754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = self->priv->editable_monitor;
#line 3754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_connect_object (_tmp5_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 27178 "Photo.c"
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFileMonitor* _tmp0_ = NULL;
	GFile* file = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileMonitor* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	GFileMonitor* _tmp6_ = NULL;
#line 3757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3759 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27198 "Photo.c"
	}
#line 3762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp1_;
#line 3763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 3763 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 27208 "Photo.c"
		GFile* _tmp3_ = NULL;
#line 3764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = file;
#line 3764 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 27214 "Photo.c"
	}
#line 3766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3767 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3767 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3757 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 27232 "Photo.c"
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 3771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3776 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_file_format_create_reader (_tmp0_, _tmp3_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp5_, &_inner_error_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp3_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27274 "Photo.c"
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3780 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 3781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3781 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27291 "Photo.c"
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 3785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27308 "Photo.c"
	}
}


static void _vala_array_add114 (gchar*** array, int* length, int* size, gchar* value) {
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27320 "Photo.c"
	}
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27326 "Photo.c"
}


static void _vala_array_add115 (gchar*** array, int* length, int* size, gchar* value) {
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27337 "Photo.c"
	}
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27343 "Photo.c"
}


static void _vala_array_add116 (gchar*** array, int* length, int* size, gchar* value) {
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27354 "Photo.c"
	}
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27360 "Photo.c"
}


static void _vala_array_add117 (gchar*** array, int* length, int* size, gchar* value) {
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27371 "Photo.c"
	}
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27377 "Photo.c"
}


static void _vala_array_add118 (gchar*** array, int* length, int* size, gchar* value) {
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27388 "Photo.c"
	}
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27394 "Photo.c"
}


static void _vala_array_add119 (gchar*** array, int* length, int* size, gchar* value) {
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27405 "Photo.c"
	}
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27411 "Photo.c"
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	PhotoFileReader* _tmp6_ = NULL;
	PhotoFileReader* _tmp7_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp9_ = NULL;
	PhotoFileReader* _tmp10_ = NULL;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp11_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	GFile* _tmp13_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	BackingPhotoRow* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp35_ = FALSE;
	PhotoFileReader* _tmp94_ = NULL;
	gboolean _tmp100_ = FALSE;
	gboolean _tmp101_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp112_ = NULL;
	gint alteration_list_length1 = 0;
	gint _alteration_list_size_ = 0;
	gboolean _tmp113_ = FALSE;
	gboolean _tmp121_ = FALSE;
	gboolean _tmp122_ = FALSE;
	gchar** _tmp131_ = NULL;
	gint _tmp131__length1 = 0;
	GError * _inner_error_ = NULL;
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = only_attributes;
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_) {
#line 27460 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = new_reader;
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 27466 "Photo.c"
	} else {
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 27470 "Photo.c"
	}
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 27476 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = only_attributes;
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = !_tmp4_;
#line 27483 "Photo.c"
	}
#line 3792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes  &&new_reader == null) || (!only_attributes)");
#line 3794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_get_editable_reader (self);
#line 3794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old_reader = _tmp5_;
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = new_reader;
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = _tmp7_;
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 27497 "Photo.c"
		PhotoFileReader* _tmp8_ = NULL;
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = old_reader;
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp8_;
#line 27503 "Photo.c"
	}
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _photo_file_adapter_ref0 (_tmp6_);
#line 3796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reader = _tmp9_;
#line 3797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = reader;
#line 3797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 3798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27521 "Photo.c"
	}
#line 3803 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	filesize_changed = FALSE;
#line 3805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	is_new_editable = FALSE;
#line 3807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp11_);
#line 3807 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable_id = _tmp11_;
#line 3808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = reader;
#line 3808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp12_);
#line 3808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp13_;
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = file;
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = photo_query_backing_photo_row (self, _tmp14_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp15_, &_inner_error_);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	detected = _tmp15_;
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing = _tmp16_;
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 27563 "Photo.c"
	}
#line 3815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = backing_photo_id_is_invalid (&editable_id);
#line 3815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_) {
#line 27569 "Photo.c"
		BackingPhotoRow* _tmp18_ = NULL;
#line 3817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = backing;
#line 3817 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp18_ != NULL) {
#line 27575 "Photo.c"
			BackingPhotoTable* _tmp19_ = NULL;
			BackingPhotoTable* _tmp20_ = NULL;
			BackingPhotoRow* _tmp21_ = NULL;
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = backing_photo_table_get_instance ();
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = backing;
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_photo_table_add (_tmp20_, _tmp21_, &_inner_error_);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 27605 "Photo.c"
			}
			{
				PhotoRow* _tmp22_ = NULL;
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = self->row;
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27613 "Photo.c"
				{
					PhotoTable* _tmp23_ = NULL;
					PhotoTable* _tmp24_ = NULL;
					PhotoRow* _tmp25_ = NULL;
					BackingPhotoRow* _tmp26_ = NULL;
					BackingPhotoID _tmp27_ = {0};
					BackingPhotoRow* _tmp28_ = NULL;
					BackingPhotoRow* _tmp29_ = NULL;
					BackingPhotoRow* _tmp30_ = NULL;
					BackingPhotoRow* _tmp31_ = NULL;
					BackingPhotoRow* _tmp32_ = NULL;
					Orientation _tmp33_ = 0;
#line 3820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3821 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					filesize_changed = TRUE;
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp23_ = photo_table_get_instance ();
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp25_ = self->row;
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp26_ = backing;
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp27_ = _tmp26_->id;
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_table_attach_editable (_tmp24_, _tmp25_, &_tmp27_, &_inner_error_);
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_database_table_unref0 (_tmp24_);
#line 3823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27646 "Photo.c"
						goto __finally250;
					}
#line 3824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp28_ = backing;
#line 3824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp29_ = _backing_photo_row_ref0 (_tmp28_);
#line 3824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->priv->editable = _tmp29_;
#line 3825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp30_ = self->priv->editable;
#line 3825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31_ = _backing_photo_row_ref0 (_tmp30_);
#line 3825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->backing_photo_row = _tmp31_;
#line 3826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp32_ = self->backing_photo_row;
#line 3826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp33_ = _tmp32_->original_orientation;
#line 3826 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_set_orientation (self, _tmp33_);
#line 27671 "Photo.c"
				}
				__finally250:
				{
					PhotoRow* _tmp34_ = NULL;
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp34_ = self->row;
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27680 "Photo.c"
				}
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3819 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 27698 "Photo.c"
				}
			}
		}
#line 3829 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		is_new_editable = TRUE;
#line 27704 "Photo.c"
	}
#line 3832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = only_attributes;
#line 3832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp35_) {
#line 27710 "Photo.c"
		gboolean _tmp36_ = FALSE;
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp45_ = NULL;
		GTimeVal _tmp46_ = {0};
		BackingPhotoTable* _tmp47_ = NULL;
		BackingPhotoTable* _tmp48_ = NULL;
		BackingPhotoID _tmp49_ = {0};
		GTimeVal _tmp50_ = {0};
		glong _tmp51_ = 0L;
		GFileInfo* _tmp52_ = NULL;
		gint64 _tmp53_ = 0LL;
#line 3834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp36_ = backing_photo_id_is_valid (&editable_id);
#line 3834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_assert (_tmp36_, "editable_id.is_valid ()");
#line 27727 "Photo.c"
		{
			GFileInfo* _tmp37_ = NULL;
			GFile* _tmp38_ = NULL;
			GFileInfo* _tmp39_ = NULL;
			GFileInfo* _tmp40_ = NULL;
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = file;
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = g_file_query_filesystem_info (_tmp38_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp37_ = _tmp39_;
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27741 "Photo.c"
				goto __catch251_g_error;
			}
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = _tmp37_;
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp37_ = NULL;
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			info = _tmp40_;
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp37_);
#line 27754 "Photo.c"
		}
		goto __finally251;
		__catch251_g_error:
		{
			GError* err = NULL;
			gchar* _tmp41_ = NULL;
			gchar* _tmp42_ = NULL;
			GError* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp41_ = data_object_to_string ((DataObject*) self);
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp43_ = err;
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp44_ = _tmp43_->message;
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_warning ("Photo.vala:3840: Unable to read editable filesystem info for %s: %s", _tmp42_, _tmp44_);
#line 3840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp42_);
#line 3841 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 27798 "Photo.c"
		}
		__finally251:
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 27819 "Photo.c"
		}
#line 3846 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = info;
#line 3846 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_file_info_get_modification_time (_tmp45_, &_tmp46_);
#line 3846 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		timestamp = _tmp46_;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = backing_photo_table_get_instance ();
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = editable_id;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp50_ = timestamp;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_ = _tmp50_.tv_sec;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = info;
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp53_ = g_file_info_get_size (_tmp52_);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp48_, &_tmp49_, (time_t) _tmp51_, _tmp53_, &_inner_error_);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp48_);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 27863 "Photo.c"
		}
		{
			PhotoRow* _tmp54_ = NULL;
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp54_ = self->row;
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 27871 "Photo.c"
			{
				BackingPhotoRow* _tmp55_ = NULL;
				time_t _tmp56_ = 0;
				GTimeVal _tmp57_ = {0};
				glong _tmp58_ = 0L;
				BackingPhotoRow* _tmp59_ = NULL;
				gint64 _tmp60_ = 0LL;
				GFileInfo* _tmp61_ = NULL;
				gint64 _tmp62_ = 0LL;
				BackingPhotoRow* _tmp63_ = NULL;
				GTimeVal _tmp64_ = {0};
				glong _tmp65_ = 0L;
				BackingPhotoRow* _tmp66_ = NULL;
				GFileInfo* _tmp67_ = NULL;
				gint64 _tmp68_ = 0LL;
#line 3851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp55_ = self->priv->editable;
#line 3851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp56_ = _tmp55_->timestamp;
#line 3851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp57_ = timestamp;
#line 3851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58_ = _tmp57_.tv_sec;
#line 3851 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				timestamp_changed = _tmp56_ != ((time_t) _tmp58_);
#line 3852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp59_ = self->priv->editable;
#line 3852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp60_ = _tmp59_->filesize;
#line 3852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp61_ = info;
#line 3852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp62_ = g_file_info_get_size (_tmp61_);
#line 3852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				filesize_changed = _tmp60_ != _tmp62_;
#line 3854 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp63_ = self->priv->editable;
#line 3854 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp64_ = timestamp;
#line 3854 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp65_ = _tmp64_.tv_sec;
#line 3854 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp63_->timestamp = (time_t) _tmp65_;
#line 3855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp66_ = self->priv->editable;
#line 3855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp67_ = info;
#line 3855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp68_ = g_file_info_get_size (_tmp67_);
#line 3855 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp66_->filesize = _tmp68_;
#line 27923 "Photo.c"
			}
			__finally252:
			{
				PhotoRow* _tmp69_ = NULL;
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp69_ = self->row;
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27932 "Photo.c"
			}
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (info);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3850 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 27952 "Photo.c"
			}
		}
#line 3832 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 27957 "Photo.c"
	} else {
		gboolean _tmp70_ = FALSE;
		gboolean _tmp71_ = FALSE;
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp71_ = backing_photo_id_is_valid (&editable_id);
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp71_) {
#line 27965 "Photo.c"
			gboolean _tmp72_ = FALSE;
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp72_ = is_new_editable;
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp70_ = !_tmp72_;
#line 27971 "Photo.c"
		} else {
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp70_ = FALSE;
#line 27975 "Photo.c"
		}
#line 3859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp70_) {
#line 27979 "Photo.c"
			BackingPhotoRow* _tmp73_ = NULL;
			BackingPhotoID _tmp74_ = {0};
			BackingPhotoTable* _tmp75_ = NULL;
			BackingPhotoTable* _tmp76_ = NULL;
			BackingPhotoRow* _tmp77_ = NULL;
#line 3864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp73_ = backing;
#line 3864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp74_ = editable_id;
#line 3864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp73_->id = _tmp74_;
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp75_ = backing_photo_table_get_instance ();
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp76_ = _tmp75_;
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp77_ = backing;
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_photo_table_update (_tmp76_, _tmp77_, &_inner_error_);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp76_);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 28017 "Photo.c"
			}
			{
				PhotoRow* _tmp78_ = NULL;
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp78_ = self->row;
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28025 "Photo.c"
				{
					BackingPhotoRow* _tmp79_ = NULL;
					time_t _tmp80_ = 0;
					BackingPhotoRow* _tmp81_ = NULL;
					time_t _tmp82_ = 0;
					BackingPhotoRow* _tmp83_ = NULL;
					gint64 _tmp84_ = 0LL;
					BackingPhotoRow* _tmp85_ = NULL;
					gint64 _tmp86_ = 0LL;
					BackingPhotoRow* _tmp87_ = NULL;
					BackingPhotoRow* _tmp88_ = NULL;
					BackingPhotoRow* _tmp89_ = NULL;
					BackingPhotoRow* _tmp90_ = NULL;
					BackingPhotoRow* _tmp91_ = NULL;
					Orientation _tmp92_ = 0;
#line 3867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp79_ = self->priv->editable;
#line 3867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp80_ = _tmp79_->timestamp;
#line 3867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp81_ = backing;
#line 3867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp82_ = _tmp81_->timestamp;
#line 3867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					timestamp_changed = _tmp80_ != _tmp82_;
#line 3868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp83_ = self->priv->editable;
#line 3868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp84_ = _tmp83_->filesize;
#line 3868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp85_ = backing;
#line 3868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp86_ = _tmp85_->filesize;
#line 3868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					filesize_changed = _tmp84_ != _tmp86_;
#line 3870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp87_ = backing;
#line 3870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp88_ = _backing_photo_row_ref0 (_tmp87_);
#line 3870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3870 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->priv->editable = _tmp88_;
#line 3871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp89_ = self->priv->editable;
#line 3871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp90_ = _backing_photo_row_ref0 (_tmp89_);
#line 3871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->backing_photo_row = _tmp90_;
#line 3872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp91_ = self->backing_photo_row;
#line 3872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp92_ = _tmp91_->original_orientation;
#line 3872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_set_orientation (self, _tmp92_);
#line 28083 "Photo.c"
				}
				__finally253:
				{
					PhotoRow* _tmp93_ = NULL;
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp93_ = self->row;
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28092 "Photo.c"
				}
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 28110 "Photo.c"
				}
			}
		}
	}
#line 3878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp94_ = new_reader;
#line 3878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp94_ != NULL) {
#line 28119 "Photo.c"
		{
			PhotoBackingReaders* _tmp95_ = NULL;
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp95_ = self->priv->readers;
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28126 "Photo.c"
			{
				PhotoBackingReaders* _tmp96_ = NULL;
				PhotoFileReader* _tmp97_ = NULL;
				PhotoFileReader* _tmp98_ = NULL;
#line 3880 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp96_ = self->priv->readers;
#line 3880 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp97_ = new_reader;
#line 3880 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp98_ = _photo_file_adapter_ref0 (_tmp97_);
#line 3880 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp96_->editable);
#line 3880 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp96_->editable = _tmp98_;
#line 28141 "Photo.c"
			}
			__finally254:
			{
				PhotoBackingReaders* _tmp99_ = NULL;
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp99_ = self->priv->readers;
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28150 "Photo.c"
			}
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 28168 "Photo.c"
			}
		}
	}
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp101_ = only_attributes;
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp101_) {
#line 28176 "Photo.c"
		PhotoFileReader* _tmp102_ = NULL;
		PhotoFileReader* _tmp103_ = NULL;
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp102_ = reader;
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp103_ = old_reader;
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp100_ = _tmp102_ != _tmp103_;
#line 28185 "Photo.c"
	} else {
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp100_ = FALSE;
#line 28189 "Photo.c"
	}
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp100_) {
#line 28193 "Photo.c"
		GFile* _tmp104_ = NULL;
		PhotoFileReader* _tmp105_ = NULL;
		GFile* _tmp108_ = NULL;
		PhotoFileReader* _tmp109_ = NULL;
#line 3885 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp105_ = old_reader;
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp105_ != NULL) {
#line 28204 "Photo.c"
			PhotoFileReader* _tmp106_ = NULL;
			GFile* _tmp107_ = NULL;
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp106_ = old_reader;
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp107_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp106_);
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp104_);
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp104_ = _tmp107_;
#line 28215 "Photo.c"
		} else {
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp104_);
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp104_ = NULL;
#line 28221 "Photo.c"
		}
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp109_ = new_reader;
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp109_ != NULL) {
#line 28227 "Photo.c"
			PhotoFileReader* _tmp110_ = NULL;
			GFile* _tmp111_ = NULL;
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp110_ = new_reader;
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp111_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp110_);
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp108_);
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp108_ = _tmp111_;
#line 28238 "Photo.c"
		} else {
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp108_);
#line 3887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp108_ = NULL;
#line 28244 "Photo.c"
		}
#line 3886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp104_, _tmp108_);
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp108_);
#line 3884 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp104_);
#line 28252 "Photo.c"
	}
#line 3890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp112_ = g_new0 (gchar*, 0 + 1);
#line 3890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	alteration_list = _tmp112_;
#line 3890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	alteration_list_length1 = 0;
#line 3890 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 3891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp113_ = timestamp_changed;
#line 3891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp113_) {
#line 28266 "Photo.c"
		gchar** _tmp114_ = NULL;
		gint _tmp114__length1 = 0;
		gchar* _tmp115_ = NULL;
		gchar** _tmp116_ = NULL;
		gint _tmp116__length1 = 0;
		gchar* _tmp117_ = NULL;
		gboolean _tmp118_ = FALSE;
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp114_ = alteration_list;
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp114__length1 = alteration_list_length1;
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp115_ = g_strdup ("metadata:editable-timestamp");
#line 3892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add114 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp115_);
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp116_ = alteration_list;
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp116__length1 = alteration_list_length1;
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp117_ = g_strdup ("metadata:baseline-timestamp");
#line 3893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add115 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp117_);
#line 3895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp118_ = photo_is_editable_source (self);
#line 3895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp118_) {
#line 28294 "Photo.c"
			gchar** _tmp119_ = NULL;
			gint _tmp119__length1 = 0;
			gchar* _tmp120_ = NULL;
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp119_ = alteration_list;
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp119__length1 = alteration_list_length1;
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp120_ = g_strdup ("metadata:source-timestamp");
#line 3896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add116 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp120_);
#line 28306 "Photo.c"
		}
	}
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp122_ = filesize_changed;
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp122_) {
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp121_ = TRUE;
#line 28315 "Photo.c"
	} else {
		PhotoFileReader* _tmp123_ = NULL;
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp123_ = new_reader;
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp121_ = _tmp123_ != NULL;
#line 28322 "Photo.c"
	}
#line 3899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp121_) {
#line 28326 "Photo.c"
		gchar** _tmp124_ = NULL;
		gint _tmp124__length1 = 0;
		gchar* _tmp125_ = NULL;
		gchar** _tmp126_ = NULL;
		gint _tmp126__length1 = 0;
		gchar* _tmp127_ = NULL;
		gboolean _tmp128_ = FALSE;
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp124_ = alteration_list;
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp124__length1 = alteration_list_length1;
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp125_ = g_strdup ("image:editable");
#line 3900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add117 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp125_);
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp126_ = alteration_list;
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp126__length1 = alteration_list_length1;
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp127_ = g_strdup ("image:baseline");
#line 3901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_array_add118 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp127_);
#line 3903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp128_ = photo_is_editable_source (self);
#line 3903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp128_) {
#line 28354 "Photo.c"
			gchar** _tmp129_ = NULL;
			gint _tmp129__length1 = 0;
			gchar* _tmp130_ = NULL;
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp129_ = alteration_list;
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp129__length1 = alteration_list_length1;
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp130_ = g_strdup ("image:source");
#line 3904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_array_add119 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp130_);
#line 28366 "Photo.c"
		}
	}
#line 3907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp131_ = alteration_list;
#line 3907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp131__length1 = alteration_list_length1;
#line 3907 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp131__length1 > 0) {
#line 28375 "Photo.c"
		gchar** _tmp132_ = NULL;
		gint _tmp132__length1 = 0;
		Alteration* _tmp133_ = NULL;
		Alteration* _tmp134_ = NULL;
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp132_ = alteration_list;
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp132__length1 = alteration_list_length1;
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp133_ = alteration_new_from_array (_tmp132_, _tmp132__length1);
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp134_ = _tmp133_;
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp134_);
#line 3908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp134_);
#line 28392 "Photo.c"
	}
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 28406 "Photo.c"
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify) {
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	has_editable = FALSE;
#line 3915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable_file = NULL;
#line 28430 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28437 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 3917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3917 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28447 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
				PhotoBackingReaders* _tmp6_ = NULL;
#line 3918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_file = _tmp5_;
#line 3919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 3919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 3920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				has_editable = TRUE;
#line 28470 "Photo.c"
			}
		}
		__finally255:
		{
			PhotoBackingReaders* _tmp7_ = NULL;
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28480 "Photo.c"
		}
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 28492 "Photo.c"
		}
	}
#line 3924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = has_editable;
#line 3924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_) {
#line 28499 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 28503 "Photo.c"
		{
			{
				PhotoRow* _tmp9_ = NULL;
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28511 "Photo.c"
				{
					PhotoRow* _tmp10_ = NULL;
					BackingPhotoID _tmp11_ = {0};
					gboolean _tmp12_ = FALSE;
					PhotoRow* _tmp16_ = NULL;
					BackingPhotoRow* _tmp17_ = NULL;
					BackingPhotoRow* _tmp18_ = NULL;
#line 3928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = self->row;
#line 3928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 3928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					editable_id = _tmp11_;
#line 3929 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = backing_photo_id_is_valid (&editable_id);
#line 3929 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp12_) {
#line 28529 "Photo.c"
						PhotoTable* _tmp13_ = NULL;
						PhotoTable* _tmp14_ = NULL;
						PhotoRow* _tmp15_ = NULL;
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp13_ = photo_table_get_instance ();
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp14_ = _tmp13_;
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp15_ = self->row;
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						photo_table_detach_editable (_tmp14_, _tmp15_, &_inner_error_);
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_database_table_unref0 (_tmp14_);
#line 3930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28545 "Photo.c"
							goto __finally257;
						}
					}
#line 3931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = self->row;
#line 3931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = _tmp16_->master;
#line 3931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = _backing_photo_row_ref0 (_tmp17_);
#line 3931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3931 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->backing_photo_row = _tmp18_;
#line 28559 "Photo.c"
				}
				__finally257:
				{
					PhotoRow* _tmp19_ = NULL;
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = self->row;
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28568 "Photo.c"
				}
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28574 "Photo.c"
						goto __catch256_database_error;
					}
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 28585 "Photo.c"
				}
			}
		}
		goto __finally256;
		__catch256_database_error:
		{
			GError* err = NULL;
			GError* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = err;
#line 3934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 3934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_warning ("Photo.vala:3934: Unable to remove editable from PhotoTable: %s", _tmp21_);
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28607 "Photo.c"
		}
		__finally256:
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 28620 "Photo.c"
		}
		{
			gboolean _tmp22_ = FALSE;
#line 3938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = backing_photo_id_is_valid (&editable_id);
#line 3938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp22_) {
#line 28628 "Photo.c"
				BackingPhotoTable* _tmp23_ = NULL;
				BackingPhotoTable* _tmp24_ = NULL;
				BackingPhotoID _tmp25_ = {0};
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = backing_photo_table_get_instance ();
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = _tmp23_;
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = editable_id;
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				backing_photo_table_remove (_tmp24_, &_tmp25_, &_inner_error_);
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_database_table_unref0 (_tmp24_);
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28646 "Photo.c"
						goto __catch258_database_error;
					}
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 28657 "Photo.c"
				}
			}
		}
		goto __finally258;
		__catch258_database_error:
		{
			GError* err = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = err;
#line 3941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = _tmp26_->message;
#line 3941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_warning ("Photo.vala:3941: Unable to remove editable from BackingPhotoTable: %s", _tmp27_);
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28679 "Photo.c"
		}
		__finally258:
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 28692 "Photo.c"
		}
	}
#line 3945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = remove_transformations;
#line 3945 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp28_) {
#line 3946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 28701 "Photo.c"
	}
#line 3948 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = has_editable;
#line 3948 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp29_) {
#line 28707 "Photo.c"
		GFile* _tmp30_ = NULL;
#line 3949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = editable_file;
#line 3950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, NULL);
#line 28715 "Photo.c"
	}
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = delete_editable;
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp32_) {
#line 28721 "Photo.c"
		GFile* _tmp33_ = NULL;
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp33_ = editable_file;
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = _tmp33_ != NULL;
#line 28727 "Photo.c"
	} else {
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = FALSE;
#line 28731 "Photo.c"
	}
#line 3953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp31_) {
#line 28735 "Photo.c"
		{
			GFile* _tmp34_ = NULL;
#line 3955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp34_ = editable_file;
#line 3955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_file_trash (_tmp34_, NULL, &_inner_error_);
#line 3955 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28744 "Photo.c"
				goto __catch259_g_error;
			}
		}
		goto __finally259;
		__catch259_g_error:
		{
			GError* err = NULL;
			GFile* _tmp35_ = NULL;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			GError* _tmp40_ = NULL;
			const gchar* _tmp41_ = NULL;
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			err = _inner_error_;
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp35_ = editable_file;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp36_ = g_file_get_path (_tmp35_);
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp37_ = _tmp36_;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = data_object_to_string ((DataObject*) self);
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = _tmp38_;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = err;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp41_ = _tmp40_->message;
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_warning ("Photo.vala:3957: Unable to trash editable %s for %s: %s", _tmp37_, _tmp39_, _tmp41_);
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp39_);
#line 3957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (_tmp37_);
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28785 "Photo.c"
		}
		__finally259:
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 28798 "Photo.c"
		}
	}
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = has_editable;
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp44_) {
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = TRUE;
#line 28807 "Photo.c"
	} else {
		gboolean _tmp45_ = FALSE;
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp45_ = remove_transformations;
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = _tmp45_;
#line 28814 "Photo.c"
	}
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp43_) {
#line 28818 "Photo.c"
		gboolean _tmp46_ = FALSE;
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = notify;
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = _tmp46_;
#line 28824 "Photo.c"
	} else {
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp42_ = FALSE;
#line 28828 "Photo.c"
	}
#line 3962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp42_) {
#line 28832 "Photo.c"
		Alteration* _tmp47_ = NULL;
		Alteration* _tmp48_ = NULL;
#line 3963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = alteration_new ("image", "revert");
#line 3963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 3963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp48_);
#line 3963 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_alteration_unref0 (_tmp48_);
#line 28843 "Photo.c"
	}
#line 3911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 28847 "Photo.c"
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
#line 3978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 28854 "Photo.c"
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
#line 3987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 28861 "Photo.c"
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
#line 3996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 28868 "Photo.c"
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFileMonitorEvent _tmp11_ = 0;
	GEnumValue* _tmp12_;
	GFile* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	GFileMonitorEvent _tmp16_ = 0;
	GError * _inner_error_ = NULL;
#line 3966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 28884 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28891 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 28902 "Photo.c"
				GFile* _tmp4_ = NULL;
				PhotoBackingReaders* _tmp5_ = NULL;
				PhotoFileReader* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = file;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = self->priv->readers;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = _tmp5_->editable;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp6_);
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = g_file_equal (_tmp4_, _tmp8_);
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = _tmp9_;
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 28925 "Photo.c"
			} else {
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 28929 "Photo.c"
			}
#line 3969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_vala_assert (_tmp1_, "readers.editable != null && file.equal (readers.editable.get_file ())");
#line 28933 "Photo.c"
		}
		__finally260:
		{
			PhotoBackingReaders* _tmp10_ = NULL;
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = self->priv->readers;
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28942 "Photo.c"
		}
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 28952 "Photo.c"
		}
	}
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = event;
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp11_);
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = file;
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:3972: EDITABLE %s: %s", (_tmp12_ != NULL) ? _tmp12_->value_name : NULL, _tmp15_);
#line 3972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = event;
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (_tmp16_) {
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 28977 "Photo.c"
		{
			OneShotScheduler* _tmp17_ = NULL;
			OneShotScheduler* _tmp19_ = NULL;
#line 3977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->priv->reimport_editable_scheduler;
#line 3977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp17_ == NULL) {
#line 28985 "Photo.c"
				OneShotScheduler* _tmp18_ = NULL;
#line 3978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3978 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp18_;
#line 28993 "Photo.c"
			}
#line 3982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = self->priv->reimport_editable_scheduler;
#line 3982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp19_, (guint) 1000, TRUE);
#line 3983 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 29001 "Photo.c"
		}
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29005 "Photo.c"
		{
			OneShotScheduler* _tmp20_ = NULL;
			OneShotScheduler* _tmp22_ = NULL;
#line 3986 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = self->priv->update_editable_attributes_scheduler;
#line 3986 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp20_ == NULL) {
#line 29013 "Photo.c"
				OneShotScheduler* _tmp21_ = NULL;
#line 3987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 3987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 3987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp21_;
#line 29021 "Photo.c"
			}
#line 3991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = self->priv->update_editable_attributes_scheduler;
#line 3991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp22_, (guint) 1000, TRUE);
#line 3992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 29029 "Photo.c"
		}
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29033 "Photo.c"
		{
			OneShotScheduler* _tmp23_ = NULL;
			OneShotScheduler* _tmp25_ = NULL;
#line 3995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = self->priv->remove_editable_scheduler;
#line 3995 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp23_ == NULL) {
#line 29041 "Photo.c"
				OneShotScheduler* _tmp24_ = NULL;
#line 3996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 3996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 3996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp24_;
#line 29049 "Photo.c"
			}
#line 4000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = self->priv->remove_editable_scheduler;
#line 4000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp25_, (guint) 3000, TRUE);
#line 4001 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 29057 "Photo.c"
		}
		default:
#line 3974 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29062 "Photo.c"
		{
#line 4006 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			break;
#line 29066 "Photo.c"
		}
	}
#line 4011 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 29071 "Photo.c"
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4014 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:4018: Reimporting editable for %s", _tmp1_);
#line 4018 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29091 "Photo.c"
	{
#line 4020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 4020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29097 "Photo.c"
			goto __catch261_g_error;
		}
	}
	goto __finally261;
	__catch261_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = err;
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:4022: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29127 "Photo.c"
	}
	__finally261:
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4019 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 29138 "Photo.c"
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4027 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:4028: Updating editable attributes for %s", _tmp1_);
#line 4028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29157 "Photo.c"
	{
#line 4030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 4030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29163 "Photo.c"
			goto __catch262_g_error;
		}
	}
	goto __finally262;
	__catch262_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = err;
#line 4032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:4032: Unable to update editable attributes: %s", _tmp3_);
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29185 "Photo.c"
	}
	__finally262:
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 29196 "Photo.c"
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
#line 4036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4037 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	reader = _tmp0_;
#line 4038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = reader;
#line 4038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 29226 "Photo.c"
	}
#line 4041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = reader;
#line 4041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp2_);
#line 4041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp3_;
#line 4042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = file;
#line 4042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 4042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 29240 "Photo.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 4043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = data_object_to_string ((DataObject*) self);
#line 4043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 4043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_debug ("Photo.vala:4043: Not removing editable for %s: file exists", _tmp7_);
#line 4043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 4045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 4045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 29257 "Photo.c"
	}
#line 4048 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = data_object_to_string ((DataObject*) self);
#line 4048 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 4048 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_debug ("Photo.vala:4048: Removing editable for %s: file no longer exists", _tmp9_);
#line 4048 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp9_);
#line 4049 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 4036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 29273 "Photo.c"
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Orientation _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
#line 4057 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dim = _tmp0_;
#line 4059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation = _tmp1_;
#line 4061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = dim;
#line 4061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp2_, &_tmp3_);
#line 4061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = _tmp3_;
#line 4061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 29302 "Photo.c"
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_ = 0;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 4065 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_original_orientation (self);
#line 4066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp1_);
#line 4066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = _tmp2_;
#line 4066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 29322 "Photo.c"
}


gboolean photo_get_crop (Photo* self, Box* crop, PhotoException exceptions) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
	Orientation _tmp3_ = 0;
	PhotoException _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
#line 4070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4072 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4072 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw = _tmp0_;
#line 4072 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 4075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (crop) {
#line 4075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*crop = _vala_crop;
#line 29354 "Photo.c"
		}
#line 4075 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 29358 "Photo.c"
	}
#line 4078 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4078 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dim = _tmp2_;
#line 4079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_get_orientation (self);
#line 4079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation = _tmp3_;
#line 4081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = exceptions;
#line 4081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_exception_allows (_tmp4_, PHOTO_EXCEPTION_ORIENTATION);
#line 4081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 29374 "Photo.c"
		Orientation _tmp6_ = 0;
		Dimensions _tmp7_ = {0};
		Box _tmp8_ = {0};
		Box _tmp9_ = {0};
#line 4082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = orientation;
#line 4082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = dim;
#line 4082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = raw;
#line 4082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 4082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_crop = _tmp9_;
#line 29389 "Photo.c"
	} else {
		Box _tmp10_ = {0};
#line 4084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = raw;
#line 4084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_crop = _tmp10_;
#line 29396 "Photo.c"
	}
#line 4086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 4086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (crop) {
#line 4086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*crop = _vala_crop;
#line 29404 "Photo.c"
	}
#line 4086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 29408 "Photo.c"
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Orientation _tmp1_ = 0;
	Box derotated = {0};
	Dimensions _tmp2_ = {0};
	Box _tmp3_ = {0};
	Box _tmp4_ = {0};
	Box _tmp5_ = {0};
	gint _tmp6_ = 0;
	Dimensions _tmp7_ = {0};
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	Box _tmp10_ = {0};
	gint _tmp11_ = 0;
	Box _tmp12_ = {0};
	gint _tmp13_ = 0;
	Dimensions _tmp14_ = {0};
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	Box _tmp17_ = {0};
	gint _tmp18_ = 0;
	Dimensions _tmp19_ = {0};
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	Box _tmp22_ = {0};
	gint _tmp23_ = 0;
	Box _tmp24_ = {0};
	gint _tmp25_ = 0;
	Dimensions _tmp26_ = {0};
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	Box _tmp29_ = {0};
#line 4090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4090 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4091 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dim = _tmp0_;
#line 4092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation = _tmp1_;
#line 4094 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = dim;
#line 4094 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = *crop;
#line 4094 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp2_, &_tmp3_, &_tmp4_);
#line 4094 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated = _tmp4_;
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = derotated;
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = _tmp5_.left;
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = dim;
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_.width;
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_ - 2);
#line 4096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated.left = _tmp9_;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = derotated;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_.right;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = derotated;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_.left;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = dim;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_.width;
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = CLAMP (_tmp11_, _tmp13_, _tmp15_ - 1);
#line 4097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated.right = _tmp16_;
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = derotated;
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = _tmp17_.top;
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = dim;
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = _tmp19_.height;
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 2);
#line 4099 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated.top = _tmp21_;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = derotated;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = _tmp22_.bottom;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = derotated;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = _tmp24_.top;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = dim;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = _tmp26_.height;
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = CLAMP (_tmp23_, _tmp25_, _tmp27_ - 1);
#line 4100 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated.bottom = _tmp28_;
#line 4102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = derotated;
#line 4102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp29_);
#line 29526 "Photo.c"
}


gboolean photo_get_straighten (Photo* self, gdouble* theta) {
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
#line 4105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 4107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (theta) {
#line 4107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*theta = _vala_theta;
#line 29549 "Photo.c"
		}
#line 4107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 29553 "Photo.c"
	}
#line 4109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 4109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (theta) {
#line 4109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*theta = _vala_theta;
#line 29561 "Photo.c"
	}
#line 4109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 29565 "Photo.c"
}


void photo_set_straighten (Photo* self, gdouble theta) {
	gdouble _tmp0_ = 0.0;
#line 4112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4113 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = theta;
#line 4113 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_set_raw_straighten (self, _tmp0_);
#line 29577 "Photo.c"
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint* _tmp4_ = NULL;
	gint x_insets_first_quadrant_length1 = 0;
	gint _x_insets_first_quadrant_size_ = 0;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp22_ = {0};
	GdkPoint _tmp23_ = {0};
	gint _tmp24_ = 0;
	EditingToolsRedeyeInstance _tmp25_ = {0};
	gint _tmp26_ = 0;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp27_ = {0};
	GdkPoint _tmp28_ = {0};
	gint _tmp29_ = 0;
	EditingToolsRedeyeInstance _tmp30_ = {0};
	gint _tmp31_ = 0;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp32_ = {0};
	GdkPoint _tmp33_ = {0};
	gint _tmp34_ = 0;
	EditingToolsRedeyeInstance _tmp35_ = {0};
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp40_ = {0};
	GdkPoint _tmp41_ = {0};
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	GdkPixbuf* _tmp45_ = NULL;
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp88_ = {0};
	GdkPoint _tmp89_ = {0};
	gint _tmp90_ = 0;
	EditingToolsRedeyeInstance _tmp91_ = {0};
	GdkPoint _tmp92_ = {0};
	gint _tmp93_ = 0;
	EditingToolsRedeyeInstance _tmp94_ = {0};
	gint _tmp95_ = 0;
	gint* _tmp96_ = NULL;
	gint _tmp96__length1 = 0;
	GdkPixbuf* _tmp133_ = NULL;
	GdkPixbuf* _tmp134_ = NULL;
#line 4116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4116 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = *inst;
#line 4126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = *inst;
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	i = 0;
#line 29661 "Photo.c"
	{
		gdouble y = 0.0;
		gdouble _tmp5_ = 0.0;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = r;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		y = _tmp5_;
#line 29669 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 29676 "Photo.c"
				gdouble _tmp8_ = 0.0;
				gdouble theta = 0.0;
				gdouble _tmp9_ = 0.0;
				gdouble _tmp10_ = 0.0;
				gdouble _tmp11_ = 0.0;
				gint x = 0;
				gdouble _tmp12_ = 0.0;
				gdouble _tmp13_ = 0.0;
				gdouble _tmp14_ = 0.0;
				gint* _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				gint _tmp16_ = 0;
				EditingToolsRedeyeInstance _tmp17_ = {0};
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp6_) {
#line 29696 "Photo.c"
					gdouble _tmp7_ = 0.0;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp7_ = y;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					y = _tmp7_ - 1.0;
#line 29702 "Photo.c"
				}
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = FALSE;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = y;
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp8_ >= 0.0)) {
#line 4130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 29712 "Photo.c"
				}
#line 4131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = y;
#line 4131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = r;
#line 4131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = asin (_tmp9_ / _tmp10_);
#line 4131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				theta = _tmp11_;
#line 4132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = r;
#line 4132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = theta;
#line 4132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = cos (_tmp13_);
#line 4132 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				x = (gint) ((_tmp12_ * _tmp14_) + 0.5);
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = x_insets_first_quadrant;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15__length1 = x_insets_first_quadrant_length1;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = i;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = *inst;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = _tmp17_.radius;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = x;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_[_tmp16_] = _tmp18_ - _tmp19_;
#line 4133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = _tmp15_[_tmp16_];
#line 4135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = i;
#line 4135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				i = _tmp21_ + 1;
#line 29750 "Photo.c"
			}
		}
	}
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = *inst;
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = _tmp22_.center;
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = _tmp23_.x;
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = *inst;
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = _tmp25_.radius;
#line 4138 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	x_bounds_min = _tmp24_ - _tmp26_;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = *inst;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = _tmp27_.center;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = _tmp28_.x;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = *inst;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = _tmp30_.radius;
#line 4139 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	x_bounds_max = _tmp29_ + _tmp31_;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = *inst;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = _tmp32_.center;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _tmp33_.y;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = *inst;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_.radius;
#line 4140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymin = _tmp34_ - _tmp36_;
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = ymin;
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp38_ < 0) {
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = 0;
#line 29796 "Photo.c"
	} else {
		gint _tmp39_ = 0;
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp39_ = ymin;
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp37_ = _tmp39_;
#line 29803 "Photo.c"
	}
#line 4141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymin = _tmp37_;
#line 4142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = *inst;
#line 4142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = _tmp40_.center;
#line 4142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = _tmp41_.y;
#line 4142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymax = _tmp42_;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = ymax;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = pixbuf;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = gdk_pixbuf_get_height (_tmp45_);
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = _tmp46_;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp44_ > (_tmp47_ - 1)) {
#line 29825 "Photo.c"
		GdkPixbuf* _tmp48_ = NULL;
		gint _tmp49_ = 0;
		gint _tmp50_ = 0;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = pixbuf;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = gdk_pixbuf_get_height (_tmp48_);
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp50_ = _tmp49_;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = _tmp50_ - 1;
#line 29837 "Photo.c"
	} else {
		gint _tmp51_ = 0;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp51_ = ymax;
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp43_ = _tmp51_;
#line 29844 "Photo.c"
	}
#line 4143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymax = _tmp43_;
#line 4147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	inset_index = 0;
#line 29850 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp52_ = 0;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp52_ = ymin;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		y_it = _tmp52_;
#line 29858 "Photo.c"
		{
			gboolean _tmp53_ = FALSE;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp53_ = TRUE;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 29865 "Photo.c"
				gint _tmp55_ = 0;
				gint _tmp56_ = 0;
				gint xmin = 0;
				gint _tmp57_ = 0;
				gint* _tmp58_ = NULL;
				gint _tmp58__length1 = 0;
				gint _tmp59_ = 0;
				gint _tmp60_ = 0;
				gint _tmp61_ = 0;
				gint _tmp62_ = 0;
				gint xmax = 0;
				gint _tmp64_ = 0;
				gint* _tmp65_ = NULL;
				gint _tmp65__length1 = 0;
				gint _tmp66_ = 0;
				gint _tmp67_ = 0;
				gint _tmp68_ = 0;
				gint _tmp69_ = 0;
				GdkPixbuf* _tmp70_ = NULL;
				gint _tmp71_ = 0;
				gint _tmp72_ = 0;
				gint _tmp87_ = 0;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp53_) {
#line 29890 "Photo.c"
					gint _tmp54_ = 0;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp54_ = y_it;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					y_it = _tmp54_ + 1;
#line 29896 "Photo.c"
				}
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp53_ = FALSE;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp55_ = y_it;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp56_ = ymax;
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp55_ <= _tmp56_)) {
#line 4148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 29908 "Photo.c"
				}
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp57_ = x_bounds_min;
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58_ = x_insets_first_quadrant;
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58__length1 = x_insets_first_quadrant_length1;
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp59_ = inset_index;
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp60_ = _tmp58_[_tmp59_];
#line 4149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmin = _tmp57_ + _tmp60_;
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp62_ = xmin;
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp62_ < 0) {
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp61_ = 0;
#line 29928 "Photo.c"
				} else {
					gint _tmp63_ = 0;
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp63_ = xmin;
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp61_ = _tmp63_;
#line 29935 "Photo.c"
				}
#line 4150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmin = _tmp61_;
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp64_ = x_bounds_max;
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp65_ = x_insets_first_quadrant;
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp65__length1 = x_insets_first_quadrant_length1;
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp66_ = inset_index;
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp67_ = _tmp65_[_tmp66_];
#line 4151 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmax = _tmp64_ - _tmp67_;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp69_ = xmax;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp70_ = pixbuf;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp71_ = gdk_pixbuf_get_width (_tmp70_);
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp72_ = _tmp71_;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp69_ > (_tmp72_ - 1)) {
#line 29961 "Photo.c"
					GdkPixbuf* _tmp73_ = NULL;
					gint _tmp74_ = 0;
					gint _tmp75_ = 0;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp73_ = pixbuf;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp74_ = gdk_pixbuf_get_width (_tmp73_);
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp75_ = _tmp74_;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp68_ = _tmp75_ - 1;
#line 29973 "Photo.c"
				} else {
					gint _tmp76_ = 0;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp76_ = xmax;
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp68_ = _tmp76_;
#line 29980 "Photo.c"
				}
#line 4152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmax = _tmp68_;
#line 29984 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp77_ = 0;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp77_ = xmin;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					x_it = _tmp77_;
#line 29992 "Photo.c"
					{
						gboolean _tmp78_ = FALSE;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp78_ = TRUE;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 29999 "Photo.c"
							gint _tmp80_ = 0;
							gint _tmp81_ = 0;
							GdkPixbuf* _tmp82_ = NULL;
							gint _tmp83_ = 0;
							gint _tmp84_ = 0;
							GdkPixbuf* _tmp85_ = NULL;
							GdkPixbuf* _tmp86_ = NULL;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp78_) {
#line 30009 "Photo.c"
								gint _tmp79_ = 0;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp79_ = x_it;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								x_it = _tmp79_ + 1;
#line 30015 "Photo.c"
							}
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp78_ = FALSE;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp80_ = x_it;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp81_ = xmax;
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!(_tmp80_ <= _tmp81_)) {
#line 4154 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 30027 "Photo.c"
							}
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp82_ = pixbuf;
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp83_ = x_it;
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp84_ = y_it;
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp85_ = photo_red_reduce_pixel (self, _tmp82_, _tmp83_, _tmp84_);
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp86_ = _tmp85_;
#line 4155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp86_);
#line 30041 "Photo.c"
						}
					}
				}
#line 4157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp87_ = inset_index;
#line 4157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				inset_index = _tmp87_ + 1;
#line 30049 "Photo.c"
			}
		}
	}
#line 4162 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp88_ = *inst;
#line 4162 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp89_ = _tmp88_.center;
#line 4162 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp90_ = _tmp89_.y;
#line 4162 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymin = _tmp90_;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp91_ = *inst;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp92_ = _tmp91_.center;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp93_ = _tmp92_.y;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp94_ = *inst;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp95_ = _tmp94_.radius;
#line 4163 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ymax = _tmp93_ + _tmp95_;
#line 4164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp96_ = x_insets_first_quadrant;
#line 4164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp96__length1 = x_insets_first_quadrant_length1;
#line 4164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	inset_index = _tmp96__length1 - 1;
#line 30079 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp97_ = 0;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp97_ = ymin;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		y_it = _tmp97_;
#line 30087 "Photo.c"
		{
			gboolean _tmp98_ = FALSE;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp98_ = TRUE;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 30094 "Photo.c"
				gint _tmp100_ = 0;
				gint _tmp101_ = 0;
				gint xmin = 0;
				gint _tmp102_ = 0;
				gint* _tmp103_ = NULL;
				gint _tmp103__length1 = 0;
				gint _tmp104_ = 0;
				gint _tmp105_ = 0;
				gint _tmp106_ = 0;
				gint _tmp107_ = 0;
				gint xmax = 0;
				gint _tmp109_ = 0;
				gint* _tmp110_ = NULL;
				gint _tmp110__length1 = 0;
				gint _tmp111_ = 0;
				gint _tmp112_ = 0;
				gint _tmp113_ = 0;
				gint _tmp114_ = 0;
				GdkPixbuf* _tmp115_ = NULL;
				gint _tmp116_ = 0;
				gint _tmp117_ = 0;
				gint _tmp132_ = 0;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp98_) {
#line 30119 "Photo.c"
					gint _tmp99_ = 0;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp99_ = y_it;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					y_it = _tmp99_ + 1;
#line 30125 "Photo.c"
				}
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp98_ = FALSE;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp100_ = y_it;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp101_ = ymax;
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp100_ <= _tmp101_)) {
#line 4165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 30137 "Photo.c"
				}
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp102_ = x_bounds_min;
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp103_ = x_insets_first_quadrant;
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp103__length1 = x_insets_first_quadrant_length1;
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp104_ = inset_index;
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp105_ = _tmp103_[_tmp104_];
#line 4166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmin = _tmp102_ + _tmp105_;
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp107_ = xmin;
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp107_ < 0) {
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp106_ = 0;
#line 30157 "Photo.c"
				} else {
					gint _tmp108_ = 0;
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp108_ = xmin;
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp106_ = _tmp108_;
#line 30164 "Photo.c"
				}
#line 4167 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmin = _tmp106_;
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp109_ = x_bounds_max;
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp110_ = x_insets_first_quadrant;
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp110__length1 = x_insets_first_quadrant_length1;
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp111_ = inset_index;
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp112_ = _tmp110_[_tmp111_];
#line 4168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmax = _tmp109_ - _tmp112_;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp114_ = xmax;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp115_ = pixbuf;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp116_ = gdk_pixbuf_get_width (_tmp115_);
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp117_ = _tmp116_;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp114_ > (_tmp117_ - 1)) {
#line 30190 "Photo.c"
					GdkPixbuf* _tmp118_ = NULL;
					gint _tmp119_ = 0;
					gint _tmp120_ = 0;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp118_ = pixbuf;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp119_ = gdk_pixbuf_get_width (_tmp118_);
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp120_ = _tmp119_;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp113_ = _tmp120_ - 1;
#line 30202 "Photo.c"
				} else {
					gint _tmp121_ = 0;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp121_ = xmax;
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp113_ = _tmp121_;
#line 30209 "Photo.c"
				}
#line 4169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				xmax = _tmp113_;
#line 30213 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp122_ = 0;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp122_ = xmin;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					x_it = _tmp122_;
#line 30221 "Photo.c"
					{
						gboolean _tmp123_ = FALSE;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp123_ = TRUE;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 30228 "Photo.c"
							gint _tmp125_ = 0;
							gint _tmp126_ = 0;
							GdkPixbuf* _tmp127_ = NULL;
							gint _tmp128_ = 0;
							gint _tmp129_ = 0;
							GdkPixbuf* _tmp130_ = NULL;
							GdkPixbuf* _tmp131_ = NULL;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp123_) {
#line 30238 "Photo.c"
								gint _tmp124_ = 0;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp124_ = x_it;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								x_it = _tmp124_ + 1;
#line 30244 "Photo.c"
							}
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp123_ = FALSE;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp125_ = x_it;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp126_ = xmax;
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!(_tmp125_ <= _tmp126_)) {
#line 4171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 30256 "Photo.c"
							}
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp127_ = pixbuf;
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp128_ = x_it;
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp129_ = y_it;
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp130_ = photo_red_reduce_pixel (self, _tmp127_, _tmp128_, _tmp129_);
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp131_ = _tmp130_;
#line 4172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp131_);
#line 30270 "Photo.c"
						}
					}
				}
#line 4174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp132_ = inset_index;
#line 4174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				inset_index = _tmp132_ - 1;
#line 30278 "Photo.c"
			}
		}
	}
#line 4177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp133_ = pixbuf;
#line 4177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp134_ = _g_object_ref0 (_tmp133_);
#line 4177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp134_;
#line 4177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 30292 "Photo.c"
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_ = 0;
	GdkPixbuf* _tmp33_ = NULL;
	GdkPixbuf* _tmp34_ = NULL;
#line 4180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4180 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = y;
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = pixbuf;
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_get_rowstride (_tmp1_);
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = x;
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (_tmp4_);
#line 4181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	px_start_byte_offset = (_tmp0_ * _tmp2_) + (_tmp3_ * _tmp5_);
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = x;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp9_ >= 0) {
#line 30333 "Photo.c"
		gint _tmp10_ = 0;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = y;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = _tmp10_ >= 0;
#line 30339 "Photo.c"
	} else {
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = FALSE;
#line 30343 "Photo.c"
	}
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_) {
#line 30347 "Photo.c"
		gint _tmp11_ = 0;
		GdkPixbuf* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = x;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = pixbuf;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp11_ < _tmp14_;
#line 30362 "Photo.c"
	} else {
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = FALSE;
#line 30366 "Photo.c"
	}
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_) {
#line 30370 "Photo.c"
		gint _tmp15_ = 0;
		GdkPixbuf* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = y;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = pixbuf;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp15_ < _tmp18_;
#line 30385 "Photo.c"
	} else {
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = FALSE;
#line 30389 "Photo.c"
	}
#line 4188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 30393 "Photo.c"
		guchar* pixel_data = NULL;
		GdkPixbuf* _tmp19_ = NULL;
		guint8* _tmp20_ = NULL;
		gint pixel_data_length1 = 0;
		gint _pixel_data_size_ = 0;
		guchar g = '\0';
		guchar* _tmp21_ = NULL;
		gint _tmp21__length1 = 0;
		gint _tmp22_ = 0;
		guchar _tmp23_ = '\0';
		guchar b = '\0';
		guchar* _tmp24_ = NULL;
		gint _tmp24__length1 = 0;
		gint _tmp25_ = 0;
		guchar _tmp26_ = '\0';
		guchar r = '\0';
		guchar _tmp27_ = '\0';
		guchar _tmp28_ = '\0';
		guchar* _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		gint _tmp30_ = 0;
		guchar _tmp31_ = '\0';
		guchar _tmp32_ = '\0';
#line 4189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = pixbuf;
#line 4189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = gdk_pixbuf_get_pixels (_tmp19_);
#line 4189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_data = _tmp20_;
#line 4189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixel_data_length1 = -1;
#line 4189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = pixel_data;
#line 4199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21__length1 = pixel_data_length1;
#line 4199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = px_start_byte_offset;
#line 4199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = _tmp21_[_tmp22_ + 1];
#line 4199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g = _tmp23_;
#line 4200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = pixel_data;
#line 4200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24__length1 = pixel_data_length1;
#line 4200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = px_start_byte_offset;
#line 4200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = _tmp24_[_tmp25_ + 2];
#line 4200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		b = _tmp26_;
#line 4202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp27_ = g;
#line 4202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp28_ = b;
#line 4202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		r = (guchar) ((_tmp27_ + _tmp28_) / 2);
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_ = pixel_data;
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29__length1 = pixel_data_length1;
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp30_ = px_start_byte_offset;
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = r;
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp29_[_tmp30_] = _tmp31_;
#line 4204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp32_ = _tmp29_[_tmp30_];
#line 30465 "Photo.c"
	}
#line 4207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = pixbuf;
#line 4207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = _g_object_ref0 (_tmp33_);
#line 4207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp34_;
#line 4207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 30475 "Photo.c"
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation unscaled_orientation = 0;
	Orientation _tmp0_ = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	GdkPoint derotated_point = {0};
	Orientation _tmp10_ = 0;
	Dimensions _tmp11_ = {0};
	GdkPoint _tmp12_ = {0};
	GdkPoint _tmp13_ = {0};
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
#line 4210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_orientation (self);
#line 4211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	unscaled_orientation = _tmp0_;
#line 4213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = unscaled_orientation;
#line 4213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 4213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp1_, &_tmp2_, &_tmp3_);
#line 4213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	unscaled_dims = _tmp3_;
#line 4216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4217 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_get_raw_crop (self, &_tmp4_);
#line 4220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	crop_box = _tmp4_;
#line 4220 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 30526 "Photo.c"
		Box _tmp6_ = {0};
		gint _tmp7_ = 0;
		Box _tmp8_ = {0};
		gint _tmp9_ = 0;
#line 4221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = crop_box;
#line 4221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_.left;
#line 4221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		unscaled_x_offset_raw = _tmp7_;
#line 4222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = crop_box;
#line 4222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = _tmp8_.top;
#line 4222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		unscaled_y_offset_raw = _tmp9_;
#line 30543 "Photo.c"
	}
#line 4225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = unscaled_orientation;
#line 4225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = unscaled_dims;
#line 4225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = *unscaled_point;
#line 4225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	orientation_derotate_point (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 4225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated_point = _tmp13_;
#line 4229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = derotated_point.x;
#line 4229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = unscaled_x_offset_raw;
#line 4229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated_point.x = _tmp14_ + _tmp15_;
#line 4230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = derotated_point.y;
#line 4230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = unscaled_y_offset_raw;
#line 4230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	derotated_point.y = _tmp16_ + _tmp17_;
#line 4232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = derotated_point;
#line 4232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 30571 "Photo.c"
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_ = {0};
	gint _tmp3_ = 0;
	GdkRectangle _tmp4_ = {0};
	gint _tmp5_ = 0;
	GdkPoint _tmp6_ = {0};
	gint _tmp7_ = 0;
	GdkRectangle _tmp8_ = {0};
	gint _tmp9_ = 0;
	GdkPoint _tmp10_ = {0};
	gint _tmp11_ = 0;
	GdkRectangle _tmp12_ = {0};
	gint _tmp13_ = 0;
	GdkPoint _tmp14_ = {0};
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_ = {0};
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_ = {0};
	gint _tmp19_ = 0;
	GdkPoint _tmp20_ = {0};
	gint _tmp21_ = 0;
	GdkPoint _tmp27_ = {0};
	gint _tmp28_ = 0;
	GdkPoint _tmp29_ = {0};
	gint _tmp30_ = 0;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_ = {0};
	gint _tmp37_ = 0;
	GdkPoint _tmp38_ = {0};
	gint _tmp39_ = 0;
	GdkPoint _tmp40_ = {0};
	gint _tmp41_ = 0;
	GdkPoint _tmp42_ = {0};
	gint _tmp43_ = 0;
	GdkPoint _tmp44_ = {0};
	gint _tmp45_ = 0;
	GdkPoint _tmp46_ = {0};
	gint _tmp47_ = 0;
#line 4235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_.x = 0;
#line 4236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	upper_left = _tmp0_;
#line 4237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_.x = 0;
#line 4237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	lower_right = _tmp1_;
#line 4238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4243 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	upper_left = _tmp15_;
#line 4244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	lower_right = _tmp17_;
#line 4246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 30683 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp22_ = {0};
		gint _tmp23_ = 0;
		GdkPoint _tmp24_ = {0};
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
#line 4247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		temp = _tmp23_;
#line 4248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp26_ = temp;
#line 4249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 30706 "Photo.c"
	}
#line 4251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 30718 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp31_ = {0};
		gint _tmp32_ = 0;
		GdkPoint _tmp33_ = {0};
		gint _tmp34_ = 0;
		gint _tmp35_ = 0;
#line 4252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		temp = _tmp32_;
#line 4253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp35_ = temp;
#line 4254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 30741 "Photo.c"
	}
#line 4257 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = raw_rect;
#line 4263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 30781 "Photo.c"
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	PixelTransformationBundle* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 4266 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4267 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	pixbuf = NULL;
#line 30796 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_ = NULL;
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 30810 "Photo.c"
			goto __catch263_g_error;
		}
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		pixbuf = _tmp3_;
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 30823 "Photo.c"
	}
	goto __finally263;
	__catch263_g_error:
	{
		GError* e = NULL;
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		e = _inner_error_;
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:4281: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 4283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (e);
#line 4283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 30843 "Photo.c"
	}
	__finally263:
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 30856 "Photo.c"
	}
#line 4290 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4290 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4290 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	transformations = _tmp5_;
#line 4298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = transformations;
#line 4298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 30870 "Photo.c"
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	transformations = _tmp0_;
#line 4304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = transformations;
#line 4304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 4305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4305 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 30896 "Photo.c"
	}
	{
		PhotoRow* _tmp2_ = NULL;
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 30904 "Photo.c"
		{
			KeyValueMap* _tmp3_ = NULL;
			KeyValueMap* _tmp4_ = NULL;
			PixelTransformationBundle* _tmp5_ = NULL;
#line 4311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_clear_original_transforms (self);
#line 4312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = photo_get_color_adjustments_map (self);
#line 4312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 4312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_original_transforms (self, _tmp4_);
#line 4312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp4_);
#line 4313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = transformations;
#line 4313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp5_);
#line 30923 "Photo.c"
		}
		__finally264:
		{
			PhotoRow* _tmp6_ = NULL;
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 30932 "Photo.c"
		}
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 30944 "Photo.c"
		}
	}
#line 4320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_set_enhanced (self, TRUE);
#line 4321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = TRUE;
#line 4321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 30955 "Photo.c"
}


gboolean photo_unenhance (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 4324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30964 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 30971 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 4326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 4326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 4326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp2_) {
#line 30981 "Photo.c"
				gboolean _tmp3_ = FALSE;
				PhotoRow* _tmp4_ = NULL;
				GeeHashMap* _tmp5_ = NULL;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _tmp4_->original_transforms;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp5_ == NULL) {
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp3_ = TRUE;
#line 30993 "Photo.c"
				} else {
					PhotoRow* _tmp6_ = NULL;
					GeeHashMap* _tmp7_ = NULL;
					gpointer _tmp8_ = NULL;
					KeyValueMap* _tmp9_ = NULL;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp7_ = _tmp6_->original_transforms;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, "adjustments");
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp9_ = (KeyValueMap*) _tmp8_;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp3_ = _tmp9_ == NULL;
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_key_value_map_unref0 (_tmp9_);
#line 31011 "Photo.c"
				}
#line 4327 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp3_) {
#line 31015 "Photo.c"
					gboolean _result_ = FALSE;
					gboolean _tmp10_ = FALSE;
					gboolean _tmp11_ = FALSE;
#line 4328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_remove_transformation (self, "adjustments");
#line 4329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_result_ = FALSE;
#line 4330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp10_ = photo_remove_transformation (self, "adjustments");
#line 4330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_result_ = _tmp10_;
#line 4331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 4331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->priv->adjustments = NULL;
#line 4332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_pixel_transformer_unref0 (self->priv->transformer);
#line 4332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					self->priv->transformer = NULL;
#line 4333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp11_ = _result_;
#line 4333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if (_tmp11_) {
#line 31039 "Photo.c"
						Alteration* _tmp12_ = NULL;
						Alteration* _tmp13_ = NULL;
#line 4334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp12_ = alteration_new ("image", "color-adjustments");
#line 4334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 4334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						data_object_notify_altered ((DataObject*) self, _tmp13_);
#line 4334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_alteration_unref0 (_tmp13_);
#line 31050 "Photo.c"
					}
				} else {
					PixelTransformationBundle* _tmp14_ = NULL;
					PixelTransformationBundle* _tmp15_ = NULL;
#line 4337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = photo_locked_original_color_adjustments (self);
#line 4337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 4337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					photo_set_color_adjustments (self, _tmp15_);
#line 4337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (_tmp15_);
#line 31063 "Photo.c"
				}
#line 4338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_set_enhanced (self, FALSE);
#line 4339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				result = TRUE;
#line 31069 "Photo.c"
				{
					PhotoRow* _tmp16_ = NULL;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = self->row;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31076 "Photo.c"
				}
#line 4339 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return result;
#line 31080 "Photo.c"
			}
		}
		__finally265:
		{
			PhotoRow* _tmp17_ = NULL;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31090 "Photo.c"
		}
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return FALSE;
#line 31100 "Photo.c"
		}
	}
#line 4342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = FALSE;
#line 4342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31107 "Photo.c"
}


gboolean photo_get_develop_raw_photos_to_files (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31120 "Photo.c"
}


void photo_set_develop_raw_photos_to_files (gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = value;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo__develop_raw_photos_to_files = _tmp0_;
#line 31130 "Photo.c"
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31153 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = closure->data;
#line 31159 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31165 "Photo.c"
}


static void photo_real_raw_development_modified (Photo* self) {
}


static void photo_real_baseline_replaced (Photo* self) {
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31196 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = closure->data;
#line 31202 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31208 "Photo.c"
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 31227 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_ = NULL;
	Photo* _tmp1_ = NULL;
	Orientation _tmp2_ = 0;
	GeeHashMap* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GeeHashMap* _tmp5_ = NULL;
	GeeHashMap* _tmp6_ = NULL;
	PixelTransformer* _tmp7_ = NULL;
	PixelTransformer* _tmp8_ = NULL;
	PixelTransformationBundle* _tmp9_ = NULL;
	PixelTransformationBundle* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	Photo* _tmp12_ = NULL;
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 181 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->photo = _tmp1_;
#line 182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = orientation;
#line 182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->orientation = _tmp2_;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = transformations;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_copy_transformations (_tmp3_);
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->transformations = _tmp4_;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = original_transformations;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_copy_transformations (_tmp5_);
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->original_transformations = _tmp6_;
#line 185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = transformer;
#line 185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _pixel_transformer_ref0 (_tmp7_);
#line 185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->transformer = _tmp8_;
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = adjustments;
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = _pixel_transformation_bundle_ref0 (_tmp9_);
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->adjustments = _tmp10_;
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = enhanced;
#line 187 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->enhanced = _tmp11_;
#line 188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo;
#line 188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_connect_object (_tmp12_, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 31304 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced) {
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments, original_transformations, enhanced);
#line 31311 "Photo.c"
}


static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 195 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->enhanced;
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31326 "Photo.c"
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	Orientation _tmp0_ = 0;
#line 199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31341 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31359 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 207 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->original_transformations;
#line 208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 208 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31377 "Photo.c"
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_ = NULL;
#line 211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31391 "Photo.c"
		PixelTransformer* _tmp2_ = NULL;
		PixelTransformer* _tmp3_ = NULL;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31402 "Photo.c"
	} else {
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 31408 "Photo.c"
	}
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31414 "Photo.c"
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
#line 215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31428 "Photo.c"
		PixelTransformationBundle* _tmp2_ = NULL;
		PixelTransformationBundle* _tmp3_ = NULL;
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31439 "Photo.c"
	} else {
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 31445 "Photo.c"
	}
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31451 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = original;
#line 221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = NULL;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 31468 "Photo.c"
	}
#line 224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	clone = _tmp1_;
#line 31474 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeHashMap* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		GeeSet* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_ = NULL;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = original;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_get_keys ((GeeMap*) _tmp2_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_object_it = _tmp7_;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 31501 "Photo.c"
			GeeIterator* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			gchar* object = NULL;
			GeeIterator* _tmp10_ = NULL;
			gpointer _tmp11_ = NULL;
			GeeHashMap* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			GeeHashMap* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gpointer _tmp16_ = NULL;
			KeyValueMap* _tmp17_ = NULL;
			KeyValueMap* _tmp18_ = NULL;
			KeyValueMap* _tmp19_ = NULL;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp9_) {
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 31523 "Photo.c"
			}
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = _object_it;
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			object = (gchar*) _tmp11_;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = clone;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = object;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = original;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = object;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = (KeyValueMap*) _tmp16_;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = key_value_map_copy (_tmp17_);
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp19_);
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp19_);
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp17_);
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_free0 (object);
#line 31555 "Photo.c"
		}
#line 225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31559 "Photo.c"
	}
#line 228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = clone;
#line 228 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 31565 "Photo.c"
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_ = FALSE;
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_transformation_state_is_broken ((PhotoTransformationState*) self);
#line 232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp0_) {
#line 233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_signal_emit_by_name ((PhotoTransformationState*) self, "broken");
#line 31579 "Photo.c"
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31591 "Photo.c"
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 31598 "Photo.c"
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 175 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31626 "Photo.c"
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders* photo_backing_readers_construct (GType object_type) {
	PhotoBackingReaders* self = NULL;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 31648 "Photo.c"
}


static PhotoBackingReaders* photo_backing_readers_new (void) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 31655 "Photo.c"
}


static void photo_value_backing_readers_init (GValue* value) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31662 "Photo.c"
}


static void photo_value_backing_readers_free_value (GValue* value) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 31671 "Photo.c"
	}
}


static void photo_value_backing_readers_copy_value (const GValue* src_value, GValue* dest_value) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 31681 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31685 "Photo.c"
	}
}


static gpointer photo_value_backing_readers_peek_pointer (const GValue* value) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31693 "Photo.c"
}


static gchar* photo_value_backing_readers_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31700 "Photo.c"
		PhotoBackingReaders* object;
		object = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31707 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31711 "Photo.c"
		}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 31715 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31719 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 31723 "Photo.c"
}


static gchar* photo_value_backing_readers_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoBackingReaders** object_p;
	object_p = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31734 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 31740 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31744 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 31748 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 31752 "Photo.c"
}


static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecBackingReaders* spec;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31766 "Photo.c"
}


static gpointer photo_value_get_backing_readers (const GValue* value) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31775 "Photo.c"
}


static void photo_value_set_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 31795 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31799 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31805 "Photo.c"
	}
}


static void photo_value_take_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31824 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31828 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31834 "Photo.c"
	}
}


static void photo_backing_readers_class_init (PhotoBackingReadersClass * klass) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 31844 "Photo.c"
}


static void photo_backing_readers_instance_init (PhotoBackingReaders * self) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 31851 "Photo.c"
}


static void photo_backing_readers_finalize (PhotoBackingReaders* obj) {
	PhotoBackingReaders * self;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 31867 "Photo.c"
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer photo_backing_readers_ref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 31892 "Photo.c"
}


static void photo_backing_readers_unref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 237 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31905 "Photo.c"
	}
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 31916 "Photo.c"
}


static void photo_value_reimport_master_state_init (GValue* value) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31923 "Photo.c"
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 31932 "Photo.c"
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 31942 "Photo.c"
	} else {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31946 "Photo.c"
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31954 "Photo.c"
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31961 "Photo.c"
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31968 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31972 "Photo.c"
		}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 31976 "Photo.c"
	} else {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31980 "Photo.c"
	}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 31984 "Photo.c"
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31995 "Photo.c"
	}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 32001 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32005 "Photo.c"
	} else {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32009 "Photo.c"
	}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 32013 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32027 "Photo.c"
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32036 "Photo.c"
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32056 "Photo.c"
	} else {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32060 "Photo.c"
	}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32066 "Photo.c"
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32085 "Photo.c"
	} else {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32089 "Photo.c"
	}
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32095 "Photo.c"
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 32105 "Photo.c"
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 32112 "Photo.c"
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32122 "Photo.c"
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 32147 "Photo.c"
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32160 "Photo.c"
	}
}


static gchar** _vala_array_dup7 (gchar** self, int length) {
	gchar** result;
	int i;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 32172 "Photo.c"
		gchar* _tmp0_ = NULL;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result[i] = _tmp0_;
#line 32178 "Photo.c"
	}
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 32182 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
#line 1258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 1258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = row;
#line 1259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 1259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->row = _tmp1_;
#line 1260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = alterations;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4__length1 = alterations_length1;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup7 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->alterations = _tmp5_;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->alterations_length1 = _tmp5__length1;
#line 1261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32234 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
#line 1258 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32241 "Photo.c"
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
#line 1252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32250 "Photo.c"
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow* _tmp0_ = NULL;
#line 1253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->row = _tmp0_;
#line 1256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32262 "Photo.c"
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
#line 1252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32278 "Photo.c"
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32300 "Photo.c"
}


static void photo_value_reimport_editable_state_init (GValue* value) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32307 "Photo.c"
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32316 "Photo.c"
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32326 "Photo.c"
	} else {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32330 "Photo.c"
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32338 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32345 "Photo.c"
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32352 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32356 "Photo.c"
		}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32360 "Photo.c"
	} else {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32364 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 32368 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32379 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 32385 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32389 "Photo.c"
	} else {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32393 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 32397 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32411 "Photo.c"
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32420 "Photo.c"
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32440 "Photo.c"
	} else {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32444 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32450 "Photo.c"
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32469 "Photo.c"
	} else {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32473 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32479 "Photo.c"
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 32489 "Photo.c"
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 32496 "Photo.c"
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32506 "Photo.c"
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 32531 "Photo.c"
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1265 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32544 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
#line 1273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 1273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing_state;
#line 1274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->backing_state = _tmp1_;
#line 1275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1275 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32577 "Photo.c"
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
#line 1273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 32584 "Photo.c"
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
#line 1268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 32593 "Photo.c"
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoRow* _tmp0_ = NULL;
#line 1269 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1269 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32605 "Photo.c"
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
#line 1268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1269 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1270 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 32619 "Photo.c"
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type) {
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32641 "Photo.c"
}


static void photo_value_reimport_raw_development_state_init (GValue* value) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32648 "Photo.c"
}


static void photo_value_reimport_raw_development_state_free_value (GValue* value) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 32657 "Photo.c"
	}
}


static void photo_value_reimport_raw_development_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 32667 "Photo.c"
	} else {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32671 "Photo.c"
	}
}


static gpointer photo_value_reimport_raw_development_state_peek_pointer (const GValue* value) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32679 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32686 "Photo.c"
		PhotoReimportRawDevelopmentState* object;
		object = collect_values[0].v_pointer;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32693 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32697 "Photo.c"
		}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 32701 "Photo.c"
	} else {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32705 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 32709 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32720 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 32726 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32730 "Photo.c"
	} else {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32734 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 32738 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32752 "Photo.c"
}


gpointer photo_value_get_reimport_raw_development_state (const GValue* value) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32761 "Photo.c"
}


void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32781 "Photo.c"
	} else {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32785 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32791 "Photo.c"
	}
}


void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32810 "Photo.c"
	} else {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32814 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32820 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 32830 "Photo.c"
}


static void photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 32837 "Photo.c"
}


static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentState * self;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32847 "Photo.c"
}


GType photo_reimport_raw_development_state_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_ref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 32872 "Photo.c"
}


void photo_reimport_raw_development_state_unref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32885 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type) {
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32896 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void) {
#line 1296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 32903 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	GeeCollection* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp3_ = NULL;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp4_ = NULL;
#line 1299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (backing != NULL);
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = backing;
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (_tmp1_, _tmp2_);
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp4_);
#line 1300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp4_);
#line 32931 "Photo.c"
}


static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self) {
	gint result = 0;
	GeeCollection* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 1303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp2_;
#line 1304 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 32952 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
#line 1287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (backing != NULL, NULL);
#line 1287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing;
#line 1288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->backing = _tmp1_;
#line 1289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 32984 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata) {
#line 1287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 32991 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32998 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33007 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33017 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33021 "Photo.c"
	}
}


static gpointer photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33029 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33036 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport* object;
		object = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33043 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33047 "Photo.c"
		}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33051 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33055 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 33059 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentStateImplDevToReimport** object_p;
	object_p = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!object_p) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33070 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = NULL;
#line 33076 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33080 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33084 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return NULL;
#line 33088 "Photo.c"
}


static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33102 "Photo.c"
}


static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33111 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33131 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33135 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33141 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33160 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33164 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33170 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33180 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self) {
	BackingPhotoRow* _tmp0_ = NULL;
#line 1284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->backing = _tmp0_;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->ref_count = 1;
#line 33192 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj) {
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33206 "Photo.c"
}


GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return instance;
#line 33231 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1283 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33244 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass) {
#line 1282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 33254 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self) {
	GeeArrayList* _tmp0_ = NULL;
#line 1293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->list = (GeeCollection*) _tmp0_;
#line 1294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33266 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 33278 "Photo.c"
}


static GType photo_reimport_raw_development_state_impl_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = photo_real_notify_editable_replaced;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = photo_real_notify_raw_development_modified;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = photo_real_notify_baseline_replaced;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = photo_real_notify_master_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = photo_real_notify_editable_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = photo_real_notify_source_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = photo_real_notify_baseline_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = photo_real_internal_delete_backing;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = photo_real_get_backing_files_state;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = photo_real_apply_user_metadata_for_reimport;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = photo_real_get_typename;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = photo_real_get_instance_id;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = photo_real_get_source_id;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = photo_real_get_preferred_thumbnail_format;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = photo_real_create_thumbnail;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = photo_real_get_file;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = photo_real_get_master_file;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = photo_real_get_timestamp;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = photo_real_get_event_id;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = photo_real_get_import_id;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = photo_real_get_master_md5;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = photo_real_commit_backlinks;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = photo_real_set_event_id;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataObjectClass *) klass)->to_string = photo_real_to_string;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->equals = photo_real_equals;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = photo_real_get_filesize;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = photo_real_get_master_filesize;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = photo_real_get_basename;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = photo_real_get_title;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = photo_real_get_comment;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = photo_real_set_title;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = photo_real_set_comment;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = photo_real_get_dimensions;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = photo_real_get_metadata;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->rotate = photo_real_rotate;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = photo_real_get_pixbuf;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = photo_real_has_user_generated_metadata;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = photo_real_set_user_metadata_for_export;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("raw_development_modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 33411 "Photo.c"
}


static void photo_dateable_interface_init (DateableIface * iface) {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->get_exposure_time = (time_t (*)(Dateable*)) photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->set_exposure_time = (void (*)(Dateable*, time_t)) photo_real_set_exposure_time;
#line 33422 "Photo.c"
}


static void photo_instance_init (Photo * self) {
	BackingPhotoRow* _tmp0_ = NULL;
	PhotoBackingReaders* _tmp1_ = NULL;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->transformer = NULL;
#line 249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->file_title = NULL;
#line 252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 257 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->developments = NULL;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 33471 "Photo.c"
}


static void photo_finalize (GObject* obj) {
	Photo * self;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 248 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 252 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 33517 "Photo.c"
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (property_id) {
#line 33540 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		break;
#line 33546 "Photo.c"
	}
}


static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	switch (property_id) {
#line 33556 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		break;
#line 33562 "Photo.c"
	}
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint _file_hash_gee_hash_data_func (gconstpointer v, gpointer self) {
	guint result;
	result = file_hash ((GFile*) v);
#line 4366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33584 "Photo.c"
}


static gboolean _file_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33593 "Photo.c"
}


static gint _int64_compare_gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33602 "Photo.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return dup;
#line 33614 "Photo.c"
}


static gboolean _int64_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33623 "Photo.c"
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
#line 4392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33632 "Photo.c"
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33639 "Photo.c"
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33646 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
#line 4392 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp1_, "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp3_, "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 33676 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
#line 4391 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 33683 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33692 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_ = NULL;
#line 4398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4399 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33708 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33717 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_ = NULL;
#line 4402 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4403 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33733 "Photo.c"
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	Workers* _tmp0_ = NULL;
	GCancellable* _tmp1_ = NULL;
	PhotoMonitor* _tmp2_ = NULL;
#line 4406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (workers != NULL, NULL);
#line 4406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 4407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = workers;
#line 4407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = cancellable;
#line 4407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_monitor_new (_tmp0_, _tmp1_);
#line 4407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (MediaMonitor*) _tmp2_;
#line 4407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33759 "Photo.c"
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
#line 4410 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4410 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source;
#line 4411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO);
#line 4411 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33777 "Photo.c"
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 4414 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 4415 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33793 "Photo.c"
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4418 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4418 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 4419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_file_format_is_file_supported (_tmp0_);
#line 4419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 4419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 33814 "Photo.c"
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 4431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 33821 "Photo.c"
}


static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 4437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 33828 "Photo.c"
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	GeeIterable* _tmp0_ = NULL;
	GeeIterable* _tmp75_ = NULL;
	GeeIterable* _tmp153_ = NULL;
	GeeIterable* _tmp154_ = NULL;
#line 4422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4424 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = added;
#line 4424 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 33844 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterable* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = added;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_object_it = _tmp2_;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 33857 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				DataObject* object = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp7_ = NULL;
				LibraryPhoto* _tmp8_ = NULL;
				GFile* editable = NULL;
				LibraryPhoto* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				LibraryPhoto* _tmp15_ = NULL;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp16_ = NULL;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* _tmp18_ = NULL;
				LibraryPhoto* _tmp28_ = NULL;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp29_ = NULL;
				BackingPhotoRow* _tmp30_ = NULL;
				BackingPhotoRow* _tmp31_ = NULL;
				gint64 _tmp32_ = 0LL;
				gint64 _tmp33_ = 0LL;
				gint64 _tmp34_ = 0LL;
				LibraryPhoto* _tmp35_ = NULL;
				BackingPhotoRow* _tmp36_ = NULL;
				BackingPhotoRow* _tmp37_ = NULL;
				gboolean _tmp38_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp43_ = NULL;
				gint64 _tmp44_ = 0LL;
				LibraryPhoto* _tmp45_ = NULL;
				GeeHashMap* _tmp46_ = NULL;
				LibraryPhoto* _tmp47_ = NULL;
				gint64 _tmp48_ = 0LL;
				gint64 _tmp49_ = 0LL;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp56_ = NULL;
				GeeCollection* _tmp57_ = NULL;
				GeeCollection* _tmp58_ = NULL;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = _object_it;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp4_) {
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 33907 "Photo.c"
				}
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _object_it;
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				object = (DataObject*) _tmp6_;
#line 4426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = object;
#line 4426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4426 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp8_;
#line 4428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo;
#line 4428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 4428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable = _tmp10_;
#line 4429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = editable;
#line 4429 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 33931 "Photo.c"
					GeeHashMap* _tmp12_ = NULL;
					GFile* _tmp13_ = NULL;
					LibraryPhoto* _tmp14_ = NULL;
#line 4430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = self->priv->by_editable_file;
#line 4430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_ = editable;
#line 4430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = photo;
#line 4430 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp14_);
#line 33943 "Photo.c"
				}
#line 4431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = photo;
#line 4431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp15_, "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = photo;
#line 4433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = photo_get_raw_developer_files ((Photo*) _tmp16_);
#line 4433 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				raw_list = _tmp17_;
#line 4434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = raw_list;
#line 4434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp18_ != NULL) {
#line 33959 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp19_ = NULL;
						GeeIterator* _tmp20_ = NULL;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp19_ = raw_list;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_f_it = _tmp20_;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 33972 "Photo.c"
							GeeIterator* _tmp21_ = NULL;
							gboolean _tmp22_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp23_ = NULL;
							gpointer _tmp24_ = NULL;
							GeeHashMap* _tmp25_ = NULL;
							GFile* _tmp26_ = NULL;
							LibraryPhoto* _tmp27_ = NULL;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp21_ = _f_it;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp22_ = gee_iterator_next (_tmp21_);
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp22_) {
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 33989 "Photo.c"
							}
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp23_ = _f_it;
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp24_ = gee_iterator_get (_tmp23_);
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							f = (GFile*) _tmp24_;
#line 4436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp25_ = self->priv->by_raw_development_file;
#line 4436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp26_ = f;
#line 4436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp27_ = photo;
#line 4436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp27_);
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 34007 "Photo.c"
						}
#line 4435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34011 "Photo.c"
					}
				}
#line 4437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = photo;
#line 4437 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp28_, "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = photo;
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = photo_get_master_photo_row ((Photo*) _tmp29_);
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = _tmp31_->filesize;
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp31_);
#line 4439 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				master_filesize = _tmp33_;
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = photo;
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = photo_get_editable_photo_row ((Photo*) _tmp35_);
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = _tmp37_ != NULL;
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp37_);
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp38_) {
#line 34044 "Photo.c"
					LibraryPhoto* _tmp39_ = NULL;
					BackingPhotoRow* _tmp40_ = NULL;
					BackingPhotoRow* _tmp41_ = NULL;
					gint64 _tmp42_ = 0LL;
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp39_ = photo;
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp40_ = photo_get_editable_photo_row ((Photo*) _tmp39_);
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp42_ = _tmp41_->filesize;
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp34_ = _tmp42_;
#line 4441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp41_);
#line 34061 "Photo.c"
				} else {
#line 4442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp34_ = (gint64) -1;
#line 34065 "Photo.c"
				}
#line 4440 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_filesize = _tmp34_;
#line 4443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = self->priv->filesize_to_photo;
#line 4443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = master_filesize;
#line 4443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = photo;
#line 4443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_set (_tmp43_, &_tmp44_, _tmp45_);
#line 4444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = self->priv->photo_to_master_filesize;
#line 4444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = photo;
#line 4444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = master_filesize;
#line 4444 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp46_, _tmp47_, &_tmp48_);
#line 4445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp49_ = editable_filesize;
#line 4445 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp49_ >= ((gint64) 0)) {
#line 34089 "Photo.c"
					GeeMultiMap* _tmp50_ = NULL;
					gint64 _tmp51_ = 0LL;
					LibraryPhoto* _tmp52_ = NULL;
					GeeHashMap* _tmp53_ = NULL;
					LibraryPhoto* _tmp54_ = NULL;
					gint64 _tmp55_ = 0LL;
#line 4446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp50_ = self->priv->filesize_to_photo;
#line 4446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp51_ = editable_filesize;
#line 4446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp52_ = photo;
#line 4446 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_set (_tmp50_, &_tmp51_, _tmp52_);
#line 4447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp53_ = self->priv->photo_to_editable_filesize;
#line 4447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp54_ = photo;
#line 4447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp55_ = editable_filesize;
#line 4447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, _tmp54_, &_tmp55_);
#line 34112 "Photo.c"
				}
#line 4450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp56_ = photo;
#line 4450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp57_ = photo_get_raw_development_photo_rows ((Photo*) _tmp56_);
#line 4450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				raw_rows = _tmp57_;
#line 4451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58_ = raw_rows;
#line 4451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp58_ != NULL) {
#line 34124 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp59_ = NULL;
						GeeIterator* _tmp60_ = NULL;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp59_ = raw_rows;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp60_ = gee_iterable_iterator ((GeeIterable*) _tmp59_);
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_row_it = _tmp60_;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 34137 "Photo.c"
							GeeIterator* _tmp61_ = NULL;
							gboolean _tmp62_ = FALSE;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp63_ = NULL;
							gpointer _tmp64_ = NULL;
							BackingPhotoRow* _tmp65_ = NULL;
							gint64 _tmp66_ = 0LL;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp61_ = _row_it;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp62_ = gee_iterator_next (_tmp61_);
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp62_) {
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 34153 "Photo.c"
							}
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp63_ = _row_it;
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp64_ = gee_iterator_get (_tmp63_);
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp64_;
#line 4453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp65_ = row;
#line 4453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp66_ = _tmp65_->filesize;
#line 4453 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (_tmp66_ >= ((gint64) 0)) {
#line 34167 "Photo.c"
								GeeMultiMap* _tmp67_ = NULL;
								BackingPhotoRow* _tmp68_ = NULL;
								gint64 _tmp69_ = 0LL;
								LibraryPhoto* _tmp70_ = NULL;
								GeeMultiMap* _tmp71_ = NULL;
								LibraryPhoto* _tmp72_ = NULL;
								BackingPhotoRow* _tmp73_ = NULL;
								gint64 _tmp74_ = 0LL;
#line 4454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp67_ = self->priv->filesize_to_photo;
#line 4454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp68_ = row;
#line 4454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp69_ = _tmp68_->filesize;
#line 4454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp70_ = photo;
#line 4454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								gee_multi_map_set (_tmp67_, &_tmp69_, _tmp70_);
#line 4455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp71_ = self->priv->photo_to_raw_development_filesize;
#line 4455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp72_ = photo;
#line 4455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp73_ = row;
#line 4455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp74_ = _tmp73_->filesize;
#line 4455 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								gee_multi_map_set (_tmp71_, _tmp72_, &_tmp74_);
#line 34196 "Photo.c"
							}
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34200 "Photo.c"
						}
#line 4452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34204 "Photo.c"
					}
				}
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 34217 "Photo.c"
			}
#line 4425 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34221 "Photo.c"
		}
	}
#line 4462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp75_ = removed;
#line 4462 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp75_ != NULL) {
#line 34228 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterable* _tmp76_ = NULL;
			GeeIterator* _tmp77_ = NULL;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp76_ = removed;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp77_ = gee_iterable_iterator (_tmp76_);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_object_it = _tmp77_;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 34241 "Photo.c"
				GeeIterator* _tmp78_ = NULL;
				gboolean _tmp79_ = FALSE;
				DataObject* object = NULL;
				GeeIterator* _tmp80_ = NULL;
				gpointer _tmp81_ = NULL;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp82_ = NULL;
				LibraryPhoto* _tmp83_ = NULL;
				GFile* editable = NULL;
				LibraryPhoto* _tmp84_ = NULL;
				GFile* _tmp85_ = NULL;
				GFile* _tmp86_ = NULL;
				LibraryPhoto* _tmp94_ = NULL;
				guint _tmp95_ = 0U;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp96_ = NULL;
				GeeCollection* _tmp97_ = NULL;
				GeeCollection* _tmp98_ = NULL;
				LibraryPhoto* _tmp107_ = NULL;
				guint _tmp108_ = 0U;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp109_ = NULL;
				BackingPhotoRow* _tmp110_ = NULL;
				BackingPhotoRow* _tmp111_ = NULL;
				gint64 _tmp112_ = 0LL;
				gint64 _tmp113_ = 0LL;
				gint64 _tmp114_ = 0LL;
				LibraryPhoto* _tmp115_ = NULL;
				BackingPhotoRow* _tmp116_ = NULL;
				BackingPhotoRow* _tmp117_ = NULL;
				gboolean _tmp118_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp123_ = NULL;
				gint64 _tmp124_ = 0LL;
				LibraryPhoto* _tmp125_ = NULL;
				GeeHashMap* _tmp126_ = NULL;
				LibraryPhoto* _tmp127_ = NULL;
				gint64 _tmp128_ = 0LL;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp134_ = NULL;
				GeeCollection* _tmp135_ = NULL;
				GeeCollection* _tmp136_ = NULL;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp78_ = _object_it;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp79_ = gee_iterator_next (_tmp78_);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp79_) {
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 34292 "Photo.c"
				}
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp80_ = _object_it;
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp81_ = gee_iterator_get (_tmp80_);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				object = (DataObject*) _tmp81_;
#line 4464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp82_ = object;
#line 4464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp83_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp83_;
#line 4466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp84_ = photo;
#line 4466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp85_ = photo_get_editable_file ((Photo*) _tmp84_);
#line 4466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable = _tmp85_;
#line 4467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp86_ = editable;
#line 4467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp86_ != NULL) {
#line 34316 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp87_ = NULL;
					LibraryPhoto* _tmp88_ = NULL;
					GFile* _tmp89_ = NULL;
					GFile* _tmp90_ = NULL;
					gboolean _tmp91_ = FALSE;
					gboolean _tmp92_ = FALSE;
					gboolean _tmp93_ = FALSE;
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp87_ = self->priv->by_editable_file;
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp88_ = photo;
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp89_ = photo_get_editable_file ((Photo*) _tmp88_);
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp90_ = _tmp89_;
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp91_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp87_, _tmp90_, NULL);
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp92_ = _tmp91_;
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp90_);
#line 4468 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					is_removed = _tmp92_;
#line 4469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp93_ = is_removed;
#line 4469 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_vala_assert (_tmp93_, "is_removed");
#line 34345 "Photo.c"
				}
#line 4471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp94_ = photo;
#line 4471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp95_, NULL, FALSE);
#line 4471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp94_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp95_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp96_ = photo;
#line 4473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp97_ = photo_get_raw_developer_files ((Photo*) _tmp96_);
#line 4473 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				raw_list = _tmp97_;
#line 4474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp98_ = raw_list;
#line 4474 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp98_ != NULL) {
#line 34363 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp99_ = NULL;
						GeeIterator* _tmp100_ = NULL;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp99_ = raw_list;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp100_ = gee_iterable_iterator ((GeeIterable*) _tmp99_);
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_f_it = _tmp100_;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 34376 "Photo.c"
							GeeIterator* _tmp101_ = NULL;
							gboolean _tmp102_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp103_ = NULL;
							gpointer _tmp104_ = NULL;
							GeeHashMap* _tmp105_ = NULL;
							GFile* _tmp106_ = NULL;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp101_ = _f_it;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp102_ = gee_iterator_next (_tmp101_);
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp102_) {
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 34392 "Photo.c"
							}
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp103_ = _f_it;
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp104_ = gee_iterator_get (_tmp103_);
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							f = (GFile*) _tmp104_;
#line 4476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp105_ = self->priv->by_raw_development_file;
#line 4476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp106_ = f;
#line 4476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_abstract_map_unset ((GeeAbstractMap*) _tmp105_, _tmp106_, NULL);
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 34408 "Photo.c"
						}
#line 4475 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34412 "Photo.c"
					}
				}
#line 4477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp107_ = photo;
#line 4477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp108_, NULL, FALSE);
#line 4477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp107_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp108_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp109_ = photo;
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp110_ = photo_get_master_photo_row ((Photo*) _tmp109_);
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp111_ = _tmp110_;
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp112_ = _tmp111_->filesize;
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp113_ = _tmp112_;
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp111_);
#line 4479 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				master_filesize = _tmp113_;
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp115_ = photo;
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp116_ = photo_get_editable_photo_row ((Photo*) _tmp115_);
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp117_ = _tmp116_;
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp118_ = _tmp117_ != NULL;
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp117_);
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp118_) {
#line 34447 "Photo.c"
					LibraryPhoto* _tmp119_ = NULL;
					BackingPhotoRow* _tmp120_ = NULL;
					BackingPhotoRow* _tmp121_ = NULL;
					gint64 _tmp122_ = 0LL;
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp119_ = photo;
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp120_ = photo_get_editable_photo_row ((Photo*) _tmp119_);
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp121_ = _tmp120_;
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp122_ = _tmp121_->filesize;
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp114_ = _tmp122_;
#line 4481 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp121_);
#line 34464 "Photo.c"
				} else {
#line 4482 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp114_ = (gint64) -1;
#line 34468 "Photo.c"
				}
#line 4480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_filesize = _tmp114_;
#line 4483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp123_ = self->priv->filesize_to_photo;
#line 4483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp124_ = master_filesize;
#line 4483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp125_ = photo;
#line 4483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_remove (_tmp123_, &_tmp124_, _tmp125_);
#line 4484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp126_ = self->priv->photo_to_master_filesize;
#line 4484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp127_ = photo;
#line 4484 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp126_, _tmp127_, NULL);
#line 4485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp128_ = editable_filesize;
#line 4485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp128_ >= ((gint64) 0)) {
#line 34490 "Photo.c"
					GeeMultiMap* _tmp129_ = NULL;
					gint64 _tmp130_ = 0LL;
					LibraryPhoto* _tmp131_ = NULL;
					GeeHashMap* _tmp132_ = NULL;
					LibraryPhoto* _tmp133_ = NULL;
#line 4486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp129_ = self->priv->filesize_to_photo;
#line 4486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp130_ = editable_filesize;
#line 4486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp131_ = photo;
#line 4486 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_remove (_tmp129_, &_tmp130_, _tmp131_);
#line 4487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp132_ = self->priv->photo_to_editable_filesize;
#line 4487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp133_ = photo;
#line 4487 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp132_, _tmp133_, NULL);
#line 34510 "Photo.c"
				}
#line 4490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp134_ = photo;
#line 4490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp135_ = photo_get_raw_development_photo_rows ((Photo*) _tmp134_);
#line 4490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				raw_rows = _tmp135_;
#line 4491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp136_ = raw_rows;
#line 4491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp136_ != NULL) {
#line 34522 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp137_ = NULL;
						GeeIterator* _tmp138_ = NULL;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp137_ = raw_rows;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp138_ = gee_iterable_iterator ((GeeIterable*) _tmp137_);
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_row_it = _tmp138_;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 34535 "Photo.c"
							GeeIterator* _tmp139_ = NULL;
							gboolean _tmp140_ = FALSE;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp141_ = NULL;
							gpointer _tmp142_ = NULL;
							BackingPhotoRow* _tmp143_ = NULL;
							gint64 _tmp144_ = 0LL;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp139_ = _row_it;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp140_ = gee_iterator_next (_tmp139_);
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp140_) {
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 34551 "Photo.c"
							}
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp141_ = _row_it;
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp142_ = gee_iterator_get (_tmp141_);
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp142_;
#line 4493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp143_ = row;
#line 4493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp144_ = _tmp143_->filesize;
#line 4493 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (_tmp144_ >= ((gint64) 0)) {
#line 34565 "Photo.c"
								GeeMultiMap* _tmp145_ = NULL;
								BackingPhotoRow* _tmp146_ = NULL;
								gint64 _tmp147_ = 0LL;
								LibraryPhoto* _tmp148_ = NULL;
								GeeMultiMap* _tmp149_ = NULL;
								LibraryPhoto* _tmp150_ = NULL;
								BackingPhotoRow* _tmp151_ = NULL;
								gint64 _tmp152_ = 0LL;
#line 4494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp145_ = self->priv->filesize_to_photo;
#line 4494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp146_ = row;
#line 4494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp147_ = _tmp146_->filesize;
#line 4494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp148_ = photo;
#line 4494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								gee_multi_map_remove (_tmp145_, &_tmp147_, _tmp148_);
#line 4495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp149_ = self->priv->photo_to_raw_development_filesize;
#line 4495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp150_ = photo;
#line 4495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp151_ = row;
#line 4495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								_tmp152_ = _tmp151_->filesize;
#line 4495 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								gee_multi_map_remove (_tmp149_, _tmp150_, &_tmp152_);
#line 34594 "Photo.c"
							}
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34598 "Photo.c"
						}
#line 4492 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34602 "Photo.c"
					}
				}
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 34615 "Photo.c"
			}
#line 4463 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34619 "Photo.c"
		}
	}
#line 4502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp153_ = added;
#line 4502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp154_ = removed;
#line 4502 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp153_, _tmp154_);
#line 34628 "Photo.c"
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp5_ = NULL;
#line 4505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 4506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 34643 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 4507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = old_file;
#line 4507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp2_, NULL);
#line 4507 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		is_removed = _tmp3_;
#line 4508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = is_removed;
#line 4508 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_assert (_tmp4_, "is_removed");
#line 34661 "Photo.c"
	}
#line 4511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = new_file;
#line 4511 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 34667 "Photo.c"
		GeeHashMap* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		Photo* _tmp8_ = NULL;
#line 4512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = self->priv->by_editable_file;
#line 4512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = new_file;
#line 4512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = photo;
#line 4512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 34679 "Photo.c"
	}
}


static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GeeMultiMap* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp23_ = NULL;
	GeeCollection* _tmp24_ = NULL;
	GeeCollection* _tmp25_ = NULL;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp35_ = NULL;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* _tmp37_ = NULL;
#line 4515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 4516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 4516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 4516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp1_;
#line 4517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo;
#line 4517 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 4518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4518 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 34718 "Photo.c"
	}
#line 4521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = self->priv->photo_to_raw_development_filesize;
#line 4521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo;
#line 4521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 4521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 34728 "Photo.c"
		GeeMultiMap* _tmp21_ = NULL;
		LibraryPhoto* _tmp22_ = NULL;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_ = NULL;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->priv->photo_to_raw_development_filesize;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = photo;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_s_it = _tmp11_;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 34757 "Photo.c"
				GeeIterator* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				gint64 s = 0LL;
				GeeIterator* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				gint64* _tmp16_ = NULL;
				gint64 _tmp17_ = 0LL;
				GeeMultiMap* _tmp18_ = NULL;
				gint64 _tmp19_ = 0LL;
				LibraryPhoto* _tmp20_ = NULL;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _s_it;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp13_) {
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 34776 "Photo.c"
				}
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = _s_it;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = (gint64*) _tmp15_;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = *_tmp16_;
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp16_);
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				s = _tmp17_;
#line 4523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = self->priv->filesize_to_photo;
#line 4523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = s;
#line 4523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = photo;
#line 4523 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_remove (_tmp18_, &_tmp19_, _tmp20_);
#line 34798 "Photo.c"
			}
#line 4522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 34802 "Photo.c"
		}
#line 4524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = self->priv->photo_to_raw_development_filesize;
#line 4524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp22_ = photo;
#line 4524 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp21_, _tmp22_);
#line 34810 "Photo.c"
	}
#line 4528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = photo;
#line 4528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = photo_get_raw_developer_files ((Photo*) _tmp23_);
#line 4528 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_list = _tmp24_;
#line 4529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = raw_list;
#line 4529 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 34822 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp26_ = NULL;
			GeeIterator* _tmp27_ = NULL;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = raw_list;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_f_it = _tmp27_;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 34835 "Photo.c"
				GeeIterator* _tmp28_ = NULL;
				gboolean _tmp29_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp30_ = NULL;
				gpointer _tmp31_ = NULL;
				GeeHashMap* _tmp32_ = NULL;
				GFile* _tmp33_ = NULL;
				LibraryPhoto* _tmp34_ = NULL;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = _f_it;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = gee_iterator_next (_tmp28_);
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp29_) {
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 34852 "Photo.c"
				}
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = _f_it;
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = gee_iterator_get (_tmp30_);
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				f = (GFile*) _tmp31_;
#line 4531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = self->priv->by_raw_development_file;
#line 4531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = f;
#line 4531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = photo;
#line 4531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp33_, _tmp34_);
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 34870 "Photo.c"
			}
#line 4530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 34874 "Photo.c"
		}
	}
#line 4533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = photo;
#line 4533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = photo_get_raw_development_photo_rows ((Photo*) _tmp35_);
#line 4533 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_rows = _tmp36_;
#line 4534 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = raw_rows;
#line 4534 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 34887 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp38_ = NULL;
			GeeIterator* _tmp39_ = NULL;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp38_ = raw_rows;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_row_it = _tmp39_;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 34900 "Photo.c"
				GeeIterator* _tmp40_ = NULL;
				gboolean _tmp41_ = FALSE;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp42_ = NULL;
				gpointer _tmp43_ = NULL;
				BackingPhotoRow* _tmp44_ = NULL;
				gint64 _tmp45_ = 0LL;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp40_ = _row_it;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp41_ = gee_iterator_next (_tmp40_);
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp41_) {
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 34916 "Photo.c"
				}
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp42_ = _row_it;
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = gee_iterator_get (_tmp42_);
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp43_;
#line 4536 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = row;
#line 4536 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = _tmp44_->filesize;
#line 4536 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp45_ > ((gint64) 0)) {
#line 34930 "Photo.c"
					GeeMultiMap* _tmp46_ = NULL;
					BackingPhotoRow* _tmp47_ = NULL;
					gint64 _tmp48_ = 0LL;
					LibraryPhoto* _tmp49_ = NULL;
					GeeMultiMap* _tmp50_ = NULL;
					LibraryPhoto* _tmp51_ = NULL;
					BackingPhotoRow* _tmp52_ = NULL;
					gint64 _tmp53_ = 0LL;
#line 4537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp47_ = row;
#line 4537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp49_ = photo;
#line 4537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp48_, _tmp49_);
#line 4538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp50_ = self->priv->photo_to_raw_development_filesize;
#line 4538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp51_ = photo;
#line 4538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp52_ = row;
#line 4538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp53_ = _tmp52_->filesize;
#line 4538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_set (_tmp50_, _tmp51_, &_tmp53_);
#line 34959 "Photo.c"
				}
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 34963 "Photo.c"
			}
#line 4535 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 34967 "Photo.c"
		}
	}
#line 4515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4515 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 34976 "Photo.c"
}


static gpointer __int64_dup0 (gpointer self) {
#line 4554 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 34983 "Photo.c"
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	GeeMap* _tmp72_ = NULL;
#line 4544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (items != NULL);
#line 34994 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = items;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_object_it = _tmp5_;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 35021 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			DataObject* object = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			Alteration* alteration = NULL;
			GeeMap* _tmp10_ = NULL;
			DataObject* _tmp11_ = NULL;
			gpointer _tmp12_ = NULL;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp13_ = NULL;
			LibraryPhoto* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			Alteration* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp7_) {
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 35045 "Photo.c"
			}
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			object = (DataObject*) _tmp9_;
#line 4546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = items;
#line 4546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = object;
#line 4546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 4546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			alteration = (Alteration*) _tmp12_;
#line 4548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = object;
#line 4548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = _tmp14_;
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = alteration;
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = alteration_has_detail (_tmp16_, "image", "master");
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp17_) {
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = TRUE;
#line 35075 "Photo.c"
			} else {
				Alteration* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = alteration;
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = alteration_has_detail (_tmp18_, "image", "editable");
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = _tmp19_;
#line 35085 "Photo.c"
			}
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp15_) {
#line 35089 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp20_ = NULL;
				LibraryPhoto* _tmp21_ = NULL;
				gpointer _tmp22_ = NULL;
				gint64* _tmp23_ = NULL;
				gint64 _tmp24_ = 0LL;
				gint64* _tmp25_ = NULL;
				GeeHashMap* _tmp26_ = NULL;
				LibraryPhoto* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp34_ = NULL;
				LibraryPhoto* _tmp35_ = NULL;
				GeeMultiMap* _tmp36_ = NULL;
				gint64 _tmp37_ = 0LL;
				LibraryPhoto* _tmp38_ = NULL;
				gint64 _tmp39_ = 0LL;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp45_ = NULL;
				BackingPhotoRow* _tmp46_ = NULL;
				BackingPhotoRow* _tmp47_ = NULL;
				gint64 _tmp48_ = 0LL;
				gint64 _tmp49_ = 0LL;
				gint64 _tmp50_ = 0LL;
				LibraryPhoto* _tmp51_ = NULL;
				BackingPhotoRow* _tmp52_ = NULL;
				BackingPhotoRow* _tmp53_ = NULL;
				gboolean _tmp54_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp59_ = NULL;
				LibraryPhoto* _tmp60_ = NULL;
				gint64 _tmp61_ = 0LL;
				GeeMultiMap* _tmp62_ = NULL;
				gint64 _tmp63_ = 0LL;
				LibraryPhoto* _tmp64_ = NULL;
				gint64 _tmp65_ = 0LL;
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = self->priv->photo_to_master_filesize;
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = photo;
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, _tmp21_);
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = (gint64*) _tmp22_;
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = *_tmp23_;
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp23_);
#line 4551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				old_master_filesize = _tmp24_;
#line 4552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = self->priv->photo_to_editable_filesize;
#line 4552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = photo;
#line 4552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp26_, _tmp27_);
#line 4552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp28_) {
#line 35148 "Photo.c"
					GeeHashMap* _tmp29_ = NULL;
					LibraryPhoto* _tmp30_ = NULL;
					gpointer _tmp31_ = NULL;
#line 4553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp29_ = self->priv->photo_to_editable_filesize;
#line 4553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp30_ = photo;
#line 4553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, _tmp30_);
#line 4553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (_tmp25_);
#line 4553 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp25_ = (gint64*) _tmp31_;
#line 35162 "Photo.c"
				} else {
					gint64 _tmp32_ = 0LL;
					gint64* _tmp33_ = NULL;
#line 4554 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp32_ = (gint64) -1;
#line 4554 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp33_ = __int64_dup0 (&_tmp32_);
#line 4554 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (_tmp25_);
#line 4554 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp25_ = _tmp33_;
#line 35174 "Photo.c"
				}
#line 4552 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				old_editable_filesize = *_tmp25_;
#line 4556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = self->priv->photo_to_master_filesize;
#line 4556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = photo;
#line 4556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp34_, _tmp35_, NULL);
#line 4557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = self->priv->filesize_to_photo;
#line 4557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = old_master_filesize;
#line 4557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = photo;
#line 4557 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_remove (_tmp36_, &_tmp37_, _tmp38_);
#line 4558 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = old_editable_filesize;
#line 4558 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp39_ >= ((gint64) 0)) {
#line 35196 "Photo.c"
					GeeHashMap* _tmp40_ = NULL;
					LibraryPhoto* _tmp41_ = NULL;
					GeeMultiMap* _tmp42_ = NULL;
					gint64 _tmp43_ = 0LL;
					LibraryPhoto* _tmp44_ = NULL;
#line 4559 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp40_ = self->priv->photo_to_editable_filesize;
#line 4559 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp41_ = photo;
#line 4559 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp40_, _tmp41_, NULL);
#line 4560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp42_ = self->priv->filesize_to_photo;
#line 4560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp43_ = old_editable_filesize;
#line 4560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp44_ = photo;
#line 4560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_remove (_tmp42_, &_tmp43_, _tmp44_);
#line 35216 "Photo.c"
				}
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = photo;
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = photo_get_master_photo_row ((Photo*) _tmp45_);
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = _tmp47_->filesize;
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp47_);
#line 4563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				master_filesize = _tmp49_;
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp51_ = photo;
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp52_ = photo_get_editable_photo_row ((Photo*) _tmp51_);
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp53_ = _tmp52_;
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp54_ = _tmp53_ != NULL;
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp53_);
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp54_) {
#line 35244 "Photo.c"
					LibraryPhoto* _tmp55_ = NULL;
					BackingPhotoRow* _tmp56_ = NULL;
					BackingPhotoRow* _tmp57_ = NULL;
					gint64 _tmp58_ = 0LL;
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp55_ = photo;
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp56_ = photo_get_editable_photo_row ((Photo*) _tmp55_);
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp57_ = _tmp56_;
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp58_ = _tmp57_->filesize;
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp50_ = _tmp58_;
#line 4565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp57_);
#line 35261 "Photo.c"
				} else {
#line 4566 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp50_ = (gint64) -1;
#line 35265 "Photo.c"
				}
#line 4564 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				editable_filesize = _tmp50_;
#line 4567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp59_ = self->priv->photo_to_master_filesize;
#line 4567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp60_ = photo;
#line 4567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp61_ = master_filesize;
#line 4567 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp59_, _tmp60_, &_tmp61_);
#line 4568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp62_ = self->priv->filesize_to_photo;
#line 4568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp63_ = master_filesize;
#line 4568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp64_ = photo;
#line 4568 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_set (_tmp62_, &_tmp63_, _tmp64_);
#line 4569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp65_ = editable_filesize;
#line 4569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp65_ >= ((gint64) 0)) {
#line 35289 "Photo.c"
					GeeHashMap* _tmp66_ = NULL;
					LibraryPhoto* _tmp67_ = NULL;
					gint64 _tmp68_ = 0LL;
					GeeMultiMap* _tmp69_ = NULL;
					gint64 _tmp70_ = 0LL;
					LibraryPhoto* _tmp71_ = NULL;
#line 4570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp66_ = self->priv->photo_to_editable_filesize;
#line 4570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp67_ = photo;
#line 4570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp68_ = editable_filesize;
#line 4570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp66_, _tmp67_, &_tmp68_);
#line 4571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp69_ = self->priv->filesize_to_photo;
#line 4571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp70_ = editable_filesize;
#line 4571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp71_ = photo;
#line 4571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_set (_tmp69_, &_tmp70_, _tmp71_);
#line 35312 "Photo.c"
				}
#line 4550 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp25_);
#line 35316 "Photo.c"
			}
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (object);
#line 35324 "Photo.c"
		}
#line 4545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35328 "Photo.c"
	}
#line 4576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp72_ = items;
#line 4576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp72_);
#line 35334 "Photo.c"
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeCollection* _tmp97_ = NULL;
#line 4580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (media_sources != NULL);
#line 4581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4581 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	map = _tmp0_;
#line 35351 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = media_sources;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_it = _tmp2_;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 35364 "Photo.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp7_ = NULL;
			LibraryPhoto* _tmp8_ = NULL;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp9_ = NULL;
			PhotoMetadata* _tmp10_ = NULL;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp11_ = NULL;
			HierarchicalTagIndex* htag_index = NULL;
			PhotoMetadata* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp18_ = NULL;
			GeeCollection* _tmp19_ = NULL;
			GeeCollection* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			PhotoMetadata* _tmp55_ = NULL;
			gboolean _tmp56_ = FALSE;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp4_) {
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 35395 "Photo.c"
			}
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _media_it;
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media = (MediaSource*) _tmp6_;
#line 4583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = media;
#line 4583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = _tmp8_;
#line 4584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = photo;
#line 4584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = photo_source_get_metadata ((PhotoSource*) _tmp9_);
#line 4584 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			metadata = _tmp10_;
#line 4587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = hierarchical_tag_index_get_global_index ();
#line 4587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			global_index = _tmp11_;
#line 4594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			htag_index = NULL;
#line 4595 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = metadata;
#line 4595 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 4595 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp13_) {
#line 35427 "Photo.c"
				PhotoMetadata* _tmp14_ = NULL;
				GeeSet* _tmp15_ = NULL;
				GeeSet* _tmp16_ = NULL;
				HierarchicalTagIndex* _tmp17_ = NULL;
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = metadata;
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = photo_metadata_get_hierarchical_keywords (_tmp14_);
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp16_);
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				htag_index = _tmp17_;
#line 4596 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp16_);
#line 35446 "Photo.c"
			}
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = photo;
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = library_photo_get_import_keywords (_tmp18_);
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = _tmp20_ != NULL;
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp20_);
#line 4600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp21_) {
#line 35460 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp22_ = NULL;
					GeeCollection* _tmp23_ = NULL;
					GeeCollection* _tmp24_ = NULL;
					GeeIterator* _tmp25_ = NULL;
					GeeIterator* _tmp26_ = NULL;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp22_ = photo;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp23_ = library_photo_get_import_keywords (_tmp22_);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp25_ = gee_iterable_iterator ((GeeIterable*) _tmp24_);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp26_ = _tmp25_;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp24_);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_keyword_it = _tmp26_;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					while (TRUE) {
#line 35484 "Photo.c"
						GeeIterator* _tmp27_ = NULL;
						gboolean _tmp28_ = FALSE;
						gchar* keyword = NULL;
						GeeIterator* _tmp29_ = NULL;
						gpointer _tmp30_ = NULL;
						gboolean _tmp31_ = FALSE;
						HierarchicalTagIndex* _tmp32_ = NULL;
						gchar* name = NULL;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
						HierarchicalTagIndex* _tmp38_ = NULL;
						const gchar* _tmp39_ = NULL;
						gboolean _tmp40_ = FALSE;
						const gchar* _tmp49_ = NULL;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp28_ = gee_iterator_next (_tmp27_);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp28_) {
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							break;
#line 35507 "Photo.c"
						}
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp29_ = _keyword_it;
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						keyword = (gchar*) _tmp30_;
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp32_ = htag_index;
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp32_ != NULL) {
#line 35519 "Photo.c"
							HierarchicalTagIndex* _tmp33_ = NULL;
							const gchar* _tmp34_ = NULL;
							gboolean _tmp35_ = FALSE;
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp33_ = htag_index;
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp34_ = keyword;
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp35_ = hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_);
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp31_ = _tmp35_;
#line 35531 "Photo.c"
						} else {
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp31_ = FALSE;
#line 35535 "Photo.c"
						}
#line 4602 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp31_) {
#line 4603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4603 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							continue;
#line 35543 "Photo.c"
						}
#line 4605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp36_ = keyword;
#line 4605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp37_ = tag_prep_tag_name (_tmp36_);
#line 4605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						name = _tmp37_;
#line 4607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp38_ = global_index;
#line 4607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp39_ = name;
#line 4607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp40_ = hierarchical_tag_index_is_tag_in_index (_tmp38_, _tmp39_);
#line 4607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp40_) {
#line 35559 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp41_ = NULL;
							const gchar* _tmp42_ = NULL;
							gchar* _tmp43_ = NULL;
							GeeHashMultiMap* _tmp44_ = NULL;
							const gchar* _tmp45_ = NULL;
							Tag* _tmp46_ = NULL;
							Tag* _tmp47_ = NULL;
							LibraryPhoto* _tmp48_ = NULL;
#line 4608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp41_ = global_index;
#line 4608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp42_ = name;
#line 4608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp43_ = hierarchical_tag_index_get_path_for_name (_tmp41_, _tmp42_);
#line 4608 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							most_derived_path = _tmp43_;
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp44_ = map;
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp45_ = most_derived_path;
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp46_ = tag_for_path (_tmp45_);
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp47_ = _tmp46_;
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp48_ = photo;
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp44_, _tmp47_, _tmp48_);
#line 4609 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp47_);
#line 4610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (name);
#line 4610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4610 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							continue;
#line 35599 "Photo.c"
						}
#line 4613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp49_ = name;
#line 4613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp49_ != NULL) {
#line 35605 "Photo.c"
							GeeHashMultiMap* _tmp50_ = NULL;
							const gchar* _tmp51_ = NULL;
							Tag* _tmp52_ = NULL;
							Tag* _tmp53_ = NULL;
							LibraryPhoto* _tmp54_ = NULL;
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp50_ = map;
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp51_ = name;
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp52_ = tag_for_path (_tmp51_);
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp53_ = _tmp52_;
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp54_ = photo;
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp50_, _tmp53_, _tmp54_);
#line 4614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp53_);
#line 35625 "Photo.c"
						}
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_free0 (name);
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_free0 (keyword);
#line 35631 "Photo.c"
					}
#line 4601 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 35635 "Photo.c"
				}
			}
#line 4618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp55_ = metadata;
#line 4618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp56_ = photo_metadata_has_hierarchical_keywords (_tmp55_);
#line 4618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp56_) {
#line 35644 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp57_ = NULL;
					GeeCollection* _tmp58_ = NULL;
					GeeCollection* _tmp59_ = NULL;
					GeeIterator* _tmp60_ = NULL;
					GeeIterator* _tmp61_ = NULL;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp57_ = htag_index;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp58_ = hierarchical_tag_index_get_all_paths (_tmp57_);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp60_ = gee_iterable_iterator ((GeeIterable*) _tmp59_);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp61_ = _tmp60_;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp59_);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_path_it = _tmp61_;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					while (TRUE) {
#line 35668 "Photo.c"
						GeeIterator* _tmp62_ = NULL;
						gboolean _tmp63_ = FALSE;
						gchar* path = NULL;
						GeeIterator* _tmp64_ = NULL;
						gpointer _tmp65_ = NULL;
						gchar* name = NULL;
						const gchar* _tmp66_ = NULL;
						gchar* _tmp67_ = NULL;
						const gchar* _tmp68_ = NULL;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp62_ = _path_it;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp63_ = gee_iterator_next (_tmp62_);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp63_) {
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							break;
#line 35686 "Photo.c"
						}
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp64_ = _path_it;
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp65_ = gee_iterator_get (_tmp64_);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						path = (gchar*) _tmp65_;
#line 4620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp66_ = path;
#line 4620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp67_ = tag_prep_tag_name (_tmp66_);
#line 4620 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						name = _tmp67_;
#line 4621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp68_ = name;
#line 4621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (_tmp68_ != NULL) {
#line 35704 "Photo.c"
							GeeHashMultiMap* _tmp69_ = NULL;
							const gchar* _tmp70_ = NULL;
							Tag* _tmp71_ = NULL;
							Tag* _tmp72_ = NULL;
							LibraryPhoto* _tmp73_ = NULL;
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp69_ = map;
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp70_ = name;
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp71_ = tag_for_path (_tmp70_);
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp72_ = _tmp71_;
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp73_ = photo;
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp69_, _tmp72_, _tmp73_);
#line 4622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (_tmp72_);
#line 35724 "Photo.c"
						}
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_free0 (name);
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_free0 (path);
#line 35730 "Photo.c"
					}
#line 4619 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 35734 "Photo.c"
				}
			}
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 35747 "Photo.c"
		}
#line 4582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35751 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp74_ = NULL;
		GeeIterator* _tmp75_ = NULL;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp74_ = media_sources;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp75_ = gee_iterable_iterator ((GeeIterable*) _tmp74_);
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_it = _tmp75_;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 35765 "Photo.c"
			GeeIterator* _tmp76_ = NULL;
			gboolean _tmp77_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp78_ = NULL;
			gpointer _tmp79_ = NULL;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp80_ = NULL;
			LibraryPhoto* _tmp81_ = NULL;
			LibraryPhoto* _tmp82_ = NULL;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp76_ = _media_it;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp77_ = gee_iterator_next (_tmp76_);
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp77_) {
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 35783 "Photo.c"
			}
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp78_ = _media_it;
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp79_ = gee_iterator_get (_tmp78_);
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media = (MediaSource*) _tmp79_;
#line 4628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp80_ = media;
#line 4628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp81_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = _tmp81_;
#line 4629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp82_ = photo;
#line 4629 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp82_);
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 35805 "Photo.c"
		}
#line 4627 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35809 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp83_ = NULL;
		GeeSet* _tmp84_ = NULL;
		GeeSet* _tmp85_ = NULL;
		GeeIterator* _tmp86_ = NULL;
		GeeIterator* _tmp87_ = NULL;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp83_ = map;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp84_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp83_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp85_ = _tmp84_;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp86_ = gee_iterable_iterator ((GeeIterable*) _tmp85_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp87_ = _tmp86_;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp85_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tag_it = _tmp87_;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 35834 "Photo.c"
			GeeIterator* _tmp88_ = NULL;
			gboolean _tmp89_ = FALSE;
			Tag* tag = NULL;
			GeeIterator* _tmp90_ = NULL;
			gpointer _tmp91_ = NULL;
			Tag* _tmp92_ = NULL;
			GeeHashMultiMap* _tmp93_ = NULL;
			Tag* _tmp94_ = NULL;
			GeeCollection* _tmp95_ = NULL;
			GeeCollection* _tmp96_ = NULL;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp88_ = _tag_it;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp89_ = gee_iterator_next (_tmp88_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp89_) {
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 35853 "Photo.c"
			}
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp90_ = _tag_it;
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp91_ = gee_iterator_get (_tmp90_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			tag = (Tag*) _tmp91_;
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp92_ = tag;
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp93_ = map;
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp94_ = tag;
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp95_ = gee_multi_map_get ((GeeMultiMap*) _tmp93_, _tmp94_);
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp96_ = _tmp95_;
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			tag_attach_many (_tmp92_, _tmp96_);
#line 4633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp96_);
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (tag);
#line 35877 "Photo.c"
		}
#line 4632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 35881 "Photo.c"
	}
#line 4635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp97_ = media_sources;
#line 4635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp97_);
#line 4580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (map);
#line 35889 "Photo.c"
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4640 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_, _tmp1_);
#line 35904 "Photo.c"
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 35913 "Photo.c"
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_, _tmp1_);
#line 35928 "Photo.c"
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 35937 "Photo.c"
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4650 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_, _tmp1_);
#line 35952 "Photo.c"
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4649 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 35961 "Photo.c"
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4655 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_, _tmp1_);
#line 35976 "Photo.c"
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 35985 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gint64 _tmp0_ = 0LL;
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
#line 4658 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = numeric_id;
#line 4659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id_init (&_tmp1_, _tmp0_);
#line 4659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
#line 4659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (MediaSource*) _tmp2_;
#line 4659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36007 "Photo.c"
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 4662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = added;
#line 4664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = removed;
#line 4664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36022 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4668 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4668 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4668 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source;
#line 4669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = media_source_is_trashed ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 4669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36044 "Photo.c"
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 4672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = added;
#line 4674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = removed;
#line 4674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36059 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source;
#line 4679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = media_source_is_offline ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 4679 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36081 "Photo.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1296 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1296 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 36104 "Photo.c"
		glong _tmp4_ = 0L;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 36112 "Photo.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 36124 "Photo.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1306 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 36148 "Photo.c"
		glong _tmp2_ = 0L;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 36154 "Photo.c"
	} else {
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36158 "Photo.c"
	}
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 36162 "Photo.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 36174 "Photo.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 36184 "Photo.c"
	}
#line 1315 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1315 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 36190 "Photo.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1317 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1317 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 36204 "Photo.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 36214 "Photo.c"
	}
#line 1321 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1321 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 36220 "Photo.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 36229 "Photo.c"
	}
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 36249 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* numeric_only = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gint64 _tmp6_ = 0LL;
	MediaSource* _tmp7_ = NULL;
#line 4682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4682 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = source_id;
#line 4683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, PHOTO_TYPENAME);
#line 4683 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp1_, "source_id.has_prefix (Photo.TYPENAME)");
#line 4684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = source_id;
#line 4684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = strlen (PHOTO_TYPENAME);
#line 4684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = string_substring (_tmp2_, (glong) _tmp4_, (glong) -1);
#line 4684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	numeric_only = _tmp5_;
#line 4686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = parse_int64 (numeric_only, 16);
#line 4686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = media_source_collection_fetch_by_numeric_id ((MediaSourceCollection*) self, _tmp6_);
#line 4686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp7_;
#line 4686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4686 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36295 "Photo.c"
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	EventID _tmp2_ = {0};
	GeeArrayList* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
#line 4689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = (GeeCollection*) _tmp3_;
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 4690 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36327 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
	DataSource* _tmp2_ = NULL;
#line 4693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key ((DatabaseSourceCollection*) self, _tmp1_);
#line 4694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36350 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 4697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 4698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 4698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4698 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36373 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 4701 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4701 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 4702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 4702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4702 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36396 "Photo.c"
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development) {
	LibraryPhoto* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	BackingPhotoRow* editable = NULL;
	LibraryPhoto* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	BackingPhotoRow* _tmp11_ = NULL;
	GeeCollection* development = NULL;
	LibraryPhoto* _tmp17_ = NULL;
	GeeCollection* _tmp18_ = NULL;
	GeeCollection* _tmp19_ = NULL;
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matches_development != NULL);
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_get_master_photo_row ((Photo*) _tmp0_);
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = info;
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = backing_photo_row_matches_file_info (_tmp2_, _tmp3_);
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp2_);
#line 4708 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 36444 "Photo.c"
		GeeCollection* _tmp6_ = NULL;
		LibraryPhoto* _tmp7_ = NULL;
#line 4709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = matches_master;
#line 4709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = photo;
#line 4709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_collection_add (_tmp6_, _tmp7_);
#line 36453 "Photo.c"
	}
#line 4711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo;
#line 4711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = photo_get_editable_photo_row ((Photo*) _tmp8_);
#line 4711 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	editable = _tmp9_;
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = editable;
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 36465 "Photo.c"
		BackingPhotoRow* _tmp12_ = NULL;
		GFileInfo* _tmp13_ = NULL;
		gboolean _tmp14_ = FALSE;
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = editable;
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = info;
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = backing_photo_row_matches_file_info (_tmp12_, _tmp13_);
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = _tmp14_;
#line 36477 "Photo.c"
	} else {
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = FALSE;
#line 36481 "Photo.c"
	}
#line 4712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp10_) {
#line 36485 "Photo.c"
		GeeCollection* _tmp15_ = NULL;
		LibraryPhoto* _tmp16_ = NULL;
#line 4713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = matches_editable;
#line 4713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = photo;
#line 4713 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_collection_add (_tmp15_, _tmp16_);
#line 36494 "Photo.c"
	}
#line 4715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = photo;
#line 4715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp18_ = photo_get_raw_development_photo_rows ((Photo*) _tmp17_);
#line 4715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	development = _tmp18_;
#line 4716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = development;
#line 4716 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 36506 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp20_ = NULL;
			GeeIterator* _tmp21_ = NULL;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = development;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_row_it = _tmp21_;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 36519 "Photo.c"
				GeeIterator* _tmp22_ = NULL;
				gboolean _tmp23_ = FALSE;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp24_ = NULL;
				gpointer _tmp25_ = NULL;
				BackingPhotoRow* _tmp26_ = NULL;
				GFileInfo* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = _row_it;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = gee_iterator_next (_tmp22_);
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp23_) {
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 36536 "Photo.c"
				}
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = _row_it;
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = gee_iterator_get (_tmp24_);
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp25_;
#line 4718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = row;
#line 4718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = info;
#line 4718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = backing_photo_row_matches_file_info (_tmp26_, _tmp27_);
#line 4718 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp28_) {
#line 36552 "Photo.c"
					GeeCollection* _tmp29_ = NULL;
					LibraryPhoto* _tmp30_ = NULL;
#line 4719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp29_ = matches_development;
#line 4719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp30_ = photo;
#line 4719 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_collection_add (_tmp29_, _tmp30_);
#line 4721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4721 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 36565 "Photo.c"
				}
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36569 "Photo.c"
			}
#line 4717 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36573 "Photo.c"
		}
	}
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (development);
#line 4705 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 36580 "Photo.c"
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development) {
#line 4729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4729 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (matched_development != NULL);
#line 36595 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		gint64 _tmp2_ = 0LL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = info;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = g_file_info_get_size (_tmp1_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = gee_multi_map_get (_tmp0_, &_tmp2_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_it = _tmp6_;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 36625 "Photo.c"
			GeeIterator* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp9_ = NULL;
			gpointer _tmp10_ = NULL;
			LibraryPhoto* _tmp11_ = NULL;
			GFileInfo* _tmp12_ = NULL;
			GeeCollection* _tmp13_ = NULL;
			GeeCollection* _tmp14_ = NULL;
			GeeCollection* _tmp15_ = NULL;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp8_) {
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 36644 "Photo.c"
			}
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _photo_it;
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp10_;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = photo;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = info;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = matches_master;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = matches_editable;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = matched_development;
#line 4732 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_);
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 36666 "Photo.c"
		}
#line 4731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36670 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp16_ = NULL;
		GeeCollection* _tmp17_ = NULL;
		GeeIterator* _tmp18_ = NULL;
		GeeIterator* _tmp19_ = NULL;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = media_source_collection_get_offline_bin_contents ((MediaSourceCollection*) self);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_it = _tmp19_;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 36692 "Photo.c"
			GeeIterator* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp22_ = NULL;
			gpointer _tmp23_ = NULL;
			MediaSource* _tmp24_ = NULL;
			GFileInfo* _tmp25_ = NULL;
			GeeCollection* _tmp26_ = NULL;
			GeeCollection* _tmp27_ = NULL;
			GeeCollection* _tmp28_ = NULL;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp20_ = _media_it;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp21_ = gee_iterator_next (_tmp20_);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp21_) {
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 36711 "Photo.c"
			}
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp22_ = _media_it;
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			media = (MediaSource*) _tmp23_;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = media;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp25_ = info;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = matches_master;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = matches_editable;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = matched_development;
#line 4735 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_LIBRARY_PHOTO, LibraryPhoto), _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 36733 "Photo.c"
		}
#line 4734 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36737 "Photo.c"
	}
}


void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result) {
	PhotoID _tmp19_ = {0};
#line 4738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4738 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 36748 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_ = NULL;
		gint64 _tmp1_ = 0LL;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = filesize;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		while (TRUE) {
#line 36775 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* _tmp10_ = NULL;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gboolean _tmp16_ = FALSE;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (!_tmp7_) {
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				break;
#line 36796 "Photo.c"
			}
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp9_;
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = photo;
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = media_source_get_master_file ((MediaSource*) _tmp10_);
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp13_ = g_file_get_basename (_tmp12_);
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp14_ = basename;
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = utf8_ci_compare (_tmp13_, _tmp14_);
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = _tmp15_ == 0;
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp12_);
#line 4740 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_tmp16_) {
#line 36822 "Photo.c"
				LibraryPhoto* _tmp17_ = NULL;
				PhotoID _tmp18_ = {0};
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = photo;
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo_get_photo_id ((Photo*) _tmp17_, &_tmp18_);
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				*result = _tmp18_;
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 36837 "Photo.c"
			}
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 36841 "Photo.c"
		}
#line 4739 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36845 "Photo.c"
	}
#line 4744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id_init (&_tmp19_, PHOTO_ID_INVALID);
#line 4744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = _tmp19_;
#line 4744 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 36853 "Photo.c"
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	PhotoID _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
#line 4748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = basename;
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = filesize;
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, _tmp0_, _tmp1_, &_tmp2_);
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_id_is_valid (&_tmp2_);
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 4749 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36879 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
#line 4752 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4752 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp4_;
#line 4754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 36914 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		LibraryPhoto* _tmp9_ = NULL;
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = file;
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 36933 "Photo.c"
	}
#line 4758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = photo;
#line 4758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36939 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
#line 4761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = md5;
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 4762 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 36970 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
#line 4765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4765 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = file;
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4766 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp4_;
#line 4767 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4767 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 37005 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		LibraryPhoto* _tmp9_ = NULL;
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = file;
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 37024 "Photo.c"
	}
#line 4771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = photo;
#line 4771 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37030 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
#line 4774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4774 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = md5;
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp4_;
#line 4775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37061 "Photo.c"
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 4778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 4779 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37087 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	GFile* _tmp0_ = NULL;
	MediaSource* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	LibraryPhoto* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	LibraryPhoto* _tmp10_ = NULL;
	LibraryPhoto* _tmp11_ = NULL;
	LibraryPhoto* _tmp12_ = NULL;
	GFile* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_ = NULL;
	LibraryPhoto* _tmp15_ = NULL;
	LibraryPhoto* _tmp16_ = NULL;
#line 4782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 4783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = media_source_collection_fetch_by_master_file ((MediaSourceCollection*) self, _tmp0_);
#line 4783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo;
#line 4784 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 4785 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = photo;
#line 4787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 4787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 37134 "Photo.c"
		}
#line 4787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37138 "Photo.c"
	}
#line 4790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = file;
#line 4790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_editable_file (self, _tmp3_);
#line 4790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4790 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp4_;
#line 4791 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4791 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = photo;
#line 4794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 4794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 37160 "Photo.c"
		}
#line 4794 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37164 "Photo.c"
	}
#line 4797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = file;
#line 4797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = library_photo_source_collection_fetch_by_raw_development_file (self, _tmp6_);
#line 4797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp7_;
#line 4798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo;
#line 4798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4799 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = photo;
#line 4801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 4801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 37186 "Photo.c"
		}
#line 4801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37190 "Photo.c"
	}
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = file;
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = library_photo_source_collection_get_trashed_by_file (self, _tmp9_);
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp10_) : NULL;
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_ == NULL) {
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp10_);
#line 37202 "Photo.c"
	}
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4804 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp11_;
#line 4805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo;
#line 4805 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 4806 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = photo;
#line 4808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 4808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 37220 "Photo.c"
		}
#line 4808 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37224 "Photo.c"
	}
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = file;
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = library_photo_source_collection_get_offline_by_file (self, _tmp13_);
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp14_) : NULL;
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp14_);
#line 37236 "Photo.c"
	}
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4811 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp15_;
#line 4812 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = photo;
#line 4812 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp16_ != NULL) {
#line 4813 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = photo;
#line 4815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (state) {
#line 4815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*state = _vala_state;
#line 37254 "Photo.c"
		}
#line 4815 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37258 "Photo.c"
	}
#line 4818 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = NULL;
#line 4820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (state) {
#line 4820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*state = _vala_state;
#line 37270 "Photo.c"
	}
#line 4820 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37274 "Photo.c"
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	SourceBacklink* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	SourceBacklink* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MediaSourceHoldingTank* _tmp7_ = NULL;
	MediaSourceHoldingTank* _tmp8_ = NULL;
	SourceBacklink* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 4823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4823 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 4824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = backlink;
#line 4824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp0_);
#line 4824 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 4825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = TRUE;
#line 4825 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37307 "Photo.c"
	}
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = backlink;
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp3_, _tmp4_);
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 4828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = TRUE;
#line 4828 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37327 "Photo.c"
	}
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = backlink;
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp8_, _tmp9_);
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp8_);
#line 4830 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp11_) {
#line 4831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = TRUE;
#line 4831 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 37347 "Photo.c"
	}
#line 4833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = FALSE;
#line 4833 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37353 "Photo.c"
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	SourceBacklink* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	MediaSourceHoldingTank* _tmp4_ = NULL;
	SourceBacklink* _tmp5_ = NULL;
	SourceBacklink* _tmp6_ = NULL;
#line 4836 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4836 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (backlink != NULL);
#line 4837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = backlink;
#line 4837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp1_, _tmp2_);
#line 4837 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = backlink;
#line 4838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp4_, _tmp5_);
#line 4838 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = backlink;
#line 4840 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp6_);
#line 37394 "Photo.c"
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_ = NULL;
	TransactionController* _tmp2_ = NULL;
#line 4357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37409 "Photo.c"
		MediaSourceTransactionController* _tmp1_ = NULL;
#line 4359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new ((MediaSourceCollection*) self);
#line 4359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		self->priv->_transaction_controller = (TransactionController*) _tmp1_;
#line 37417 "Photo.c"
	}
#line 4361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp2_;
#line 4361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 37425 "Photo.c"
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37432 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = closure->data;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37451 "Photo.c"
	} else {
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data2 = closure->data;
#line 37457 "Photo.c"
	}
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37463 "Photo.c"
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4382 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37470 "Photo.c"
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37477 "Photo.c"
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4388 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37484 "Photo.c"
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = library_photo_source_collection_real_create_trashcan;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = library_photo_source_collection_real_create_offline_bin;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = library_photo_source_collection_real_create_media_monitor;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = library_photo_source_collection_real_holds_type_of_source;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = library_photo_source_collection_real_get_typename;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = library_photo_source_collection_real_is_file_recognized;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = library_photo_source_collection_real_notify_contents_altered;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = library_photo_source_collection_real_items_altered;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = library_photo_source_collection_real_postprocess_imported_media;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = library_photo_source_collection_real_notify_master_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = library_photo_source_collection_real_notify_editable_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = library_photo_source_collection_real_notify_source_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = library_photo_source_collection_real_notify_baseline_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = library_photo_source_collection_real_fetch_by_numeric_id;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = library_photo_source_collection_real_fetch_by_source_id;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = library_photo_source_collection_real_get_event_source_ids;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = library_photo_source_collection_real_has_backlink;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = library_photo_source_collection_real_remove_backlink;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 37549 "Photo.c"
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	GeeTreeMultiMap* _tmp2_ = NULL;
	GeeHashMap* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GeeTreeMultiMap* _tmp5_ = NULL;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4365 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->filesize_to_photo = (GeeMultiMap*) _tmp2_;
#line 4372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = (GeeMultiMap*) _tmp5_;
#line 37588 "Photo.c"
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4365 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4366 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 37612 "Photo.c"
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
#line 4868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 37631 "Photo.c"
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row) {
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_ = NULL;
	OneShotScheduler* _tmp1_ = NULL;
	PhotoRow* _tmp2_ = NULL;
	guint64 _tmp3_ = 0ULL;
#line 4863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 4864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = row;
#line 4864 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4866 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4868 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp1_;
#line 4871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = row;
#line 4871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_->flags;
#line 4871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((_tmp3_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37663 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_ = NULL;
		PhotoRow* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 4872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 4872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = row;
#line 4872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp5_->backlinks;
#line 4872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp4_, _tmp6_);
#line 37675 "Photo.c"
	}
#line 4863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 37679 "Photo.c"
}


static LibraryPhoto* library_photo_new (PhotoRow* row) {
#line 4863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 37686 "Photo.c"
}


static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params) {
	LibraryPhoto * self = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoImportParams* _tmp2_ = NULL;
	GeeCollection* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
	OneShotScheduler* _tmp5_ = NULL;
	PhotoImportParams* _tmp6_ = NULL;
	PhotoRow* _tmp7_ = NULL;
	guint64 _tmp8_ = 0ULL;
#line 4875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (import_params != NULL, NULL);
#line 4876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = import_params;
#line 4876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_->row;
#line 4876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp1_);
#line 4878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = import_params;
#line 4878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_->keywords;
#line 4878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 4878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4878 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->import_keywords = _tmp4_;
#line 4879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp5_;
#line 4882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = import_params;
#line 4882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp6_->row;
#line 4882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37733 "Photo.c"
		LibraryPhotoSourceCollection* _tmp9_ = NULL;
		PhotoImportParams* _tmp10_ = NULL;
		PhotoRow* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 4883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = library_photo_global;
#line 4883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = import_params;
#line 4883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp10_->row;
#line 4883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = _tmp11_->backlinks;
#line 4883 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp9_, _tmp12_);
#line 37748 "Photo.c"
	}
#line 4875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 37752 "Photo.c"
}


static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params) {
#line 4875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 37759 "Photo.c"
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_ = NULL;
	PhotoTable* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_ = NULL;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_ = NULL;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_ = NULL;
	gint count = 0;
	GeeArrayList* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	LibraryPhotoSourceCollection* _tmp34_ = NULL;
	GeeArrayList* _tmp35_ = NULL;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* _tmp37_ = NULL;
	LibraryPhotoSourceCollection* _tmp38_ = NULL;
	GeeArrayList* _tmp39_ = NULL;
	LibraryPhotoSourceCollection* _tmp40_ = NULL;
	GeeArrayList* _tmp41_ = NULL;
#line 4887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 4887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 4887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 4891 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	all = _tmp4_;
#line 4892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 4892 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	all_photos = _tmp5_;
#line 4893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 4893 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 4894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 4894 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	offline_photos = _tmp7_;
#line 4895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = all;
#line 4895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp8_);
#line 4895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 4895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	count = _tmp10_;
#line 37826 "Photo.c"
	{
		gint ctr = 0;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		ctr = 0;
#line 37831 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = TRUE;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 37838 "Photo.c"
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				PhotoRow* row = NULL;
				GeeArrayList* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				gpointer _tmp17_ = NULL;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp18_ = NULL;
				LibraryPhoto* _tmp19_ = NULL;
				guint64 flags = 0ULL;
				PhotoRow* _tmp20_ = NULL;
				guint64 _tmp21_ = 0ULL;
				guint64 _tmp22_ = 0ULL;
				ProgressMonitor _tmp30_ = NULL;
				void* _tmp30__target = NULL;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp11_) {
#line 37856 "Photo.c"
					gint _tmp12_ = 0;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp12_ = ctr;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 37862 "Photo.c"
				}
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = FALSE;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = ctr;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = count;
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 37874 "Photo.c"
				}
#line 4897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = all;
#line 4897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = ctr;
#line 4897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
#line 4897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				row = (PhotoRow*) _tmp17_;
#line 4898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = row;
#line 4898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp19_ = library_photo_new (_tmp18_);
#line 4898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp19_;
#line 4899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = row;
#line 4899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = _tmp20_->flags;
#line 4899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				flags = _tmp21_;
#line 4901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = flags;
#line 4901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if ((_tmp22_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 37900 "Photo.c"
					GeeArrayList* _tmp23_ = NULL;
					LibraryPhoto* _tmp24_ = NULL;
#line 4902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp23_ = trashed_photos;
#line 4902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp24_ = photo;
#line 4902 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 37909 "Photo.c"
				} else {
					guint64 _tmp25_ = 0ULL;
#line 4903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp25_ = flags;
#line 4903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					if ((_tmp25_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 37916 "Photo.c"
						GeeArrayList* _tmp26_ = NULL;
						LibraryPhoto* _tmp27_ = NULL;
#line 4904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp26_ = offline_photos;
#line 4904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp27_ = photo;
#line 4904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 37925 "Photo.c"
					} else {
						GeeArrayList* _tmp28_ = NULL;
						LibraryPhoto* _tmp29_ = NULL;
#line 4906 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp28_ = all_photos;
#line 4906 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp29_ = photo;
#line 4906 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 37935 "Photo.c"
					}
				}
#line 4908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = monitor;
#line 4908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30__target = monitor_target;
#line 4908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp30_ != NULL) {
#line 37944 "Photo.c"
					ProgressMonitor _tmp31_ = NULL;
					void* _tmp31__target = NULL;
					gint _tmp32_ = 0;
					gint _tmp33_ = 0;
#line 4909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31_ = monitor;
#line 4909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31__target = monitor_target;
#line 4909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp32_ = ctr;
#line 4909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp33_ = count;
#line 4909 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp31_ ((guint64) _tmp32_, (guint64) _tmp33_, TRUE, _tmp31__target);
#line 37959 "Photo.c"
				}
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_photo_row_unref0 (row);
#line 37965 "Photo.c"
			}
		}
	}
#line 4912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = library_photo_global;
#line 4912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = all_photos;
#line 4912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = data_collection_add_many ((DataCollection*) _tmp34_, (GeeCollection*) _tmp35_, NULL, NULL);
#line 4912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 4912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp37_);
#line 4913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = library_photo_global;
#line 4913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = trashed_photos;
#line 4913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_collection_add_many_to_trash ((MediaSourceCollection*) _tmp38_, (GeeCollection*) _tmp39_);
#line 4914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 4914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = offline_photos;
#line 4914 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	media_source_collection_add_many_to_offline ((MediaSourceCollection*) _tmp40_, (GeeCollection*) _tmp41_);
#line 4886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 4886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 4886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 4886 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (all);
#line 37999 "Photo.c"
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	PhotoImportParams* _tmp2_ = NULL;
	PhotoRow* _tmp3_ = NULL;
	PhotoID _tmp4_ = {0};
	PhotoID _tmp5_ = {0};
	gboolean _tmp6_ = FALSE;
	PhotoImportParams* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_ = NULL;
#line 4924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = params;
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_->row;
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp3_, &_tmp4_);
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4926 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id = _tmp5_;
#line 4927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = photo_id_is_invalid (&photo_id);
#line 4927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 4928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 4928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_vala_photo = NULL;
#line 4930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 4930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (photo) {
#line 4930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			*photo = _vala_photo;
#line 38052 "Photo.c"
		} else {
#line 4930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38056 "Photo.c"
		}
#line 4930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 38060 "Photo.c"
	}
#line 4934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = params;
#line 4934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = library_photo_new_from_import_params (_tmp7_);
#line 4934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 4934 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_photo = _tmp8_;
#line 4936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 4936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (photo) {
#line 4936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*photo = _vala_photo;
#line 38076 "Photo.c"
	} else {
#line 4936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38080 "Photo.c"
	}
#line 4936 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 38084 "Photo.c"
}


void library_photo_import_failed (LibraryPhoto* photo) {
	GError * _inner_error_ = NULL;
#line 4939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 38092 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_ = NULL;
		LibraryPhoto* _tmp2_ = NULL;
		PhotoID _tmp3_ = {0};
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = photo;
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_get_photo_id ((Photo*) _tmp2_, &_tmp3_);
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 38114 "Photo.c"
				goto __catch266_database_error;
			}
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 38123 "Photo.c"
		}
	}
	goto __finally266;
	__catch266_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_ = NULL;
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = err;
#line 4943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38141 "Photo.c"
	}
	__finally266:
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4940 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 38152 "Photo.c"
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4948 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4948 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4950 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp1_, self, _tmp2_);
#line 38174 "Photo.c"
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4954 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp1_, self, _tmp2_);
#line 38195 "Photo.c"
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4959 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4962 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp1_, self, _tmp2_);
#line 38216 "Photo.c"
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4968 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp1_, self, _tmp2_);
#line 38237 "Photo.c"
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
#line 4971 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 38245 "Photo.c"
	{
#line 4973 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		thumbnail_cache_import_from_source ((ThumbnailSource*) self, TRUE, &_inner_error_);
#line 4973 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38251 "Photo.c"
			goto __catch267_g_error;
		}
	}
	goto __finally267;
	__catch267_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = err;
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:4975: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 4975 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38281 "Photo.c"
	}
	__finally267:
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4972 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 38292 "Photo.c"
	}
#line 4979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38296 "Photo.c"
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 4983 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 4984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 4984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 4984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 38314 "Photo.c"
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
#line 4987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38325 "Photo.c"
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Alteration* _tmp5_ = NULL;
#line 4991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (alteration != NULL);
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp1_) {
#line 38342 "Photo.c"
		Alteration* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = alteration_has_subject (_tmp2_, "image");
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 38351 "Photo.c"
	} else {
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 38355 "Photo.c"
	}
#line 4993 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_) {
#line 38359 "Photo.c"
		OneShotScheduler* _tmp4_ = NULL;
#line 4994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = self->priv->thumbnail_scheduler;
#line 4994 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp4_, G_PRIORITY_LOW);
#line 38365 "Photo.c"
	}
#line 4996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = alteration;
#line 4996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp5_);
#line 38371 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4999 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4999 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) self, (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 5000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	pixbuf = _tmp0_;
#line 5000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38396 "Photo.c"
	}
#line 5002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp1_;
#line 5002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5002 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 38406 "Photo.c"
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	Rotation _tmp0_ = 0;
	GError * _inner_error_ = NULL;
#line 5005 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5007 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = rotation;
#line 5008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 5009 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38424 "Photo.c"
	{
		Rotation _tmp1_ = 0;
#line 5017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = rotation;
#line 5017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		thumbnail_cache_rotate ((ThumbnailSource*) self, _tmp1_, &_inner_error_);
#line 5017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38433 "Photo.c"
			goto __catch268_g_error;
		}
	}
	goto __finally268;
	__catch268_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = err;
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_warning ("Photo.vala:5020: Unable to update thumbnails for %s: %s", _tmp3_, _tmp5_);
#line 5020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38463 "Photo.c"
	}
	__finally268:
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5016 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 38474 "Photo.c"
	}
#line 5023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38478 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 5027 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = scale;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = thumbnail_cache_fetch ((ThumbnailSource*) self, _tmp1_, &_inner_error_);
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38504 "Photo.c"
	}
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp3_;
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5028 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 38516 "Photo.c"
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 38523 "Photo.c"
}


static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error) {
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	BackingPhotoRow* _tmp1_ = NULL;
	GFile* file = NULL;
	BackingPhotoRow* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5033 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5034 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = backing;
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 38548 "Photo.c"
	} else {
		BackingPhotoRow* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = backing;
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = _tmp2_->filepath;
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 38558 "Photo.c"
	}
#line 5035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_) {
#line 5036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*result = backing_id;
#line 5036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 38566 "Photo.c"
	}
#line 5038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = backing;
#line 5038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_->filepath;
#line 5038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 5038 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	file = _tmp6_;
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = file;
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = g_file_query_exists (_tmp7_, NULL);
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_) {
#line 38582 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp11_ = NULL;
		DetectedPhotoInformation* _tmp12_ = NULL;
		BackingPhotoRow* _tmp13_ = NULL;
		BackingPhotoRow* _tmp14_ = NULL;
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp9_ = file;
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = library_files_duplicate (_tmp9_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		dupe_file = _tmp10_;
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5040 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 38606 "Photo.c"
		}
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = dupe_file;
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = photo_query_backing_photo_row ((Photo*) self, _tmp11_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp12_, &_inner_error_);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		detected = _tmp12_;
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		state = _tmp13_;
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5043 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 38630 "Photo.c"
		}
#line 5045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = state;
#line 5045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp14_ != NULL) {
#line 38636 "Photo.c"
			BackingPhotoTable* _tmp15_ = NULL;
			BackingPhotoTable* _tmp16_ = NULL;
			BackingPhotoRow* _tmp17_ = NULL;
			BackingPhotoRow* _tmp18_ = NULL;
			BackingPhotoID _tmp19_ = {0};
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp15_ = backing_photo_table_get_instance ();
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp17_ = state;
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_photo_table_add (_tmp16_, _tmp17_, &_inner_error_);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_database_table_unref0 (_tmp16_);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 5046 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				return;
#line 38666 "Photo.c"
			}
#line 5047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp18_ = state;
#line 5047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp19_ = _tmp18_->id;
#line 5047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			backing_id = _tmp19_;
#line 38674 "Photo.c"
		}
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 38682 "Photo.c"
	}
#line 5051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = backing_id;
#line 5051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 5051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 38690 "Photo.c"
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_ = NULL;
	BackingPhotoRow* _tmp5_ = NULL;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_ = {0};
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_ = NULL;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_ = {0};
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_ = NULL;
	BackingPhotoRow* _tmp13_ = NULL;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_ = {0};
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_ = NULL;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_ = {0};
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_ = NULL;
	PhotoTable* _tmp21_ = NULL;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	BackingPhotoID _tmp26_ = {0};
	BackingPhotoID _tmp27_ = {0};
	BackingPhotoID _tmp28_ = {0};
	BackingPhotoID _tmp29_ = {0};
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_ = {0};
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_ = NULL;
	PhotoID _tmp34_ = {0};
	PhotoRow* _tmp35_ = NULL;
	PhotoRow* _tmp36_ = NULL;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_ = NULL;
	LibraryPhoto* _tmp38_ = NULL;
	LibraryPhoto* _tmp39_ = NULL;
	LibraryPhotoSourceCollection* _tmp40_ = NULL;
	LibraryPhoto* _tmp41_ = NULL;
	LibraryPhoto* _tmp42_ = NULL;
	Event* _tmp43_ = NULL;
	Event* _tmp44_ = NULL;
	gboolean _tmp45_ = FALSE;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_ = NULL;
	GeeList* _tmp51_ = NULL;
	GeeCollection* _tmp52_ = NULL;
	GError * _inner_error_ = NULL;
#line 5054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_file = _tmp3_;
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5056 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38775 "Photo.c"
	}
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row ((Photo*) self);
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error_);
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38797 "Photo.c"
	}
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_SHOTWELL);
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error_);
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5060 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38819 "Photo.c"
	}
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_CAMERA);
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error_);
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5062 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38841 "Photo.c"
	}
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_EMBEDDED);
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error_);
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return NULL;
#line 38863 "Photo.c"
	}
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp22_);
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5068 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_id = _tmp31_;
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5070 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe_row = _tmp36_;
#line 5073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	dupe = _tmp38_;
#line 5076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = dupe;
#line 5076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	thumbnail_cache_duplicate ((ThumbnailSource*) self, (ThumbnailSource*) _tmp39_);
#line 5079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp41_ = dupe;
#line 5079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	data_collection_add ((DataCollection*) _tmp40_, (DataObject*) _tmp41_);
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp42_ = dupe;
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp43_ = media_source_get_event ((MediaSource*) _tmp42_);
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp45_) {
#line 38937 "Photo.c"
		LibraryPhoto* _tmp46_ = NULL;
		Event* _tmp47_ = NULL;
		Event* _tmp48_ = NULL;
		LibraryPhoto* _tmp49_ = NULL;
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp46_ = dupe;
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp47_ = media_source_get_event ((MediaSource*) _tmp46_);
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp49_ = dupe;
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		event_attach (_tmp48_, (MediaSource*) _tmp49_);
#line 5083 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 38954 "Photo.c"
	}
#line 5086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp50_ = tag_global;
#line 5086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, (MediaSource*) self);
#line 5086 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	tags = (GeeCollection*) _tmp51_;
#line 5087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp52_ = tags;
#line 5087 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 38966 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_ = NULL;
			GeeIterator* _tmp54_ = NULL;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp53_ = tags;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_it = _tmp54_;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 38979 "Photo.c"
				GeeIterator* _tmp55_ = NULL;
				gboolean _tmp56_ = FALSE;
				Tag* tag = NULL;
				GeeIterator* _tmp57_ = NULL;
				gpointer _tmp58_ = NULL;
				Tag* _tmp59_ = NULL;
				LibraryPhoto* _tmp60_ = NULL;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp56_ = gee_iterator_next (_tmp55_);
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp56_) {
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 38995 "Photo.c"
				}
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp57_ = _tag_it;
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp58_ = gee_iterator_get (_tmp57_);
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag = (Tag*) _tmp58_;
#line 5089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp59_ = tag;
#line 5089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp60_ = dupe;
#line 5089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag_attach (_tmp59_, (MediaSource*) _tmp60_);
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39011 "Photo.c"
			}
#line 5088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 39015 "Photo.c"
		}
	}
#line 5093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = dupe;
#line 5093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39028 "Photo.c"
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
#line 5096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5097 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	spin_event_loop ();
#line 39037 "Photo.c"
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH);
#line 5102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 5102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39053 "Photo.c"
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
#line 5105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39063 "Photo.c"
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
#line 5109 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39073 "Photo.c"
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5113 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 5114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39089 "Photo.c"
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
#line 5117 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5118 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39099 "Photo.c"
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
#line 5121 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5122 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39109 "Photo.c"
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5125 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp0_;
#line 5126 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39125 "Photo.c"
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
#line 5129 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5130 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39143 "Photo.c"
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
#line 5133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5134 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39161 "Photo.c"
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_inner_error_);
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return FALSE;
#line 39184 "Photo.c"
	}
#line 5140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (!_tmp0_) {
#line 5141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = FALSE;
#line 5141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 39192 "Photo.c"
	}
#line 5143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = media_source_delete_original_file ((MediaSource*) self);
#line 5143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp2_;
#line 5143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39200 "Photo.c"
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError * _inner_error_ = NULL;
#line 5146 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp0_);
#line 5147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id = _tmp0_;
#line 5150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	thumbnail_cache_remove ((ThumbnailSource*) self);
#line 39217 "Photo.c"
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_ = NULL;
		PhotoID _tmp3_ = {0};
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_id;
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 39236 "Photo.c"
				goto __catch269_database_error;
			}
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 5156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			return;
#line 39245 "Photo.c"
		}
	}
	goto __finally269;
	__catch269_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_ = NULL;
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		err = _inner_error_;
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 5158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = err;
#line 5158 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_error_free0 (err);
#line 39263 "Photo.c"
	}
	__finally269:
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 39274 "Photo.c"
	}
#line 5161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 39278 "Photo.c"
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	PhotoID _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = file_format;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_get_nontrash_duplicate (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_id_is_valid (&_tmp4_);
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = _tmp5_;
#line 5166 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39306 "Photo.c"
}


void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result) {
	PhotoID* ids = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	gint _tmp4_ = 0;
	PhotoID* _tmp5_ = NULL;
	gint ids_length1 = 0;
	gint _ids_size_ = 0;
	gboolean _tmp6_ = FALSE;
	PhotoID* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	PhotoID* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	PhotoID _tmp18_ = {0};
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = file;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = file_format;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = photo_get_duplicate_ids (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ids = _tmp5_;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ids_length1 = _tmp4_;
#line 5171 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = ids;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7__length1 = ids_length1;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 39350 "Photo.c"
	} else {
		PhotoID* _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = ids;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8__length1 = ids_length1;
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = _tmp8__length1 == 0;
#line 39360 "Photo.c"
	}
#line 5173 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp6_) {
#line 39364 "Photo.c"
		PhotoID _tmp9_ = {0};
#line 5174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_id_init (&_tmp9_, PHOTO_ID_INVALID);
#line 5174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		*result = _tmp9_;
#line 5174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return;
#line 39374 "Photo.c"
	}
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = ids;
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10__length1 = ids_length1;
#line 39380 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		id_collection = _tmp10_;
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		id_collection_length1 = _tmp10__length1;
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		for (id_it = 0; id_it < _tmp10__length1; id_it = id_it + 1) {
#line 39392 "Photo.c"
			PhotoID id = {0};
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			id = id_collection[id_it];
#line 39396 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp11_ = NULL;
				PhotoID _tmp12_ = {0};
				LibraryPhoto* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				LibraryPhoto* _tmp15_ = NULL;
#line 5177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = library_photo_global;
#line 5177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = id;
#line 5177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = library_photo_source_collection_fetch (_tmp11_, &_tmp12_);
#line 5177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp13_;
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = photo;
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 39416 "Photo.c"
					LibraryPhoto* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = photo;
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = media_source_is_trashed ((MediaSource*) _tmp16_);
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = !_tmp17_;
#line 39425 "Photo.c"
				} else {
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = FALSE;
#line 39429 "Photo.c"
				}
#line 5178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp14_) {
#line 5179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					*result = id;
#line 5179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 5179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return;
#line 39441 "Photo.c"
				}
#line 5176 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 39445 "Photo.c"
			}
		}
	}
#line 5182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_id_init (&_tmp18_, PHOTO_ID_INVALID);
#line 5182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	*result = _tmp18_;
#line 5182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return;
#line 39457 "Photo.c"
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	GeeSet* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	GeeList* _tmp12_ = NULL;
	gint tags_count = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_ = NULL;
	gint keywords_count = 0;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
	GeeList* _tmp24_ = NULL;
#line 5185 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	tags = _tmp1_;
#line 5188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata ((PhotoSource*) self);
#line 5188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	metadata = _tmp2_;
#line 5189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = metadata;
#line 5189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 39499 "Photo.c"
		gboolean _tmp4_ = FALSE;
		GeeList* _tmp5_ = NULL;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = tags;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		if (_tmp5_ != NULL) {
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = TRUE;
#line 39508 "Photo.c"
		} else {
			GeeList* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = tags;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = _tmp8_ > 0;
#line 39521 "Photo.c"
		}
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = _tmp4_;
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5190 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 39531 "Photo.c"
	}
#line 5192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = metadata;
#line 5192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp10_ = photo_metadata_get_keywords (_tmp9_, NULL, NULL, NULL);
#line 5192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	keywords = _tmp10_;
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp12_ = tags;
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 39543 "Photo.c"
		GeeList* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp13_ = tags;
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = _tmp15_;
#line 39555 "Photo.c"
	} else {
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = 0;
#line 39559 "Photo.c"
	}
#line 5193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	tags_count = _tmp11_;
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp17_ = keywords;
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 39567 "Photo.c"
		GeeSet* _tmp18_ = NULL;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = keywords;
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = _tmp20_;
#line 39579 "Photo.c"
	} else {
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp16_ = 0;
#line 39583 "Photo.c"
	}
#line 5194 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	keywords_count = _tmp16_;
#line 5196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = tags_count;
#line 5196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = keywords_count;
#line 5196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp21_ != _tmp22_) {
#line 5197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = TRUE;
#line 5197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 39603 "Photo.c"
	}
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp24_ = tags;
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 39609 "Photo.c"
		GeeSet* _tmp25_ = NULL;
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp25_ = keywords;
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = _tmp25_ != NULL;
#line 39615 "Photo.c"
	} else {
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp23_ = FALSE;
#line 39619 "Photo.c"
	}
#line 5199 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp23_) {
#line 39623 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp26_ = NULL;
			GeeList* _tmp27_ = NULL;
			gint _tag_size = 0;
			GeeList* _tmp28_ = NULL;
			gint _tmp29_ = 0;
			gint _tmp30_ = 0;
			gint _tag_index = 0;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp26_ = tags;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_list = _tmp27_;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp28_ = _tag_list;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp30_ = _tmp29_;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_size = _tmp30_;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_index = -1;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 39651 "Photo.c"
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
				Tag* tag = NULL;
				GeeList* _tmp34_ = NULL;
				gint _tmp35_ = 0;
				gpointer _tmp36_ = NULL;
				GeeSet* _tmp37_ = NULL;
				Tag* _tmp38_ = NULL;
				gchar* _tmp39_ = NULL;
				gchar* _tmp40_ = NULL;
				gchar* _tmp41_ = NULL;
				gchar* _tmp42_ = NULL;
				gboolean _tmp43_ = FALSE;
				gboolean _tmp44_ = FALSE;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = _tag_index;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tag_index = _tmp31_ + 1;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = _tag_index;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = _tag_size;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 39679 "Photo.c"
				}
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = _tag_list;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp35_ = _tag_index;
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = gee_list_get (_tmp34_, _tmp35_);
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag = (Tag*) _tmp36_;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = keywords;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = tag;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = data_object_get_name ((DataObject*) _tmp38_);
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp40_ = _tmp39_;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp41_ = g_utf8_normalize (_tmp40_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = gee_collection_contains ((GeeCollection*) _tmp37_, _tmp42_);
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = !_tmp43_;
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp42_);
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp40_);
#line 5201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp44_) {
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					result = TRUE;
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5202 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					return result;
#line 39725 "Photo.c"
				}
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39729 "Photo.c"
			}
#line 5200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 39733 "Photo.c"
		}
	}
#line 5206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = FALSE;
#line 5206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 39746 "Photo.c"
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	GeeList* _tmp2_ = NULL;
#line 5209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 39770 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_ = NULL;
		PhotoMetadata* _tmp19_ = NULL;
		GeeCollection* _tmp20_ = NULL;
#line 5212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 5212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		string_tags = (GeeCollection*) _tmp3_;
#line 39779 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_ = NULL;
			GeeList* _tmp5_ = NULL;
			gint _tag_size = 0;
			GeeList* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint _tag_index = 0;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tag_index = -1;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 39807 "Photo.c"
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				Tag* tag = NULL;
				GeeList* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gpointer _tmp14_ = NULL;
				GeeCollection* _tmp15_ = NULL;
				Tag* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 39831 "Photo.c"
				}
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = tag;
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = data_object_get_name ((DataObject*) _tmp16_);
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5214 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39855 "Photo.c"
			}
#line 5213 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 39859 "Photo.c"
		}
#line 5216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = metadata;
#line 5216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp20_ = string_tags;
#line 5216 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp19_, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5211 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 39869 "Photo.c"
	} else {
		PhotoMetadata* _tmp21_ = NULL;
#line 5218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp21_ = metadata;
#line 5218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp21_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 39876 "Photo.c"
	}
#line 5209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 39880 "Photo.c"
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GeeCollection* keywords = NULL;
	PhotoMetadata* _tmp6_ = NULL;
	GeeSet* _tmp7_ = NULL;
	GeeCollection* _tmp8_ = NULL;
	HierarchicalTagIndex* _tmp39_ = NULL;
#line 5221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	new_htag_index = NULL;
#line 5224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 5224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = photo_metadata_has_hierarchical_keywords (_tmp0_);
#line 5224 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp1_) {
#line 39906 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		HierarchicalTagIndex* _tmp5_ = NULL;
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_hierarchical_keywords (_tmp2_);
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp4_);
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		new_htag_index = _tmp5_;
#line 5225 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 39925 "Photo.c"
	}
#line 5229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = metadata;
#line 5229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp7_ = photo_metadata_get_keywords (_tmp6_, NULL, NULL, NULL);
#line 5229 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	keywords = (GeeCollection*) _tmp7_;
#line 5230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp8_ = keywords;
#line 5230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 39937 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = keywords;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_keyword_it = _tmp10_;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 39950 "Photo.c"
				GeeIterator* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gchar* keyword = NULL;
				GeeIterator* _tmp13_ = NULL;
				gpointer _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				HierarchicalTagIndex* _tmp16_ = NULL;
				gchar* safe_keyword = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp22_ = NULL;
				gchar* _tmp23_ = NULL;
				TagSourceCollection* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				gboolean _tmp26_ = FALSE;
				TagSourceCollection* _tmp30_ = NULL;
				const gchar* _tmp31_ = NULL;
				gboolean _tmp32_ = FALSE;
				const gchar* _tmp36_ = NULL;
				Tag* _tmp37_ = NULL;
				Tag* _tmp38_ = NULL;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _keyword_it;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp12_) {
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 39981 "Photo.c"
				}
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = _keyword_it;
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				keyword = (gchar*) _tmp14_;
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = new_htag_index;
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp16_ != NULL) {
#line 39993 "Photo.c"
					HierarchicalTagIndex* _tmp17_ = NULL;
					const gchar* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = new_htag_index;
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = keyword;
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = hierarchical_tag_index_is_tag_in_index (_tmp17_, _tmp18_);
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = _tmp19_;
#line 40005 "Photo.c"
				} else {
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = FALSE;
#line 40009 "Photo.c"
				}
#line 5232 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp15_) {
#line 5233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5233 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					continue;
#line 40017 "Photo.c"
				}
#line 5235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp20_ = keyword;
#line 5235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp21_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp20_);
#line 5235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				safe_keyword = _tmp21_;
#line 5236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp22_ = safe_keyword;
#line 5236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp22_);
#line 5236 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				promoted_keyword = _tmp23_;
#line 5239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = tag_global;
#line 5239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = safe_keyword;
#line 5239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = tag_source_collection_exists (_tmp24_, _tmp25_, FALSE);
#line 5239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp26_) {
#line 40039 "Photo.c"
					const gchar* _tmp27_ = NULL;
					Tag* _tmp28_ = NULL;
					Tag* _tmp29_ = NULL;
#line 5240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp27_ = safe_keyword;
#line 5240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp28_ = tag_for_path (_tmp27_);
#line 5240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp29_ = _tmp28_;
#line 5240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					tag_attach (_tmp29_, (MediaSource*) self);
#line 5240 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp29_);
#line 5241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					continue;
#line 40061 "Photo.c"
				}
#line 5244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = tag_global;
#line 5244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = promoted_keyword;
#line 5244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = tag_source_collection_exists (_tmp30_, _tmp31_, FALSE);
#line 5244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp32_) {
#line 40071 "Photo.c"
					const gchar* _tmp33_ = NULL;
					Tag* _tmp34_ = NULL;
					Tag* _tmp35_ = NULL;
#line 5245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp33_ = promoted_keyword;
#line 5245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp34_ = tag_for_path (_tmp33_);
#line 5245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 5245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					tag_attach (_tmp35_, (MediaSource*) self);
#line 5245 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp35_);
#line 5246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5246 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					continue;
#line 40093 "Photo.c"
				}
#line 5249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp36_ = keyword;
#line 5249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp37_ = tag_for_path (_tmp36_);
#line 5249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 5249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag_attach (_tmp38_, (MediaSource*) self);
#line 5249 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp38_);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (keyword);
#line 40111 "Photo.c"
			}
#line 5231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40115 "Photo.c"
		}
	}
#line 5253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp39_ = new_htag_index;
#line 5253 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp39_ != NULL) {
#line 40122 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp40_ = NULL;
			GeeCollection* _tmp41_ = NULL;
			GeeCollection* _tmp42_ = NULL;
			GeeIterator* _tmp43_ = NULL;
			GeeIterator* _tmp44_ = NULL;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp40_ = new_htag_index;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp41_ = hierarchical_tag_index_get_all_paths (_tmp40_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp43_ = gee_iterable_iterator ((GeeIterable*) _tmp42_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp44_ = _tmp43_;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp42_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_path_it = _tmp44_;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 40146 "Photo.c"
				GeeIterator* _tmp45_ = NULL;
				gboolean _tmp46_ = FALSE;
				gchar* path = NULL;
				GeeIterator* _tmp47_ = NULL;
				gpointer _tmp48_ = NULL;
				const gchar* _tmp49_ = NULL;
				Tag* _tmp50_ = NULL;
				Tag* _tmp51_ = NULL;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = _path_it;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = gee_iterator_next (_tmp45_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp46_) {
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 40163 "Photo.c"
				}
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = _path_it;
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = gee_iterator_get (_tmp47_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				path = (gchar*) _tmp48_;
#line 5255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp49_ = path;
#line 5255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp50_ = tag_for_path (_tmp49_);
#line 5255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 5255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				tag_attach (_tmp51_, (MediaSource*) self);
#line 5255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp51_);
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_free0 (path);
#line 40183 "Photo.c"
			}
#line 5254 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40187 "Photo.c"
		}
	}
#line 5221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5221 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40194 "Photo.c"
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = library_photo_real_notify_master_reimported;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = library_photo_real_notify_editable_reimported;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = library_photo_real_notify_source_reimported;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = library_photo_real_notify_baseline_reimported;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = library_photo_real_notify_altered;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = library_photo_real_get_preview_pixbuf;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->rotate = library_photo_real_rotate;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = library_photo_real_get_thumbnail;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = library_photo_real_is_trashed;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->trash = library_photo_real_trash;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = library_photo_real_untrash;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = library_photo_real_is_offline;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = library_photo_real_mark_offline;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = library_photo_real_mark_online;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = library_photo_real_internal_delete_backing;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((DataSourceClass *) klass)->destroy = library_photo_real_destroy;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = library_photo_real_has_user_generated_metadata;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = library_photo_real_set_user_metadata_for_export;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = library_photo_real_apply_user_metadata_for_reimport;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40243 "Photo.c"
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
#line 40256 "Photo.c"
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->set_master_file = (void (*)(Monitorable*, GFile*)) photo_set_master_file;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	iface->set_master_timestamp = (void (*)(Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 40273 "Photo.c"
}


static void library_photo_instance_init (LibraryPhoto * self) {
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 4859 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4860 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40284 "Photo.c"
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4860 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4848 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40298 "Photo.c"
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
	LibraryPhotoSourceHoldingTank* self = NULL;
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	SourceHoldingTankCheckToKeep _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GetSourceDatabaseKey _tmp2_ = NULL;
	void* _tmp2__target = NULL;
#line 5271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = sources;
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = check_to_keep;
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1__target = check_to_keep_target;
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = get_key;
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2__target = get_key_target;
#line 5273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, (MediaSourceCollection*) _tmp0_, _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 5271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return self;
#line 40341 "Photo.c"
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 5271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 40348 "Photo.c"
}


LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
	LibraryPhoto* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	gpointer _tmp6_ = NULL;
#line 5276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 5277 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ret = NULL;
#line 5278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = file;
#line 5278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 5278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5278 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp2_;
#line 5279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = ret;
#line 5279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 5280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		result = ret;
#line 5280 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		return result;
#line 40386 "Photo.c"
	}
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = self->priv->development_file_map;
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = file;
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp6_;
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	return result;
#line 40400 "Photo.c"
}


static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 5306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 40407 "Photo.c"
}


static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 5307 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 40414 "Photo.c"
}


static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
	LibraryPhotoSourceHoldingTank * self;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp40_ = NULL;
	GeeCollection* _tmp81_ = NULL;
	GeeCollection* _tmp82_ = NULL;
#line 5285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) base;
#line 5287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = added;
#line 5287 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 40430 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp1_ = added;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_source_it = _tmp2_;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 40443 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp7_ = NULL;
				LibraryPhoto* _tmp8_ = NULL;
				LibraryPhoto* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp23_ = NULL;
				GeeCollection* _tmp24_ = NULL;
				GeeCollection* _tmp25_ = NULL;
				LibraryPhoto* _tmp38_ = NULL;
				LibraryPhoto* _tmp39_ = NULL;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp3_ = _source_it;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp4_) {
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 40470 "Photo.c"
				}
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp5_ = _source_it;
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				source = (DataSource*) _tmp6_;
#line 5289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp7_ = source;
#line 5289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp8_;
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp9_ = photo;
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _tmp11_ != NULL;
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 5292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp12_) {
#line 40496 "Photo.c"
					GeeHashMap* _tmp13_ = NULL;
					LibraryPhoto* _tmp14_ = NULL;
					GFile* _tmp15_ = NULL;
					GFile* _tmp16_ = NULL;
					LibraryPhoto* _tmp17_ = NULL;
					GeeMultiMap* _tmp18_ = NULL;
					LibraryPhoto* _tmp19_ = NULL;
					LibraryPhoto* _tmp20_ = NULL;
					GFile* _tmp21_ = NULL;
					GFile* _tmp22_ = NULL;
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp13_ = self->priv->editable_file_map;
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp14_ = photo;
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp15_ = photo_get_editable_file ((Photo*) _tmp14_);
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp16_ = _tmp15_;
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp17_ = photo;
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp16_, _tmp17_);
#line 5293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp16_);
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp18_ = self->priv->reverse_editable_file_map;
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp19_ = photo;
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp20_ = photo;
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp21_ = photo_get_editable_file ((Photo*) _tmp20_);
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					gee_multi_map_set (_tmp18_, _tmp19_, _tmp22_);
#line 5294 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 40535 "Photo.c"
				}
#line 5298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp23_ = photo;
#line 5298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp24_ = photo_get_raw_developer_files ((Photo*) _tmp23_);
#line 5298 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				raw_files = _tmp24_;
#line 5299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = raw_files;
#line 5299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 40547 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp26_ = NULL;
						GeeIterator* _tmp27_ = NULL;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp26_ = raw_files;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_f_it = _tmp27_;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						while (TRUE) {
#line 40560 "Photo.c"
							GeeIterator* _tmp28_ = NULL;
							gboolean _tmp29_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp30_ = NULL;
							gpointer _tmp31_ = NULL;
							GeeHashMap* _tmp32_ = NULL;
							GFile* _tmp33_ = NULL;
							LibraryPhoto* _tmp34_ = NULL;
							GeeMultiMap* _tmp35_ = NULL;
							LibraryPhoto* _tmp36_ = NULL;
							GFile* _tmp37_ = NULL;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp28_ = _f_it;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp29_ = gee_iterator_next (_tmp28_);
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							if (!_tmp29_) {
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
								break;
#line 40580 "Photo.c"
							}
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp30_ = _f_it;
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp31_ = gee_iterator_get (_tmp30_);
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							f = (GFile*) _tmp31_;
#line 5301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp32_ = self->priv->development_file_map;
#line 5301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp33_ = f;
#line 5301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp34_ = photo;
#line 5301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp33_, _tmp34_);
#line 5302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp35_ = self->priv->reverse_development_file_map;
#line 5302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp36_ = photo;
#line 5302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_tmp37_ = f;
#line 5302 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							gee_multi_map_set (_tmp35_, _tmp36_, _tmp37_);
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 40606 "Photo.c"
						}
#line 5300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 40610 "Photo.c"
					}
				}
#line 5306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp38_ = photo;
#line 5306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp38_, "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5307 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp39_ = photo;
#line 5307 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp39_, "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 40627 "Photo.c"
			}
#line 5288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40631 "Photo.c"
		}
	}
#line 5311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp40_ = removed;
#line 5311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 40638 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp41_ = NULL;
			GeeIterator* _tmp42_ = NULL;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp41_ = removed;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_source_it = _tmp42_;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 40651 "Photo.c"
				GeeIterator* _tmp43_ = NULL;
				gboolean _tmp44_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp45_ = NULL;
				gpointer _tmp46_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp47_ = NULL;
				LibraryPhoto* _tmp48_ = NULL;
				GeeMultiMap* _tmp73_ = NULL;
				LibraryPhoto* _tmp74_ = NULL;
				GeeMultiMap* _tmp75_ = NULL;
				LibraryPhoto* _tmp76_ = NULL;
				LibraryPhoto* _tmp77_ = NULL;
				guint _tmp78_ = 0U;
				LibraryPhoto* _tmp79_ = NULL;
				guint _tmp80_ = 0U;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp43_ = _source_it;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp44_ = gee_iterator_next (_tmp43_);
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp44_) {
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 40676 "Photo.c"
				}
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp45_ = _source_it;
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp46_ = gee_iterator_get (_tmp45_);
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				source = (DataSource*) _tmp46_;
#line 5313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp47_ = source;
#line 5313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5313 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				photo = _tmp48_;
#line 40690 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp49_ = NULL;
					LibraryPhoto* _tmp50_ = NULL;
					GeeCollection* _tmp51_ = NULL;
					GeeCollection* _tmp52_ = NULL;
					GeeIterator* _tmp53_ = NULL;
					GeeIterator* _tmp54_ = NULL;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp49_ = self->priv->reverse_editable_file_map;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp50_ = photo;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp51_ = gee_multi_map_get (_tmp49_, _tmp50_);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_f_it = _tmp54_;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					while (TRUE) {
#line 40717 "Photo.c"
						GeeIterator* _tmp55_ = NULL;
						gboolean _tmp56_ = FALSE;
						GFile* f = NULL;
						GeeIterator* _tmp57_ = NULL;
						gpointer _tmp58_ = NULL;
						GeeHashMap* _tmp59_ = NULL;
						GFile* _tmp60_ = NULL;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp55_ = _f_it;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp56_ = gee_iterator_next (_tmp55_);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp56_) {
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							break;
#line 40733 "Photo.c"
						}
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp57_ = _f_it;
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp58_ = gee_iterator_get (_tmp57_);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						f = (GFile*) _tmp58_;
#line 5315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp59_ = self->priv->editable_file_map;
#line 5315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp60_ = f;
#line 5315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp59_, _tmp60_, NULL);
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 40749 "Photo.c"
					}
#line 5314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 40753 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp61_ = NULL;
					LibraryPhoto* _tmp62_ = NULL;
					GeeCollection* _tmp63_ = NULL;
					GeeCollection* _tmp64_ = NULL;
					GeeIterator* _tmp65_ = NULL;
					GeeIterator* _tmp66_ = NULL;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp61_ = self->priv->reverse_development_file_map;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp62_ = photo;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp64_ = _tmp63_;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp65_ = gee_iterable_iterator ((GeeIterable*) _tmp64_);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_tmp66_ = _tmp65_;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_tmp64_);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_f_it = _tmp66_;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					while (TRUE) {
#line 40781 "Photo.c"
						GeeIterator* _tmp67_ = NULL;
						gboolean _tmp68_ = FALSE;
						GFile* f = NULL;
						GeeIterator* _tmp69_ = NULL;
						gpointer _tmp70_ = NULL;
						GeeHashMap* _tmp71_ = NULL;
						GFile* _tmp72_ = NULL;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp67_ = _f_it;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp68_ = gee_iterator_next (_tmp67_);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						if (!_tmp68_) {
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
							break;
#line 40797 "Photo.c"
						}
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp69_ = _f_it;
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp70_ = gee_iterator_get (_tmp69_);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						f = (GFile*) _tmp70_;
#line 5318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp71_ = self->priv->development_file_map;
#line 5318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_tmp72_ = f;
#line 5318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp71_, _tmp72_, NULL);
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 40813 "Photo.c"
					}
#line 5317 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 40817 "Photo.c"
				}
#line 5320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp73_ = self->priv->reverse_editable_file_map;
#line 5320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp74_ = photo;
#line 5320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp73_, _tmp74_);
#line 5321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp75_ = self->priv->reverse_development_file_map;
#line 5321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp76_ = photo;
#line 5321 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp75_, _tmp76_);
#line 5323 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp77_ = photo;
#line 5323 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp78_, NULL, FALSE);
#line 5323 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp77_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp78_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp79_ = photo;
#line 5324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp80_, NULL, FALSE);
#line 5324 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp79_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp80_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 40847 "Photo.c"
			}
#line 5312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40851 "Photo.c"
		}
	}
#line 5328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp81_ = added;
#line 5328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp82_ = removed;
#line 5328 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), _tmp81_, _tmp82_);
#line 40860 "Photo.c"
}


static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp9_ = NULL;
	GeeMultiMap* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
#line 5331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 5332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5332 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp1_;
#line 5333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo;
#line 5333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = old_file;
#line 5335 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 40892 "Photo.c"
		GeeHashMap* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GeeMultiMap* _tmp6_ = NULL;
		LibraryPhoto* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
#line 5336 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp4_ = self->priv->editable_file_map;
#line 5336 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp5_ = old_file;
#line 5336 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp5_, NULL);
#line 5337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp6_ = self->priv->reverse_editable_file_map;
#line 5337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp7_ = photo;
#line 5337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp8_ = old_file;
#line 5337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_multi_map_remove (_tmp6_, _tmp7_, _tmp8_);
#line 40912 "Photo.c"
	}
#line 5340 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp9_ = new_file;
#line 5340 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 40918 "Photo.c"
		GeeHashMap* _tmp10_ = NULL;
		GFile* _tmp11_ = NULL;
		LibraryPhoto* _tmp12_ = NULL;
#line 5341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp10_ = self->priv->editable_file_map;
#line 5341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp11_ = new_file;
#line 5341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp12_ = photo;
#line 5341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, _tmp12_);
#line 40930 "Photo.c"
	}
#line 5342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp13_ = self->priv->reverse_editable_file_map;
#line 5342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp14_ = photo;
#line 5342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp15_ = new_file;
#line 5342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	gee_multi_map_set (_tmp13_, _tmp14_, _tmp15_);
#line 5331 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 40942 "Photo.c"
}


static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GeeMultiMap* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp20_ = NULL;
	GeeCollection* _tmp21_ = NULL;
	GeeCollection* _tmp22_ = NULL;
#line 5345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 5346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5346 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	photo = _tmp1_;
#line 5347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = photo;
#line 5347 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = self->priv->reverse_development_file_map;
#line 5350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp4_ = photo;
#line 5350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 5350 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp5_) {
#line 40980 "Photo.c"
		GeeMultiMap* _tmp18_ = NULL;
		LibraryPhoto* _tmp19_ = NULL;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_ = NULL;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp6_ = self->priv->reverse_development_file_map;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp7_ = photo;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_f_it = _tmp11_;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 41009 "Photo.c"
				GeeIterator* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				GeeHashMap* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp12_ = _f_it;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp13_) {
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 41025 "Photo.c"
				}
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp14_ = _f_it;
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				f = (GFile*) _tmp15_;
#line 5352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp16_ = self->priv->development_file_map;
#line 5352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp17_ = f;
#line 5352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp16_, _tmp17_, NULL);
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 41041 "Photo.c"
			}
#line 5351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41045 "Photo.c"
		}
#line 5353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp18_ = self->priv->reverse_development_file_map;
#line 5353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		_tmp19_ = photo;
#line 5353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 41053 "Photo.c"
	}
#line 5357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp20_ = photo;
#line 5357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 5357 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	raw_list = _tmp21_;
#line 5358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp22_ = raw_list;
#line 5358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 41065 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp23_ = NULL;
			GeeIterator* _tmp24_ = NULL;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp23_ = raw_list;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_f_it = _tmp24_;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			while (TRUE) {
#line 41078 "Photo.c"
				GeeIterator* _tmp25_ = NULL;
				gboolean _tmp26_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp27_ = NULL;
				gpointer _tmp28_ = NULL;
				GeeHashMap* _tmp29_ = NULL;
				GFile* _tmp30_ = NULL;
				LibraryPhoto* _tmp31_ = NULL;
				GeeMultiMap* _tmp32_ = NULL;
				LibraryPhoto* _tmp33_ = NULL;
				GFile* _tmp34_ = NULL;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp25_ = _f_it;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp26_ = gee_iterator_next (_tmp25_);
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				if (!_tmp26_) {
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
					break;
#line 41098 "Photo.c"
				}
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp27_ = _f_it;
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp28_ = gee_iterator_get (_tmp27_);
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				f = (GFile*) _tmp28_;
#line 5360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp29_ = self->priv->development_file_map;
#line 5360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp30_ = f;
#line 5360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp31_ = photo;
#line 5360 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp30_, _tmp31_);
#line 5361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp32_ = self->priv->reverse_development_file_map;
#line 5361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp33_ = photo;
#line 5361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_tmp34_ = f;
#line 5361 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				gee_multi_map_set (_tmp32_, _tmp33_, _tmp34_);
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 41124 "Photo.c"
			}
#line 5359 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41128 "Photo.c"
		}
	}
#line 5345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41135 "Photo.c"
}


static void library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass) {
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = library_photo_source_holding_tank_real_notify_contents_altered;
#line 41148 "Photo.c"
}


static void library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	GeeHashMultiMap* _tmp2_ = NULL;
	GeeHashMultiMap* _tmp3_ = NULL;
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5266 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5266 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->reverse_editable_file_map = (GeeMultiMap*) _tmp2_;
#line 5268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self->priv->reverse_development_file_map = (GeeMultiMap*) _tmp3_;
#line 41175 "Photo.c"
}


static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj) {
	LibraryPhotoSourceHoldingTank * self;
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5262 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5266 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5261 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41193 "Photo.c"
}


GType library_photo_source_holding_tank_get_type (void) {
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



