/* PhotoMetadata.c generated by valac 0.34.4, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
#define HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField))
#define HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))
#define IS_HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define IS_HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define HIERARCHICAL_KEYWORD_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))

typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
typedef struct _HierarchicalKeywordFieldClass HierarchicalKeywordFieldClass;
typedef struct _HierarchicalKeywordFieldPrivate HierarchicalKeywordFieldPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
typedef struct _Block7Data Block7Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block10Data Block10Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block11Data Block11Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _HierarchicalKeywordField {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HierarchicalKeywordFieldPrivate * priv;
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
};

struct _HierarchicalKeywordFieldClass {
	GTypeClass parent_class;
	void (*finalize) (HierarchicalKeywordField *self);
};

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
	gchar* (*get_comment) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, void* user_data);
struct _Block7Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* value;
};

struct _Block8Data {
	int _ref_count_;
	PhotoMetadata* self;
	GeeCollection* values;
};

struct _Block9Data {
	int _ref_count_;
	PhotoMetadata* self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block10Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block11Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataDateTime* date_time;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};


static gpointer hierarchical_keyword_field_parent_class = NULL;
static gpointer photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
gpointer hierarchical_keyword_field_ref (gpointer instance);
void hierarchical_keyword_field_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_keyword_field (GValue* value, gpointer v_object);
void value_take_hierarchical_keyword_field (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_keyword_field (const GValue* value);
GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST;
enum  {
	HIERARCHICAL_KEYWORD_FIELD_DUMMY_PROPERTY
};
HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable);
HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable);
static void hierarchical_keyword_field_finalize (HierarchicalKeywordField* obj);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static guint8* _vala_array_dup22 (guint8* self, int length);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag, PrepareInputTextOptions options);
gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag, PrepareInputTextOptions options);
gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value, PrepareInputTextOptions options);
static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda5_ (Block7Data* _data7_, const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection);
static void _vala_array_add232 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add233 (gchar*** array, int* length, int* size, gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda6_ (Block8Data* _data8_, const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda7_ (Block9Data* _data9_, const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gchar* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda8_ (Block10Data* _data10_, const gchar* tag);
static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
const gchar* metadata_domain_to_string (MetadataDomain self);
void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda9_ (Block11Data* _data11_, const gchar* tag);
static void ___lambda9__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup23 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_comment (MediaMetadata* base);
void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
#define TAG_PATH_SEPARATOR_STRING "/"
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
HierarchicalTagIndex* hierarchical_tag_index_new (void);
HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
void hierarchical_tag_index_add_path (HierarchicalTagIndex* self, const gchar* tag, const gchar* path);
GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag, const gchar* foreign_separator);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup24 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (MediaMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable) {
	HierarchicalKeywordField* self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 50 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 50 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 50 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = field_name;
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 52 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->field_name = _tmp1_;
#line 53 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = path_separator;
#line 53 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 53 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 53 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp3_;
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = wants_leading_separator;
#line 54 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = _tmp4_;
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = is_writeable;
#line 55 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->is_writeable = _tmp5_;
#line 50 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self;
#line 664 "PhotoMetadata.c"
}


HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable) {
#line 50 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable);
#line 671 "PhotoMetadata.c"
}


static void value_hierarchical_keyword_field_init (GValue* value) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 678 "PhotoMetadata.c"
}


static void value_hierarchical_keyword_field_free_value (GValue* value) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 687 "PhotoMetadata.c"
	}
}


static void value_hierarchical_keyword_field_copy_value (const GValue* src_value, GValue* dest_value) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 697 "PhotoMetadata.c"
	} else {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 701 "PhotoMetadata.c"
	}
}


static gpointer value_hierarchical_keyword_field_peek_pointer (const GValue* value) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 709 "PhotoMetadata.c"
}


static gchar* value_hierarchical_keyword_field_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 716 "PhotoMetadata.c"
		HierarchicalKeywordField* object;
		object = collect_values[0].v_pointer;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 723 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 727 "PhotoMetadata.c"
		}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 731 "PhotoMetadata.c"
	} else {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 735 "PhotoMetadata.c"
	}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 739 "PhotoMetadata.c"
}


static gchar* value_hierarchical_keyword_field_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	HierarchicalKeywordField** object_p;
	object_p = collect_values[0].v_pointer;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 750 "PhotoMetadata.c"
	}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 756 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 760 "PhotoMetadata.c"
	} else {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 764 "PhotoMetadata.c"
	}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 768 "PhotoMetadata.c"
}


GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecHierarchicalKeywordField* spec;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 782 "PhotoMetadata.c"
}


gpointer value_get_hierarchical_keyword_field (const GValue* value) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 791 "PhotoMetadata.c"
}


void value_set_hierarchical_keyword_field (GValue* value, gpointer v_object) {
	HierarchicalKeywordField* old;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 811 "PhotoMetadata.c"
	} else {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 815 "PhotoMetadata.c"
	}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 821 "PhotoMetadata.c"
	}
}


void value_take_hierarchical_keyword_field (GValue* value, gpointer v_object) {
	HierarchicalKeywordField* old;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 840 "PhotoMetadata.c"
	} else {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 844 "PhotoMetadata.c"
	}
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 850 "PhotoMetadata.c"
	}
}


static void hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((HierarchicalKeywordFieldClass *) klass)->finalize = hierarchical_keyword_field_finalize;
#line 860 "PhotoMetadata.c"
}


static void hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 867 "PhotoMetadata.c"
}


static void hierarchical_keyword_field_finalize (HierarchicalKeywordField* obj) {
	HierarchicalKeywordField * self;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 45 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 46 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 881 "PhotoMetadata.c"
}


GType hierarchical_keyword_field_get_type (void) {
	static volatile gsize hierarchical_keyword_field_type_id__volatile = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&hierarchical_keyword_field_type_id__volatile, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__volatile;
}


gpointer hierarchical_keyword_field_ref (gpointer instance) {
	HierarchicalKeywordField* self;
	self = instance;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return instance;
#line 906 "PhotoMetadata.c"
}


void hierarchical_keyword_field_unref (gpointer instance) {
	HierarchicalKeywordField* self;
	self = instance;
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 44 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 919 "PhotoMetadata.c"
	}
}


PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension) {
	PhotoPreview* self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	Dimensions _tmp2_ = {0};
	guint32 _tmp3_ = 0U;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 67 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp1_;
#line 68 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = *dimensions;
#line 68 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp2_;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = size;
#line 69 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->size = _tmp3_;
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = mime_type;
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 70 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp5_;
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = extension;
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 71 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp7_;
#line 66 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self;
#line 978 "PhotoMetadata.c"
}


gchar* photo_preview_get_name (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 74 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 75 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 75 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 996 "PhotoMetadata.c"
}


void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
	Dimensions _tmp0_ = {0};
#line 78 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 79 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 79 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 79 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return;
#line 1010 "PhotoMetadata.c"
}


guint32 photo_preview_get_size (PhotoPreview* self) {
	guint32 result = 0U;
	guint32 _tmp0_ = 0U;
#line 82 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 83 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->size;
#line 83 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 83 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1025 "PhotoMetadata.c"
}


gchar* photo_preview_get_mime_type (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 86 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 87 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 87 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 87 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1043 "PhotoMetadata.c"
}


gchar* photo_preview_get_extension (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 90 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 91 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 91 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 91 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1061 "PhotoMetadata.c"
}


static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 94 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 94 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1070 "PhotoMetadata.c"
}


guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 94 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 1079 "PhotoMetadata.c"
}


static guint8* _vala_array_dup22 (guint8* self, int length) {
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 1086 "PhotoMetadata.c"
}


static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
	GdkPixbuf* result = NULL;
	guint8* flattened = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_ = NULL;
	gint flattened_length1 = 0;
	gint _flattened_size_ = 0;
	GError * _inner_error_ = NULL;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flattened = _tmp1_;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flattened_length1 = _tmp0_;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 97 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return NULL;
#line 1112 "PhotoMetadata.c"
	}
	{
		GdkPixbuf* _tmp2_ = NULL;
		guint8* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		GMemoryInputStream* _tmp4_ = NULL;
		GMemoryInputStream* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		GdkPixbuf* _tmp8_ = NULL;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = (flattened != NULL) ? _vala_array_dup22 (flattened, flattened_length1) : ((gpointer) flattened);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3__length1 = flattened_length1;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp3_, _tmp3__length1, NULL);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = gdk_pixbuf_new_from_stream ((GInputStream*) _tmp5_, NULL, &_inner_error_);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp5_);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp7_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1141 "PhotoMetadata.c"
			goto __catch516_g_error;
		}
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp2_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = NULL;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = _tmp8_;
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp2_);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 102 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1156 "PhotoMetadata.c"
	}
	goto __finally516;
	__catch516_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = self->priv->name;
#line 105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = err;
#line 105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp10_->message;
#line 105 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:105: Unable to decode thumbnail for %s: %s", _tmp9_, _tmp11_);
#line 107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1185 "PhotoMetadata.c"
	}
	__finally516:
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error_);
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flattened = (g_free (flattened), NULL);
#line 101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1194 "PhotoMetadata.c"
}


GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
#line 96 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 1203 "PhotoMetadata.c"
}


static void value_photo_preview_init (GValue* value) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1210 "PhotoMetadata.c"
}


static void value_photo_preview_free_value (GValue* value) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 1219 "PhotoMetadata.c"
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 1229 "PhotoMetadata.c"
	} else {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1233 "PhotoMetadata.c"
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1241 "PhotoMetadata.c"
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1248 "PhotoMetadata.c"
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1255 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1259 "PhotoMetadata.c"
		}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 1263 "PhotoMetadata.c"
	} else {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1267 "PhotoMetadata.c"
	}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1271 "PhotoMetadata.c"
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1282 "PhotoMetadata.c"
	}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1288 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1292 "PhotoMetadata.c"
	} else {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 1296 "PhotoMetadata.c"
	}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1300 "PhotoMetadata.c"
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1314 "PhotoMetadata.c"
}


gpointer value_get_photo_preview (const GValue* value) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1323 "PhotoMetadata.c"
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 1343 "PhotoMetadata.c"
	} else {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1347 "PhotoMetadata.c"
	}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1353 "PhotoMetadata.c"
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1372 "PhotoMetadata.c"
	} else {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1376 "PhotoMetadata.c"
	}
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1382 "PhotoMetadata.c"
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_preview_finalize;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = photo_preview_real_flatten;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->get_pixbuf = photo_preview_real_get_pixbuf;
#line 1398 "PhotoMetadata.c"
}


static void photo_preview_instance_init (PhotoPreview * self) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1407 "PhotoMetadata.c"
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 60 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 63 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 64 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 1423 "PhotoMetadata.c"
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return instance;
#line 1448 "PhotoMetadata.c"
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 59 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1461 "PhotoMetadata.c"
	}
}


GType photo_metadata_set_option_get_type (void) {
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}


PhotoMetadata* photo_metadata_construct (GType object_type) {
	PhotoMetadata* self = NULL;
#line 152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self;
#line 1484 "PhotoMetadata.c"
}


PhotoMetadata* photo_metadata_new (void) {
#line 152 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1491 "PhotoMetadata.c"
}


static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error) {
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_ = NULL;
	GExiv2Metadata* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	ExifData* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 155 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 156 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 157 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = file;
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp4_, &_inner_error_);
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp4_);
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 159 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 1541 "PhotoMetadata.c"
	}
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = file;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = exif_data_new_from_file (_tmp7_);
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp8_;
#line 160 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = file;
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_file_get_basename (_tmp9_);
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 161 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp10_;
#line 1565 "PhotoMetadata.c"
}


void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
	GExiv2Metadata* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 164 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = file;
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp3_, &_inner_error_);
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 165 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 1597 "PhotoMetadata.c"
	}
}


void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_ = 0;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp3_ = 0;
	GExiv2Metadata* _tmp4_ = NULL;
	GExiv2Metadata* _tmp5_ = NULL;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gint _tmp7_ = 0;
	guint8* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gint _tmp9_ = 0;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 168 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 169 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1625 "PhotoMetadata.c"
		guint8* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
#line 170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 170 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1634 "PhotoMetadata.c"
	}
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 172 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp2__length1 >= _tmp3_, "buffer.length >= length");
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 174 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 175 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 175 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 177 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 1670 "PhotoMetadata.c"
	}
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 178 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<memory buffer %d bytes>", _tmp11_);
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 179 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1692 "PhotoMetadata.c"
}


void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_ = 0;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp3_ = 0;
	GExiv2Metadata* _tmp4_ = NULL;
	GExiv2Metadata* _tmp5_ = NULL;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gint _tmp7_ = 0;
	guint8* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gint _tmp9_ = 0;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 182 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 183 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1719 "PhotoMetadata.c"
		guint8* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 184 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1728 "PhotoMetadata.c"
	}
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 186 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp2__length1 >= _tmp3_, "buffer.length >= length");
#line 188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 188 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 189 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 191 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 1764 "PhotoMetadata.c"
	}
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 192 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<app1 segment %d bytes>", _tmp11_);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 193 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1786 "PhotoMetadata.c"
}


MetadataDomain photo_metadata_get_tag_domain (const gchar* tag) {
	MetadataDomain result = 0;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 196 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_is_exif_tag (_tmp0_);
#line 197 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 198 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1810 "PhotoMetadata.c"
	}
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tag;
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_is_xmp_tag (_tmp2_);
#line 200 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 201 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1822 "PhotoMetadata.c"
	}
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = tag;
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = gexiv2_metadata_is_iptc_tag (_tmp4_);
#line 203 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 204 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1834 "PhotoMetadata.c"
	}
#line 206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 206 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1840 "PhotoMetadata.c"
}


gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_ = 0;
#line 209 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1855 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_has_exif (_tmp1_);
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 212 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1867 "PhotoMetadata.c"
		}
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1871 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
#line 215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_has_xmp (_tmp3_);
#line 215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 215 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1883 "PhotoMetadata.c"
		}
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1887 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_has_iptc (_tmp5_);
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 218 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1899 "PhotoMetadata.c"
		}
		default:
#line 210 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1904 "PhotoMetadata.c"
		{
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 222 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1910 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_has_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 226 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 227 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1927 "PhotoMetadata.c"
}


gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 230 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 231 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1942 "PhotoMetadata.c"
}


gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 234 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 235 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1957 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_ = 0;
#line 238 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1972 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_get_supports_exif (_tmp1_);
#line 241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 241 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1984 "PhotoMetadata.c"
		}
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1988 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
#line 244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_get_supports_xmp (_tmp3_);
#line 244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 244 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 2000 "PhotoMetadata.c"
		}
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2004 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_get_supports_iptc (_tmp5_);
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 247 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 2016 "PhotoMetadata.c"
		}
		default:
#line 239 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 2021 "PhotoMetadata.c"
		{
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 251 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			return result;
#line 2027 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 255 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 256 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2044 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 259 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 260 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2059 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 263 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 264 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2074 "PhotoMetadata.c"
}


gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 267 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_has_tag (_tmp0_, _tmp1_);
#line 268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 268 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2097 "PhotoMetadata.c"
}


static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify) {
	GeeSet* result = NULL;
	GCompareDataFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 273 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 2113 "PhotoMetadata.c"
		GeeHashSet* _tmp1_ = NULL;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp1_;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 274 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 2129 "PhotoMetadata.c"
	} else {
		GCompareDataFunc _tmp2_ = NULL;
		void* _tmp2__target = NULL;
		GDestroyNotify _tmp2__target_destroy_notify = NULL;
		GeeTreeSet* _tmp3_ = NULL;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = compare_func;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2__target = compare_func_target;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2__target_destroy_notify = compare_func_target_destroy_notify;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp2_, _tmp2__target, _tmp2__target_destroy_notify);
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp3_;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 276 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 2157 "PhotoMetadata.c"
	}
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 271 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 2167 "PhotoMetadata.c"
}


GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify) {
	GeeCollection* result = NULL;
	gchar** tags = NULL;
	gint tags_length1 = 0;
	gint _tags_size_ = 0;
	MetadataDomain _tmp0_ = 0;
	gboolean _tmp10_ = FALSE;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	GeeCollection* collection = NULL;
	GCompareDataFunc _tmp13_ = NULL;
	void* _tmp13__target = NULL;
	GDestroyNotify _tmp13__target_destroy_notify = NULL;
	GeeSet* _tmp14_ = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
#line 279 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 281 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 2201 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_ = NULL;
			gchar** _tmp2_ = NULL;
			gchar** _tmp3_ = NULL;
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_ = gexiv2_metadata_get_exif_tags (_tmp1_);
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = _tmp3_;
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp2_);
#line 284 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 285 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 2220 "PhotoMetadata.c"
		}
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 2224 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp4_ = NULL;
			gchar** _tmp5_ = NULL;
			gchar** _tmp6_ = NULL;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->exiv2;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = _tmp5_ = gexiv2_metadata_get_xmp_tags (_tmp4_);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = _tmp6_;
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp5_);
#line 288 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 289 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 2243 "PhotoMetadata.c"
		}
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2247 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp7_ = NULL;
			gchar** _tmp8_ = NULL;
			gchar** _tmp9_ = NULL;
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = self->priv->exiv2;
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_ = gexiv2_metadata_get_iptc_tags (_tmp7_);
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags = _tmp9_;
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp8_);
#line 292 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 293 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 2266 "PhotoMetadata.c"
		}
		default:
#line 282 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		break;
#line 2271 "PhotoMetadata.c"
	}
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = tags;
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11__length1 = tags_length1;
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_ == NULL) {
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = TRUE;
#line 2281 "PhotoMetadata.c"
	} else {
		gchar** _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = tags;
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12__length1 = tags_length1;
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12__length1 == 0;
#line 2291 "PhotoMetadata.c"
	}
#line 296 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp10_) {
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 297 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 2309 "PhotoMetadata.c"
	}
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = compare_func;
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13__target = compare_func_target;
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13__target_destroy_notify = compare_func_target_destroy_notify;
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = photo_metadata_create_string_set (self, _tmp13_, _tmp13__target, _tmp13__target_destroy_notify);
#line 299 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	collection = (GeeCollection*) _tmp14_;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = tags;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15__length1 = tags_length1;
#line 2327 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp15_;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp15__length1;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp15__length1; tag_it = tag_it + 1) {
#line 2339 "PhotoMetadata.c"
			gchar* _tmp16_ = NULL;
			gchar* tag = NULL;
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp16_ = g_strdup (tag_collection[tag_it]);
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp16_;
#line 2346 "PhotoMetadata.c"
			{
				GeeCollection* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
#line 301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp17_ = collection;
#line 301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp18_ = tag;
#line 301 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp17_, _tmp18_);
#line 300 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2358 "PhotoMetadata.c"
			}
		}
	}
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = collection;
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 303 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2376 "PhotoMetadata.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 2383 "PhotoMetadata.c"
}


GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify) {
	GeeCollection* result = NULL;
	GeeCollection* all_tags = NULL;
	GCompareDataFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	GeeSet* _tmp1_ = NULL;
	GeeCollection* exif_tags = NULL;
	GeeCollection* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* xmp_tags = NULL;
	GeeCollection* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GeeCollection* _tmp12_ = NULL;
	GeeCollection* iptc_tags = NULL;
	GeeCollection* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	GeeCollection* _tmp20_ = NULL;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_ = NULL;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	GeeCollection* _tmp31_ = NULL;
#line 306 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__target_destroy_notify = compare_func_target_destroy_notify;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 308 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	all_tags = (GeeCollection*) _tmp1_;
#line 310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL, NULL, NULL);
#line 310 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 2433 "PhotoMetadata.c"
		GeeCollection* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 2445 "PhotoMetadata.c"
	} else {
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 2449 "PhotoMetadata.c"
	}
#line 311 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 2453 "PhotoMetadata.c"
		GeeCollection* _tmp8_ = NULL;
		GeeCollection* _tmp9_ = NULL;
#line 312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = all_tags;
#line 312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = exif_tags;
#line 312 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp8_, _tmp9_);
#line 2462 "PhotoMetadata.c"
	}
#line 314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL, NULL, NULL);
#line 314 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp10_;
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = xmp_tags;
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp12_ != NULL) {
#line 2472 "PhotoMetadata.c"
		GeeCollection* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = xmp_tags;
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = gee_collection_get_size (_tmp13_);
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp15_ > 0;
#line 2484 "PhotoMetadata.c"
	} else {
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 2488 "PhotoMetadata.c"
	}
#line 315 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_) {
#line 2492 "PhotoMetadata.c"
		GeeCollection* _tmp16_ = NULL;
		GeeCollection* _tmp17_ = NULL;
#line 316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = all_tags;
#line 316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = xmp_tags;
#line 316 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp16_, _tmp17_);
#line 2501 "PhotoMetadata.c"
	}
#line 318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL, NULL, NULL);
#line 318 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp18_;
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = iptc_tags;
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp20_ != NULL) {
#line 2511 "PhotoMetadata.c"
		GeeCollection* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		gint _tmp23_ = 0;
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = iptc_tags;
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (_tmp21_);
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp23_ > 0;
#line 2523 "PhotoMetadata.c"
	} else {
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 2527 "PhotoMetadata.c"
	}
#line 319 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 2531 "PhotoMetadata.c"
		GeeCollection* _tmp24_ = NULL;
		GeeCollection* _tmp25_ = NULL;
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = all_tags;
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp25_ = iptc_tags;
#line 320 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp24_, _tmp25_);
#line 2540 "PhotoMetadata.c"
	}
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp27_ = all_tags;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = gee_collection_get_size (_tmp27_);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp28_;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp29_ > 0) {
#line 2550 "PhotoMetadata.c"
		GeeCollection* _tmp30_ = NULL;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp30_ = all_tags;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp30_;
#line 2556 "PhotoMetadata.c"
	} else {
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = NULL;
#line 2560 "PhotoMetadata.c"
	}
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp31_ = _g_object_ref0 (_tmp26_);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp31_;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 322 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2584 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 325 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_label (_tmp0_);
#line 326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 326 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2607 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 329 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_description (_tmp0_);
#line 330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 330 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2630 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag, PrepareInputTextOptions options) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	PrepareInputTextOptions _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_string (_tmp0_, _tmp1_);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = options;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = prepare_input_text (_tmp3_, _tmp4_, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp5_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp6_;
#line 334 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2667 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag, PrepareInputTextOptions options) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	PrepareInputTextOptions _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, _tmp1_);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = options;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = prepare_input_text (_tmp3_, _tmp4_, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp5_;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp6_;
#line 338 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2704 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 341 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2718 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2730 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2737 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp2_ = NULL;
				gchar* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string (self, _tmp2_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 343 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 344 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = value;
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 345 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 2759 "PhotoMetadata.c"
				}
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 342 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2765 "PhotoMetadata.c"
			}
		}
	}
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 348 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2773 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 351 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2787 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2799 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2806 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp2_ = NULL;
				gchar* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_interpreted (self, _tmp2_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 353 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 354 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = value;
#line 355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 355 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 2828 "PhotoMetadata.c"
				}
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 352 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2834 "PhotoMetadata.c"
			}
		}
	}
#line 358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 358 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2842 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag) {
	GeeList* result = NULL;
	gchar** values = NULL;
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint values_length1 = 0;
	gint _values_size_ = 0;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	GeeList* list = NULL;
	GeeArrayList* _tmp7_ = NULL;
	GeeHashSet* collection = NULL;
	GeeHashSet* _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GeeList* _tmp22_ = NULL;
	GeeList* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GeeList* _tmp27_ = NULL;
#line 367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_tag_multiple (_tmp0_, _tmp1_);
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values = _tmp3_;
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp2_);
#line 368 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = values;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = values_length1;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_ == NULL) {
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = TRUE;
#line 2893 "PhotoMetadata.c"
	} else {
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = values;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = values_length1;
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp6__length1 == 0;
#line 2903 "PhotoMetadata.c"
	}
#line 369 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 370 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 2913 "PhotoMetadata.c"
	}
#line 372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 372 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	list = (GeeList*) _tmp7_;
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 374 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	collection = _tmp8_;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = values;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9__length1 = values_length1;
#line 2927 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value_collection = _tmp9_;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp9__length1;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < _tmp9__length1; value_it = value_it + 1) {
#line 2939 "PhotoMetadata.c"
			gchar* _tmp10_ = NULL;
			gchar* value = NULL;
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp10_ = g_strdup (value_collection[value_it]);
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			value = _tmp10_;
#line 2946 "PhotoMetadata.c"
			{
				gchar* prepped = NULL;
				const gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				const gchar* _tmp14_ = NULL;
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = value;
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = prepare_input_text (_tmp11_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 376 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				prepped = _tmp12_;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp14_ = prepped;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp14_ != NULL) {
#line 2963 "PhotoMetadata.c"
					GeeHashSet* _tmp15_ = NULL;
					const gchar* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp15_ = collection;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp16_ = prepped;
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp17_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp13_ = !_tmp17_;
#line 2975 "PhotoMetadata.c"
				} else {
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp13_ = FALSE;
#line 2979 "PhotoMetadata.c"
				}
#line 379 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp13_) {
#line 2983 "PhotoMetadata.c"
					GeeList* _tmp18_ = NULL;
					const gchar* _tmp19_ = NULL;
					GeeHashSet* _tmp20_ = NULL;
					const gchar* _tmp21_ = NULL;
#line 380 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp18_ = list;
#line 380 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp19_ = prepped;
#line 380 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp18_, _tmp19_);
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp20_ = collection;
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp21_ = prepped;
#line 381 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 3000 "PhotoMetadata.c"
				}
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 375 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 3006 "PhotoMetadata.c"
			}
		}
	}
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = list;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = gee_collection_get_size ((GeeCollection*) _tmp23_);
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = _tmp24_;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp25_ > 0) {
#line 3018 "PhotoMetadata.c"
		GeeList* _tmp26_ = NULL;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = list;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp26_;
#line 3024 "PhotoMetadata.c"
	} else {
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = NULL;
#line 3028 "PhotoMetadata.c"
	}
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp27_ = _g_object_ref0 (_tmp22_);
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp27_;
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 385 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3042 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1) {
	GeeList* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 394 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3056 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3068 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3075 "PhotoMetadata.c"
			{
				GeeList* values = NULL;
				const gchar* _tmp2_ = NULL;
				GeeList* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				GeeList* _tmp5_ = NULL;
#line 396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 396 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				values = _tmp3_;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 3092 "PhotoMetadata.c"
					GeeList* _tmp6_ = NULL;
					gint _tmp7_ = 0;
					gint _tmp8_ = 0;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 3104 "PhotoMetadata.c"
				} else {
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 3108 "PhotoMetadata.c"
				}
#line 397 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = values;
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 398 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 3118 "PhotoMetadata.c"
				}
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 395 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3124 "PhotoMetadata.c"
			}
		}
	}
#line 401 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 401 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3132 "PhotoMetadata.c"
}


void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value, PrepareInputTextOptions options) {
	gchar* prepped = NULL;
	const gchar* _tmp0_ = NULL;
	PrepareInputTextOptions _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GExiv2Metadata* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = options;
#line 405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = prepare_input_text (_tmp0_, _tmp1_, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 405 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	prepped = _tmp2_;
#line 406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = prepped;
#line 406 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_ == NULL) {
#line 3164 "PhotoMetadata.c"
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = tag;
#line 407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = value;
#line 407 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:407: Not setting tag %s to string %s: invalid UTF-8", _tmp4_, _tmp5_);
#line 409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 409 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 3177 "PhotoMetadata.c"
	}
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->exiv2;
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = tag;
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = prepped;
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = gexiv2_metadata_set_tag_string (_tmp6_, _tmp7_, _tmp8_);
#line 412 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp9_) {
#line 3189 "PhotoMetadata.c"
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = tag;
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = value;
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->source_name;
#line 413 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:413: Unable to set tag %s to string %s from source " \
"%s", _tmp10_, _tmp11_, _tmp12_);
#line 3201 "PhotoMetadata.c"
	}
#line 404 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 3205 "PhotoMetadata.c"
}


static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target) {
	gboolean written = FALSE;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	PhotoMetadataSetOption _tmp11_ = 0;
#line 418 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 419 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3224 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3236 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3243 "PhotoMetadata.c"
			{
				gboolean _tmp2_ = FALSE;
				PhotoMetadataSetOption _tmp3_ = 0;
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = option;
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp3_ == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp2_ = TRUE;
#line 3253 "PhotoMetadata.c"
				} else {
					const gchar* _tmp4_ = NULL;
					MetadataDomain _tmp5_ = 0;
					gboolean _tmp6_ = FALSE;
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = tag;
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp5_ = photo_metadata_get_tag_domain (_tmp4_);
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = photo_metadata_has_domain (self, _tmp5_);
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp2_ = _tmp6_;
#line 3266 "PhotoMetadata.c"
				}
#line 421 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp2_) {
#line 3270 "PhotoMetadata.c"
					PhotoMetadataSetGenericValue _tmp7_ = NULL;
					void* _tmp7__target = NULL;
					const gchar* _tmp8_ = NULL;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = setter;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7__target = setter_target;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = tag;
#line 422 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ (_tmp8_, _tmp7__target);
#line 423 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 3284 "PhotoMetadata.c"
				}
#line 420 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3288 "PhotoMetadata.c"
			}
		}
	}
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = option;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_ == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 3296 "PhotoMetadata.c"
		gboolean _tmp12_ = FALSE;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = written;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = !_tmp12_;
#line 3302 "PhotoMetadata.c"
	} else {
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 3306 "PhotoMetadata.c"
	}
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp10_) {
#line 3310 "PhotoMetadata.c"
		gchar** _tmp13_ = NULL;
		gint _tmp13__length1 = 0;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = tags;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13__length1 = tags_length1;
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp13__length1 > 0;
#line 3319 "PhotoMetadata.c"
	} else {
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = FALSE;
#line 3323 "PhotoMetadata.c"
	}
#line 427 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp9_) {
#line 3327 "PhotoMetadata.c"
		MetadataDomain default_domain = 0;
		gchar** _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		const gchar* _tmp15_ = NULL;
		MetadataDomain _tmp16_ = 0;
		PhotoMetadataSetGenericValue _tmp17_ = NULL;
		void* _tmp17__target = NULL;
		gchar** _tmp18_ = NULL;
		gint _tmp18__length1 = 0;
		const gchar* _tmp19_ = NULL;
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = tags;
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp14__length1 = tags_length1;
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_[0];
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = photo_metadata_get_tag_domain (_tmp15_);
#line 428 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		default_domain = _tmp16_;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = setter;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17__target = setter_target;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = tags;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp18__length1 = tags_length1;
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp18_[0];
#line 431 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17_ (_tmp19_, _tmp17__target);
#line 3360 "PhotoMetadata.c"
		{
			gint ctr = 0;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 3365 "PhotoMetadata.c"
			{
				gboolean _tmp20_ = FALSE;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp20_ = TRUE;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 3372 "PhotoMetadata.c"
					gint _tmp22_ = 0;
					gchar** _tmp23_ = NULL;
					gint _tmp23__length1 = 0;
					gchar** _tmp24_ = NULL;
					gint _tmp24__length1 = 0;
					gint _tmp25_ = 0;
					const gchar* _tmp26_ = NULL;
					MetadataDomain _tmp27_ = 0;
					MetadataDomain _tmp28_ = 0;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (!_tmp20_) {
#line 3384 "PhotoMetadata.c"
						gint _tmp21_ = 0;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp21_ = ctr;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						ctr = _tmp21_ + 1;
#line 3390 "PhotoMetadata.c"
					}
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp20_ = FALSE;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp22_ = ctr;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp23_ = tags;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp23__length1 = tags_length1;
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (!(_tmp22_ < _tmp23__length1)) {
#line 434 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						break;
#line 3404 "PhotoMetadata.c"
					}
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp24_ = tags;
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp24__length1 = tags_length1;
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp25_ = ctr;
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp26_ = _tmp24_[_tmp25_];
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp27_ = photo_metadata_get_tag_domain (_tmp26_);
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp28_ = default_domain;
#line 435 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (_tmp27_ == _tmp28_) {
#line 3420 "PhotoMetadata.c"
						PhotoMetadataSetGenericValue _tmp29_ = NULL;
						void* _tmp29__target = NULL;
						gchar** _tmp30_ = NULL;
						gint _tmp30__length1 = 0;
						gint _tmp31_ = 0;
						const gchar* _tmp32_ = NULL;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp29_ = setter;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp29__target = setter_target;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp30_ = tags;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp30__length1 = tags_length1;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp31_ = ctr;
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp32_ = _tmp30_[_tmp31_];
#line 436 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp29_ (_tmp32_, _tmp29__target);
#line 3441 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}


static Block7Data* block7_data_ref (Block7Data* _data7_) {
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return _data7_;
#line 3455 "PhotoMetadata.c"
}


static void block7_data_unref (void * _userdata_) {
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3464 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		self = _data7_->self;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_data7_->value);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block7Data, _data7_);
#line 3474 "PhotoMetadata.c"
	}
}


static void __lambda5_ (Block7Data* _data7_, const gchar* tag) {
	PhotoMetadata* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = _data7_->self;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data7_->value;
#line 443 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, _tmp0_, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 3493 "PhotoMetadata.c"
}


static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 3500 "PhotoMetadata.c"
}


void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option) {
	Block7Data* _data7_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	PhotoMetadataSetOption _tmp3_ = 0;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data7_->_ref_count_ = 1;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data7_->self = media_metadata_ref (self);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_data7_->value);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data7_->value = _tmp1_;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 442 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda5__photo_metadata_set_generic_value, _data7_);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	block7_data_unref (_data7_);
#line 441 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data7_ = NULL;
#line 3541 "PhotoMetadata.c"
}


static void _vala_array_add232 (gchar*** array, int* length, int* size, gchar* value) {
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3552 "PhotoMetadata.c"
	}
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3558 "PhotoMetadata.c"
}


static void _vala_array_add233 (gchar*** array, int* length, int* size, gchar* value) {
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3569 "PhotoMetadata.c"
	}
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3575 "PhotoMetadata.c"
}


void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection) {
	gchar** values = NULL;
	gchar** _tmp0_ = NULL;
	gint values_length1 = 0;
	gint _values_size_ = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gchar** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	GExiv2Metadata* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gchar** _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gboolean _tmp20_ = FALSE;
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (collection != NULL);
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 448 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 3607 "PhotoMetadata.c"
	{
		GeeIterator* _value_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = collection;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_value_it = _tmp2_;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 3620 "PhotoMetadata.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			gchar* value = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			gchar* prepped = NULL;
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			if (!_tmp4_) {
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				break;
#line 3638 "PhotoMetadata.c"
			}
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = _value_it;
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp6_;
#line 450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = value;
#line 450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp8_ = prepare_input_text (_tmp7_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 450 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			prepped = _tmp8_;
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = prepped;
#line 451 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			if (_tmp9_ != NULL) {
#line 3656 "PhotoMetadata.c"
				gchar** _tmp10_ = NULL;
				gint _tmp10__length1 = 0;
				const gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = values;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp10__length1 = values_length1;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = prepped;
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 452 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_vala_array_add232 (&values, &values_length1, &_values_size_, _tmp12_);
#line 3671 "PhotoMetadata.c"
			} else {
				const gchar* _tmp13_ = NULL;
				const gchar* _tmp14_ = NULL;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp13_ = value;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp14_ = tag;
#line 454 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:454: Unable to set string %s to %s: invalid UTF-8", _tmp13_, _tmp14_);
#line 3681 "PhotoMetadata.c"
			}
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 3687 "PhotoMetadata.c"
		}
#line 449 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 3691 "PhotoMetadata.c"
	}
#line 457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = values;
#line 457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15__length1 = values_length1;
#line 457 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp15__length1 == 0) {
#line 458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 458 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 3703 "PhotoMetadata.c"
	}
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = values;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp16__length1 = values_length1;
#line 464 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_array_add233 (&values, &values_length1, &_values_size_, NULL);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = self->priv->exiv2;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = tag;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = values;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = values_length1;
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = gexiv2_metadata_set_tag_multiple (_tmp17_, _tmp18_, _tmp19_);
#line 466 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp20_) {
#line 3723 "PhotoMetadata.c"
		gchar** _tmp21_ = NULL;
		gint _tmp21__length1 = 0;
		const gchar* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = values;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp21__length1 = values_length1;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = tag;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = self->priv->source_name;
#line 467 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:467: Unable to set %d strings to tag %s from source" \
" %s", _tmp21__length1, _tmp22_, _tmp23_);
#line 3738 "PhotoMetadata.c"
	}
#line 447 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 3742 "PhotoMetadata.c"
}


static Block8Data* block8_data_ref (Block8Data* _data8_) {
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return _data8_;
#line 3751 "PhotoMetadata.c"
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3760 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		self = _data8_->self;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data8_->values);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block8Data, _data8_);
#line 3770 "PhotoMetadata.c"
	}
}


static void __lambda6_ (Block8Data* _data8_, const gchar* tag) {
	PhotoMetadata* self;
	const gchar* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = _data8_->self;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data8_->values;
#line 472 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, _tmp0_, _tmp1_);
#line 3789 "PhotoMetadata.c"
}


static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 3796 "PhotoMetadata.c"
}


void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option) {
	Block8Data* _data8_;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	PhotoMetadataSetOption _tmp3_ = 0;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (values != NULL);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data8_->_ref_count_ = 1;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data8_->self = media_metadata_ref (self);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = values;
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_data8_->values);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data8_->values = _tmp1_;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 471 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda6__photo_metadata_set_generic_value, _data8_);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	block8_data_unref (_data8_);
#line 470 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data8_ = NULL;
#line 3837 "PhotoMetadata.c"
}


gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GExiv2Metadata* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	glong _tmp4_ = 0L;
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 476 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, _tmp0_);
#line 477 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 478 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_vala_value = (glong) 0;
#line 480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (value) {
#line 480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 3867 "PhotoMetadata.c"
		}
#line 480 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 3871 "PhotoMetadata.c"
	}
#line 483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = tag;
#line 483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_tag_long (_tmp2_, _tmp3_);
#line 483 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_value = _tmp4_;
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (value) {
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3887 "PhotoMetadata.c"
	}
#line 485 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3891 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 488 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3906 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3918 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3925 "PhotoMetadata.c"
			{
				const gchar* _tmp2_ = NULL;
				glong _tmp3_ = 0L;
				gboolean _tmp4_ = FALSE;
#line 490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_long (self, _tmp2_, &_tmp3_);
#line 490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_vala_value = _tmp3_;
#line 490 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (value) {
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 3946 "PhotoMetadata.c"
					}
#line 491 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 3950 "PhotoMetadata.c"
				}
#line 489 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3954 "PhotoMetadata.c"
			}
		}
	}
#line 494 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (value) {
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3966 "PhotoMetadata.c"
	}
#line 496 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3970 "PhotoMetadata.c"
}


void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value) {
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	glong _tmp2_ = 0L;
	gboolean _tmp3_ = FALSE;
#line 499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 499 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_set_tag_long (_tmp0_, _tmp1_, _tmp2_);
#line 500 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp3_) {
#line 3993 "PhotoMetadata.c"
		const gchar* _tmp4_ = NULL;
		glong _tmp5_ = 0L;
		const gchar* _tmp6_ = NULL;
#line 501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = tag;
#line 501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = value;
#line 501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->source_name;
#line 501 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:501: Unable to set tag %s to long %ld from source %" \
"s", _tmp4_, _tmp5_, _tmp6_);
#line 4005 "PhotoMetadata.c"
	}
}


static Block9Data* block9_data_ref (Block9Data* _data9_) {
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return _data9_;
#line 4015 "PhotoMetadata.c"
}


static void block9_data_unref (void * _userdata_) {
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 4024 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		self = _data9_->self;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block9Data, _data9_);
#line 4032 "PhotoMetadata.c"
	}
}


static void __lambda7_ (Block9Data* _data9_, const gchar* tag) {
	PhotoMetadata* self;
	const gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = _data9_->self;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data9_->value;
#line 506 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, _tmp0_, _tmp1_);
#line 4051 "PhotoMetadata.c"
}


static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 4058 "PhotoMetadata.c"
}


void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option) {
	Block9Data* _data9_;
	glong _tmp0_ = 0L;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	PhotoMetadataSetOption _tmp2_ = 0;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data9_->_ref_count_ = 1;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data9_->self = media_metadata_ref (self);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data9_->value = _tmp0_;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 505 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda7__photo_metadata_set_generic_value, _data9_);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	block9_data_unref (_data9_);
#line 504 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data9_ = NULL;
#line 4092 "PhotoMetadata.c"
}


gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gint numerator = 0;
	gint denominator = 0;
	gboolean _result_ = FALSE;
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 510 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	numerator = _tmp2_;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	denominator = _tmp3_;
#line 512 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_result_ = _tmp4_;
#line 514 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, numerator, denominator);
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _result_;
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4131 "PhotoMetadata.c"
	}
#line 516 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4135 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 519 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4150 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4162 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4169 "PhotoMetadata.c"
			{
				const gchar* _tmp2_ = NULL;
				MetadataRational _tmp3_ = {0};
				gboolean _tmp4_ = FALSE;
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_rational (self, _tmp2_, &_tmp3_);
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp3_;
#line 521 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (rational) {
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 4190 "PhotoMetadata.c"
					}
#line 522 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 4194 "PhotoMetadata.c"
				}
#line 520 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4198 "PhotoMetadata.c"
			}
		}
	}
#line 525 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4210 "PhotoMetadata.c"
	}
#line 527 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4214 "PhotoMetadata.c"
}


void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	MetadataRational _tmp2_ = {0};
	gint _tmp3_ = 0;
	MetadataRational _tmp4_ = {0};
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
#line 530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 530 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = *rational;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = gexiv2_metadata_set_exif_tag_rational (_tmp0_, _tmp1_, _tmp3_, _tmp5_);
#line 531 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 4248 "PhotoMetadata.c"
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = tag;
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = metadata_rational_to_string (rational);
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_;
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:532: Unable to set tag %s to rational %s from sourc" \
"e %s", _tmp7_, _tmp9_, _tmp10_);
#line 532 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp9_);
#line 4265 "PhotoMetadata.c"
	}
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return _data10_;
#line 4275 "PhotoMetadata.c"
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 4284 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		self = _data10_->self;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block10Data, _data10_);
#line 4292 "PhotoMetadata.c"
	}
}


static void __lambda8_ (Block10Data* _data10_, const gchar* tag) {
	PhotoMetadata* self;
	const gchar* _tmp0_ = NULL;
	MetadataRational _tmp1_ = {0};
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = _data10_->self;
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data10_->rational;
#line 539 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, _tmp0_, &_tmp1_);
#line 4311 "PhotoMetadata.c"
}


static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	__lambda8_ (self, tag);
#line 4318 "PhotoMetadata.c"
}


void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option) {
	Block10Data* _data10_;
	MetadataRational _tmp0_ = {0};
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	PhotoMetadataSetOption _tmp2_ = 0;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data10_->_ref_count_ = 1;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data10_->self = media_metadata_ref (self);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data10_->rational = _tmp0_;
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 538 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda8__photo_metadata_set_generic_value, _data10_);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	block10_data_unref (_data10_);
#line 537 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data10_ = NULL;
#line 4354 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag) {
	MetadataDateTime* result = NULL;
	gchar* value = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 543 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 543 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_string (self, _tmp0_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 544 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	value = _tmp1_;
#line 545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 545 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == NULL) {
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 546 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4385 "PhotoMetadata.c"
	}
	{
		const gchar* _tmp3_ = NULL;
		MetadataDomain _tmp4_ = 0;
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = tag;
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_tag_domain (_tmp3_);
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		switch (_tmp4_) {
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 4398 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				MetadataDateTime* _tmp7_ = NULL;
				MetadataDateTime* _tmp8_ = NULL;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = value;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = metadata_date_time_new_from_xmp (_tmp6_, &_inner_error_);
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp7_;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4412 "PhotoMetadata.c"
					goto __catch517_g_error;
				}
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = _tmp5_;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = NULL;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				result = _tmp8_;
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp5_);
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 551 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				return result;
#line 4427 "PhotoMetadata.c"
			}
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 4431 "PhotoMetadata.c"
			{
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				result = NULL;
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 556 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				return result;
#line 4439 "PhotoMetadata.c"
			}
			default:
#line 549 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 4444 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp9_ = NULL;
				const gchar* _tmp10_ = NULL;
				MetadataDateTime* _tmp11_ = NULL;
				MetadataDateTime* _tmp12_ = NULL;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = metadata_date_time_new_from_exif (_tmp10_, &_inner_error_);
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp11_;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4458 "PhotoMetadata.c"
					goto __catch517_g_error;
				}
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = _tmp9_;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = NULL;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				result = _tmp12_;
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp9_);
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 560 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				return result;
#line 4473 "PhotoMetadata.c"
			}
		}
	}
	goto __finally517;
	__catch517_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = tag;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = self->priv->source_name;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = err;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = _tmp15_->message;
#line 563 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:563: Unable to read date/time %s from source %s: %s", _tmp13_, _tmp14_, _tmp16_);
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 565 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4507 "PhotoMetadata.c"
	}
	__finally517:
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error_);
#line 548 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 4518 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 569 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4532 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4544 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4551 "PhotoMetadata.c"
			{
				MetadataDateTime* date_time = NULL;
				const gchar* _tmp2_ = NULL;
				MetadataDateTime* _tmp3_ = NULL;
				MetadataDateTime* _tmp4_ = NULL;
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_date_time (self, _tmp2_);
#line 571 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				date_time = _tmp3_;
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = date_time;
#line 572 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = date_time;
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 573 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 4573 "PhotoMetadata.c"
				}
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 570 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4579 "PhotoMetadata.c"
			}
		}
	}
#line 576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 576 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4587 "PhotoMetadata.c"
}


void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time) {
	const gchar* _tmp0_ = NULL;
	MetadataDomain _tmp1_ = 0;
#line 579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 579 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_tag_domain (_tmp0_);
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	switch (_tmp1_) {
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4608 "PhotoMetadata.c"
		{
			const gchar* _tmp2_ = NULL;
			MetadataDateTime* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = tag;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = date_time;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = metadata_date_time_get_exif_label (_tmp3_);
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_;
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp2_, _tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 582 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp5_);
#line 583 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 4628 "PhotoMetadata.c"
		}
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4632 "PhotoMetadata.c"
		{
			const gchar* _tmp6_ = NULL;
			MetadataDateTime* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = tag;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = date_time;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp8_ = metadata_date_time_get_xmp_label (_tmp7_);
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_;
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp6_, _tmp9_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 586 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp9_);
#line 587 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 4652 "PhotoMetadata.c"
		}
		default:
#line 580 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4657 "PhotoMetadata.c"
		{
			const gchar* _tmp10_ = NULL;
			const gchar* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			MetadataDomain _tmp13_ = 0;
			GEnumValue* _tmp14_;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp10_ = tag;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp11_ = self->priv->source_name;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp12_ = tag;
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp13_ = photo_metadata_get_tag_domain (_tmp12_);
#line 593 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp14_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), _tmp13_);
#line 592 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:592: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", _tmp10_, _tmp11_, (_tmp14_ != NULL) ? _tmp14_->value_name : NULL);
#line 594 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 4678 "PhotoMetadata.c"
		}
	}
}


static gpointer _metadata_date_time_ref0 (gpointer self) {
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 4687 "PhotoMetadata.c"
}


static Block11Data* block11_data_ref (Block11Data* _data11_) {
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return _data11_;
#line 4696 "PhotoMetadata.c"
}


static void block11_data_unref (void * _userdata_) {
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 4705 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		self = _data11_->self;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data11_->date_time);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block11Data, _data11_);
#line 4715 "PhotoMetadata.c"
	}
}


static void __lambda9_ (Block11Data* _data11_, const gchar* tag) {
	PhotoMetadata* self;
	const gchar* _tmp0_ = NULL;
	MetadataDateTime* _tmp1_ = NULL;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = _data11_->self;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data11_->date_time;
#line 600 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, _tmp0_, _tmp1_);
#line 4734 "PhotoMetadata.c"
}


static void ___lambda9__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	__lambda9_ (self, tag);
#line 4741 "PhotoMetadata.c"
}


void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	Block11Data* _data11_;
	MetadataDateTime* _tmp0_ = NULL;
	MetadataDateTime* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	PhotoMetadataSetOption _tmp3_ = 0;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data11_->_ref_count_ = 1;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data11_->self = media_metadata_ref (self);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _metadata_date_time_ref0 (_tmp0_);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_metadata_date_time_unref0 (_data11_->date_time);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data11_->date_time = _tmp1_;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 599 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda9__photo_metadata_set_generic_value, _data11_);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	block11_data_unref (_data11_);
#line 598 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_data11_ = NULL;
#line 4782 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
	guint8* result = NULL;
	ExifData* _tmp0_ = NULL;
	guchar* thumbnail = NULL;
	ExifData* _tmp2_ = NULL;
	guchar* _tmp3_ = NULL;
	guint thumbnail_size = 0U;
	ExifData* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	gboolean _tmp6_ = FALSE;
	guint8* flattened = NULL;
	gint flattened_length1 = 0;
	gint _flattened_size_ = 0;
	guchar* saved_data = NULL;
	guint saved_size = 0U;
	ExifData* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	guint _tmp11_ = 0U;
	ExifData* _tmp21_ = NULL;
	guchar* _tmp22_ = NULL;
	ExifData* _tmp23_ = NULL;
	guint _tmp24_ = 0U;
	guint8* _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
#line 605 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 606 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 4816 "PhotoMetadata.c"
		guint8* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = 0;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (result_length1) {
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*result_length1 = _tmp1__length1;
#line 4827 "PhotoMetadata.c"
		}
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = _tmp1_;
#line 607 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4833 "PhotoMetadata.c"
	}
#line 611 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exif;
#line 611 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_->data;
#line 611 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	thumbnail = _tmp3_;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_->size;
#line 612 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	thumbnail_size = _tmp5_;
#line 613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = include_preview;
#line 613 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 4851 "PhotoMetadata.c"
		ExifData* _tmp7_ = NULL;
		ExifData* _tmp8_ = NULL;
#line 614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 614 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_->data = NULL;
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = self->priv->exif;
#line 615 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_->size = (guint) 0;
#line 4862 "PhotoMetadata.c"
	}
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flattened = NULL;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flattened_length1 = 0;
#line 618 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 621 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 622 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = self->priv->exif;
#line 623 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp9_, &saved_data, &saved_size);
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = saved_size;
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_ > ((guint) 0)) {
#line 4882 "PhotoMetadata.c"
		guchar* _tmp12_ = NULL;
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = saved_data;
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4888 "PhotoMetadata.c"
	} else {
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 4892 "PhotoMetadata.c"
	}
#line 624 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp10_) {
#line 4896 "PhotoMetadata.c"
		guint _tmp13_ = 0U;
		guint8* _tmp14_ = NULL;
		guint8* _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		guchar* _tmp16_ = NULL;
		guint _tmp17_ = 0U;
		ExifMem* _tmp18_ = NULL;
		ExifMem* _tmp19_ = NULL;
		guchar* _tmp20_ = NULL;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = saved_size;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = g_new0 (guint8, _tmp13_);
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		flattened = _tmp14_;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		flattened_length1 = _tmp13_;
#line 625 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_flattened_size_ = flattened_length1;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = flattened;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp15__length1 = flattened_length1;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = saved_data;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = saved_size;
#line 626 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		memcpy (_tmp15_, _tmp16_, (gsize) _tmp17_);
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = exif_mem_new_default ();
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp18_;
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = saved_data;
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp19_, _tmp20_);
#line 628 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp19_);
#line 4938 "PhotoMetadata.c"
	}
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp21_ = self->priv->exif;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = thumbnail;
#line 632 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp21_->data = _tmp22_;
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = self->priv->exif;
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = thumbnail_size;
#line 633 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_->size = _tmp24_;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = flattened;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp25__length1 = flattened_length1;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp25__length1;
#line 4960 "PhotoMetadata.c"
	}
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp25_;
#line 635 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4966 "PhotoMetadata.c"
}


static guint8* _vala_array_dup23 (guint8* self, int length) {
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4973 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
	guint8* result = NULL;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	GExiv2Metadata* _tmp1_ = NULL;
	guint8* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	guint8* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
#line 639 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_thumbnail (_tmp1_, &_tmp2_, &_tmp3_);
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	buffer = _tmp2_;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp3_;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 5009 "PhotoMetadata.c"
		guchar* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = buffer;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = buffer_length1;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp5_;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = _tmp5__length1;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 5022 "PhotoMetadata.c"
	} else {
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = 0;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 5030 "PhotoMetadata.c"
	}
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = (_tmp0_ != NULL) ? _vala_array_dup23 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = _tmp0__length1;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7__length1 = _tmp6__length1;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp7__length1;
#line 5044 "PhotoMetadata.c"
	}
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp7_;
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 641 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5052 "PhotoMetadata.c"
}


guint photo_metadata_get_preview_count (PhotoMetadata* self) {
	guint result = 0U;
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_ = NULL;
	GExiv2PreviewProperties** _tmp1_ = NULL;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	gint props_length1 = 0;
	gint _props_size_ = 0;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
#line 644 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 645 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 5085 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 5094 "PhotoMetadata.c"
	} else {
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 5098 "PhotoMetadata.c"
	}
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = (guint) _tmp3_;
#line 647 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5104 "PhotoMetadata.c"
}


PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
	PhotoPreview* result = NULL;
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_ = NULL;
	GExiv2PreviewProperties** _tmp1_ = NULL;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	gint props_length1 = 0;
	gint _props_size_ = 0;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	const gchar* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	GExiv2PreviewProperties** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	guint _tmp10_ = 0U;
	GExiv2PreviewProperties* _tmp11_ = NULL;
	PhotoMetadataInternalPhotoPreview* _tmp12_ = NULL;
#line 651 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 652 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 5146 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		guint _tmp6_ = 0U;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = number;
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= _tmp6_;
#line 5159 "PhotoMetadata.c"
	}
#line 653 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 654 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 5167 "PhotoMetadata.c"
	}
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = self->priv->source_name;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = number;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = props;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9__length1 = props_length1;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = number;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = _tmp9_[_tmp10_];
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = photo_metadata_internal_photo_preview_new (self, _tmp7_, _tmp8_, _tmp11_);
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = (PhotoPreview*) _tmp12_;
#line 656 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5187 "PhotoMetadata.c"
}


void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_ = NULL;
	ExifData* _tmp1_ = NULL;
#line 659 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 660 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 661 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 5204 "PhotoMetadata.c"
		ExifMem* _tmp2_ = NULL;
		ExifMem* _tmp3_ = NULL;
		ExifData* _tmp4_ = NULL;
		guchar* _tmp5_ = NULL;
		ExifData* _tmp6_ = NULL;
		ExifData* _tmp7_ = NULL;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 662 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 663 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 664 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 5231 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag) {
	GExiv2Metadata* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 668 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 668 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 669 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, _tmp1_);
#line 5249 "PhotoMetadata.c"
}


void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 672 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 5262 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 5274 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 5281 "PhotoMetadata.c"
			{
				const gchar* _tmp2_ = NULL;
#line 674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 674 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp2_);
#line 673 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5290 "PhotoMetadata.c"
			}
		}
	}
}


void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
	MetadataDomain _tmp0_ = 0;
#line 677 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 5307 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_ = NULL;
#line 680 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 680 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp1_);
#line 681 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 5316 "PhotoMetadata.c"
		}
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 5320 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_ = NULL;
#line 684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 684 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp2_);
#line 685 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 5329 "PhotoMetadata.c"
		}
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 5333 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_ = NULL;
#line 688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 688 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp3_);
#line 689 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			break;
#line 5342 "PhotoMetadata.c"
		}
		default:
#line 678 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		break;
#line 5347 "PhotoMetadata.c"
	}
}


void photo_metadata_clear (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_ = NULL;
#line 693 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 694 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 5360 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	MetadataDateTime* _tmp1_ = NULL;
#line 703 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 704 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5381 "PhotoMetadata.c"
}


void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_ = NULL;
#line 707 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 709 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5393 "PhotoMetadata.c"
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		MetadataDateTime* _tmp2_ = NULL;
		PhotoMetadataSetOption _tmp3_ = 0;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 710 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5408 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
#line 712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DATE_TIME_TAGS;
#line 712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 712 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5418 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	MetadataDateTime* _tmp1_ = NULL;
#line 724 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 725 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5440 "PhotoMetadata.c"
}


void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_ = NULL;
#line 728 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 730 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5452 "PhotoMetadata.c"
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		MetadataDateTime* _tmp2_ = NULL;
		PhotoMetadataSetOption _tmp3_ = 0;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 731 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5467 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 733 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5477 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	MetadataDateTime* _tmp1_ = NULL;
#line 741 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 742 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5499 "PhotoMetadata.c"
}


void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_ = NULL;
#line 745 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 747 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5511 "PhotoMetadata.c"
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		MetadataDateTime* _tmp2_ = NULL;
		PhotoMetadataSetOption _tmp3_ = 0;
#line 748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 748 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5526 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
#line 750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 750 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5536 "PhotoMetadata.c"
	}
}


static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base) {
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* creation = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	MetadataDateTime* _tmp1_ = NULL;
#line 753 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 754 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 755 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 5557 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_ = NULL;
#line 756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 756 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 5565 "PhotoMetadata.c"
	}
#line 758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = creation;
#line 758 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5571 "PhotoMetadata.c"
}


static gpointer _dimensions_dup0 (gpointer self) {
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 5578 "PhotoMetadata.c"
}


Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
	Dimensions* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 775 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 777 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0__length1 == _tmp1__length1, "WIDTH_TAGS.length == HEIGHT_TAGS.length");
#line 5600 "PhotoMetadata.c"
	{
		gint ctr = 0;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 5605 "PhotoMetadata.c"
		{
			gboolean _tmp2_ = FALSE;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 5612 "PhotoMetadata.c"
				gint _tmp4_ = 0;
				gchar** _tmp5_ = NULL;
				gint _tmp5__length1 = 0;
				glong width = 0L;
				gchar** _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gint _tmp7_ = 0;
				const gchar* _tmp8_ = NULL;
				glong _tmp9_ = 0L;
				gboolean _tmp10_ = FALSE;
				glong height = 0L;
				gchar** _tmp11_ = NULL;
				gint _tmp11__length1 = 0;
				gint _tmp12_ = 0;
				const gchar* _tmp13_ = NULL;
				glong _tmp14_ = 0L;
				gboolean _tmp15_ = FALSE;
				glong _tmp16_ = 0L;
				glong _tmp17_ = 0L;
				Dimensions _tmp18_ = {0};
				Dimensions* _tmp19_ = NULL;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!_tmp2_) {
#line 5636 "PhotoMetadata.c"
					gint _tmp3_ = 0;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp3_ = ctr;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					ctr = _tmp3_ + 1;
#line 5642 "PhotoMetadata.c"
				}
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = ctr;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_WIDTH_TAGS;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!(_tmp4_ < _tmp5__length1)) {
#line 778 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					break;
#line 5656 "PhotoMetadata.c"
				}
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = photo_metadata_WIDTH_TAGS;
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = ctr;
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = _tmp6_[_tmp7_];
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = photo_metadata_get_long (self, _tmp8_, &_tmp9_);
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				width = _tmp9_;
#line 782 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!_tmp10_) {
#line 783 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					continue;
#line 5674 "PhotoMetadata.c"
				}
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = photo_metadata_HEIGHT_TAGS;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp11__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = ctr;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp13_ = _tmp11_[_tmp12_];
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp15_ = photo_metadata_get_long (self, _tmp13_, &_tmp14_);
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				height = _tmp14_;
#line 786 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!_tmp15_) {
#line 787 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					continue;
#line 5692 "PhotoMetadata.c"
				}
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp16_ = width;
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp17_ = height;
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp18_, (gint) _tmp16_, (gint) _tmp17_);
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp19_ = _dimensions_dup0 (&_tmp18_);
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				result = _tmp19_;
#line 789 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				return result;
#line 5706 "PhotoMetadata.c"
			}
		}
	}
#line 792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 792 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5714 "PhotoMetadata.c"
}


void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option) {
	Dimensions* _tmp0_ = NULL;
#line 795 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = dim;
#line 796 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5726 "PhotoMetadata.c"
		gchar** _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		Dimensions* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		PhotoMetadataSetOption _tmp4_ = 0;
		gchar** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		Dimensions* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		PhotoMetadataSetOption _tmp8_ = 0;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_WIDTH_TAGS;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = dim;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = (*_tmp2_).width;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = option;
#line 797 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, _tmp1__length1, (glong) _tmp3_, _tmp4_);
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = photo_metadata_HEIGHT_TAGS;
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = dim;
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = (*_tmp6_).height;
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = option;
#line 798 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp5_, _tmp5__length1, (glong) _tmp7_, _tmp8_);
#line 5761 "PhotoMetadata.c"
	} else {
		gchar** _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		gchar** _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = photo_metadata_WIDTH_TAGS;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 800 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp9_, _tmp9__length1);
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = photo_metadata_HEIGHT_TAGS;
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 801 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp10_, _tmp10__length1);
#line 5779 "PhotoMetadata.c"
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1207 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1208 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1208 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1209 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1209 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1210 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _result_;
#line 1210 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 5803 "PhotoMetadata.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1376 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1376 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 5823 "PhotoMetadata.c"
}


static gchar* photo_metadata_real_get_title (MediaMetadata* base) {
	PhotoMetadata * self;
	gchar* result = NULL;
	GeeList* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GeeList* titles = NULL;
	GeeList* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	GeeList* _tmp8_ = NULL;
	gchar* title = NULL;
	gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	gchar* _tmp28_ = NULL;
#line 834 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 5852 "PhotoMetadata.c"
		GeeList* _tmp2_ = NULL;
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 843 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp2_;
#line 5860 "PhotoMetadata.c"
	} else {
		gchar** _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		GeeList* _tmp4_ = NULL;
#line 844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_first_string_multiple (self, _tmp3_, _tmp3__length1);
#line 844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 844 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp4_;
#line 5875 "PhotoMetadata.c"
	}
#line 842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _g_object_ref0 (_tmp0_);
#line 842 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	titles = _tmp5_;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = titles;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp8_ != NULL) {
#line 5885 "PhotoMetadata.c"
		GeeList* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = titles;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp10_;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp11_ > 0;
#line 5897 "PhotoMetadata.c"
	} else {
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = FALSE;
#line 5901 "PhotoMetadata.c"
	}
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp7_) {
#line 5905 "PhotoMetadata.c"
		GeeList* _tmp12_ = NULL;
		gpointer _tmp13_ = NULL;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = titles;
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = gee_list_get (_tmp12_, 0);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp6_);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = (gchar*) _tmp13_;
#line 5916 "PhotoMetadata.c"
	} else {
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp6_);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = NULL;
#line 5922 "PhotoMetadata.c"
	}
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup (_tmp6_);
#line 849 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	title = _tmp14_;
#line 852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = title;
#line 852 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp15_ != NULL) {
#line 5932 "PhotoMetadata.c"
		const gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = title;
#line 853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = string_strip (_tmp16_);
#line 853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 853 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		title = _tmp17_;
#line 5943 "PhotoMetadata.c"
	}
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp21_ = title;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = is_string_empty (_tmp21_);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp22_) {
#line 5951 "PhotoMetadata.c"
		const gchar* _tmp23_ = NULL;
		gboolean _tmp24_ = FALSE;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = title;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = string_contains (_tmp23_, "\n");
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = !_tmp24_;
#line 5960 "PhotoMetadata.c"
	} else {
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = FALSE;
#line 5964 "PhotoMetadata.c"
	}
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp20_) {
#line 5968 "PhotoMetadata.c"
		const gchar* _tmp25_ = NULL;
		gboolean _tmp26_ = FALSE;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp25_ = title;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = string_contains (_tmp25_, "\r");
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = !_tmp26_;
#line 5977 "PhotoMetadata.c"
	} else {
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 5981 "PhotoMetadata.c"
	}
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 5985 "PhotoMetadata.c"
		const gchar* _tmp27_ = NULL;
#line 857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp27_ = title;
#line 857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = _tmp27_;
#line 5991 "PhotoMetadata.c"
	} else {
#line 857 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = NULL;
#line 5995 "PhotoMetadata.c"
	}
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = g_strdup (_tmp18_);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp28_;
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp6_);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 856 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6011 "PhotoMetadata.c"
}


void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 860 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = title;
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 861 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 6026 "PhotoMetadata.c"
		gboolean _tmp2_ = FALSE;
#line 862 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 862 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (_tmp2_) {
#line 6032 "PhotoMetadata.c"
			const gchar* _tmp3_ = NULL;
#line 863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = title;
#line 863 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 6038 "PhotoMetadata.c"
		} else {
			gchar** _tmp4_ = NULL;
			gint _tmp4__length1 = 0;
			const gchar* _tmp5_ = NULL;
			PhotoMetadataSetOption _tmp6_ = 0;
#line 865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = title;
#line 865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = option;
#line 865 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp4_, _tmp4__length1, _tmp5_, _tmp6_);
#line 6054 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
#line 867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 867 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp7_, _tmp7__length1);
#line 6065 "PhotoMetadata.c"
	}
}


static gchar* photo_metadata_real_get_comment (MediaMetadata* base) {
	PhotoMetadata * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 871 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.UserComment", PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 872 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6082 "PhotoMetadata.c"
}


void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 875 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = comment;
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 876 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 6097 "PhotoMetadata.c"
		const gchar* _tmp2_ = NULL;
#line 877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = comment;
#line 877 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Photo.UserComment", _tmp2_, PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 6103 "PhotoMetadata.c"
	} else {
#line 879 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tag (self, "Exif.Photo.UserComment");
#line 6107 "PhotoMetadata.c"
	}
}


GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify) {
	GeeSet* result = NULL;
	GeeSet* keywords = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GeeSet* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	GeeSet* _tmp24_ = NULL;
	GeeSet* _tmp29_ = NULL;
#line 895 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 896 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 6129 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 6141 "PhotoMetadata.c"
			gchar* _tmp1_ = NULL;
			gchar* tag = NULL;
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 6148 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				const gchar* _tmp2_ = NULL;
				GeeList* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_ = NULL;
#line 898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 898 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp3_;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 6165 "PhotoMetadata.c"
					GeeCollection* _tmp6_ = NULL;
					gint _tmp7_ = 0;
					gint _tmp8_ = 0;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 6177 "PhotoMetadata.c"
				} else {
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 6181 "PhotoMetadata.c"
				}
#line 899 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 6185 "PhotoMetadata.c"
					GeeSet* _tmp9_ = NULL;
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp9_ = keywords;
#line 900 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					if (_tmp9_ == NULL) {
#line 6191 "PhotoMetadata.c"
						GCompareDataFunc _tmp10_ = NULL;
						void* _tmp10__target = NULL;
						GDestroyNotify _tmp10__target_destroy_notify = NULL;
						GeeSet* _tmp11_ = NULL;
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp10_ = compare_func;
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp10__target = compare_func_target;
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp10__target_destroy_notify = compare_func_target_destroy_notify;
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						compare_func_target_destroy_notify = NULL;
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp11_ = photo_metadata_create_string_set (self, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify);
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 901 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						keywords = _tmp11_;
#line 6210 "PhotoMetadata.c"
					}
					{
						GeeIterator* _current_value_it = NULL;
						GeeCollection* _tmp12_ = NULL;
						GeeIterator* _tmp13_ = NULL;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp12_ = values;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp13_;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6224 "PhotoMetadata.c"
							GeeIterator* _tmp14_ = NULL;
							gboolean _tmp15_ = FALSE;
							gchar* current_value = NULL;
							GeeIterator* _tmp16_ = NULL;
							gpointer _tmp17_ = NULL;
							GeeSet* _tmp18_ = NULL;
							const gchar* _tmp19_ = NULL;
							gchar* _tmp20_ = NULL;
							gchar* _tmp21_ = NULL;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp14_ = _current_value_it;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp15_ = gee_iterator_next (_tmp14_);
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							if (!_tmp15_) {
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
								break;
#line 6242 "PhotoMetadata.c"
							}
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp16_ = _current_value_it;
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp17_ = gee_iterator_get (_tmp16_);
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp17_;
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp18_ = keywords;
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp19_ = current_value;
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp20_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp19_);
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp21_ = _tmp20_;
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp18_, _tmp21_);
#line 904 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp21_);
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 6264 "PhotoMetadata.c"
						}
#line 903 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 6268 "PhotoMetadata.c"
					}
				}
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 897 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 6275 "PhotoMetadata.c"
			}
		}
	}
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = keywords;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp24_ != NULL) {
#line 6283 "PhotoMetadata.c"
		GeeSet* _tmp25_ = NULL;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp25_ = keywords;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp27_ = _tmp26_;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp27_ > 0;
#line 6295 "PhotoMetadata.c"
	} else {
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = FALSE;
#line 6299 "PhotoMetadata.c"
	}
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp23_) {
#line 6303 "PhotoMetadata.c"
		GeeSet* _tmp28_ = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp28_ = keywords;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp28_;
#line 6309 "PhotoMetadata.c"
	} else {
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = NULL;
#line 6313 "PhotoMetadata.c"
	}
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp29_ = _g_object_ref0 (_tmp22_);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp29_;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 908 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6331 "PhotoMetadata.c"
}


static gpointer _hierarchical_keyword_field_ref0 (gpointer self) {
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 6338 "PhotoMetadata.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1380 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1380 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1380 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 6351 "PhotoMetadata.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 6382 "PhotoMetadata.c"
				goto __catch518_g_regex_error;
			}
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1382 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			return NULL;
#line 6391 "PhotoMetadata.c"
		}
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 6407 "PhotoMetadata.c"
				goto __catch518_g_regex_error;
			}
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			return NULL;
#line 6418 "PhotoMetadata.c"
		}
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 6432 "PhotoMetadata.c"
	}
	goto __finally518;
	__catch518_g_regex_error:
	{
		GError* e = NULL;
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1385 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 6446 "PhotoMetadata.c"
	}
	__finally518:
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1381 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return NULL;
#line 6457 "PhotoMetadata.c"
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1295 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1296 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1296 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 6481 "PhotoMetadata.c"
		glong _tmp4_ = 0L;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1297 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 6489 "PhotoMetadata.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1299 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 6501 "PhotoMetadata.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1306 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 6525 "PhotoMetadata.c"
		glong _tmp2_ = 0L;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 6531 "PhotoMetadata.c"
	} else {
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 6535 "PhotoMetadata.c"
	}
#line 1308 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 6539 "PhotoMetadata.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1310 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 6551 "PhotoMetadata.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1312 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 6561 "PhotoMetadata.c"
	}
#line 1315 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1315 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 6567 "PhotoMetadata.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1317 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1317 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 6581 "PhotoMetadata.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1319 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 6591 "PhotoMetadata.c"
	}
#line 1321 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1321 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 6597 "PhotoMetadata.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1322 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 6606 "PhotoMetadata.c"
	}
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 6626 "PhotoMetadata.c"
}


static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index) {
	HierarchicalKeywordField** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	HierarchicalTagIndex* _tmp4_ = NULL;
	HierarchicalKeywordField** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
#line 911 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6642 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp0__length1; current_field_it = current_field_it + 1) {
#line 6654 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_ = NULL;
			HierarchicalKeywordField* current_field = NULL;
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 6661 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_ = NULL;
				const gchar* _tmp3_ = NULL;
#line 913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 913 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 912 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6673 "PhotoMetadata.c"
			}
		}
	}
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = index;
#line 915 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 916 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return;
#line 6683 "PhotoMetadata.c"
	}
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6689 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp5_;
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp5__length1;
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp5__length1; current_field_it = current_field_it + 1) {
#line 6701 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp6_ = NULL;
			HierarchicalKeywordField* current_field = NULL;
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			current_field = _tmp6_;
#line 6708 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				GeeSet* writeable_set = NULL;
				GeeTreeSet* _tmp9_ = NULL;
				HierarchicalKeywordField* _tmp29_ = NULL;
				const gchar* _tmp30_ = NULL;
				GeeSet* _tmp31_ = NULL;
#line 919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = current_field;
#line 919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = _tmp7_->is_writeable;
#line 919 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 920 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					continue;
#line 6727 "PhotoMetadata.c"
				}
#line 922 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 922 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				writeable_set = (GeeSet*) _tmp9_;
#line 6733 "PhotoMetadata.c"
				{
					GeeIterator* _current_path_it = NULL;
					HierarchicalTagIndex* _tmp10_ = NULL;
					GeeCollection* _tmp11_ = NULL;
					GeeCollection* _tmp12_ = NULL;
					GeeIterator* _tmp13_ = NULL;
					GeeIterator* _tmp14_ = NULL;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp10_ = index;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp11_ = hierarchical_tag_index_get_all_paths (_tmp10_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp12_ = _tmp11_;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp14_ = _tmp13_;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp12_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp14_;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 6757 "PhotoMetadata.c"
						GeeIterator* _tmp15_ = NULL;
						gboolean _tmp16_ = FALSE;
						gchar* current_path = NULL;
						GeeIterator* _tmp17_ = NULL;
						gpointer _tmp18_ = NULL;
						gchar* writeable_path = NULL;
						const gchar* _tmp19_ = NULL;
						HierarchicalKeywordField* _tmp20_ = NULL;
						const gchar* _tmp21_ = NULL;
						gchar* _tmp22_ = NULL;
						HierarchicalKeywordField* _tmp23_ = NULL;
						gboolean _tmp24_ = FALSE;
						GeeSet* _tmp27_ = NULL;
						const gchar* _tmp28_ = NULL;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp15_ = _current_path_it;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp16_ = gee_iterator_next (_tmp15_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						if (!_tmp16_) {
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							break;
#line 6780 "PhotoMetadata.c"
						}
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp17_ = _current_path_it;
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp18_;
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp19_ = current_path;
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp20_ = current_field;
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp21_ = _tmp20_->path_separator;
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp22_ = string_replace (_tmp19_, TAG_PATH_SEPARATOR_STRING, _tmp21_);
#line 925 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						writeable_path = _tmp22_;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp23_ = current_field;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp24_ = _tmp23_->wants_leading_separator;
#line 927 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						if (!_tmp24_) {
#line 6804 "PhotoMetadata.c"
							const gchar* _tmp25_ = NULL;
							gchar* _tmp26_ = NULL;
#line 928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp25_ = writeable_path;
#line 928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp26_ = string_substring (_tmp25_, (glong) 1, (glong) -1);
#line 928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 928 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							writeable_path = _tmp26_;
#line 6815 "PhotoMetadata.c"
						}
#line 930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp27_ = writeable_set;
#line 930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp28_ = writeable_path;
#line 930 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						gee_collection_add ((GeeCollection*) _tmp27_, _tmp28_);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 6827 "PhotoMetadata.c"
					}
#line 924 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 6831 "PhotoMetadata.c"
				}
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp29_ = current_field;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp30_ = _tmp29_->field_name;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp31_ = writeable_set;
#line 933 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp30_, (GeeCollection*) _tmp31_);
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 918 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6845 "PhotoMetadata.c"
			}
		}
	}
}


void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option) {
	HierarchicalTagIndex* htag_index = NULL;
	HierarchicalTagIndex* _tmp0_ = NULL;
	GeeSet* flat_keywords = NULL;
	GeeTreeSet* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GeeCollection* _tmp28_ = NULL;
#line 937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 938 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 939 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	flat_keywords = (GeeSet*) _tmp1_;
#line 941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = keywords;
#line 941 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ != NULL) {
#line 6873 "PhotoMetadata.c"
		GeeSet* _tmp24_ = NULL;
		HierarchicalTagIndex* _tmp25_ = NULL;
		GeeCollection* _tmp26_ = NULL;
		GeeCollection* _tmp27_ = NULL;
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp3_ = NULL;
			GeeIterator* _tmp4_ = NULL;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = keywords;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp4_;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6890 "PhotoMetadata.c"
				GeeIterator* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				gchar* keyword = NULL;
				GeeIterator* _tmp7_ = NULL;
				gpointer _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = _keyword_it;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = gee_iterator_next (_tmp5_);
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (!_tmp6_) {
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					break;
#line 6906 "PhotoMetadata.c"
				}
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = _keyword_it;
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp8_;
#line 943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = keyword;
#line 943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = g_str_has_prefix (_tmp9_, TAG_PATH_SEPARATOR_STRING);
#line 943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp10_) {
#line 6920 "PhotoMetadata.c"
					GeeCollection* path_components = NULL;
					const gchar* _tmp11_ = NULL;
					GeeList* _tmp12_ = NULL;
#line 944 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp11_ = keyword;
#line 944 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp12_ = hierarchical_tag_utilities_enumerate_path_components (_tmp11_);
#line 944 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					path_components = (GeeCollection*) _tmp12_;
#line 6930 "PhotoMetadata.c"
					{
						GeeIterator* _component_it = NULL;
						GeeCollection* _tmp13_ = NULL;
						GeeIterator* _tmp14_ = NULL;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp13_ = path_components;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_component_it = _tmp14_;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6943 "PhotoMetadata.c"
							GeeIterator* _tmp15_ = NULL;
							gboolean _tmp16_ = FALSE;
							gchar* component = NULL;
							GeeIterator* _tmp17_ = NULL;
							gpointer _tmp18_ = NULL;
							HierarchicalTagIndex* _tmp19_ = NULL;
							const gchar* _tmp20_ = NULL;
							const gchar* _tmp21_ = NULL;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp15_ = _component_it;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_next (_tmp15_);
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							if (!_tmp16_) {
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
								break;
#line 6960 "PhotoMetadata.c"
							}
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp17_ = _component_it;
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp18_ = gee_iterator_get (_tmp17_);
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp18_;
#line 947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp19_ = htag_index;
#line 947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp20_ = component;
#line 947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp21_ = keyword;
#line 947 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp19_, _tmp20_, _tmp21_);
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 6978 "PhotoMetadata.c"
						}
#line 946 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 6982 "PhotoMetadata.c"
					}
#line 943 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 6986 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp22_ = NULL;
					const gchar* _tmp23_ = NULL;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp22_ = flat_keywords;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp23_ = keyword;
#line 949 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp22_, _tmp23_);
#line 6996 "PhotoMetadata.c"
				}
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 7000 "PhotoMetadata.c"
			}
#line 942 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 7004 "PhotoMetadata.c"
		}
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = hierarchical_tag_index_get_all_tags (_tmp25_);
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp27_ = _tmp26_;
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all ((GeeCollection*) _tmp24_, _tmp27_);
#line 953 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp27_);
#line 7018 "PhotoMetadata.c"
	}
#line 956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = keywords;
#line 956 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp28_ != NULL) {
#line 7024 "PhotoMetadata.c"
		gchar** _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		GeeSet* _tmp30_ = NULL;
		PhotoMetadataSetOption _tmp31_ = 0;
		HierarchicalTagIndex* _tmp32_ = NULL;
#line 957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp29_ = photo_metadata_KEYWORD_TAGS;
#line 957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp29__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp30_ = flat_keywords;
#line 957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp31_ = option;
#line 957 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp29_, _tmp29__length1, (GeeCollection*) _tmp30_, _tmp31_);
#line 958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp32_ = htag_index;
#line 958 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp32_);
#line 7044 "PhotoMetadata.c"
	} else {
		gchar** _tmp33_ = NULL;
		gint _tmp33__length1 = 0;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp33_ = photo_metadata_KEYWORD_TAGS;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp33__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 960 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp33_, _tmp33__length1);
#line 961 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 7056 "PhotoMetadata.c"
	}
#line 937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 937 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 7062 "PhotoMetadata.c"
}


gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self) {
	gboolean result = FALSE;
	HierarchicalKeywordField** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 965 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7076 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp0__length1; field_it = field_it + 1) {
#line 7088 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_ = NULL;
			HierarchicalKeywordField* field = NULL;
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 7095 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp2_ = NULL;
				const gchar* _tmp3_ = NULL;
				GeeList* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_ = NULL;
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 967 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp4_;
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 7115 "PhotoMetadata.c"
					GeeCollection* _tmp7_ = NULL;
					gint _tmp8_ = 0;
					gint _tmp9_ = 0;
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 7127 "PhotoMetadata.c"
				} else {
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 7131 "PhotoMetadata.c"
				}
#line 969 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp5_) {
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 970 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					return result;
#line 7143 "PhotoMetadata.c"
				}
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 966 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 7149 "PhotoMetadata.c"
			}
		}
	}
#line 973 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 973 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7157 "PhotoMetadata.c"
}


GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self) {
	GeeSet* result = NULL;
	gboolean _tmp0_ = FALSE;
	GeeSet* h_keywords = NULL;
	GeeSet* _tmp1_ = NULL;
	HierarchicalKeywordField** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
#line 976 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_hierarchical_keywords (self);
#line 977 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0_, "has_hierarchical_keywords ()");
#line 979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, NULL, NULL, NULL);
#line 979 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	h_keywords = _tmp1_;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7182 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		field_collection = _tmp2_;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp2__length1;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp2__length1; field_it = field_it + 1) {
#line 7194 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp3_ = NULL;
			HierarchicalKeywordField* field = NULL;
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			field = _tmp3_;
#line 7201 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				GeeList* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
				GeeCollection* _tmp8_ = NULL;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = field;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp4_->field_name;
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = photo_metadata_get_string_multiple (self, _tmp5_);
#line 982 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp6_;
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = values;
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp8_ == NULL) {
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = TRUE;
#line 7223 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp9_ = NULL;
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp9_ = values;
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_collection_get_size (_tmp9_);
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp11_ < 1;
#line 7236 "PhotoMetadata.c"
				}
#line 984 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				if (_tmp7_) {
#line 985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 985 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					continue;
#line 7246 "PhotoMetadata.c"
				}
				{
					GeeIterator* _current_value_it = NULL;
					GeeCollection* _tmp12_ = NULL;
					GeeIterator* _tmp13_ = NULL;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp12_ = values;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp13_;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 7260 "PhotoMetadata.c"
						GeeIterator* _tmp14_ = NULL;
						gboolean _tmp15_ = FALSE;
						gchar* current_value = NULL;
						GeeIterator* _tmp16_ = NULL;
						gpointer _tmp17_ = NULL;
						gchar* canonicalized = NULL;
						const gchar* _tmp18_ = NULL;
						HierarchicalKeywordField* _tmp19_ = NULL;
						const gchar* _tmp20_ = NULL;
						gchar* _tmp21_ = NULL;
						const gchar* _tmp22_ = NULL;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp14_ = _current_value_it;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp15_ = gee_iterator_next (_tmp14_);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						if (!_tmp15_) {
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							break;
#line 7280 "PhotoMetadata.c"
						}
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp16_ = _current_value_it;
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp17_ = gee_iterator_get (_tmp16_);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp17_;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp18_ = current_value;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp19_ = field;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp20_ = _tmp19_->path_separator;
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp21_ = hierarchical_tag_utilities_canonicalize (_tmp18_, _tmp20_);
#line 988 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						canonicalized = _tmp21_;
#line 991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_tmp22_ = canonicalized;
#line 991 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						if (_tmp22_ != NULL) {
#line 7302 "PhotoMetadata.c"
							GeeSet* _tmp23_ = NULL;
							const gchar* _tmp24_ = NULL;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp23_ = h_keywords;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							_tmp24_ = canonicalized;
#line 992 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp23_, _tmp24_);
#line 7311 "PhotoMetadata.c"
						}
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 7317 "PhotoMetadata.c"
					}
#line 987 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 7321 "PhotoMetadata.c"
				}
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 981 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 7327 "PhotoMetadata.c"
			}
		}
	}
#line 996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 996 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7335 "PhotoMetadata.c"
}


gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_ = NULL;
	GExiv2Orientation _tmp1_ = 0;
#line 999 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_ == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 1000 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7353 "PhotoMetadata.c"
}


Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
	Orientation result = 0;
	GExiv2Orientation orientation = 0;
	GExiv2Metadata* _tmp0_ = NULL;
	GExiv2Orientation _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GExiv2Orientation _tmp4_ = 0;
#line 1004 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1007 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1007 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 1007 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	orientation = _tmp1_;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = orientation;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 7379 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp5_ = 0;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = orientation;
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ < ORIENTATION_MIN;
#line 7386 "PhotoMetadata.c"
	}
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 7392 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp6_ = 0;
#line 1009 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = orientation;
#line 1009 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp6_ > ORIENTATION_MAX;
#line 7399 "PhotoMetadata.c"
	}
#line 1008 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1010 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 1010 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7407 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp7_ = 0;
#line 1012 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = orientation;
#line 1012 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = (Orientation) _tmp7_;
#line 1012 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7416 "PhotoMetadata.c"
	}
}


void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
	GExiv2Metadata* _tmp0_ = NULL;
	Orientation _tmp1_ = 0;
#line 1015 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = orientation;
#line 1017 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) _tmp1_);
#line 7432 "PhotoMetadata.c"
}


gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude) {
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 1020 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 1022 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1023 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_vala_long_ref = NULL;
#line 1024 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1024 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_vala_lat_ref = NULL;
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 7478 "PhotoMetadata.c"
		}
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 7484 "PhotoMetadata.c"
		} else {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 7488 "PhotoMetadata.c"
		}
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 7494 "PhotoMetadata.c"
		}
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 7500 "PhotoMetadata.c"
		} else {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 7504 "PhotoMetadata.c"
		}
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 7510 "PhotoMetadata.c"
		}
#line 1026 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7514 "PhotoMetadata.c"
	}
#line 1029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 1029 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 1030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 1030 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 7534 "PhotoMetadata.c"
	}
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 7540 "PhotoMetadata.c"
	} else {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 7544 "PhotoMetadata.c"
	}
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 7550 "PhotoMetadata.c"
	}
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 7556 "PhotoMetadata.c"
	} else {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 7560 "PhotoMetadata.c"
	}
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 7566 "PhotoMetadata.c"
	}
#line 1032 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7570 "PhotoMetadata.c"
}


gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
	MetadataRational _vala_exposure = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 1035 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 7591 "PhotoMetadata.c"
	}
#line 1036 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7595 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_string (PhotoMetadata* self) {
	gchar* result = NULL;
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
#line 1039 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1041 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1042 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7618 "PhotoMetadata.c"
	}
#line 1044 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = metadata_rational_is_valid (&exposure_time);
#line 1044 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp2_) {
#line 1045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1045 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7628 "PhotoMetadata.c"
	}
#line 1047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp3_;
#line 1047 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7636 "PhotoMetadata.c"
}


gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
	glong _vala_iso = 0L;
	gboolean result = FALSE;
	gboolean fetched_ok = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	glong _tmp4_ = 0L;
#line 1050 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1051 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = fetched_ok;
#line 1053 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == FALSE) {
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7667 "PhotoMetadata.c"
		}
#line 1054 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7671 "PhotoMetadata.c"
	}
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = _vala_iso;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ < ((glong) 6)) {
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 7679 "PhotoMetadata.c"
	} else {
		glong _tmp5_ = 0L;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = _vala_iso;
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ > ((glong) 409600);
#line 7686 "PhotoMetadata.c"
	}
#line 1058 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 1059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7696 "PhotoMetadata.c"
		}
#line 1059 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7700 "PhotoMetadata.c"
	}
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 7708 "PhotoMetadata.c"
	}
#line 1061 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7712 "PhotoMetadata.c"
}


gchar* photo_metadata_get_iso_string (PhotoMetadata* self) {
	gchar* result = NULL;
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_ = NULL;
#line 1064 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1066 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1067 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7734 "PhotoMetadata.c"
	}
#line 1069 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1069 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1069 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7742 "PhotoMetadata.c"
}


gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
	MetadataRational _vala_aperture = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 1072 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 7763 "PhotoMetadata.c"
	}
#line 1073 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7767 "PhotoMetadata.c"
}


gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
	gchar* result = NULL;
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gdouble aperture_value = 0.0;
	MetadataRational _tmp2_ = {0};
	gint _tmp3_ = 0;
	MetadataRational _tmp4_ = {0};
	gint _tmp5_ = 0;
	gdouble _tmp6_ = 0.0;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
#line 1076 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1078 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1078 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1078 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1079 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		return result;
#line 7803 "PhotoMetadata.c"
	}
#line 1081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 1081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = aperture;
#line 1081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 1081 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp3_) / ((gdouble) _tmp5_);
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = aperture_value;
#line 1082 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (_tmp6_ * 10.0)) / 10.0;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = pango_formatted;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = "<i>f</i>/";
#line 7825 "PhotoMetadata.c"
	} else {
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = "f/";
#line 7829 "PhotoMetadata.c"
	}
#line 1085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = aperture_value;
#line 1085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (fmod (_tmp10_, 1) == ((gdouble) 0)) {
#line 1085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.0f";
#line 7837 "PhotoMetadata.c"
	} else {
#line 1085 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.1f";
#line 7841 "PhotoMetadata.c"
	}
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = aperture_value;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf (_tmp9_, _tmp11_);
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp12_;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp13_);
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp15_;
#line 1084 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7859 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_make (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1088 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1089 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7874 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_model (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1092 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1093 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7889 "PhotoMetadata.c"
}


gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
	glong _vala_flash = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
#line 1096 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 7910 "PhotoMetadata.c"
	}
#line 1098 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7914 "PhotoMetadata.c"
}


gchar* photo_metadata_get_flash_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1101 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1103 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7929 "PhotoMetadata.c"
}


gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
	MetadataRational _vala_focal_length = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 1106 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 7950 "PhotoMetadata.c"
	}
#line 1107 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7954 "PhotoMetadata.c"
}


gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1110 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1111 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1111 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1111 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7969 "PhotoMetadata.c"
}


gchar* photo_metadata_get_artist (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar* _tmp1_ = NULL;
#line 1119 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, _tmp0__length1);
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1120 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 7990 "PhotoMetadata.c"
}


gchar* photo_metadata_get_copyright (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1123 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1124 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 8005 "PhotoMetadata.c"
}


gchar* photo_metadata_get_software (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 8020 "PhotoMetadata.c"
}


void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = software;
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = version;
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%s %s", _tmp0_, _tmp1_);
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 1135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_has_iptc (self);
#line 1135 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 8052 "PhotoMetadata.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 1136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = software;
#line 1136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", _tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = version;
#line 1137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", _tmp6_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 8063 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_software (PhotoMetadata* self) {
#line 1141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1143 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 8077 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1147 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 8092 "PhotoMetadata.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 8099 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
	PhotoMetadataInternalPhotoPreview* self = NULL;
	const gchar* _tmp0_ = NULL;
	GExiv2PreviewProperties* _tmp1_ = NULL;
	guint32 _tmp2_ = 0U;
	GExiv2PreviewProperties* _tmp3_ = NULL;
	guint32 _tmp4_ = 0U;
	Dimensions _tmp5_ = {0};
	GExiv2PreviewProperties* _tmp6_ = NULL;
	guint32 _tmp7_ = 0U;
	GExiv2PreviewProperties* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	GExiv2PreviewProperties* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoMetadata* _tmp12_ = NULL;
	PhotoMetadata* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
#line 131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = props;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_width (_tmp1_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = props;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_preview_properties_get_height (_tmp3_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp5_, (gint) _tmp2_, (gint) _tmp4_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = props;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = gexiv2_preview_properties_get_size (_tmp6_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = props;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = gexiv2_preview_properties_get_mime_type (_tmp8_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_preview_properties_get_extension (_tmp10_);
#line 133 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, _tmp0_, &_tmp5_, _tmp7_, _tmp9_, _tmp11_);
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = owner;
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _media_metadata_ref0 (_tmp12_);
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 136 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->owner = _tmp13_;
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = number;
#line 137 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->number = _tmp14_;
#line 131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return self;
#line 8166 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
#line 131 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 8173 "PhotoMetadata.c"
}


static guint8* _vala_array_dup24 (guint8* self, int length) {
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 8180 "PhotoMetadata.c"
}


static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	GExiv2PreviewProperties** props = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	GExiv2Metadata* _tmp1_ = NULL;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	GExiv2PreviewProperties** _tmp3_ = NULL;
	gint props_length1 = 0;
	gint _props_size_ = 0;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	PhotoMetadata* _tmp8_ = NULL;
	GExiv2Metadata* _tmp9_ = NULL;
	GExiv2PreviewProperties** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	guint _tmp11_ = 0U;
	GExiv2PreviewProperties* _tmp12_ = NULL;
	GExiv2PreviewImage* _tmp13_ = NULL;
	GExiv2PreviewImage* _tmp14_ = NULL;
	guint32 _tmp15_;
	guint8* _tmp16_ = NULL;
	guint8* _tmp17_ = NULL;
	gint _tmp17__length1 = 0;
	guint8* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	guint8* _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
#line 140 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) base;
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 141 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 8233 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		guint _tmp7_ = 0U;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->number;
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > _tmp7_;
#line 8245 "PhotoMetadata.c"
	} else {
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 8249 "PhotoMetadata.c"
	}
#line 142 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp4_, "props != null  &&props.length > number");
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = self->owner;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = _tmp8_->priv->exiv2;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10__length1 = props_length1;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = self->number;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp10_[_tmp11_];
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = gexiv2_metadata_get_preview_image (_tmp9_, _tmp12_);
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = _tmp13_;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = gexiv2_preview_image_get_data (_tmp14_, &_tmp15_);
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup24 (_tmp16_, _tmp15_) : ((gpointer) _tmp16_);
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp17__length1 = _tmp15_;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = _tmp17_;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18__length1 = _tmp17__length1;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp14_);
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = _tmp18_;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = _tmp18__length1;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp19__length1;
#line 8289 "PhotoMetadata.c"
	}
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	result = _tmp19_;
#line 144 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	return result;
#line 8295 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
#line 127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
#line 8306 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
#line 127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 128 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 127 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 8322 "PhotoMetadata.c"
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar** _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar** _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar** _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar** _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	gchar** _tmp28_ = NULL;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_ = NULL;
	gchar** _tmp31_ = NULL;
	HierarchicalKeywordField* _tmp32_ = NULL;
	HierarchicalKeywordField* _tmp33_ = NULL;
	HierarchicalKeywordField* _tmp34_ = NULL;
	HierarchicalKeywordField** _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
	gchar** _tmp38_ = NULL;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = photo_metadata_finalize;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = photo_metadata_real_read_from_file;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = photo_metadata_real_get_creation_date_time;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = photo_metadata_real_get_title;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = photo_metadata_real_get_comment;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_[0] = _tmp0_;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_[1] = _tmp1_;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp3_[2] = _tmp2_;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp3_;
#line 697 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_new0 (gchar*, 6 + 1);
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[0] = _tmp4_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[1] = _tmp5_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[2] = _tmp6_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[3] = _tmp7_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[4] = _tmp8_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp10_[5] = _tmp9_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp10_;
#line 715 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_[0] = _tmp11_;
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp13_[1] = _tmp12_;
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp13_;
#line 736 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = g_new0 (gchar*, 4 + 1);
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_[0] = _tmp14_;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_[1] = _tmp15_;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_[2] = _tmp16_;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp18_[3] = _tmp17_;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp18_;
#line 761 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = g_new0 (gchar*, 4 + 1);
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_[0] = _tmp19_;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_[1] = _tmp20_;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_[2] = _tmp21_;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp23_[3] = _tmp22_;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp23_;
#line 768 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Xmp.dc.title");
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = g_new0 (gchar*, 4 + 1);
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_[0] = _tmp24_;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_[1] = _tmp25_;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_[2] = _tmp26_;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp28_[3] = _tmp27_;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp28_;
#line 827 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.dc.subject");
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp31_[0] = _tmp29_;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp31_[1] = _tmp30_;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp31_;
#line 882 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 2;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp32_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, FALSE);
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp33_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE);
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp34_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE);
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp35_ = g_new0 (HierarchicalKeywordField*, 3 + 1);
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp35_[0] = _tmp32_;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp35_[1] = _tmp33_;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp35_[2] = _tmp34_;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp35_;
#line 887 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 3;
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Exif.Image.Artist");
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp37_ = g_strdup ("Exif.Canon.OwnerName");
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp38_ = g_new0 (gchar*, 2 + 1);
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp38_[0] = _tmp36_;
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp38_[1] = _tmp37_;
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp38_;
#line 1114 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 2;
#line 8566 "PhotoMetadata.c"
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	GExiv2Metadata* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 8585 "PhotoMetadata.c"
}


static void photo_metadata_finalize (MediaMetadata* obj) {
	PhotoMetadata * self;
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 148 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 149 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 150 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 112 "/builddir/build/BUILD/pantheon-photos-0.2.1.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 8601 "PhotoMetadata.c"
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



